<?php

class AffinityPricingule {
    function upsert($forceinsert=false) {
    	if ($forceinsert) {
			$arr = array('paymentProfile' => array(
					'profileName' => 'PAYMENT_AFFINITY_POLICY',
					'profileType' => 'PAYMENT',
					'profileDescription' => 'PAYMENT_AFFINITY_POLICY',
					'acceptedPaymentMethod' => array('PAY_PAL'),
					'immediatePay' => true,
					'paypalEmailAddress' => $this->_paypal
			));

			for($i=0; $i<5; $i++) {
				if(!empty($this->_profile_id) || (empty($this->_profile_id) && $i > 0)) {
					$objDateTime = new DateTime('NOW');
					$time = $objDateTime->format('YmdHis');
					$arr['paymentProfile']['profileName'] = 'PAYMENT_AFFINITY_POLICY' . $time;
				}

				$res = AffinityBackendService::sendProfileSyncRequest($arr, 'POST');
				
				if (!empty($res['arrResult']['data'])) {
					if (!empty($res['arrResult']['data'][0]) && !empty($res['arrResult']['data'][0]['errorId']) && $res['arrResult']['data'][0]['errorId'] == 178056) {
						if($i == 4) {
							if (!empty($res['arrResult']['errors'])) {
								$errors = array();
								if (!empty($res['arrResult']['errors'])) {
									foreach ($res['arrResult']['errors'] as $error) {
										$errors[] = $error;
									}
								}
								if (!empty($res['arrResult']['warnings'])) {
									foreach ($res['arrResult']['warnings'] as $warning) {
										$errors[] = $warning;
									}
								}
								
								$errors = array_unique($errors);
								update_option('ebayaffinity_pricing_errors', json_encode($errors));
								$this->_profile_id = '';
								$this->_profile_name = '';
							}
						}
						continue;
					}
					else if (!empty($res['arrResult']['data'][0]) && !empty($res['arrResult']['data'][0]['errorId']) && $res['arrResult']['data'][0]['errorId'] == 178149) {
						if (!empty($res['arrResult']['data'][0]['parameter'])) {
							$this->_profile_id = '';
							$this->_profile_name = '';
							foreach ($res['arrResult']['data'][0]['parameter'] as $param) {
								if ($param['name'] === 'DuplicateProfileId') {
									$this->_profile_id = $param['value'];
									$arr['paymentProfile']['profileId'] = $this->_profile_id;
								} else if ($param['name'] === 'DuplicateProfileName') {
									$this->_profile_name = $param['value'];
									$arr['paymentProfile']['profileName'] = $this->_profile_name;
								}
							}
							update_option('ebayaffinity_pricing_errors', '[]');
							break;		
						}
					}
				}

				if (!empty($res['arrResult']['errors'])) {
					$errors = array();
					if (!empty($res['arrResult']['errors'])) {
						foreach ($res['arrResult']['errors'] as $error) {
							$errors[] = $error;
						}
					}
					if (!empty($res['arrResult']['warnings'])) {
						foreach ($res['arrResult']['warnings'] as $warning) {
							$errors[] = $warning;
						}
					}
					
					$errors = array_unique($errors);
					update_option('ebayaffinity_pricing_errors', json_encode($errors));
					$this->_profile_id = '';
					$this->_profile_name = '';
				}
				else {
					if (!empty($res['arrResult']['warnings'])) {
						$errors = array();
						foreach ($res['arrResult']['warnings'] as $warning) {
							$errors[] = $warning;
						}
						$errors = array_unique($errors);
						update_option('ebayaffinity_pricing_errors', json_encode($errors));
					}
					else {
						update_option('ebayaffinity_pricing_errors', '[]');
					}
				
					if (!empty($res['arrResult']['data'])) {
						if (!empty($res['arrResult']['data']['paymentProfile'])) {
							if (!empty($res['arrResult']['data']['paymentProfile'][0])) {
								if (!empty($res['arrResult']['data']['paymentProfile'][0]['profileId'])) {
									// Our last PUT/POST was a success.
									$this->_profile_id = $res['arrResult']['data']['paymentProfile'][0]['profileId'];
									$this->_profile_name = $res['arrResult']['data']['paymentProfile'][0]['profileName'];
								}
							}
						}
					}
				}
				break;				
			}
    		
    		if (!empty($this->_profile_id)) {
    			update_option('ebayaffinity_pricing_profile_id', $this->_profile_id);
    		}
    		if (!empty($this->_profile_name)) {
    			update_option('ebayaffinity_pricing_profile_name', $this->_profile_name);
    		}
		}
    }
    
    static function generate($product) {
    	return get_option('ebayaffinity_pricing_profile_name');
	}

}
