<?php
class AffinityEbayInstCategory {
	static public function recSortCats($obj) {
		global $affinity_complete_cats;
		
		if (!empty($obj['category']['id'])) {
			$affinity_complete_cats[] = '('.implode(',', array(
					intval($obj['category']['id']),
					"'".esc_sql($obj['category']['name'])."'",
					intval($obj['category']['level']),
					intval(empty($obj['category']['parent'])?-1:$obj['category']['parent']),
					"'".esc_sql(implode(':', array_slice(array_reverse($obj['category']['ancestors']), 1)))."'",
					intval($obj['category']['leaf'] ? 1 : 0))).')';
		}
		
		if (!empty($obj['children'])) {
			for ($i = 0; $i < count($obj['children']); $i++) {
				self::recSortCats($obj['children'][$i]);
			}
		}
	}
	
	static public function installNew() {
		require_once(__DIR__ . "/../service/AffinityBackendService.php");
		
		global $affinity_complete_cats;
		$affinity_complete_cats = array();
		
		$a = AffinityBackendService::getCategoryTree();
		self::recSortCats($a['data']['categoryNode']);
		
		global $wpdb;
		
		if (!empty($affinity_complete_cats)) {
			$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."ebayaffinity_categories_bak`;");
			$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."ebayaffinity_categories_tmp`;");
			$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."ebayaffinity_categories_tmp` (
			  `categoryId` int(11) NOT NULL DEFAULT '0',
			  `name` varchar(255) DEFAULT NULL,
			  `level` int(11) DEFAULT '0',
			  `parentCategoryId` int(11) DEFAULT '0',
			  `path` varchar(255) DEFAULT NULL,
			  `leaf` tinyint(1) DEFAULT '0',
			  PRIMARY KEY (`categoryId`),
			  INDEX (`parentCategoryId`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			
			$wpdb->query("INSERT INTO `".$wpdb->prefix."ebayaffinity_categories_tmp` VALUES ".implode(',', $affinity_complete_cats));
			$wpdb->query("RENAME TABLE `".$wpdb->prefix."ebayaffinity_categories` TO `".$wpdb->prefix."ebayaffinity_categories_bak`, `".$wpdb->prefix."ebayaffinity_categories_tmp` TO `".$wpdb->prefix."ebayaffinity_categories`");
		}
		
		$json = AffinityBackendService::getCategoryExpired();
		
		if ((!empty($json['data'])) && (!empty($json['data']['expiredCategories']))) {
			$results = $wpdb->get_results("SELECT post_id, meta_value FROM ".$wpdb->postmeta." WHERE meta_key = '_affinity_ebaycategory'");
			
			foreach ($results as $result) {
				if (!empty($json['data']['expiredCategories'][$result->meta_value])) {
					update_post_meta($result->post_id, '_affinity_ebaycategory', $json['data']['expiredCategories'][$result->meta_value][0]);
				}
			}
			
			$results = $wpdb->get_results("SELECT term_id, meta_value FROM ".$wpdb->termmeta." WHERE meta_key = '_affinity_ebaycategory'");
			
			foreach ($results as $result) {
				if (!empty($json['data']['expiredCategories'][$result->meta_value])) {
					update_term_meta($result->term_id, '_affinity_ebaycategory', $json['data']['expiredCategories'][$result->meta_value][0]);
				}
			}
		}
	}
	
    static function install() {
    	global $wpdb;
		    	
		$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."ebayaffinity_categories` (
		  `categoryId` int(11) NOT NULL DEFAULT '0',
		  `name` varchar(255) DEFAULT NULL,
		  `level` int(11) DEFAULT '0',
		  `parentCategoryId` int(11) DEFAULT '0',
		  `path` varchar(255) DEFAULT NULL,
		  `leaf` tinyint(1) DEFAULT '0',
		  PRIMARY KEY (`categoryId`),
		  INDEX (`parentCategoryId`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
		
		$categoryId = $wpdb->get_var("SELECT categoryId FROM `".$wpdb->prefix."ebayaffinity_categories` LIMIT 1");
		if (!empty($categoryId)) {
			return;
		}
		
		$wpdb->query("INSERT INTO `".$wpdb->prefix."ebayaffinity_categories` VALUES (1,'Collectables',1,-1,'',0),
(12,'Other Antiques',2,20081,'20081',1),
(14,'Other Glass',3,50693,'870:50693',1),
(15,'Other Countries',4,955,'870:50693:955',1),
(24,'Pottery, Porcelain',2,870,'870',0),
(25,'Other Porcelain',3,24,'870:24',1),
(26,'Figurines',3,24,'870:24',1),
(30,'Other Vintage Toys',3,717,'220:717',1),
(34,'Advertising',2,1,'1',0),
(36,'Soft Drink',3,34,'1:34',1),
(39,'Petrol',3,34,'1:34',1),
(44,'Cigarette',3,34,'1:34',1),
(63,'Comic Books',2,267,'267',1),
(82,'Other Home, Kitchen',3,13905,'1:13905',1),
(84,'Other Shakers',4,4049,'1:13905:4049',1),
(86,'Other Pottery',3,24,'870:24',1),
(88,'Hummel, Goebel',3,24,'870:24',1),
(95,'Other Royal Doulton',4,43813,'870:24:43813',1),
(99,'Lots More...',1,-1,'',0),
(100,'Other Ornaments',4,13777,'1:13905:13777',1),
(118,'Other Breweriana',3,562,'1:562',1),
(124,'Paper, Postcards',2,1,'1',0),
(125,'Other Paper, Postcards',3,124,'1:124',1),
(127,'Other Postcards',4,914,'1:124:914',1),
(128,'Other Cultural, Religious',3,3913,'1:3913',1),
(130,'Other Railroadiana',4,1444,'1:417:1444',1),
(132,'Other Radio Items',4,931,'1:29832:931',1),
(133,'Other Tobacciana',3,593,'1:593',1),
(135,'Other Eras, Wars',3,13956,'1:13956',1),
(137,'Disneyana',2,1,'1',1),
(149,'Money Boxes',3,13905,'1:13905',1),
(158,'Other Writing Items',3,966,'1:966',1),
(162,'Other Computers & Networking',2,58058,'58058',1),
(164,'CPUs/Processors',3,175673,'58058:175673',1),
(165,'Drives, Storage & Blank Media',2,58058,'58058',0),
(167,'Other Drives, Storage & Media',3,165,'58058:165',1),
(169,'Floppy, Zip & Jaz Drives',3,165,'58058:165',1),
(170,'Other Keyboards & Mice',3,3676,'58058:3676',1),
(177,'PC Laptops & Netbooks',3,175672,'58058:175672',1),
(179,'PC Desktops & All-In-Ones',3,171957,'58058:171957',1),
(182,'Other Computer Software',3,18793,'58058:18793',1),
(185,'Web & Desktop Publishing',3,18793,'58058:18793',1),
(187,'Other Video Games',2,1249,'1249',1),
(196,'Movie Memorabilia',2,11232,'11232',0),
(197,'Other',3,196,'11232:196',1),
(201,'Other',3,1424,'11232:1424',1),
(203,'Unsigned Memorabilia',3,39991,'888:39991',1),
(208,'Other Historical',3,13877,'1:13877',1),
(212,'Sports Trading Cards',2,888,'888',0),
(213,'Baseball Cards',3,212,'888:212',1),
(214,'Basketball Cards',3,212,'888:212',1),
(215,'Gridiron Cards',3,212,'888:212',1),
(216,'Ice Hockey Cards',3,212,'888:212',1),
(217,'Other Sports Trading Cards',3,212,'888:212',1),
(218,'Other MTG Items',4,19107,'220:2536:19107',1),
(219,'Other Non-Sport Card Merch',3,182982,'1:182982',1),
(220,'Toys, Hobbies',1,-1,'',0),
(222,'Diecast Vehicles',2,220,'220',0),
(229,'Wind-up',3,717,'220:717',1),
(230,'Other Bean Bag Toys',3,49019,'220:49019',1),
(233,'Games',2,220,'220',0),
(234,'Other',3,233,'220:233',1),
(237,'Dolls, Bears',1,-1,'',0),
(238,'Dolls',2,237,'237',0),
(239,'Other Dolls',3,238,'237:238',1),
(243,'Cabbage Patch',3,238,'237:238',1),
(246,'Action Figures',2,220,'220',0),
(253,'US',4,45145,'11116:58520:45145',0),
(257,'Other Coins',3,58520,'11116:58520',1),
(259,'Other Exonumia',3,3452,'11116:3452',1),
(260,'Stamps',1,-1,'',0),
(261,'US',3,181444,'260:181444',1),
(264,'Other World Stamps',3,181420,'260:181420',1),
(267,'Books, Magazines',1,-1,'',0),
(268,'Other Books',2,267,'267',1),
(279,'Other Children & Young Adults',3,182882,'267:182882',1),
(281,'Jewellery & Watches',1,-1,'',0),
(282,'Other Loose Gemstones',4,181077,'281:491:181077',1),
(293,'Electronics',1,-1,'',0),
(296,'Other Radio Communication',3,1500,'293:1500',1),
(299,'Cleaning, Housekeeping',2,11700,'11700',0),
(300,'Other',3,299,'11700:299',1),
(301,'Other Pet Supplies',2,1281,'1281',1),
(303,'Other Hand Tools',4,3244,'11700:631:3244',1),
(308,'Other Musical Instruments',2,619,'619',1),
(309,'VHS Tapes',2,11232,'11232',1),
(310,'Other Sports',3,40141,'888:40141',1),
(312,'Other',2,11450,'11450',1),
(313,'Other',3,1059,'11450:1059',1),
(314,'Other',3,15724,'11450:15724',1),
(316,'Services',1,-1,'',0),
(317,'Other',2,316,'316',1),
(326,'Antique (pre-1930)',3,238,'237:238',1),
(329,'Doll Accessories',2,237,'237',0),
(332,'Hard Plastic',3,238,'237:238',1),
(333,'Other',3,1202,'237:1202',1),
(336,'Modern',3,238,'237:238',1),
(339,'Cloth',3,238,'237:238',1),
(343,'Other',3,329,'237:329',1),
(348,'Other Action Figures',3,246,'220:246',1),
(357,'Folk Art',2,550,'550',1),
(358,'Other Metalware',4,1211,'20081:20086:1211',1),
(362,'Other Textiles, Linens',3,181677,'20081:181677',1),
(363,'Other Animation Art',3,13658,'1:13658',1),
(364,'Other Art Deco',3,153113,'20081:153113',1),
(369,'Other Bottles, Jars, Jugs',3,29797,'1:29797',1),
(371,'Other Lighting',4,1404,'1:13905:1404',1),
(374,'Other Fisher Price',4,2524,'220:19169:2524',1),
(381,'Laserdiscs',2,11232,'11232',1),
(383,'Other Hunting',3,7301,'888:7301',1),
(384,'Other Fishing',3,1492,'888:1492',1),
(385,'Other Notes',3,58507,'11116:58507',1),
(386,'Bears',2,237,'237',1),
(387,'Bear Accessories',2,237,'237',1),
(397,'Clocks',3,13905,'1:13905',1),
(412,'Science, Medical',2,1,'1',0),
(415,'Other Rocks, Fossils',3,3213,'1:3213',1),
(417,'Transportation',2,1,'1',0),
(418,'Other',4,50428,'131090:6747:50428',1),
(419,'Other Aviation',4,14049,'1:417:14049',1),
(421,'Number Plates',3,6030,'131090:6030',1),
(430,'Memorabilia',3,13340,'888:13340',1),
(436,'Stuffed Animals',2,220,'220',1),
(439,'Disney',3,49019,'220:49019',1),
(458,'Tableware',4,65020,'870:24:65020',1),
(462,'Chintz, Floral',3,24,'870:24',1),
(463,'Decorative',3,24,'870:24',1),
(472,'Tableware',4,64979,'870:24:64979',1),
(474,'Figurines: Animal',3,24,'870:24',1),
(475,'Other Collectible Blades',3,1401,'1:1401',1),
(476,'Magnets',2,1,'1',1),
(484,'Other',4,19128,'220:180250:19128',1),
(485,'Other',4,19145,'220:180250:19145',1),
(486,'Other',4,19119,'220:180250:19119',1),
(491,'Loose Diamonds & Gemstones',2,281,'281',0),
(493,'Specimen',5,110848,'281:491:181077:110848',1),
(494,'Other',3,164352,'281:164352',1),
(499,'Other Fashion Jewellery',3,10968,'281:10968',1),
(505,'Other Fine Jewellery',3,4196,'281:4196',1),
(525,'Mixed US',5,253,'11116:58520:45145:253',1),
(531,'Other Supplies',3,83274,'11116:83274',1),
(534,'Other',4,40711,'11116:58520:40711',1),
(536,'Canada',4,45145,'11116:58520:45145',1),
(539,'France',4,45148,'11116:58520:45148',1),
(544,'Mixed Regions',3,58520,'11116:58520',1),
(545,'Mint, Proof Sets',3,58520,'11116:58520',1),
(550,'Art',1,-1,'',0),
(554,'Mixed Media, Collage',2,550,'550',1),
(562,'Breweriana, Beer',2,1,'1',0),
(563,'Bottles',3,562,'1:562',1),
(565,'Coasters',3,562,'1:562',1),
(566,'Openers',3,562,'1:562',1),
(567,'Labels',3,562,'1:562',1),
(569,'Signs',3,562,'1:562',1),
(572,'Trays',3,562,'1:562',1),
(574,'Collector Plates',4,13777,'1:13905:13777',1),
(575,'Other',3,3944,'1249:3944',1),
(581,'Limited Editions',2,1,'1',1),
(593,'Tobacciana',2,1,'1',0),
(594,'Ashtrays',3,593,'1:593',1),
(597,'Vanity, Perfume, Shaving',2,1,'1',0),
(598,'Other Vanity',3,597,'1:597',1),
(599,'Accessories',3,597,'1:597',1),
(617,'DVDs & Blu-ray Discs',2,11232,'11232',1),
(618,'Other Formats',2,11233,'11233',1),
(619,'Musical Instruments',1,-1,'',0),
(620,'Other Brass',3,16212,'619:16212',1),
(621,'Other Guitars',3,3858,'619:3858',1),
(622,'Other Percussion',3,180012,'619:180012',1),
(623,'Other String Instruments',3,180016,'619:180016',1),
(624,'Other Wind & Woodwind',3,10181,'619:10181',1),
(625,'Cameras',1,-1,'',0),
(629,'Other Darkroom & Developing',4,182077,'625:69323:182077',1),
(630,'Other Golf',3,1513,'888:1513',1),
(631,'Tools',2,11700,'11700',0),
(632,'Other Power Tools',4,3247,'11700:631:3247',1),
(633,'Other',3,64808,'170769:64808',1),
(666,'Auto Racing Cards',3,212,'888:212',1),
(672,'Trading Card Singles',4,100899,'1:182982:100899',1),
(698,'World Errors & Misperfs',3,181420,'260:181420',1),
(699,'Other European',3,4742,'260:4742',1),
(700,'First Day Covers',3,181420,'260:181420',1),
(701,'Publications',3,181421,'260:181421',1),
(703,'Other Topics',3,4752,'260:4752',1),
(705,'Other',3,181421,'260:181421',1),
(711,'Other Vintage Photography',3,3326,'625:3326',1),
(713,'Native American',3,3913,'1:3913',1),
(717,'Vintage, Antique Toys, Games',2,220,'220',0),
(719,'Battery Operated',3,717,'220:717',1),
(723,'Character Toys',3,717,'220:717',1),
(724,'Vintage [Pre-1980]',4,28811,'220:183446:28811',1),
(727,'Play Sets',3,717,'220:717',1),
(735,'Tin',3,717,'220:717',1),
(739,'Vehicles',3,717,'220:717',1),
(740,'Vintage Manufacture',4,180274,'220:222:180274',1),
(741,'Vintage Manufacture',4,180275,'220:222:180275',1),
(742,'Vintage Manufacture',4,180276,'220:222:180276',1),
(754,'Sports',3,246,'220:246',1),
(767,'Fast Food',3,19077,'220:19077',1),
(774,'Other Model Building',3,1188,'220:1188',1),
(776,'Other Slot Cars',3,2616,'220:2616',1),
(786,'Other US',5,253,'11116:58520:45145:253',1),
(793,'Other',4,180001,'888:1492:180001',1),
(805,'Airlines',4,14049,'1:417:14049',1),
(821,'Distillery',3,34,'1:34',1),
(827,'Agriculture',3,34,'1:34',1),
(849,'Restaurant',3,34,'1:34',1),
(870,'Pottery, Glass',1,-1,'',0),
(873,'Confectionary',3,34,'1:34',1),
(887,'Barber Shop, Shaving',3,597,'1:597',1),
(888,'Sporting Goods',1,-1,'',0),
(898,'Casino',2,1,'1',1),
(905,'Other Stamping',3,3122,'14339:3122',1),
(914,'Postcards',3,124,'1:124',0),
(916,'Artist Signed',4,914,'1:124:914',1),
(919,'Greetings',4,914,'1:124:914',1),
(921,'Military',4,914,'1:124:914',1),
(928,'Police',3,13877,'1:13877',1),
(931,'Radio',3,29832,'1:29832',0),
(932,'Transistor Radios',4,931,'1:29832:931',1),
(934,'Publications',4,931,'1:29832:931',1),
(951,'Lighters',3,593,'1:593',1),
(954,'Other Crocheting & Knitting',4,3094,'14339:160706:3094',1),
(955,'Art Glass',3,50693,'870:50693',0),
(957,'Other Vintage Accessories',4,182059,'11450:175759:182059',1),
(965,'Other Women\'s Vintage Clothing',4,182047,'11450:175759:182047',1),
(966,'Pens, Writing Items',2,1,'1',0),
(970,'Inkwells, Ink Pots',3,966,'1:966',1),
(971,'Sets',3,966,'1:966',1),
(978,'Tableware',3,13905,'1:13905',0),
(979,'Other Tableware',4,978,'1:13905:978',1),
(980,'Sets',4,978,'1:13905:978',1),
(994,'Italian',4,955,'870:50693:955',1),
(1002,'Depression',3,50693,'870:50693',1),
(1010,'1950 - 1979',3,50693,'870:50693',1),
(1011,'Kitchen Glassware',3,50693,'870:50693',1),
(1020,'Elegant',3,50693,'870:50693',1),
(1031,'Swarovski, Figurines',3,50693,'870:50693',1),
(1039,'Other',2,220,'220',1),
(1043,'British Art',3,24,'870:24',1),
(1044,'European Makers',3,24,'870:24',1),
(1048,'Other Equestrian',3,3153,'888:3153',1),
(1059,'Men\'s Clothing',2,11450,'11450',0),
(1060,'Other',3,4250,'11450:4250',1),
(1063,'Other',3,4251,'11450:4251',1),
(1067,'Other',3,11452,'11450:11452',1),
(1070,'Other Baby Clothing',3,3082,'2984:3082',1),
(1082,'Electronic Pets',3,19071,'220:19071',1),
(1184,'Board Games',3,717,'220:717',1),
(1188,'Model Building',2,220,'220',0),
(1189,'Air',3,1188,'220:1188',0),
(1190,'Other Automotive',4,2580,'220:1188:2580',1),
(1191,'Other Military',4,2586,'220:1188:2586',1),
(1196,'Other Promotional Toys',3,19077,'220:19077',1),
(1197,'Wooden Toys',2,220,'220',1),
(1201,'Furniture',3,1202,'237:1202',1),
(1202,'Houses, Miniatures',2,237,'237',0),
(1206,'Trolls',3,238,'237:238',1),
(1211,'Metalware',3,20086,'20081:20086',0),
(1212,'Bronze',4,1211,'20081:20086:1211',1),
(1213,'Copper',4,1211,'20081:20086:1211',1),
(1230,'Stained Glass',3,50693,'870:50693',1),
(1238,'Tea Pots, Trios',3,24,'870:24',1),
(1240,'Wall Pockets',3,24,'870:24',1),
(1242,'Figures',4,70054,'870:24:70054',1),
(1244,'Motherboards',3,175673,'58058:175673',1),
(1245,'Printers',3,171961,'58058:171961',1),
(1249,'Video Games & Consoles',1,-1,'',0),
(1261,'Other Baby Items',2,2984,'2984',1),
(1264,'Other',3,172378,'2984:172378',1),
(1265,'Other',3,3259,'11450:3259',1),
(1266,'Industrial Supply, MRO',2,170769,'170769',1),
(1269,'Other',3,11748,'170769:11748',1),
(1271,'Other',3,11874,'170638:11874',1),
(1275,'Other',2,14308,'14308',1),
(1277,'Other Health & Beauty',2,26395,'26395',1),
(1278,'Energy Bars, Shakes & Drinks',3,180959,'26395:180959',1),
(1279,'Other Natural Remedies',3,67659,'26395:67659',1),
(1281,'Pet Supplies',1,-1,'',0),
(1283,'Other Supplies',3,20742,'1281:20742',1),
(1284,'Other',3,20737,'1281:20737',1),
(1285,'Reptiles',2,1281,'1281',1),
(1288,'Other Generic Accessories',3,180008,'619:180008',1),
(1289,'Other Keyboards & Pianos',3,180010,'619:180010',1),
(1290,'Other',3,19273,'170638:19273',1),
(1291,'Other Archery',3,20835,'888:20835',1),
(1292,'Other',3,21567,'888:21567',1),
(1294,'Other Boating, Water Sports',3,23806,'888:23806',1),
(1295,'Personal Watercrafts',4,166101,'888:23806:166101',1),
(1299,'Other',3,30105,'888:30105',1),
(1300,'Other Scuba',3,16052,'888:16052',1),
(1301,'Other Skating',3,106465,'888:106465',1),
(1302,'Other',4,16059,'888:36259:16059',1),
(1303,'Other',3,36259,'888:36259',1),
(1305,'Tickets',2,11730,'11730',1),
(1313,'Autos',3,34,'1:34',1),
(1314,'Other',5,27371,'131090:6747:50428:27371',1),
(1322,'Cereal',3,34,'1:34',1),
(1335,'Animals',2,1,'1',1),
(1340,'Other Fantasy, Magic',3,10860,'1:10860',1),
(1345,'Other Japanese',4,11118,'1:13658:11118',1),
(1349,'Avon',4,13777,'1:13905:13777',1),
(1364,'Other Tole Painting Supplies',3,183126,'14339:183126',1),
(1401,'Knives, Swords & Blades',2,1,'1',0),
(1404,'Lighting',3,13905,'1:13905',0),
(1405,'Other Electric',5,4053,'1:13905:1404:4053',1),
(1406,'Other Non-Electric',5,4057,'1:13905:1404:4057',1),
(1408,'Shades',4,1404,'1:13905:1404',1),
(1414,'Other',4,39630,'1:13877:39630',1),
(1424,'Television Memorabilia',2,11232,'11232',0),
(1430,'Metalware',2,1,'1',1),
(1438,'Playing Cards',3,124,'1:124',1),
(1443,'Promotional Glasses',2,1,'1',1),
(1444,'Railroadiana',3,417,'1:417',0),
(1461,'Other Tools, Hardware, Locks',3,13849,'1:13849',1),
(1466,'Weird Stuff',2,1,'1',0),
(1467,'Slightly Unusual',3,1466,'1:1466',1),
(1469,'Totally Bizarre',3,1466,'1:1466',1),
(1492,'Fishing',2,888,'888',0),
(1493,'Spinners & Spinnerbaits',4,179961,'888:1492:179961',1),
(1498,'Other Vehicle Electronics, GPS',3,3270,'131090:3270',1),
(1500,'Radio Communication',2,293,'293',0),
(1513,'Golf',2,888,'888',0),
(1514,'Other Golf Accessories',4,181128,'888:1513:181128',1),
(1523,'Other Metaphysical',3,19266,'99:19266',1),
(1529,'Animation Art',3,13658,'1:13658',1),
(2023,'Other',3,21194,'888:21194',1),
(2030,'Post-1970',4,101893,'9800:29690:101893',1),
(2032,'Gardening Supplies',3,159912,'11700:159912',0),
(2034,'Other Garden Décor',4,20498,'11700:159912:20498',1),
(2036,'Other Badges',4,109779,'1:32615:109779',1),
(2194,'Other Asian',3,20082,'20081:20082',1),
(2203,'Other Ceramics',4,63521,'20081:20086:63521',1),
(2204,'Other Ethnographic',3,2207,'20081:2207',1),
(2205,'Other Glass',4,63538,'20081:20086:63538',1),
(2207,'Ethnographic',2,20081,'20081',0),
(2212,'Silverplate',3,20096,'20081:20096',1),
(2213,'Sterling',3,20096,'20081:20096',1),
(2219,'Other Lace, Crochet, Doilies',4,39444,'20081:181677:39444',1),
(2220,'Linens',3,181677,'20081:181677',1),
(2224,'Tapestries',3,181677,'20081:181677',1),
(2228,'Textbooks',2,267,'267',1),
(2329,'Memorabilia',2,11233,'11233',1),
(2387,'Celebrity',3,238,'237:238',1),
(2389,'Other Doll Making',3,2408,'237:2408',1),
(2404,'Artist Offerings, OOAK',3,238,'237:238',1),
(2408,'Doll Making, Repair',2,237,'237',0),
(2430,'Crissy',3,238,'237:238',1),
(2434,'Mattel',3,238,'237:238',1),
(2458,'Houses',3,1202,'237:1202',1),
(2500,'Track',4,180278,'220:222:180278',1),
(2518,'Other Education Toys',3,11731,'220:11731',1),
(2524,'Fisher Price',3,19169,'220:19169',0),
(2527,'Little People',4,2524,'220:19169:2524',1),
(2528,'Pull Toys',3,19169,'220:19169',1),
(2535,'Other CCG Items',3,2536,'220:2536',1),
(2536,'Collectible Card Games',2,220,'220',0),
(2537,'Other Miniatures',4,16486,'220:233:16486',1),
(2540,'Electronic Games',3,233,'220:233',1),
(2543,'Role Playing Games',3,233,'220:233',1),
(2550,'Board & Traditional Games',3,233,'220:233',0),
(2552,'Other',4,180350,'220:233:180350',1),
(2562,'Radio Control & Control Line',2,220,'220',0),
(2568,'Chemistry',4,83756,'220:11731:83756',1),
(2576,'Playskool',3,19169,'220:19169',1),
(2580,'Automotive',3,1188,'220:1188',0),
(2584,'Trucks',4,2580,'220:1188:2580',1),
(2586,'Military',3,1188,'220:1188',0),
(2588,'Armour',4,2586,'220:1188:2586',1),
(2589,'Land',4,2586,'220:1188:2586',1),
(2590,'Sea',4,2586,'220:1188:2586',1),
(2591,'Motorcycles',4,2580,'220:1188:2580',1),
(2594,'Tools, Supplies',3,1188,'220:1188',1),
(2608,'Other Pokémon TCG Items',4,183466,'220:2536:183466',1),
(2611,'Pokémon Individual Cards',4,183466,'220:2536:183466',1),
(2613,'Puzzles',2,220,'220',1),
(2616,'Slot Cars',2,220,'220',0),
(2624,'Character Toys',2,220,'220',1),
(2631,'Toy Soldiers',2,220,'220',1),
(2650,'Vintage Manufacture',4,180268,'220:222:180268',1),
(2663,'Yo-Yos',3,19016,'220:19016',1),
(2714,'Cut Glass',3,50693,'870:50693',1),
(2719,'Fenton',3,50693,'870:50693',1),
(2735,'Opaque',3,50693,'870:50693',1),
(2742,'Paperweights',3,50693,'870:50693',1),
(2753,'Blue Willow, Flow Blue',3,24,'870:24',1),
(2760,'Crown Devon',3,24,'870:24',1),
(2774,'Imperial',3,24,'870:24',1),
(2776,'Johnson Brothers',3,24,'870:24',1),
(2781,'Maling',3,24,'870:24',1),
(2790,'Sylvac',3,24,'870:24',1),
(2793,'Aynsley',3,24,'870:24',1),
(2796,'Bing & Grondahl',3,24,'870:24',1),
(2798,'Commemorative',3,24,'870:24',1),
(2806,'Lord Nelson',3,24,'870:24',1),
(2807,'Japanese',4,91012,'870:24:91012',1),
(2808,'Alfred Meakin',3,24,'870:24',1),
(2809,'Meissen',3,24,'870:24',1),
(2810,'Minton',3,24,'870:24',1),
(2811,'Ridgway',3,24,'870:24',1),
(2813,'Rosenthal',3,24,'870:24',1),
(2816,'Sadler',3,24,'870:24',1),
(2817,'Spode',3,24,'870:24',1),
(2818,'Villeroy & Boch',3,24,'870:24',1),
(2855,'Memorabilia',3,7294,'888:7294',1),
(2875,'Other Motor Racing',3,19292,'888:19292',1),
(2883,'Memorabilia',3,23806,'888:23806',1),
(2904,'Other',3,7294,'888:7294',1),
(2905,'Other Tenpin Bowling',3,20846,'888:20846',1),
(2906,'Other',3,21557,'888:21557',1),
(2907,'Other Darts',3,72575,'888:72575',1),
(2912,'Other Rugby Union',3,21563,'888:21563',1),
(2914,'Other Soccer',3,20862,'888:20862',1),
(2916,'Other Surfing',3,22709,'888:22709',1),
(2917,'Other',3,13340,'888:13340',1),
(2956,'Olympics Cards',3,212,'888:212',1),
(2969,'Rugby Union Cards',3,212,'888:212',1),
(2984,'Baby',1,-1,'',0),
(2985,'Cots & Cribs',3,20422,'2984:20422',1),
(2986,'High Chairs',3,20400,'2984:20400',1),
(2987,'Other Car Seats',3,66692,'2984:66692',1),
(2988,'Play Pens',3,20433,'2984:20433',1),
(2989,'Other Prams & Strolllers',3,66698,'2984:66698',1),
(2990,'Swings',3,20422,'2984:20422',1),
(2992,'Other',3,11759,'170638:11759',1),
(2993,'Belts',3,4250,'11450:4250',1),
(2994,'Gloves',3,4250,'11450:4250',1),
(2996,'Wallets',3,4250,'11450:4250',1),
(3001,'Suits',3,1059,'11450:1059',1),
(3002,'Blazers, Sport Coats',3,1059,'11450:1059',1),
(3003,'Belts',3,4251,'11450:4251',1),
(3009,'Jumpsuits, Rompers & Playsuits',3,15724,'11450:15724',1),
(3034,'Women\'s Shoes',2,11450,'11450',0),
(3075,'Other',3,57881,'11450:57881',1),
(3081,'Blankets & Throws',3,20416,'2984:20416',1),
(3082,'Baby Clothing',2,2984,'2984',0),
(3094,'Crocheting & Knitting',3,160706,'14339:160706',0),
(3097,'Floral Supplies',2,14339,'14339',1),
(3098,'Mixed Regions',3,58507,'11116:58507',1),
(3099,'Glass Art Crafts',2,14339,'14339',1),
(3108,'Needlepoint/Tapestry Patterns',5,183199,'14339:160706:28141:183199',1),
(3109,'Needlepoint/Tapestry Kits',5,183197,'14339:160706:28141:183197',1),
(3110,'Other Quilting Supplies',4,180930,'14339:160737:180930',1),
(3115,'Other Sewing',3,160737,'14339:160737',1),
(3118,'Sewing Machines',3,160737,'14339:160737',1),
(3120,'Craft Shells',4,160704,'14339:28102:160704',1),
(3121,'Other Spinning Supplies',5,183218,'14339:160706:183209:183218',1),
(3122,'Stamping',2,14339,'14339',0),
(3123,'Cards',3,3122,'14339:3122',1),
(3125,'Other Weaving Supplies',4,183233,'14339:160706:183233',1),
(3127,'Woodworking',2,14339,'14339',0),
(3129,'Other Project Kits',4,183151,'14339:3127:183151',1),
(3153,'Horse Riding',2,888,'888',0),
(3155,'Other English Tack',4,3159,'888:3153:3159',1),
(3159,'English Saddles & Tack',3,3153,'888:3153',0),
(3161,'Western Saddles & Tack',3,3153,'888:3153',0),
(3167,'Other Rider Clothing',4,16240,'888:3153:16240',1),
(3173,'Other European',4,45339,'11116:58507:45339',1),
(3177,'Bridles & Headstalls',4,3161,'888:3153:3161',1),
(3179,'Other',3,11815,'170769:11815',1),
(3180,'Other',3,26238,'170638:26238',1),
(3185,'Bushes & Shrubs',5,19617,'11700:159912:181003:19617',1),
(3186,'Other Garden Hand Tools',5,181033,'11700:159912:2032:181033',1),
(3187,'Building Materials & DIY',2,11700,'11700',0),
(3188,'Other Electrical',4,57215,'11700:3187:57215',1),
(3191,'Other',4,20601,'11700:3187:20601',1),
(3193,'Other Mobility & Disability',3,11778,'26395:11778',1),
(3197,'Furniture',2,11700,'11700',0),
(3199,'Bookshelves',3,3197,'11700:3197',1),
(3201,'Other Lighting, Fans',3,20697,'11700:20697',1),
(3211,'Other Supplies',3,20734,'1281:20734',1),
(3213,'Rocks, Fossils, Minerals',2,1,'1',0),
(3215,'Fossils',3,3213,'1:3213',1),
(3220,'Mineral Specimens',3,3213,'1:3213',1),
(3226,'Crystals',3,3213,'1:3213',1),
(3239,'Meteorite',3,3213,'1:3213',1),
(3240,'Other',3,41979,'293:41979',1),
(3243,'Other Pools & Spas',4,20727,'11700:159912:20727',1),
(3244,'Hand Tools',3,631,'11700:631',0),
(3247,'Power Tools',3,631,'11700:631',0),
(3252,'Travel',2,11730,'11730',1),
(3253,'Flights',2,11730,'11730',1),
(3258,'Wholesale, Bulk Lots',2,170638,'170638',1),
(3259,'Wedding',2,11450,'11450',0),
(3265,'Barware',2,1,'1',0),
(3268,'Other Wedding Supplies',3,11827,'11700:11827',1),
(3269,'Other Barware',3,3265,'1:3265',1),
(3270,'Vehicle Electronics & GPS',2,131090,'131090',0),
(3271,'Equalizers',3,14969,'293:14969',1),
(3278,'Other Pro Audio',3,180014,'619:180014',1),
(3281,'Public Address Systems',2,293,'293',1),
(3295,'Personal Organisers',3,58271,'170638:58271',1),
(3298,'Fax Machines',3,50203,'170638:50203',1),
(3299,'Filing Cabinets',3,11828,'170638:11828',1),
(3300,'Other',3,11828,'170638:11828',1),
(3305,'Paper Products',3,58271,'170638:58271',1),
(3314,'Pagers',3,164874,'15032:164874',1),
(3317,'Laserdisc Players',4,175740,'293:183077:175740',1),
(3323,'Lenses',3,78997,'625:78997',1),
(3326,'Vintage Movie & Photography',2,625,'625',0),
(3360,'Other',4,45134,'11116:178078:45134',1),
(3361,'Other',4,39487,'11116:178078:39487',1),
(3372,'Decimal',4,45142,'11116:58520:45142',1),
(3390,'Ireland',4,45148,'11116:58520:45148',1),
(3391,'Japan',4,40711,'11116:58520:40711',1),
(3394,'UK',4,45148,'11116:58520:45148',1),
(3412,'US',4,45338,'11116:58507:45338',1),
(3424,'Australian',3,58507,'11116:58507',1),
(3426,'Canada',4,45338,'11116:58507:45338',1),
(3431,'Other',4,45338,'11116:58507:45338',1),
(3432,'China',4,8008,'11116:58507:8008',1),
(3433,'France',4,45339,'11116:58507:45339',1),
(3434,'Germany',4,45339,'11116:58507:45339',1),
(3437,'Korea',4,8008,'11116:58507:8008',1),
(3438,'Mexico',4,45338,'11116:58507:45338',1),
(3439,'Russia',4,45339,'11116:58507:45339',1),
(3440,'South America',3,58507,'11116:58507',1),
(3452,'Exonumia',2,11116,'11116',0),
(3454,'Medals',3,3452,'11116:3452',1),
(3459,'Cinderellas',3,7898,'260:7898',1),
(3468,'Australia',2,260,'260',0),
(3469,'Other',4,153379,'260:3468:153379',1),
(3470,'Booklets',4,153383,'260:3468:153383',1),
(3471,'Collections, Mixture',4,153383,'260:3468:153383',1),
(3472,'Covers',4,153383,'260:3468:153383',0),
(3473,'First Day Covers',4,153383,'260:3468:153383',0),
(3474,'Flight Covers',4,153383,'260:3468:153383',1),
(3475,'Plate Block, Multiples',4,153383,'260:3468:153383',1),
(3476,'Sheets',4,153383,'260:3468:153383',1),
(3478,'Canada',3,181444,'260:181444',1),
(3489,'Germany & Colonies',3,4742,'260:4742',1),
(3490,'Ireland',3,4742,'260:4742',1),
(3494,'Mexico',3,181444,'260:181444',1),
(3499,'UK',3,4742,'260:4742',1),
(3515,'United Nations',3,181420,'260:181420',1),
(3516,'Manuals & Resources',2,58058,'58058',1),
(3557,'Locks, Keys',3,13849,'1:13849',1),
(3637,'Snowglobes',4,13777,'1:13905:13777',1),
(3668,'Other Computer Cables',3,182094,'58058:182094',1),
(3673,'Other Computer Fans & Cooling',4,42000,'58058:175673:42000',1),
(3676,'Keyboards, Mice & Pointers',2,58058,'58058',0),
(3680,'Graphics Tablets/Boards & Pens',3,3676,'58058:3676',1),
(3702,'Computer Speakers',3,31530,'58058:31530',1),
(3709,'Laptop Docking Stations',3,31530,'58058:31530',1),
(3761,'Video Capture & TV Tuner Cards',3,175673,'58058:175673',1),
(3768,'Office & Business',3,18793,'58058:18793',1),
(3783,'Education, Language, Reference',3,18793,'58058:18793',1),
(3820,'Jewellery Boxes',3,10321,'281:10321',1),
(3825,'Natural Emeralds',5,10218,'281:491:181077:10218',1),
(3826,'Other Opals',5,10239,'281:491:181077:10239',1),
(3827,'Natural Rubies',5,10254,'281:491:181077:10254',1),
(3836,'Other',4,92738,'281:10968:92738',1),
(3858,'Guitars & Basses',2,619,'619',0),
(3860,'Other Continuous Lighting',4,19590,'625:30078:19590',1),
(3885,'Clothing, Fashion',3,34,'1:34',1),
(3913,'Cultural, Religious',2,1,'1',0),
(3919,'Cans',3,562,'1:562',1),
(3920,'Steins, Drinkware',3,562,'1:562',1),
(3937,'Pocket Watches',3,14324,'281:14324',0),
(3938,'Modern',4,3937,'281:14324:3937',1),
(3940,'Antique',4,3937,'281:14324:3937',1),
(3944,'Coin-Operated',2,1249,'1249',0),
(4002,'Australiana',3,3913,'1:3913',1),
(4036,'Schools',3,13877,'1:13877',1),
(4037,'Fans',3,13905,'1:13905',1),
(4038,'Firefighting',3,13877,'1:13877',1),
(4049,'Salt & Pepper Shakers',3,13905,'1:13905',0),
(4050,'Souvenir',4,4049,'1:13905:4049',1),
(4051,'Singles',4,4049,'1:13905:4049',1),
(4053,'Electric Lamps',4,1404,'1:13905:1404',0),
(4056,'Table',5,4053,'1:13905:1404:4053',1),
(4057,'Non-Electric Lamps',4,1404,'1:13905:1404',0),
(4059,'Kerosene',5,4057,'1:13905:1404:4057',1),
(4061,'Oil',5,4057,'1:13905:1404:4057',1),
(4065,'Medical, Dental',3,412,'1:412',1),
(4093,'Comic',4,914,'1:124:914',1),
(4094,'Sports',4,914,'1:124:914',1),
(4097,'Pez',2,1,'1',1),
(4115,'Scales',3,13905,'1:13905',1),
(4117,'Matchboxes',3,593,'1:593',1),
(4118,'Pipes',3,593,'1:593',1),
(4122,'Mechanics',3,13849,'1:13849',1),
(4125,'Hardware',4,1444,'1:417:1444',1),
(4135,'Tickets',4,1444,'1:417:1444',1),
(4149,'Other',4,19151,'220:180250:19151',1),
(4150,'Other Transportation',3,417,'1:417',1),
(4155,'Sets',3,597,'1:597',1),
(4172,'Pacific Islands & Oceania',3,2207,'20081:2207',1),
(4173,'Native American',3,2207,'20081:2207',1),
(4174,'Other Art',2,550,'550',1),
(4175,'Brass',4,1211,'20081:20086:1211',1),
(4176,'Gold',4,1211,'20081:20086:1211',1),
(4186,'Sweden',4,45148,'11116:58520:45148',1),
(4193,'Other Vintage Computing',3,11189,'58058:11189',1),
(4195,'Tanzanite',4,181077,'281:491:181077',1),
(4196,'Fine Jewellery',2,281,'281',0),
(4201,'Film',3,69323,'625:69323',1),
(4220,'Coalport',3,24,'870:24',1),
(4221,'Colclough',3,24,'870:24',1),
(4222,'Crown Ducal',3,24,'870:24',1),
(4223,'James Kent',3,24,'870:24',1),
(4224,'J & G Meakin',3,24,'870:24',1),
(4226,'Mikasa',3,24,'870:24',1),
(4227,'Tableware',4,64961,'870:24:64961',1),
(4228,'Royal Copenhagen',3,24,'870:24',1),
(4229,'Royal Standard',3,24,'870:24',1),
(4230,'Royal Winton, Grimwades',3,24,'870:24',1),
(4231,'Royal Worcester',3,24,'870:24',1),
(4233,'Grindley',3,24,'870:24',1),
(4240,'Golf Cards',3,212,'888:212',1),
(4249,'Character Figurines',3,1188,'220:1188',1),
(4250,'Men\'s Accessories',2,11450,'11450',0),
(4251,'Women\'s Accessories',2,11450,'11450',0),
(4301,'Pokémon Sealed Booster Packs',4,183466,'220:2536:183466',1),
(4318,'Modern [Post-1980]',4,28811,'220:183446:28811',1),
(4369,'Other',4,8008,'11116:58507:8008',1),
(4379,'Australian',3,238,'237:238',1),
(4388,'Hockey',2,888,'888',0),
(4616,'Webcams',3,31530,'58058:31530',1),
(4626,'Antique Reproductions',3,238,'237:238',1),
(4631,'International',3,238,'237:238',1),
(4644,'Natural Sapphires',5,10259,'281:491:181077:10259',1),
(4660,'Other Electronic Components',4,182412,'170769:92074:182412',1),
(4662,'Capacitors',4,182412,'170769:92074:182412',1),
(4666,'Transistors',5,36330,'170769:92074:182412:36330',1),
(4670,'Ham, Amateur Radio',3,1500,'293:1500',0),
(4672,'Ham, Amateur Radio Antennas',4,183502,'293:1500:183502',1),
(4673,'Ham Radio Receivers',4,4670,'293:1500:4670',1),
(4675,'Ham Radio Transmitters',4,4670,'293:1500:4670',1),
(4678,'Other Test Meters & Detectors',5,181968,'170769:92074:181939:181968',1),
(4684,'Camera Manuals & Guides',2,625,'625',1),
(4689,'Movie Cameras',3,69323,'625:69323',1),
(4690,'Movie Camera Accessories',3,69323,'625:69323',1),
(4692,'Stereo Cameras',4,101643,'625:3326:101643',1),
(4701,'Other Vintage Cameras',4,101643,'625:3326:101643',1),
(4702,'Vintage Parts & Accessories',3,3326,'625:3326',1),
(4707,'Architectural, Garden',2,20081,'20081',1),
(4713,'Bass Guitars',3,3858,'619:3858',1),
(4733,'Ancient',3,58520,'11116:58520',1),
(4742,'Europe',2,260,'260',0),
(4744,'Belgium & Colonies',3,4742,'260:4742',1),
(4749,'Switzerland',3,4742,'260:4742',1),
(4751,'Postal Stationery',3,7898,'260:7898',1),
(4752,'Topics',2,260,'260',0),
(4753,'Animation, Cartoons',3,4752,'260:4752',1),
(4764,'Pressed Glass',3,50693,'870:50693',1),
(4776,'Shelley',3,24,'870:24',1),
(4779,'Cars',3,2616,'220:2616',1),
(4785,'Mixers',3,180014,'619:180014',1),
(4787,'Compact & Shelf Stereos',3,14969,'293:14969',1),
(4790,'Movie Editing Equipment',3,69323,'625:69323',1),
(4844,'Other',3,11514,'11450:11514',1),
(4935,'Uranium, Vaseline',3,50693,'870:50693',1),
(4939,'Other',4,21225,'888:106465:21225',1),
(4941,'Other European',4,45148,'11116:58520:45148',1),
(4959,'Flowers, Floral Décor',3,10033,'11700:10033',1),
(4978,'Other',4,122601,'220:180250:122601',1),
(6030,'Car, Truck Parts',2,131090,'131090',0),
(6049,'Trucks, Commercial Vehicles',2,9800,'9800',1),
(6072,'Dependencies',4,153383,'260:3468:153383',1),
(6073,'KGV Heads',4,153383,'260:3468:153383',1),
(6074,'Blocks, Sets, Sheets',5,111866,'260:3468:153383:111866',1),
(6075,'Sets',5,111860,'260:3468:153383:111860',1),
(6093,'Memorabilia',3,20862,'888:20862',1),
(6747,'Clothing, Merchandise, Media',2,131090,'131090',0),
(6752,'Shirts',4,34352,'131090:6747:34352',1),
(6753,'Other Clothing & Merchandise',3,6747,'131090:6747',1),
(6763,'Other',3,6030,'131090:6030',1),
(6778,'Oil Pumps',4,33612,'131090:6030:33612',1),
(6779,'Other',4,33718,'131090:6030:33718',1),
(6781,'Other',4,33683,'131090:6030:33683',1),
(7111,'Beanie Kids',3,49019,'220:49019',1),
(7266,'Other Guitar Accessories',4,180009,'619:3858:180009',1),
(7269,'Christmas Lights',4,42154,'11700:159912:42154',1),
(7275,'Parts, Accessories',4,931,'1:29832:931',1),
(7276,'Other',4,19116,'220:180250:19116',1),
(7278,'Pens',3,966,'1:966',0),
(7282,'Pencils',3,966,'1:966',1),
(7286,'Crystals & Oscillators',5,182415,'170769:92074:182412:182415',1),
(7288,'Inductors, Coils & Filters',5,182415,'170769:92074:182412:182415',1),
(7291,'Waterford',5,153371,'870:50693:170514:153371',1),
(7294,'Cycling',2,888,'888',0),
(7300,'Crankbaits',4,179961,'888:1492:179961',1),
(7301,'Hunting',2,888,'888',0),
(7303,'Clothing',4,36239,'888:7301:36239',1),
(7315,'Other',4,180278,'220:222:180278',1),
(7317,'Game Pieces & Parts',3,233,'220:233',1),
(7318,'Other Accessories',4,137902,'220:2616:137902',1),
(7320,'Buttons',4,183253,'14339:160737:183253',1),
(7389,'Other Warhammer',5,31398,'220:233:16486:31398',1),
(7886,'Monaco',3,4742,'260:4742',1),
(7891,'Hungary',3,4742,'260:4742',1),
(7898,'Philately',2,260,'260',0),
(7903,'Europa CEPT',3,4742,'260:4742',1),
(7908,'Philatelic Covers',3,181420,'260:181420',1),
(7921,'Collections, Mixture',3,181420,'260:181420',1),
(7937,'Other',3,7898,'260:7898',1),
(7992,'Mexico',4,45145,'11116:58520:45145',1),
(8008,'Asia',3,58507,'11116:58507',0),
(8384,'Spirits & Liqueurs',3,179836,'14308:179836',1),
(8409,'Other Rugs & Carpets',3,20571,'11700:20571',1),
(8434,'Foam Sheets',4,160704,'14339:28102:160704',1),
(8439,'Other Seeds & Bulbs',5,40605,'11700:159912:181003:40605',1),
(8444,'Other',3,20754,'1281:20754',1),
(8504,'Other Camping',3,16034,'888:16034',1),
(8575,'Manga',2,267,'267',1),
(8616,'Simpsons',3,13658,'1:13658',1),
(9037,'Other',4,180509,'220:180250:180509',1),
(9041,'Other',4,30654,'220:180250:30654',1),
(9045,'Figures & People',5,81055,'220:180250:19119:81055',1),
(9047,'Books & Guides',3,180250,'220:180250',0),
(9049,'Books',4,9047,'220:180250:9047',1),
(9051,'Other',4,9047,'220:180250:9047',1),
(9161,'Other Radio & Electronics',5,19839,'220:2562:182187:19839',1),
(9355,'Mobile Phones',2,15032,'15032',1),
(9394,'Mobile Accessories',2,15032,'15032',0),
(9425,'Home Telephone Parts',3,164874,'15032:164874',1),
(9426,'Other',3,164874,'15032:164874',1),
(9723,'Stepper Motors',4,181730,'170769:42892:181730',1),
(9800,'Cars, Bikes, Boats',1,-1,'',0),
(9946,'Other',3,14780,'131090:14780',1),
(10025,'Sundials',4,20498,'11700:159912:20498',1),
(10033,'Home Décor',2,11700,'11700',0),
(10034,'Other Home Décor',3,10033,'11700:10033',1),
(10035,'Other Patio & Garden Furniture',4,25863,'11700:159912:25863',1),
(10064,'Pocket Bike Accessories',2,131090,'131090',1),
(10073,'Vintage Car & Truck Parts',3,6030,'131090:6030',1),
(10173,'Other Accessories',4,181254,'619:180012:181254',1),
(10175,'Other Drums',4,181227,'619:180012:181227',1),
(10177,'Banjos',4,181282,'619:180016:181282',1),
(10178,'Cellos',4,181281,'619:180016:181281',1),
(10179,'Mandolins',4,181282,'619:180016:181282',1),
(10181,'Wind & Woodwind',2,619,'619',0),
(10183,'Flutes',4,181267,'619:10181:181267',1),
(10185,'Agate',4,181077,'281:491:181077',1),
(10190,'Alexandrite',4,181077,'281:491:181077',1),
(10191,'Amber',4,181077,'281:491:181077',1),
(10192,'Amethyst',4,181077,'281:491:181077',1),
(10200,'Aquamarine',4,181077,'281:491:181077',1),
(10205,'Citrine',4,181077,'281:491:181077',1),
(10210,'Loose Diamonds',3,491,'281:491',1),
(10218,'Emerald',4,181077,'281:491:181077',0),
(10224,'Other Garnets',5,181085,'281:491:181077:181085',1),
(10231,'Other Jade',5,181087,'281:491:181077:181087',1),
(10235,'Lapis Lazuli',4,181077,'281:491:181077',1),
(10236,'Malachite',4,181077,'281:491:181077',1),
(10237,'Moonstone',4,181077,'281:491:181077',1),
(10238,'Onyx',4,181077,'281:491:181077',1),
(10239,'Opal',4,181077,'281:491:181077',0),
(10240,'Doublets',5,10239,'281:491:181077:10239',1),
(10241,'Triplets',5,10239,'281:491:181077:10239',1),
(10243,'Pearl',4,181077,'281:491:181077',1),
(10247,'Peridot',4,181077,'281:491:181077',1),
(10252,'Other Quartz',5,181097,'281:491:181077:181097',1),
(10254,'Ruby',4,181077,'281:491:181077',0),
(10259,'Sapphire',4,181077,'281:491:181077',0),
(10270,'Topaz',4,181077,'281:491:181077',1),
(10278,'Tourmaline',4,181077,'281:491:181077',1),
(10284,'Turquoise',4,181077,'281:491:181077',1),
(10286,'Zircon',4,181077,'281:491:181077',1),
(10290,'Men\'s Jewellery',2,281,'281',0),
(10298,'Tie Pins, Tie Bars',3,10290,'281:10290',1),
(10321,'Jewellery Boxes & Organisers',2,281,'281',0),
(10322,'Chains',4,164353,'281:164352:164353',1),
(10323,'Other Tools',4,34082,'281:164352:34082',1),
(10324,'Other',5,63200,'281:14324:173696:63200',1),
(10326,'Chains',5,63200,'281:14324:173696:63200',1),
(10328,'Fobs',5,63200,'281:14324:173696:63200',1),
(10329,'Pendant Watches',3,14324,'281:14324',1),
(10542,'Real Estate',2,11700,'11700',1),
(10793,'Coffee, Tea',3,34,'1:34',1),
(10860,'Fantasy, Magic',2,1,'1',0),
(10861,'Other Dragons',4,35863,'1:10860:35863',1),
(10862,'Unicorns',3,10860,'1:10860',1),
(10900,'Paint by Numbers Kits',4,28110,'14339:11783:28110',1),
(10902,'Ice Buckets',3,3265,'1:3265',1),
(10903,'Pourers, Stoppers',3,3265,'1:3265',1),
(10904,'Shakers',3,3265,'1:3265',1),
(10905,'Swizzle, Stir Sticks',3,3265,'1:3265',1),
(10911,'Egyptian',3,3913,'1:3913',1),
(10917,'Candles, Holders',4,13777,'1:13905:13777',1),
(10968,'Fashion Jewellery',2,281,'281',0),
(10975,'Bracelets',3,4196,'281:4196',1),
(10985,'Earrings',3,4196,'281:4196',1),
(11008,'Brooches',3,4196,'281:4196',1),
(11071,'Televisions',2,172176,'172176',1),
(11104,'Cook Books',2,267,'267',1),
(11116,'Coins',1,-1,'',0),
(11118,'Japanese, Anime',3,13658,'1:13658',0),
(11144,'Rods',4,180001,'888:1492:180001',1),
(11161,'Other Blank Media & Accs',4,80133,'58058:165:80133',1),
(11175,'Other Enterprise Networking',3,175698,'58058:175698',1),
(11176,'Home Networking & Connectivity',2,58058,'58058',0),
(11180,'Network Hubs',4,182091,'58058:175698:182091',1),
(11183,'Wired Routers',3,11176,'58058:11176',1),
(11189,'Vintage Computing',2,58058,'58058',0),
(11195,'Printer Ink, Toner & Paper',3,171961,'58058:171961',0),
(11197,'Feeders & Trays',4,182086,'58058:171961:182086',1),
(11202,'Ink Ribbons',4,11195,'58058:171961:11195',1),
(11205,'Scanners',3,171961,'58058:171961',1),
(11209,'Other Network Disk Arrays',4,182093,'58058:175698:182093',1),
(11210,'Server Memory (RAM)',4,51240,'58058:175698:51240',1),
(11211,'Servers',4,175700,'58058:175698:175700',1),
(11226,'Operating Systems',3,18793,'58058:18793',1),
(11232,'Movies',1,-1,'',0),
(11233,'Music',1,-1,'',0),
(11236,'Suitcases',3,16080,'11730:16080',1),
(11312,'Tribal, Ethnic Jewellery',2,281,'281',1),
(11329,'Other',3,11330,'888:11330',1),
(11330,'Scooters',2,888,'888',0),
(11331,'Push Scooters',3,11330,'888:11330',1),
(11332,'Accessories, Parts',3,11330,'888:11330',1),
(11424,'Evangelion',4,11118,'1:13658:11118',1),
(11450,'Clothing, Shoes, Accessories',1,-1,'',0),
(11452,'Boy\'s Clothing',2,11450,'11450',0),
(11462,'Girl\'s Clothing',2,11450,'11450',0),
(11467,'Other',3,15628,'11450:15628',1),
(11483,'Jeans',3,1059,'11450:1059',1),
(11484,'Jumpers',3,1059,'11450:1059',1),
(11498,'Boots',3,93427,'11450:93427',1),
(11501,'Occupational',3,93427,'11450:93427',1),
(11504,'Sandals, Flip-Flops',3,93427,'11450:93427',1),
(11505,'Slippers',3,93427,'11450:93427',1),
(11507,'Underwear',3,1059,'11450:1059',1),
(11510,'Sleepwear',3,1059,'11450:1059',1),
(11511,'Socks',3,1059,'11450:1059',1),
(11514,'Women\'s Lingerie, Intimates',2,11450,'11450',0),
(11517,'Bras',3,172378,'2984:172378',1),
(11521,'Camisoles',3,11514,'11450:11514',1),
(11522,'Corsets, Bustiers',3,11514,'11450:11514',1),
(11523,'Other',4,11524,'11450:15724:11524',1),
(11524,'Hosiery',3,15724,'11450:15724',0),
(11525,'Pantyhose & Tights',4,11524,'11450:15724:11524',1),
(11527,'Stockings',4,11524,'11450:15724:11524',1),
(11530,'Shapewear',3,11514,'11450:11514',1),
(11532,'Slips',3,11514,'11450:11514',1),
(11534,'Dresses',3,172378,'2984:172378',1),
(11535,'Jeans',3,172378,'2984:172378',1),
(11536,'Skirts',3,172378,'2984:172378',1),
(11538,'Jumpers',3,172378,'2984:172378',1),
(11554,'Jeans',3,15724,'11450:15724',1),
(11555,'Shorts',3,15724,'11450:15724',1),
(11632,'Slippers',3,3034,'11450:3034',1),
(11635,'Corkscrews',3,3265,'1:3265',1),
(11644,'Other',5,180280,'220:180250:19128:180280',1),
(11647,'Figures & People',5,180280,'220:180250:19128:180280',1),
(11648,'Scenery & Trees',5,180280,'220:180250:19128:180280',1),
(11650,'Small Appliances',3,13905,'1:13905',1),
(11657,'Tupperware',3,13905,'1:13905',1),
(11658,'Utensils',3,13905,'1:13905',1),
(11660,'Cutlery',3,13905,'1:13905',1),
(11671,'Cigar-Related',3,593,'1:593',1),
(11695,'Patterns',3,2408,'237:2408',1),
(11700,'Home & Garden',1,-1,'',0),
(11702,'Other',4,20605,'11700:299:20605',1),
(11703,'Individual Containers',4,20652,'11700:20625:20652',1),
(11704,'Other',3,631,'11700:631',1),
(11705,'Other Parts, Accessories',4,164613,'11700:631:164613',1),
(11711,'Calculators',3,14948,'293:14948',1),
(11716,'Box Cameras',4,101643,'625:3326:101643',1),
(11717,'Folding Cameras',4,101643,'625:3326:101643',1),
(11718,'Instant Cameras',4,101643,'625:3326:101643',1),
(11719,'Movie Cameras',4,101643,'625:3326:101643',1),
(11720,'SLR Cameras',4,101643,'625:3326:101643',1),
(11721,'TLR Cameras',4,101643,'625:3326:101643',1),
(11722,'Vintage Projectors & Screens',3,3326,'625:3326',1),
(11724,'Camcorders',2,625,'625',1),
(11725,'DVRs, Hard Drive Recorders',2,172176,'172176',1),
(11730,'Tickets, Travel',1,-1,'',0),
(11731,'Educational Toys',2,220,'220',0),
(11732,'Alphabet',3,11731,'220:11731',1),
(11733,'Geography',3,11731,'220:11731',1),
(11735,'Music',3,11731,'220:11731',1),
(11736,'Reading, Writing',3,11731,'220:11731',1),
(11737,'Other Science',4,83756,'220:11731:83756',1),
(11739,'Magic',2,220,'220',1),
(11740,'Play-Doh',3,19169,'220:19169',1),
(11742,'Other Outdoor Toys',3,11743,'220:11743',1),
(11743,'Outdoor Toys',2,220,'220',0),
(11745,'Water Guns',3,11743,'220:11743',1),
(11748,'Farming & Agriculture',2,170769,'170769',0),
(11751,'Other',4,46526,'170769:11748:46526',1),
(11752,'Other Implements & Attachments',4,177647,'170769:41489:177647',1),
(11753,'Manuals',4,135245,'170769:11748:135245',1),
(11759,'Websites & Businesses for Sale',2,170638,'170638',0),
(11761,'Shops',3,11759,'170638:11759',1),
(11762,'Service Businesses',3,11759,'170638:11759',1),
(11766,'Other',3,177641,'170769:177641',1),
(11774,'Other Welding Equipment',4,34095,'170769:182941:34095',1),
(11776,'Vitamins & Minerals',3,180959,'26395:180959',1),
(11777,'Magnetic Therapy Devices',3,67659,'26395:67659',1),
(11778,'Medical, Mobility & Disability',2,26395,'26395',0),
(11779,'Other First Aid',4,180931,'26395:67588:180931',1),
(11781,'Other Weight Management',4,31817,'26395:180959:31817',1),
(11783,'Art Supplies',2,14339,'14339',0),
(11784,'Other Drawing Supplies',4,183081,'14339:11783:183081',1),
(11785,'Other Painting Supplies',4,28110,'14339:11783:28110',1),
(11787,'Mosaic',2,14339,'14339',0),
(11788,'Scrapbooking & Paper Crafts',2,14339,'14339',0),
(11789,'Scrapbooking & Card Kits',3,11788,'14339:11788',1),
(11790,'Craft Markers & Pens',3,28102,'14339:28102',1),
(11793,'Paper Punches',5,83981,'14339:11788:31253:83981',1),
(11794,'Stickers',4,160704,'14339:28102:160704',1),
(11808,'Sealing Machines',2,170638,'170638',1),
(11812,'Glassware',3,11815,'170769:11815',1),
(11813,'Microscope Parts, Accessories',3,11815,'170769:11815',1),
(11815,'Medicine, Science',2,170769,'170769',0),
(11817,'Medical Equipment',3,11815,'170769:11815',1),
(11827,'Wedding Supplies',2,11700,'11700',0),
(11828,'Office Furniture',2,170638,'170638',0),
(11829,'Bookshelves',3,11828,'170638:11828',1),
(11832,'Desks',3,11828,'170638:11828',1),
(11837,'Other Bath & Body',3,11838,'26395:11838',1),
(11838,'Bath & Body',2,26395,'26395',0),
(11840,'Other Shaving & Hair Removal',3,31762,'26395:31762',1),
(11841,'Body Lotions & Moisturisers',3,11838,'26395:11838',1),
(11843,'Other Dental & Oral Care',3,31769,'26395:31769',1),
(11844,'Men\'s Shavers',4,180512,'26395:31762:180512',1),
(11848,'Women\'s Fragrances',3,180345,'26395:180345',1),
(11854,'Hair Care & Styling',2,26395,'26395',0),
(11855,'Brushes & Combs',3,11854,'26395:11854',1),
(11858,'Hair Dryers',3,11854,'26395:11854',1),
(11860,'Styling Products',3,11854,'26395:11854',1),
(11862,'Other Skin Care',3,11863,'26395:11863',1),
(11863,'Skin Care',2,26395,'26395',0),
(11864,'Blush',4,172025,'26395:31786:172025',1),
(11865,'Concealer',4,172025,'26395:31786:172025',1),
(11869,'Mascara',4,172020,'26395:31786:172020',1),
(11870,'Other Nail Care',3,47945,'26395:47945',1),
(11872,'Manicure/Pedicure Tools & Kits',3,47945,'26395:47945',1),
(11873,'Nail Polish',3,47945,'26395:47945',1),
(11874,'Restaurants',2,170638,'170638',0),
(11879,'Flatware',4,25381,'170638:11874:25381',1),
(11883,'Tables',4,57093,'170638:11874:57093',1),
(11884,'Glassware',4,25381,'170638:11874:25381',1),
(11885,'Other',4,50935,'170638:11874:50935',1),
(11887,'Dinnerware',4,25381,'170638:11874:25381',1),
(11890,'Shop Equipment',2,170638,'170638',0),
(11891,'Cash Registers',3,71465,'170638:71465',1),
(11896,'Other',3,170211,'170638:170211',1),
(11897,'Safety',2,170769,'170769',0),
(11901,'Protective Gear',3,11897,'170769:11897',1),
(11906,'Safes',3,170211,'170638:170211',1),
(11907,'Telephone Systems',2,170638,'170638',0),
(11908,'Phone Systems, PBXs',3,11907,'170638:11907',1),
(11909,'Business Telephones',3,11907,'170638:11907',1),
(11951,'Nickels',5,253,'11116:58520:45145:253',1),
(11956,'Dimes',5,253,'11116:58520:45145:253',1),
(11962,'Quarters',5,253,'11116:58520:45145:253',1),
(11968,'Halves',5,253,'11116:58520:45145:253',1),
(11975,'Dollars',5,253,'11116:58520:45145:253',1),
(11985,'Mixed Makeup',3,31786,'26395:31786',1),
(12040,'Audio/Video Remotes',4,60207,'131090:3270:60207',1),
(12317,'Rock Crystal (Colourless)',5,181097,'281:491:181077:181097',1),
(12513,'Furniture',3,13905,'1:13905',1),
(12519,'Other',3,110633,'281:110633',1),
(12521,'Beswick',3,24,'870:24',1),
(12563,'Italy',3,4742,'260:4742',1),
(12580,'Grinding Machines',3,177641,'170769:177641',1),
(12582,'Inspection, Measurement',3,177644,'170769:177644',1),
(12584,'Mills & Milling Machines',3,177641,'170769:177641',1),
(12821,'Africa',3,58507,'11116:58507',1),
(12921,'Stage Lighting Systems & Kits',3,12922,'619:12922',1),
(12922,'Stage Lighting & Effects',2,619,'619',0),
(12930,'Parts & Accessories',3,12922,'619:12922',1),
(13289,'Other',4,13290,'220:180250:13290',1),
(13290,'1 Gauge',3,180250,'220:180250',0),
(13294,'Other',5,81055,'220:180250:19119:81055',1),
(13340,'Tennis',2,888,'888',0),
(13343,'Racquet Strings',3,13340,'888:13340',1),
(13360,'Other',5,40883,'888:15273:158913:40883',1),
(13362,'Other Fitness, Running & Yoga',3,15273,'888:15273',1),
(13376,'Other Driving Equipment',4,85178,'888:3153:85178',1),
(13550,'Bottle Caps',3,562,'1:562',1),
(13551,'Mirrors',3,3265,'1:3265',1),
(13559,'American',5,27371,'131090:6747:50428:27371',1),
(13565,'Asian',5,27371,'131090:6747:50428:27371',1),
(13566,'British',5,27371,'131090:6747:50428:27371',1),
(13582,'European',5,27371,'131090:6747:50428:27371',1),
(13595,'Household',3,34,'1:34',1),
(13640,'Gargoyles',3,10860,'1:10860',1),
(13641,'Mermaids',3,10860,'1:10860',1),
(13658,'Animation Art',2,1,'1',0),
(13673,'Smurfs',3,13658,'1:13658',1),
(13674,'Warner Brothers',3,13658,'1:13658',1),
(13718,'Arcade Machine Accessories',2,1249,'1249',1),
(13721,'Jukeboxes',2,1,'1',1),
(13724,'Pinball',3,3944,'1249:3944',1),
(13765,'Pacific',3,3913,'1:3913',1),
(13777,'Decorative Ornaments',3,13905,'1:13905',0),
(13815,'Limoges',3,24,'870:24',1),
(13836,'Spoons',4,13777,'1:13905:13777',1),
(13849,'Tools, Hardware, Locks',2,1,'1',0),
(13862,'Ceiling Fixtures, Chandeliers',4,1404,'1:13905:1404',1),
(13863,'Torches',2,293,'293',1),
(13865,'Parts, Accessories',4,1404,'1:13905:1404',1),
(13870,'Woodwork, Carpentry',3,13849,'1:13849',1),
(13871,'Chisels',3,13849,'1:13849',1),
(13872,'Drills',3,13849,'1:13849',1),
(13874,'Planes',3,13849,'1:13849',1),
(13875,'Saws',3,13849,'1:13849',1),
(13877,'Historical Memorabilia',2,1,'1',0),
(13879,'Fairs, Expos',3,13877,'1:13877',1),
(13885,'Boy Scouts',3,13877,'1:13877',1),
(13891,'Girl Guides',3,13877,'1:13877',1),
(13897,'Political',3,13877,'1:13877',1),
(13905,'Homeware, Kitchenware',2,1,'1',0),
(13906,'Bar Sets',3,3265,'1:3265',1),
(13907,'Coasters',3,3265,'1:3265',1),
(13912,'Jugs, Jars',3,29797,'1:29797',1),
(13925,'Mixing Bowls',3,13905,'1:13905',1),
(13926,'Moulds',3,13905,'1:13905',1),
(13927,'Napkin Holders',3,13905,'1:13905',1),
(13929,'Range Sets',4,4049,'1:13905:4049',1),
(13933,'Kettles, Tea Pots',3,13905,'1:13905',1),
(13956,'Militaria',2,1,'1',0),
(13962,'1914 - 1918 (WWI)',3,13956,'1:13956',1),
(13977,'1939 - 1945 (WWII)',3,13956,'1:13956',1),
(13989,'Brochures',3,124,'1:124',1),
(13992,'Newspapers',3,124,'1:124',1),
(13997,'Hotel, Restaurant',4,914,'1:124:914',1),
(13998,'Royalty',4,914,'1:124:914',1),
(13999,'Fountain',4,7278,'1:966:7278',1),
(14012,'Magic',3,10860,'1:10860',1),
(14020,'Science',3,412,'1:412',1),
(14024,'Automobilia',3,417,'1:417',1),
(14028,'Clothing & Hats',4,50428,'131090:6747:50428',1),
(14049,'Aviation',3,417,'1:417',0),
(14052,'Nautical',3,417,'1:417',1),
(14062,'Hat Boxes',4,182059,'11450:175759:182059',1),
(14070,'Ties, Bow Ties & Cravats',4,182059,'11450:175759:182059',1),
(14081,'Hand Mirrors',3,597,'1:597',1),
(14085,'Earrings, Studs',3,10290,'281:10290',1),
(14109,'Other Golf Training Aids',4,181129,'888:1513:181129',1),
(14112,'Test Auctions',2,99,'99',0),
(14277,'Photographic Images',3,170281,'1:170281',1),
(14295,'Laptop Batteries',3,31530,'58058:31530',1),
(14308,'Alcohol & Food',1,-1,'',0),
(14310,'Desserts',2,14308,'14308',1),
(14311,'Jams, Preserves',2,14308,'14308',1),
(14313,'Oils, Condiments, Sauces',2,14308,'14308',1),
(14314,'Spices, Seasonings',2,14308,'14308',1),
(14324,'Watches, Parts & Accessories',2,281,'281',0),
(14339,'Crafts',1,-1,'',0),
(14733,'Polly Pocket',3,238,'237:238',1),
(14737,'Steam Powered',3,19071,'220:19071',1),
(14780,'Motorcycle Parts',2,131090,'131090',0),
(14879,'Other',3,41964,'11450:41964',1),
(14883,'Other Home Wholesale',3,31605,'11700:31605',1),
(14884,'Other Wholesale',3,40131,'281:40131',1),
(14898,'Egg Cups',3,13905,'1:13905',1),
(14901,'Serving Trays',3,13905,'1:13905',1),
(14906,'Vintage Manuals & Merchandise',3,11189,'58058:11189',1),
(14936,'Car Speakers & Speaker Systems',4,175716,'131090:3270:175716',1),
(14948,'Gadgets & Other Electronics',2,293,'293',0),
(14954,'Laser Pointers',3,14948,'293:14948',1),
(14955,'Metal Detectors',3,14948,'293:14948',1),
(14961,'Accessories',2,293,'293',0),
(14962,'Audio Tapes',4,94893,'293:14961:94893',1),
(14964,'Audio Cables & Adapters',3,71582,'172176:71582',1),
(14969,'Home Audio Stereos, Components',2,293,'293',0),
(14970,'Amplifiers & Preamps',3,14969,'293:14969',1),
(14971,'CD Players & Recorders',3,14969,'293:14969',1),
(14981,'Receivers',3,14969,'293:14969',1),
(14985,'DJ & Monitoring Headphones',3,48458,'619:48458',1),
(14990,'Home Speakers & Subwoofers',3,14969,'293:14969',1),
(15032,'Phones & Accessories',1,-1,'',0),
(15048,'Caller ID Units',3,164874,'15032:164874',1),
(15050,'Manuals & Magazines',4,183503,'293:1500:183503',1),
(15051,'Shortwave Radio',3,1500,'293:1500',1),
(15052,'Portable Audio & Headphones',2,293,'293',0),
(15053,'Personal Cassette Players',3,15052,'293:15052',1),
(15054,'Personal CD Players',3,15052,'293:15052',1),
(15088,'VCRs',2,172176,'172176',1),
(15124,'Body Jewellery',2,281,'281',0),
(15199,'Multi-Track Recorders',3,180014,'619:180014',1),
(15200,'Camera & Photo Accessories',2,625,'625',0),
(15216,'Filters',3,78997,'625:78997',1),
(15226,'Photographic Paper',4,182077,'625:69323:182077',1),
(15230,'Film Cameras',3,69323,'625:69323',1),
(15250,'Slide & Movie Projection',3,69323,'625:69323',0),
(15251,'Projector Bulbs & Lamps',4,15250,'625:69323:15250',1),
(15252,'Movie Projectors',4,15250,'625:69323:15250',1),
(15256,'Slide Projectors',4,15250,'625:69323:15250',1),
(15257,'Other Slide & Movie Projection',4,15250,'625:69323:15250',1),
(15262,'Personal Floatation Devices',4,166096,'888:23806:166096',1),
(15273,'Fitness, Running & Yoga',2,888,'888',0),
(15274,'Abdominal Machines',4,28064,'888:15273:28064',1),
(15277,'Heart Rate Monitors',4,44075,'888:15273:44075',1),
(15280,'Treadmills',4,28059,'888:15273:28059',1),
(15281,'Benches',4,28066,'888:15273:28066',1),
(15528,'Child Seats',4,177832,'888:7294:177832',1),
(15559,'Nappies (Disposable)',3,26268,'2984:26268',1),
(15615,'Shorts',3,11452,'11450:11452',1),
(15620,'Mixed Items & Lots',3,11452,'11450:11452',1),
(15628,'Girl\'s Accessories',2,11450,'11450',0),
(15629,'Purses & Wallets',3,15628,'11450:15628',1),
(15630,'Hats',3,15628,'11450:15628',1),
(15633,'Mixed Items & Lots',3,15628,'11450:15628',1),
(15648,'Shorts',3,11462,'11450:11462',1),
(15652,'Mixed Items & Lots',3,11462,'11450:11462',1),
(15662,'Ties',3,4250,'11450:4250',1),
(15687,'T-Shirts',3,1059,'11450:1059',1),
(15689,'Shorts',3,1059,'11450:1059',1),
(15690,'Swimwear',3,1059,'11450:1059',1),
(15691,'Vests',3,1059,'11450:1059',1),
(15709,'Athletic',3,93427,'11450:93427',1),
(15718,'Garters',4,106127,'11450:3259:106127',1),
(15719,'Veils, Tiaras',4,106127,'11450:3259:106127',1),
(15720,'Wedding Dresses',3,3259,'11450:3259',1),
(15724,'Women\'s Clothing',2,11450,'11450',0),
(15746,'Mixed Items',3,11514,'11450:11514',1),
(15747,'Shorts',3,172378,'2984:172378',1),
(15748,'Swimwear',3,172378,'2984:172378',1),
(15751,'Breastfeeding',3,172378,'2984:172378',1),
(15754,'Mixed Items',3,172378,'2984:172378',1),
(15775,'Vests',3,15724,'11450:15724',1),
(15958,'Clothing',3,329,'237:329',1),
(16021,'Baseball & Softball',2,888,'888',0),
(16030,'Gloves, Mitts',3,16021,'888:16021',1),
(16034,'Camping, Hiking',2,888,'888',0),
(16036,'Other Camping Cooking Supplies',4,181381,'888:16034:181381',1),
(16037,'Flashlights',4,106983,'888:16034:106983',1),
(16038,'Camping Furniture',3,16034,'888:16034',1),
(16039,'Generators & Heaters',3,16034,'888:16034',1),
(16040,'Other Sleeping Gear',4,181403,'888:16034:181403',1),
(16043,'Lacrosse',2,888,'888',1),
(16044,'Other Boxing & Martial Arts',3,179767,'888:179767',1),
(16045,'Paintball',2,888,'888',1),
(16052,'Scuba, Snorkeling',2,888,'888',0),
(16053,'Buoyancy Compensators (BCD)',3,16052,'888:16052',1),
(16054,'Fins',3,16052,'888:16052',1),
(16056,'Regulators',3,16052,'888:16052',1),
(16057,'Tanks',3,16052,'888:16052',1),
(16059,'Skiing Equipment',3,36259,'888:36259',0),
(16060,'Other Clothing',4,21233,'888:36259:21233',1),
(16064,'Softballs',4,181313,'888:16021:181313',1),
(16080,'Luggage',2,11730,'11730',0),
(16081,'Backpacks',3,16080,'11730:16080',1),
(16084,'Sets',3,16080,'11730:16080',1),
(16085,'Other Luggage',3,16080,'11730:16080',1),
(16086,'Parties, Occasions',2,11700,'11700',0),
(16102,'Candle Holders & Accessories',3,10033,'11700:10033',1),
(16135,'Annuals',2,267,'267',1),
(16145,'Other Components & Parts',3,175673,'58058:175673',1),
(16191,'Ink Cartridges',4,11195,'58058:171961:11195',1),
(16204,'Toner Cartridges',4,11195,'58058:171961:11195',1),
(16211,'Printer Memory',4,182086,'58058:171961:182086',1),
(16212,'Brass',2,619,'619',0),
(16214,'Trumpets',3,16212,'619:16212',1),
(16215,'French Horns',3,16212,'619:16212',1),
(16216,'Trombones',3,16212,'619:16212',1),
(16219,'Organs',3,180010,'619:180010',1),
(16220,'Other Pianos',4,181225,'619:180010:181225',1),
(16221,'Autoharps & Zithers',4,181282,'619:180016:181282',1),
(16222,'Double Bass',4,181281,'619:180016:181281',1),
(16223,'Harps',4,181282,'619:180016:181282',1),
(16224,'Ukuleles',4,181282,'619:180016:181282',1),
(16225,'Violas',4,181281,'619:180016:181281',1),
(16226,'Bagpipes',4,181268,'619:10181:181268',1),
(16227,'Bassoons',4,181267,'619:10181:181267',1),
(16229,'Piccolos',4,181267,'619:10181:181267',1),
(16230,'Recorders',4,181267,'619:10181:181267',1),
(16231,'Saxophones',4,181267,'619:10181:181267',1),
(16240,'Clothing & Accessories',3,3153,'888:3153',0),
(16242,'Jodhpurs & Breeches',5,183365,'888:3153:16240:183365',1),
(16244,'Bits',4,3159,'888:3153:3159',1),
(16253,'Bits',4,3161,'888:3153:3161',1),
(16260,'Protective Gear',3,106465,'888:106465',1),
(16262,'Skateboarding',2,888,'888',0),
(16263,'Decks',4,159073,'888:16262:159073',1),
(16264,'Skateboards',3,16262,'888:16262',1),
(16265,'Other',3,16262,'888:16262',1),
(16486,'Miniatures',3,233,'220:233',0),
(16504,'Embossing Supplies',3,3122,'14339:3122',1),
(16508,'Other Art Supplies',3,11783,'14339:11783',1),
(16509,'Other',4,19143,'220:180250:19143',1),
(16511,'Soldiers, Figures',4,2586,'220:1188:2586',1),
(16705,'Other Tattoos',3,33914,'26395:33914',1),
(16706,'Education, Learning',2,99,'99',1),
(16710,'Other Religious Products',3,102545,'99:102545',1),
(17734,'France & Colonies',3,4742,'260:4742',1),
(17937,'Vatican',3,4742,'260:4742',1),
(18466,'Medieval',3,58520,'11116:58520',1),
(18646,'Duvet Inserts',3,20416,'2984:20416',1),
(18786,'Hair Accessories',4,163222,'2984:3082:163222',1),
(18791,'Vanity, Trinket Boxes',3,597,'1:597',1),
(18793,'Software',2,58058,'58058',0),
(18795,'Car Amplifiers',4,175716,'131090:3270:175716',1),
(18805,'Car Subwoofers',4,175716,'131090:3270:175716',1),
(18820,'Ads, Flyers',3,196,'11232:196',1),
(18821,'Lobby Cards',3,196,'11232:196',1),
(18823,'Photographs',3,196,'11232:196',1),
(18828,'Posters',3,196,'11232:196',1),
(18833,'Scripts',3,196,'11232:196',1),
(18854,'Photographs',3,1424,'11232:1424',1),
(18871,'Memory Cards',3,15200,'625:15200',1),
(18876,'Adderley',3,24,'870:24',1),
(18879,'Grafton, Royal Grafton',3,24,'870:24',1),
(18880,'Hammersley',3,24,'870:24',1),
(18883,'Paragon',3,24,'870:24',1),
(18886,'Royal Crown Derby',3,24,'870:24',1),
(18887,'Royal Stafford',3,24,'870:24',1),
(18891,'Tuscan',3,24,'870:24',1),
(18893,'Arabia',3,24,'870:24',1),
(18896,'Burleigh Ware',3,24,'870:24',1),
(18901,'Midwinter',3,24,'870:24',1),
(18903,'Myott',3,24,'870:24',1),
(18904,'Poole, Torquay',3,24,'870:24',1),
(18913,'Susie Cooper',3,24,'870:24',1),
(18917,'Wood & Sons',3,24,'870:24',1),
(18924,'Golf Balls',4,181153,'888:1513:181153',1),
(18928,'Ball Markers',4,181128,'888:1513:181128',1),
(18930,'Club Head Covers',4,181128,'888:1513:181128',1),
(18931,'Golf Tees',4,181153,'888:1513:181153',1),
(18932,'Golf Towels',4,181128,'888:1513:181128',1),
(18933,'Golf Umbrellas',4,181128,'888:1513:181128',1),
(18992,'Blocks',3,183446,'220:183446',1),
(19001,'Minifigures',4,183447,'220:183446:183447',1),
(19006,'LEGO Complete Sets & Packs',4,183447,'220:183446:183447',1),
(19013,'Lincoln Logs',3,183446,'220:183446',1),
(19014,'Tinkertoy',3,183446,'220:183446',1),
(19015,'Other Building Toys',3,183446,'220:183446',1),
(19016,'Classic Toys',2,220,'220',0),
(19019,'Etch-a-Sketch',3,19016,'220:19016',1),
(19023,'Ride-On Toys',2,220,'220',1),
(19027,'Other Classic Toys',3,19016,'220:19016',1),
(19029,'Contemporary Manufacture',4,180268,'220:222:180268',1),
(19033,'Contemporary Manufacture',4,180269,'220:222:180269',1),
(19034,'Vintage Manufacture',4,180269,'220:222:180269',1),
(19068,'Toys (0 - 12 months)',2,2984,'2984',0),
(19069,'Activity Toys',3,19169,'220:19169',1),
(19071,'Powered Toys',2,220,'220',0),
(19072,'Battery Operated',3,19071,'220:19071',1),
(19075,'Wind-Up Toys',3,19071,'220:19071',1),
(19077,'Promotional Toys',2,220,'220',0),
(19078,'Cereal Toys',3,19077,'220:19077',1),
(19082,'Card Games-Contemporary',4,180350,'220:233:180350',1),
(19088,'Vintage Chess',4,40852,'220:233:40852',1),
(19100,'Vintage Manufacture',4,2550,'220:233:2550',1),
(19107,'Magic: The Gathering',3,2536,'220:2536',0),
(19109,'MTG Sealed Booster Packs',4,19107,'220:2536:19107',1),
(19113,'MTG Mixed Card Lots',4,19107,'220:2536:19107',1),
(19114,'MTG Complete Sets',4,19107,'220:2536:19107',1),
(19116,'Z Scale',3,180250,'220:180250',0),
(19119,'N Scale',3,180250,'220:180250',0),
(19128,'HO Scale',3,180250,'220:180250',0),
(19143,'S Scale',3,180250,'220:180250',0),
(19145,'O Scale',3,180250,'220:180250',0),
(19151,'G Scale',3,180250,'220:180250',0),
(19159,'Plastic Canvas',5,183195,'14339:160706:28141:183195',1),
(19160,'Quilting Kits',4,180930,'14339:160737:180930',1),
(19161,'Quilting Tools & Equipment',4,180930,'14339:160737:180930',1),
(19169,'Preschool Toys & Pretend Play',2,220,'220',0),
(19172,'Dress-Up, Costumes',3,19169,'220:19169',1),
(19178,'Little Tikes',3,19169,'220:19169',1),
(19180,'Puppets',3,19169,'220:19169',1),
(19181,'Other Pretend Play',3,19169,'220:19169',1),
(19192,'Robots, Space Toys',2,220,'220',0),
(19197,'Robots',3,19192,'220:19192',1),
(19200,'Space Toys',3,19192,'220:19192',1),
(19205,'Beanie Babies',3,49019,'220:49019',1),
(19206,'Beanie Buddies',3,49019,'220:49019',1),
(19252,'Cowboy, Western',3,717,'220:717',1),
(19258,'Aromatherapy',3,67659,'26395:67659',1),
(19260,'Herbs & Botanicals',3,180959,'26395:180959',1),
(19262,'Other Vitamins & Supplements',3,180959,'26395:180959',1),
(19263,'Other Massage',3,36447,'26395:36447',1),
(19264,'Orthotics, Braces & Sleeves',4,182132,'26395:11778:182132',1),
(19265,'Wheelchairs',4,28175,'26395:11778:28175',1),
(19266,'Metaphysical',2,99,'99',0),
(19267,'Astrology',3,19266,'99:19266',1),
(19268,'Other Crystal, Gems, Rocks',4,113795,'99:19266:113795',1),
(19269,'Other Feng Shui',4,102502,'99:19266:102502',1),
(19270,'Other Psychic, Spiritual',4,102513,'99:19266:102513',1),
(19271,'Other Tarot',4,102520,'99:19266:102520',1),
(19273,'Postal Supplies',2,170638,'170638',0),
(19276,'Packing Tape',4,109735,'170638:19273:109735',1),
(19292,'Motor Racing',2,888,'888',0),
(19298,'Boots',4,159178,'888:20862:159178',1),
(19315,'Adaptors, Electrical',3,93838,'11730:93838',1),
(19327,'Forceps',3,11815,'170769:11815',1),
(19590,'Continuous Lighting',3,30078,'625:30078',0),
(19591,'Lighting Kits',4,19590,'625:30078:19590',1),
(19617,'Plants & Seedlings',4,181003,'11700:159912:181003',0),
(19618,'Lawn Grass Seeds',5,40605,'11700:159912:181003:40605',1),
(19699,'DJ Mixers',3,48458,'619:48458',1),
(19783,'Other',3,26677,'11700:26677',1),
(19839,'Control, Radio & Electronics',4,182187,'220:2562:182187',0),
(19854,'Playmobil',3,19169,'220:19169',1),
(19985,'Chairs & Seats',4,179985,'888:1492:179985',1),
(20034,'Batteries',3,164874,'15032:164874',1),
(20081,'Antiques',1,-1,'',0),
(20082,'Asian Antiques',2,20081,'20081',0),
(20086,'Decorative Arts',2,20081,'20081',0),
(20087,'Cast Iron',4,1211,'20081:20086:1211',1),
(20088,'Wrought Iron',4,1211,'20081:20086:1211',1),
(20089,'Mirrors',3,20086,'20081:20086',1),
(20091,'Furniture',2,20081,'20081',0),
(20094,'Science, Medicine',2,20081,'20081',1),
(20096,'Silver',2,20081,'20081',0),
(20117,'Embroidery',3,181677,'20081:181677',1),
(20119,'Drawings',2,550,'550',1),
(20125,'Paintings',2,550,'550',1),
(20138,'Photographs',2,550,'550',1),
(20140,'Prints',2,550,'550',1),
(20158,'Other Art from the Artist',3,60435,'550:60435',1),
(20161,'Business Cards',2,170638,'170638',1),
(20245,'Countries',4,914,'1:124:914',1),
(20272,'Other Collectable Swords',4,43336,'1:1401:43336',1),
(20284,'Maps',3,124,'1:124',1),
(20291,'Other Kids\' Vintage Clothing',4,182025,'11450:175759:182025',1),
(20311,'Networking Cables & Adapters',3,182094,'58058:182094',0),
(20315,'Other Power Protection',3,86722,'58058:86722',1),
(20318,'Internal Network Cards',4,182088,'58058:175673:182088',1),
(20349,'Cases, Covers & Skins',3,9394,'15032:9394',1),
(20357,'Batteries',3,9394,'15032:9394',1),
(20373,'Faceplates, Decals & Stickers',3,9394,'15032:9394',1),
(20381,'Walkie Talkies, Two-Way Radios',3,1500,'293:1500',1),
(20394,'Bathing, Grooming',2,2984,'2984',0),
(20397,'Disposal',3,26268,'2984:26268',1),
(20398,'Skincare',3,20394,'2984:20394',1),
(20399,'Other Nappies',3,26268,'2984:26268',1),
(20400,'Feeding',2,2984,'2984',0),
(20402,'Bottles',3,20400,'2984:20400',1),
(20403,'Formula',3,20400,'2984:20400',1),
(20404,'Bottle Warmers',3,20400,'2984:20400',1),
(20405,'Other Feeding',3,20400,'2984:20400',1),
(20406,'Breastfeeding Supplies',3,20400,'2984:20400',1),
(20408,'Bibs',3,20400,'2984:20400',1),
(20410,'Sterilisers',3,20400,'2984:20400',1),
(20416,'Nursery Bedding',2,2984,'2984',0),
(20417,'Bumpers',3,20416,'2984:20416',1),
(20421,'Other Nursery Bedding',3,20416,'2984:20416',1),
(20422,'Furniture',2,2984,'2984',0),
(20423,'Bassinettes',3,20422,'2984:20422',1),
(20424,'Changing Tables',3,20422,'2984:20422',1),
(20426,'Other Furniture',3,20422,'2984:20422',1),
(20428,'Lamps, Lights',3,66697,'2984:66697',1),
(20429,'Mobiles',3,66697,'2984:66697',1),
(20433,'Safety',2,2984,'2984',0),
(20435,'Monitors',3,20433,'2984:20433',1),
(20436,'Other Safety Items',3,20433,'2984:20433',1),
(20441,'Shower Curtains',3,26677,'11700:26677',1),
(20442,'Towel Racks',4,20601,'11700:3187:20601',1),
(20444,'Bedding',2,11700,'11700',0),
(20445,'Pillows',3,20444,'11700:20444',1),
(20450,'Valances',3,20444,'11700:20444',1),
(20460,'Sheets',3,20444,'11700:20444',1),
(20472,'Cereals, Grains, Pasta',2,14308,'14308',1),
(20473,'Biscuits, Cookies',2,14308,'14308',1),
(20475,'Recipes',3,20625,'11700:20625',1),
(20480,'Bedroom Sets & Suites',3,3197,'11700:3197',1),
(20485,'Other Kitchen, Dining, Bar',3,20625,'11700:20625',1),
(20487,'Cabinets & Cupboards',3,3197,'11700:3197',1),
(20488,'Entertainment Units, TV Stands',3,3197,'11700:3197',1),
(20490,'Ottomans, Footstools & Poufs',3,3197,'11700:3197',1),
(20498,'Garden Décor',3,159912,'11700:159912',0),
(20507,'Outdoor Fountains',4,93632,'11700:159912:93632',1),
(20509,'Other Outdoor Lighting',4,42154,'11700:159912:42154',1),
(20512,'Weathervanes',4,20498,'11700:159912:20498',1),
(20513,'Wind Chimes',4,20498,'11700:159912:20498',1),
(20518,'Baskets, Pots & Window Boxes',5,179308,'11700:159912:2032:179308',1),
(20520,'Water Plants',5,19617,'11700:159912:181003:19617',1),
(20524,'Bonsai',5,19617,'11700:159912:181003:19617',1),
(20525,'Bonsai Seeds',5,40605,'11700:159912:181003:40605',1),
(20527,'Annuals & Biennials',5,19617,'11700:159912:181003:19617',1),
(20529,'Perennials',5,19617,'11700:159912:181003:19617',1),
(20531,'Annual & Biennial Seeds',5,40605,'11700:159912:181003:40605',1),
(20533,'Bush & Shrub Seeds',5,40605,'11700:159912:181003:40605',1),
(20542,'Lawn Sprinklers',5,29521,'11700:159912:2032:29521',1),
(20545,'Clothing & Protective Gear',5,159473,'11700:159912:2032:159473',1),
(20546,'Other Hydroponics',5,43554,'11700:159912:2032:43554',1),
(20547,'Watering Cans',5,29521,'11700:159912:2032:29521',1),
(20549,'Throws, Afghans',3,10033,'11700:10033',1),
(20552,'Home Fragrances',3,10033,'11700:10033',1),
(20558,'Clocks',3,10033,'11700:10033',1),
(20563,'Cushions, Decorative Pillows',3,10033,'11700:10033',1),
(20564,'Other Fireplace Accessories',3,38219,'11700:38219',1),
(20569,'Fountains',3,10033,'11700:10033',1),
(20571,'Rugs & Carpets',2,11700,'11700',0),
(20573,'Door Mats & Floor Mats',3,20571,'11700:20571',1),
(20574,'Runners',3,20571,'11700:20571',1),
(20578,'Suncatchers & Mobiles',3,10033,'11700:10033',1),
(20580,'Mirrors',3,10033,'11700:10033',1),
(20585,'Blinds',3,63514,'11700:63514',1),
(20586,'Other',3,63514,'11700:63514',1),
(20589,'Other',3,41968,'11700:41968',1),
(20593,'Other Door Hardware',4,41976,'11700:3187:41976',1),
(20594,'Other Building Materials',3,3187,'11700:3187',1),
(20595,'Environmental Solutions',2,11700,'11700',1),
(20599,'Letterboxes',3,3187,'11700:3187',1),
(20601,'Plumbing & Fixtures',3,3187,'11700:3187',0),
(20604,'Other Flooring',4,180983,'11700:3187:180983',1),
(20605,'Cleaning Supplies',3,299,'11700:299',0),
(20607,'Mops, Brooms',4,20605,'11700:299:20605',1),
(20608,'Wastebaskets, Bins',4,43502,'11700:299:43502',1),
(20612,'Portable Fans',3,69197,'20710:69197',1),
(20613,'Portable Heaters',3,69197,'20710:69197',1),
(20614,'Vacuum Cleaners',2,20710,'20710',0),
(20615,'Canister Vacuums',3,20614,'20710:20614',1),
(20616,'Handheld Vacuums',3,20614,'20710:20614',1),
(20617,'Upright Vacuums',3,20614,'20710:20614',1),
(20620,'Laundry',3,299,'11700:299',0),
(20621,'Other',4,43502,'11700:299:43502',1),
(20624,'Other',4,20620,'11700:299:20620',1),
(20625,'Kitchen, Dining, Bar',2,11700,'11700',0),
(20628,'Cookware',3,20625,'11700:20625',1),
(20635,'Utensils, Gadgets',3,20625,'11700:20625',0),
(20637,'Cutlery',3,20625,'11700:20625',0),
(20639,'Knives',4,20637,'11700:20625:20637',1),
(20641,'Peelers, Slicers',4,20635,'11700:20625:20635',1),
(20645,'Shakers',4,20635,'11700:20625:20635',1),
(20649,'Cooking Utensils',4,20635,'11700:20625:20635',1),
(20651,'Other',4,20635,'11700:20625:20635',1),
(20652,'Food Storage',3,20625,'11700:20625',0),
(20653,'Bags',4,20652,'11700:20625:20652',1),
(20655,'Other',4,106191,'11700:20625:106191',1),
(20657,'Aprons',4,71237,'11700:20625:71237',1),
(20659,'Napkins',4,71237,'11700:20625:71237',1),
(20661,'Oven Mitts & Potholders',4,71237,'11700:20625:71237',1),
(20663,'Table Cloths',4,71237,'11700:20625:71237',1),
(20664,'Tea Towels, Dishcloths',4,71237,'11700:20625:71237',1),
(20667,'Small Kitchen Appliances',2,20710,'20710',0),
(20669,'Bread Makers',3,20667,'20710:20667',1),
(20670,'Can Openers',3,20667,'20710:20667',1),
(20671,'Coffee Accessories',3,170737,'20710:170737',1),
(20672,'Steamers',3,20667,'20710:20667',1),
(20673,'Food Processors',3,20667,'20710:20667',1),
(20674,'Electric Pans, Woks',3,20667,'20710:20667',1),
(20675,'Grills, Sandwich Makers',3,20667,'20710:20667',1),
(20676,'Ice Cream Makers',3,20667,'20710:20667',1),
(20677,'Juicers',3,20667,'20710:20667',1),
(20680,'Pasta Makers',3,20667,'20710:20667',1),
(20681,'Slicers, Electric Knives',3,20667,'20710:20667',1),
(20684,'Water Filters',3,20667,'20710:20667',1),
(20685,'Other',3,20667,'20710:20667',1),
(20687,'Barware',3,20625,'11700:20625',0),
(20688,'Corkscrews, Bottle Openers',4,20687,'11700:20625:20687',1),
(20689,'Racks',4,71259,'14308:179836:71259',1),
(20690,'Other Barware',4,20687,'11700:20625:20687',1),
(20695,'Mugs',4,36027,'11700:20625:36027',1),
(20696,'Glassware',3,20625,'11700:20625',1),
(20697,'Lighting, Fans',2,11700,'11700',0),
(20702,'Night Lights',3,20697,'11700:20697',1),
(20706,'Light Bulbs',3,20697,'11700:20697',1),
(20708,'Lamp Shades',3,20697,'11700:20697',1),
(20710,'Home Appliances',1,-1,'',0),
(20713,'Refrigerators',3,149229,'20710:149229',1),
(20714,'Washer & Dryer Parts',3,170737,'20710:170737',1),
(20715,'Other',2,20710,'20710',1),
(20719,'Hammocks',4,25863,'11700:159912:25863',1),
(20725,'BBQ Tools & Accessories',4,149242,'11700:159912:149242',1),
(20727,'Pools & Spas',3,159912,'11700:159912',0),
(20734,'Birds',2,1281,'1281',0),
(20736,'Toys',3,20734,'1281:20734',1),
(20737,'Cats',2,1281,'1281',0),
(20738,'Flea, Tick Remedies',3,20737,'1281:20737',1),
(20740,'Furniture & Scratchers',3,20737,'1281:20737',1),
(20741,'Toys',3,20737,'1281:20737',1),
(20742,'Dogs',2,1281,'1281',0),
(20744,'Beds',3,20742,'1281:20742',1),
(20745,'Carriers',3,20742,'1281:20742',1),
(20749,'Flea, Tick Remedies',3,20742,'1281:20742',1),
(20752,'Leashes',3,20742,'1281:20742',1),
(20754,'Fish',2,1281,'1281',0),
(20755,'Aquariums',3,20754,'1281:20754',1),
(20759,'Food',3,20754,'1281:20754',1),
(20761,'Clamps & Vices',4,3244,'11700:631:3244',1),
(20762,'Chisels',3,46576,'170769:46576',1),
(20763,'Hammers',4,3244,'11700:631:3244',1),
(20765,'Spirit Levels',3,46576,'170769:46576',1),
(20767,'Pliers',3,46576,'170769:46576',1),
(20768,'Saws',4,3244,'11700:631:3244',1),
(20773,'Spanners & Wrenches',4,3244,'11700:631:3244',1),
(20778,'Other Grinders',5,42275,'11700:631:3247:42275',1),
(20783,'Saws',4,3247,'11700:631:3247',0),
(20784,'Band Saws',4,46585,'170769:64808:46585',1),
(20786,'Jig Saws',4,46585,'170769:64808:46585',1),
(20788,'Reciprocating Saws',5,20783,'11700:631:3247:20783',1),
(20789,'Table Saws',4,46585,'170769:64808:46585',1),
(20791,'Other',4,46585,'170769:64808:46585',1),
(20794,'Batteries & Chargers',4,164613,'11700:631:164613',1),
(20798,'Other Safety, Protective Gear',4,43614,'11700:631:43614',1),
(20834,'Crown Staffordshire',3,24,'870:24',1),
(20835,'Archery',2,888,'888',0),
(20838,'Compound',4,181293,'888:20835:181293',1),
(20839,'Recurve',4,181293,'888:20835:181293',1),
(20843,'Quivers',4,36098,'888:20835:36098',1),
(20844,'Shafts',4,181307,'888:20835:181307',1),
(20845,'Sights',4,36098,'888:20835:36098',1),
(20846,'Bowling (Tenpin)',2,888,'888',0),
(20850,'Shoes',3,20846,'888:20846',1),
(20862,'Soccer',2,888,'888',0),
(20863,'Balls',3,20862,'888:20862',1),
(20869,'Bags',3,13340,'888:13340',1),
(20870,'Balls',3,13340,'888:13340',1),
(20871,'Racquets',3,13340,'888:13340',1),
(20898,'Dollhouses',4,2524,'220:19169:2524',1),
(20925,'Genealogy',2,99,'99',1),
(20934,'Balloons',3,11827,'11700:11827',1),
(20935,'Wedding Cake Toppers',3,11827,'11700:11827',1),
(20936,'Candles & Candle Holders',3,11827,'11700:11827',1),
(20938,'Flowers, Petals & Garlands',3,11827,'11700:11827',1),
(20940,'Guest Books & Pens',3,11827,'11700:11827',1),
(20941,'Ribbons & Bows',3,11827,'11700:11827',1),
(20942,'Tulle',3,11827,'11700:11827',1),
(21021,'Face Powder',4,172025,'26395:31786:172025',1),
(21022,'Masks & Peels',3,11863,'26395:11863',1),
(21035,'Spain & Colonies',3,4742,'260:4742',1),
(21136,'Health, Beauty',3,34,'1:34',1),
(21194,'Basketball',2,888,'888',0),
(21196,'Backboards, Systems, Rims',3,21194,'888:21194',1),
(21198,'Stock Photo Collections',3,30078,'625:30078',1),
(21205,'Moisturisers',3,11863,'26395:11863',1),
(21208,'Balls',3,21194,'888:21194',1),
(21210,'Other',4,75184,'888:21567:75184',1),
(21211,'Cue Cases',4,75184,'888:21567:75184',1),
(21213,'Tables',3,21567,'888:21567',1),
(21214,'Equipment',3,31636,'888:31636',1),
(21225,'Ice Skating',3,106465,'888:106465',0),
(21226,'Clothing',4,21225,'888:106465:21225',1),
(21229,'Skiing & Snowboarding Bags',4,119236,'888:36259:119236',1),
(21230,'Snow Goggles',3,36259,'888:36259',1),
(21231,'Racks & Carriers',4,119236,'888:36259:119236',1),
(21232,'Other',4,119236,'888:36259:119236',1),
(21233,'Clothing',3,36259,'888:36259',0),
(21238,'Bindings',4,16059,'888:36259:16059',1),
(21239,'Boots',4,16059,'888:36259:16059',1),
(21247,'Snowboarding',3,36259,'888:36259',0),
(21248,'Bindings',4,21247,'888:36259:21247',1),
(21254,'K\'NEX',3,183446,'220:183446',1),
(21557,'Cricket',2,888,'888',0),
(21558,'Clothing',3,21557,'888:21557',1),
(21561,'Diet & Weight Loss',4,97033,'888:15273:97033',1),
(21563,'Rugby Union',2,888,'888',0),
(21567,'Snooker, Pool, Billiards',2,888,'888',0),
(21568,'Cues',3,21567,'888:21567',1),
(21669,'Other Tyre & Wheel Parts',4,180035,'131090:14780:180035',1),
(21670,'Manuals',4,34352,'131090:6747:34352',1),
(21766,'Other Accessories',4,181224,'619:180010:181224',1),
(22176,'Whips & Crops',3,3153,'888:3153',1),
(22189,'Horse Supplements',4,139576,'888:3153:139576',1),
(22420,'Other Wines',4,26270,'14308:179836:26270',1),
(22422,'Incunabula',2,20081,'20081',1),
(22547,'Starter Sets & Packs',4,19119,'220:180250:19119',1),
(22548,'Starter Sets & Packs',4,19128,'220:180250:19128',1),
(22610,'Projectors',2,172176,'172176',1),
(22635,'Radio Tuners',3,14969,'293:14969',1),
(22652,'Other Australian Pottery',3,170518,'870:170518',1),
(22653,'CD & Video Racks',3,3197,'11700:3197',1),
(22656,'Coat & Hat Racks',4,43502,'11700:299:43502',1),
(22659,'Air Tools',3,631,'11700:631',0),
(22664,'Other',4,22659,'11700:631:22659',1),
(22669,'Other Guitar Effects Pedals',5,181222,'619:3858:180009:181222',1),
(22670,'Pickups',5,181223,'619:3858:180009:181223',1),
(22671,'Stands, Hangers',4,180009,'619:3858:180009',1),
(22672,'Tuners',4,180009,'619:3858:180009',1),
(22679,'Bicycle Frames',3,7294,'888:7294',1),
(22682,'Cycling Clothing',3,7294,'888:7294',0),
(22683,'Gloves',4,22682,'888:7294:22682',1),
(22686,'Shoes',4,177862,'888:7294:177862',1),
(22689,'Lights & Reflectors',4,177832,'888:7294:177832',1),
(22691,'Pumps',4,177832,'888:7294:177832',1),
(22696,'Tackle Boxes & Bags',4,179985,'888:1492:179985',1),
(22704,'Skate Shoes',3,106465,'888:106465',1),
(22709,'Surfing',2,888,'888',0),
(22710,'Surfboards',4,166201,'888:22709:166201',1),
(22711,'Decals',4,71164,'888:22709:71164',1),
(22712,'Wetsuits',4,151563,'888:22709:151563',1),
(22966,'Electro-Acoustic Guitars',3,3858,'619:3858',1),
(23048,'Manuscripts',2,20081,'20081',1),
(23160,'Mice, Trackballs & Touchpads',3,3676,'58058:3676',1),
(23308,'Other Music Instruction',3,182150,'619:182150',1),
(23711,'Tiger\'s Eye',4,181077,'281:491:181077',1),
(23738,'Queen Mother',5,153170,'1:13877:39630:153170',1),
(23789,'Cases, Rack & Bags',3,180014,'619:180014',1),
(23791,'Signal Processors/Rack Effects',3,180014,'619:180014',1),
(23800,'Canoes',4,166101,'888:23806:166101',1),
(23806,'Boating, Water Sports',2,888,'888',0),
(23809,'Walking & Trekking Sticks',4,181401,'888:16034:181401',1),
(23812,'Flies',4,179961,'888:1492:179961',1),
(23816,'Other Fly Tying Materials',5,44912,'888:1492:179961:44912',1),
(23817,'Fly Line, Leaders & Tippets',4,179965,'888:1492:179965',1),
(23818,'Fly Fishing Reels',4,179950,'888:1492:179950',1),
(23819,'Fly Fishing Rods',4,179946,'888:1492:179946',1),
(23825,'Clothing',3,16262,'888:16262',0),
(23829,'T-Shirts',4,23825,'888:16262:23825',1),
(23830,'Wheels',4,159073,'888:16262:159073',1),
(23851,'Kangaroos',4,153383,'260:3468:153383',1),
(23895,'Mouse Pads & Wrist Rests',3,31530,'58058:31530',1),
(24087,'Casual',3,93427,'11450:93427',1),
(25253,'Cranes',3,177641,'170769:177641',1),
(25257,'Cutting Tools, Consumables',3,177644,'170769:177644',1),
(25264,'Angle Grinders',3,64808,'170769:64808',1),
(25277,'EDM Machines',3,177641,'170769:177641',1),
(25283,'Manufacturing Equipment Parts',3,41489,'170769:41489',0),
(25290,'Other Replacement Parts',4,25283,'170769:41489:25283',1),
(25292,'Chucks',3,177644,'170769:177644',1),
(25297,'Vices',3,177644,'170769:177644',1),
(25321,'Projectors',3,162497,'58058:162497',1),
(25326,'Typewriters, Word Processors',3,50203,'170638:50203',1),
(25350,'Record Books',3,58271,'170638:58271',1),
(25351,'Pens & Writing Instruments',3,58271,'170638:58271',1),
(25353,'Whiteboard Markers',3,58271,'170638:58271',1),
(25367,'Kitchen Equipment',3,11874,'170638:11874',0),
(25370,'Other',4,25367,'170638:11874:25367',1),
(25372,'Meat Grinders',4,25367,'170638:11874:25367',1),
(25373,'Mixers',4,25367,'170638:11874:25367',1),
(25374,'Slicers',4,25367,'170638:11874:25367',1),
(25380,'Signs',2,170638,'170638',1),
(25381,'Tabletop & Serving',3,11874,'170638:11874',0),
(25382,'Disposables',4,25381,'170638:11874:25381',1),
(25386,'Linens',4,25381,'170638:11874:25381',1),
(25387,'Tabletop Accessories',4,25381,'170638:11874:25381',1),
(25388,'Other',4,25381,'170638:11874:25381',1),
(25389,'Vending Machines',2,170638,'170638',1),
(25399,'Other Calibrators',6,181999,'170769:92074:181939:181998:181999',1),
(25400,'Test Equipment Controllers',5,36315,'170769:92074:181939:36315',1),
(25403,'RF & Microwave Pass Filters',5,181992,'170769:92074:181939:181992',1),
(25409,'Test Equip. Manuals & Books',4,181939,'170769:92074:181939',1),
(25414,'Other Test Equip. Parts & Accs',5,36315,'170769:92074:181939:36315',1),
(25416,'Recorders & Plotters',6,36314,'170769:92074:181939:181940:36314',1),
(25421,'LCR & Impedance Meters',5,181968,'170769:92074:181939:181968',1),
(25423,'Sound Level Meters',5,181968,'170769:92074:181939:181968',1),
(25425,'Test Equipment Waveguides',5,36315,'170769:92074:181939:36315',1),
(25451,'Soap Dishes, Dispensers',3,26677,'11700:26677',1),
(25452,'Tissue Box Covers',3,26677,'11700:26677',1),
(25453,'Toothbrush Holders',3,26677,'11700:26677',1),
(25460,'Fruits, Nuts, Seeds',2,14308,'14308',1),
(25464,'Bakeware',3,20625,'11700:20625',1),
(25579,'Cricket Cards',3,212,'888:212',1),
(25583,'Rugby League (NRL) Cards',3,212,'888:212',1),
(25622,'Motorcycle Accessories',2,131090,'131090',0),
(25640,'Other Scooter Parts',3,84149,'131090:84149',1),
(25642,'Covers & Tarpaulins',4,183536,'131090:25622:183536',1),
(25644,'Onboard Tool & Repair Kits',3,25622,'131090:25622',1),
(25645,'Other Motorcycle Accessories',3,25622,'131090:25622',1),
(25815,'Other',3,20444,'11700:20444',1),
(25845,'Soda Makers',3,20667,'20710:20667',1),
(25863,'Patio & Garden Furniture',3,159912,'11700:159912',0),
(25873,'Other Garden Clothing & Gear',5,159473,'11700:159912:2032:159473',1),
(25876,'Other Plant Care & Accessories',5,179308,'11700:159912:2032:179308',1),
(26187,'Grain Equipment',4,177647,'170769:41489:177647',1),
(26189,'Irrigation Equipment',3,11748,'170769:11748',0),
(26190,'Material Handling Equipment',4,177647,'170769:41489:177647',1),
(26197,'Other',3,41498,'170769:41498',1),
(26204,'Other',3,42297,'170769:42297',1),
(26211,'Toggle Switches',5,181845,'170769:92074:100016:181845',1),
(26213,'Other Wire & Cable',5,73136,'170769:92074:100016:73136',1),
(26217,'Screws',3,42901,'170769:42901',1),
(26223,'Other',3,57004,'170769:57004',1),
(26224,'Trolleys',3,64808,'170769:64808',1),
(26232,'Centrifuges',3,11815,'170769:11815',1),
(26238,'Printing Equipment',2,170638,'170638',0),
(26243,'Binders',3,58271,'170638:58271',1),
(26244,'Binding Machines',3,50203,'170638:50203',1),
(26261,'Other',2,170769,'170769',1),
(26267,'Covers',3,26268,'2984:26268',1),
(26268,'Nappies',2,2984,'2984',0),
(26270,'Wine',3,179836,'14308:179836',0),
(26272,'Wines (Champagne, Sparkling)',4,26270,'14308:179836:26270',1),
(26322,'Iolite',4,181077,'281:491:181077',1),
(26324,'Balls',3,20846,'888:20846',1),
(26343,'Ice Skates',4,21225,'888:106465:21225',1),
(26346,'Jackets',4,21233,'888:36259:21233',1),
(26384,'Balloons, Decorations',3,16086,'11700:16086',1),
(26385,'Favours',3,16086,'11700:16086',1),
(26388,'Tableware, Serveware',3,16086,'11700:16086',1),
(26395,'Health & Beauty',1,-1,'',0),
(26414,'Disposable Supplies',3,11815,'170769:11815',1),
(26423,'Wholesale, Bulk Lots',2,888,'888',1),
(26424,'Other Wholesale Lots',3,40149,'220:40149',1),
(26425,'Wholesale, Bulk Lots',2,1,'1',1),
(26428,'Other',3,63676,'9800:63676',1),
(26429,'Boats',2,9800,'9800',0),
(26434,'Other Boats',3,26429,'9800:26429',1),
(26435,'Aircraft Parts, Accessories',2,131090,'131090',1),
(26443,'Boat Parts, Accessories',2,131090,'131090',0),
(26444,'Other',4,31274,'131090:26443:31274',1),
(26446,'Anchoring, Mooring',3,26443,'131090:26443',0),
(26447,'Covers',3,26443,'131090:26443',1),
(26448,'Deck, Cabin Hardware',3,26443,'131090:26443',1),
(26449,'Plumbing & Ventilation',3,26443,'131090:26443',1),
(26450,'Safety Equipment',3,26443,'131090:26443',0),
(26451,'Other',4,50440,'131090:26443:50440',1),
(26453,'Media',3,26443,'131090:26443',1),
(26455,'Other',3,26443,'131090:26443',1),
(26456,'Propellers',3,26443,'131090:26443',1),
(26677,'Bath',2,11700,'11700',0),
(26696,'Small Animals',2,1281,'1281',1),
(27031,'Riding Boots & Accessories',3,3153,'888:3153',0),
(27158,'Other Aboriginal Art',3,113357,'550:113357',1),
(27173,'Hotel, Motel, Pub',3,34,'1:34',1),
(27291,'Summer, Winter Games',2,888,'888',1),
(27362,'Other',4,72891,'888:16034:72891',1),
(27363,'Other Hiking Equipment',4,181401,'888:16034:181401',1),
(27371,'Advertising Collectables',4,50428,'131090:6747:50428',0),
(27386,'Graphics/Video Cards',3,175673,'58058:175673',1),
(27391,'Memorabilia',3,21557,'888:21557',1),
(27414,'Other Tackle & Accessories',4,179985,'888:1492:179985',1),
(27415,'Other',4,179978,'888:1492:179978',1),
(27416,'Floats & Bobbers',4,179973,'888:1492:179973',1),
(27432,'Other Cameras, Accessories',2,625,'625',1),
(27538,'Sauna Heaters',4,20727,'11700:159912:20727',1),
(27652,'Flight Controllers & Gyros',5,19839,'220:2562:182187:19839',1),
(27912,'Air Pumps',4,181403,'888:16034:181403',1),
(27952,'Hydration Packs',4,177832,'888:7294:177832',1),
(28015,'Uniforms',2,11450,'11450',1),
(28016,'Uniforms',3,11452,'11450:11452',1),
(28017,'Uniforms',3,11462,'11450:11462',1),
(28019,'Desktop Items',3,966,'1:966',1),
(28057,'Combos',4,3247,'11700:631:3247',1),
(28059,'Cardio Equipment',3,15273,'888:15273',0),
(28060,'Rowing Machines',4,28059,'888:15273:28059',1),
(28061,'Ski Machines',4,28059,'888:15273:28059',1),
(28062,'Step Machines',4,28059,'888:15273:28059',1),
(28063,'Other',4,28059,'888:15273:28059',1),
(28064,'Fitness Equipment & Gear',3,15273,'888:15273',0),
(28065,'Other Equipment & Gear',4,28064,'888:15273:28064',1),
(28066,'Strength Training',3,15273,'888:15273',0),
(28067,'Other Strength Training',4,28066,'888:15273:28066',1),
(28102,'Multi-Purpose Craft Supplies',2,14339,'14339',0),
(28107,'Art Pastels',4,183081,'14339:11783:183081',1),
(28108,'Art Pencils & Charcoal',4,183081,'14339:11783:183081',1),
(28109,'Art Pens & Markers',4,183081,'14339:11783:183081',1),
(28110,'Painting Supplies',3,11783,'14339:11783',0),
(28112,'Oil Paint',5,183102,'14339:11783:28110:183102',1),
(28113,'Watercolour Paint',5,183102,'14339:11783:28110:183102',1),
(28114,'Candle, Soap Making',2,14339,'14339',1),
(28124,'Pottery Wheels',4,183303,'14339:183302:183303',1),
(28127,'Patterns & Instructions',3,183126,'14339:183126',1),
(28128,'Ready to Paint Items',3,183126,'14339:183126',1),
(28131,'Leathercrafts',2,14339,'14339',0),
(28133,'Other Leather Tools',4,183128,'14339:28131:183128',1),
(28135,'Ceramic, China',3,11787,'14339:11787',1),
(28137,'Eyelets',4,160704,'14339:28102:160704',1),
(28140,'Crochet Hooks',4,3094,'14339:160706:3094',1),
(28141,'Embroidery & Cross Stitch',3,160706,'14339:160706',0),
(28142,'Other Hand Embroidery Kits',5,183197,'14339:160706:28141:183197',1),
(28143,'Other Patterns & Magazines',5,183199,'14339:160706:28141:183199',1),
(28144,'Hand Embroidery Floss & Thread',4,28141,'14339:160706:28141',1),
(28145,'Other Kids Crafts',3,116652,'14339:116652',1),
(28146,'Knitting Machines',5,146370,'14339:160706:3094:146370',1),
(28147,'Rug-Making',3,160706,'14339:160706',0),
(28148,'Latch Hooking Kits',5,157027,'14339:160706:28147:157027',1),
(28150,'Other Latch Hooking Supplies',5,157027,'14339:160706:28147:157027',1),
(28151,'Other Macramé',4,183205,'14339:160706:183205',1),
(28162,'Fabric',2,14339,'14339',1),
(28168,'Other Sewing Machine Accs',4,180929,'14339:160737:180929',1),
(28170,'Hand Sewing Needles',4,183281,'14339:160737:183281',1),
(28171,'Dressmaker\'s Scissors & Shears',4,183265,'14339:160737:183265',1),
(28172,'Sewing Thread',3,160737,'14339:160737',1),
(28173,'Zippers',4,183253,'14339:160737:183253',1),
(28174,'Sewing Patterns',3,160737,'14339:160737',1),
(28175,'Mobility/Walking Equipment',3,11778,'26395:11778',0),
(28176,'Walkers & Canes',4,28175,'26395:11778:28175',1),
(28177,'Other Mobility Equipment',4,28175,'26395:11778:28175',1),
(28179,'Binoculars & Telescopes',2,625,'625',0),
(28641,'Other',4,72200,'131090:6030:72200',1),
(28811,'Meccano & Erector Sets',3,183446,'220:183446',0),
(29223,'Antiquarian & Collectable',2,267,'267',1),
(29399,'Wholesale Lots',2,267,'267',1),
(29405,'Toners',3,67076,'170638:67076',1),
(29468,'Animals',4,914,'1:124:914',1),
(29474,'Holidays',4,914,'1:124:914',1),
(29480,'Real Photo',4,914,'1:124:914',1),
(29485,'Transportation',4,914,'1:124:914',1),
(29509,'Cloths, Gloves',4,20605,'11700:299:20605',1),
(29511,'Statues & Lawn Ornaments',4,20498,'11700:159912:20498',1),
(29514,'Plant Stands',4,20498,'11700:159912:20498',1),
(29518,'Outdoor Power Equipment',3,159912,'11700:159912',0),
(29519,'Tillers',4,29518,'11700:159912:29518',1),
(29520,'Other Outdoor Power Equipment',4,29518,'11700:159912:29518',1),
(29521,'Watering Equipment',4,2032,'11700:159912:2032',0),
(29522,'Other Watering Equipment',5,29521,'11700:159912:2032:29521',1),
(29526,'Planes',3,46576,'170769:46576',1),
(29554,'Bohemian, Czech',4,955,'870:50693:955',1),
(29557,'French',4,955,'870:50693:955',1),
(29560,'North American',4,955,'870:50693:955',1),
(29562,'Scandinavian',4,955,'870:50693:955',1),
(29574,'Boots',3,16052,'888:16052',1),
(29575,'Dive Lights',3,16052,'888:16052',1),
(29576,'Gear Bags',3,16052,'888:16052',1),
(29577,'Knives',3,16052,'888:16052',1),
(29580,'Deodorants & Antiperspirants',3,11838,'26395:11838',1),
(29581,'Body Powders',3,11838,'26395:11838',1),
(29582,'Exfoliators & Scrubs',3,11863,'26395:11863',1),
(29583,'Other Tanning, Sun Care',3,31772,'26395:31772',1),
(29584,'Mixed Items',3,11838,'26395:11838',1),
(29585,'Men\'s Fragrances',3,180345,'26395:180345',1),
(29618,'Acne & Blemish Control',3,11863,'26395:11863',1),
(29685,'Merchandise',3,39991,'888:39991',1),
(29690,'Cars',2,9800,'9800',0),
(29711,'Other Badge, Poster, Patches',5,72183,'131090:6747:50428:72183',1),
(29722,'Mikasa',5,153371,'870:50693:170514:153371',1),
(29723,'Fishfinders',4,179985,'888:1492:179985',1),
(29778,'Prepaid Recharge Cards',2,15032,'15032',1),
(29792,'Audio Books',2,267,'267',1),
(29797,'Bottles, Jars, Jugs',2,1,'1',0),
(29800,'Wizards',3,10860,'1:10860',1),
(29801,'Bakeware',3,13905,'1:13905',1),
(29804,'Figurals',4,4049,'1:13905:4049',1),
(29812,'Bowls, Bowl Sets',4,106191,'11700:20625:106191',1),
(29814,'Jugs',4,106191,'11700:20625:106191',1),
(29815,'Plates',4,106191,'11700:20625:106191',1),
(29826,'Ball Point',4,7278,'1:966:7278',1),
(29832,'Radio, Gramophone, Phone',2,1,'1',0),
(29945,'Lighting Stands & Trusses',3,12922,'619:12922',1),
(29946,'Microphones & Wireless Systems',3,180014,'619:180014',1),
(29948,'Microphone Holders & Stands',3,180014,'619:180014',1),
(29953,'Other Photo Albums & Storage',4,182075,'625:15200:182075',1),
(29954,'Telescope Eyepieces & Lenses',4,74922,'625:28179:74922',1),
(29965,'Rangefinder Units & Accs',3,69323,'625:69323',1),
(29967,'Battery Grips',3,15200,'625:15200',1),
(29970,'Motor Drives & Winders',3,69323,'625:69323',1),
(29973,'Film Backs & Holders',3,69323,'625:69323',1),
(29980,'Lens Boards',3,69323,'625:69323',1),
(29983,'Film Development Chemicals',4,182077,'625:69323:182077',1),
(29985,'Enlargement Equipment',4,182077,'625:69323:182077',1),
(29986,'Enlarging Lenses',4,182077,'625:69323:182077',1),
(29990,'Safelights & Bulbs',4,182077,'625:69323:182077',1),
(29991,'Darkroom Timers',4,182077,'625:69323:182077',1),
(29993,'Processing & Finishing Equip',4,182077,'625:69323:182077',1),
(29994,'Accessory Bundles',3,15200,'625:15200',1),
(30038,'Film Camera Parts',3,182074,'625:182074',1),
(30040,'Filter Rings & Holders',3,78997,'625:78997',1),
(30059,'Lens Adapters, Mounts & Tubes',3,78997,'625:78997',1),
(30078,'Lighting & Studio',2,625,'625',0),
(30082,'Studio Reflectors',4,79007,'625:30078:79007',1),
(30085,'Props & Stage Equipment',3,30078,'625:30078',1),
(30086,'Slaves & Trigger Systems',4,124848,'625:30078:124848',1),
(30087,'Other Flash Lighting',4,124848,'625:30078:124848',1),
(30088,'Other Lighting & Studio',3,30078,'625:30078',1),
(30089,'Projection Screens & Material',4,15250,'625:69323:15250',1),
(30090,'Tripods & Supports',2,625,'625',0),
(30093,'Tripods & Monopods',3,30090,'625:30090',1),
(30095,'Tripod Heads',3,30090,'625:30090',1),
(30097,'Other Tripods & Supports',3,30090,'625:30090',1),
(30101,'Punching Bags',4,179784,'888:179767:179784',1),
(30102,'Gloves - Boxing',3,179767,'888:179767',1),
(30105,'Climbing Equipment',2,888,'888',0),
(30106,'Shoes',3,30105,'888:30105',1),
(30108,'Cycle Computers & GPS',4,177840,'888:7294:177840',1),
(30109,'Golf Club Bags',4,181153,'888:1513:181153',1),
(30115,'Monitoring & Testing',3,11778,'26395:11778',0),
(30117,'Other Diabetic Aids',5,72873,'26395:11778:30115:72873',1),
(30118,'Fertility Monitors & OPKs',4,176992,'26395:67588:176992',1),
(30261,'Architecture',3,4752,'260:4752',1),
(30354,'Air & Water Flossers',3,31769,'26395:31769',1),
(30368,'Replacement Lenses',3,31414,'26395:31414',1),
(30506,'Air Compressors',4,22659,'11700:631:22659',1),
(30541,'Nails',4,180974,'11700:3187:180974',1),
(30554,'Paint Thinner & Solvents',4,41989,'11700:3187:41989',1),
(30562,'Wall Panelling',4,180969,'11700:3187:180969',1),
(30564,'Other Timber & Composites',4,180969,'11700:3187:180969',1),
(30651,'Other',5,80979,'220:180250:19151:80979',1),
(30654,'TT Scale',3,180250,'220:180250',0),
(30670,'Other',5,81064,'220:180250:30654:81064',1),
(30671,'Other',5,81083,'220:180250:19116:81083',1),
(30889,'Stage Lighting Controllers',3,12922,'619:12922',1),
(31015,'Silk Painting',3,183118,'14339:183118',0),
(31016,'Patterns & Instructions',4,31015,'14339:183118:31015',1),
(31019,'Silk Painting Supplies',4,31015,'14339:183118:31015',1),
(31097,'Other',5,81043,'220:180250:19145:81043',1),
(31100,'Lamps & Lights',5,81055,'220:180250:19119:81055',1),
(31101,'Catenaries',5,81055,'220:180250:19119:81055',1),
(31103,'Signals',5,81055,'220:180250:19119:81055',1),
(31104,'Scenery & Trees',5,81055,'220:180250:19119:81055',1),
(31107,'Lamps & Lights',5,180280,'220:180250:19128:180280',1),
(31108,'Catenaries',5,180280,'220:180250:19128:180280',1),
(31109,'Other',4,180339,'220:180250:180339',1),
(31155,'Western Hats',4,16240,'888:3153:16240',1),
(31248,'Other AFL',3,109938,'888:109938',1),
(31253,'Scrapbooking',3,11788,'14339:11788',0),
(31269,'Motorboats',3,26429,'9800:26429',1),
(31274,'Electronics',3,26443,'131090:26443',0),
(31275,'Marine Radio',4,31274,'131090:26443:31274',1),
(31277,'Compasses',4,26450,'131090:26443:26450',1),
(31281,'Other Sailing Hardware & Gear',4,181461,'131090:26443:181461',1),
(31283,'Steering',3,26443,'131090:26443',1),
(31284,'Ignition & Starting Systems',4,50440,'131090:26443:50440',1),
(31285,'Exhaust Systems',4,50440,'131090:26443:50440',1),
(31286,'Intake & Fuel System',4,50440,'131090:26443:50440',1),
(31287,'Eyeglass Straps & Cords',3,31414,'26395:31414',1),
(31289,'Contact Lens Care Solutions',3,31414,'26395:31414',1),
(31385,'Shelves',3,26677,'11700:26677',1),
(31387,'Wristwatches',3,14324,'281:14324',1),
(31388,'Digital Cameras',2,625,'625',1),
(31390,'Exercise Balls',4,28064,'888:15273:28064',1),
(31393,'Yu-Gi-Oh! Trading Card Game',3,2536,'220:2536',0),
(31395,'Yu-Gi-Oh! Individual Cards',4,31393,'220:2536:31393',1),
(31396,'Yu-Gi-Oh! Sealed Booster Packs',4,31393,'220:2536:31393',1),
(31397,'Other Yu-Gi-Oh! TCG Items',4,31393,'220:2536:31393',1),
(31398,'Warhammer',4,16486,'220:233:16486',0),
(31399,'Other 40K Items',6,44408,'220:233:16486:31398:44408',1),
(31400,'Other WFB Items',6,44409,'220:233:16486:31398:44409',1),
(31401,'Acrylic Paint',5,183102,'14339:11783:28110:183102',1),
(31412,'Hair Colouring',3,11854,'26395:11854',1),
(31413,'Hair Loss Treatments',3,11854,'26395:11854',1),
(31414,'Vision Care',2,26395,'26395',0),
(31416,'Other Vision Care',3,31414,'26395:31414',1),
(31492,'Audio Cables & Adapters',3,182094,'58058:182094',1),
(31493,'FireWire Cables & Adapters',3,182094,'58058:182094',1),
(31509,'CD, DVD & Blu-ray Duplicators',3,165,'58058:165',1),
(31510,'Laptop Power Adapters/Chargers',3,31530,'58058:31530',1),
(31519,'Laptop Cases & Bags',3,31530,'58058:31530',1),
(31529,'Anti-Theft Locks & Kits',3,31530,'58058:31530',1),
(31530,'Laptop & Desktop Accessories',2,58058,'58058',0),
(31534,'Other Laptop & Desktop Accs',3,31530,'58058:31530',1),
(31568,'Laptop Replacement Keyboards',4,182089,'58058:175673:182089',1),
(31569,'Laptop Screens & LCD Panels',4,182089,'58058:175673:182089',1),
(31579,'Other Computer Whlsl Lots',3,159260,'58058:159260',1),
(31587,'Plaques & Signs',3,10033,'11700:10033',1),
(31601,'Screens & Room Dividers',3,3197,'11700:3197',1),
(31605,'Wholesale Lots',2,11700,'11700',0),
(31606,'Wholesale, Bulk Lots',2,11232,'11232',1),
(31608,'Wholesale, Bulk Lots',2,11233,'11233',1),
(31626,'Memorabilia',3,21194,'888:21194',1),
(31633,'Memorabilia',3,179767,'888:179767',1),
(31636,'Gridiron',2,888,'888',0),
(31647,'Golf Memorabilia',3,1513,'888:1513',1),
(31663,'Memorabilia',3,170497,'888:170497',1),
(31690,'Jigs',4,179961,'888:1492:179961',1),
(31691,'Soft Plastics',4,179961,'888:1492:179961',1),
(31692,'Spoons',4,179961,'888:1492:179961',1),
(31693,'Other',4,179961,'888:1492:179961',1),
(31710,'Scopes, Optics, Lasers',3,7301,'888:7301',0),
(31711,'Binoculars',4,31710,'888:7301:31710',1),
(31712,'Range Finders',4,31710,'888:7301:31710',1),
(31723,'Beads',2,14339,'14339',0),
(31726,'Other Beads',3,31723,'14339:31723',1),
(31730,'Fabric Transfers',3,183118,'14339:183118',1),
(31732,'Buttons',4,160704,'14339:28102:160704',1),
(31733,'Mini Bows',5,183591,'14339:11788:31253:183591',1),
(31737,'Vellum',3,11788,'14339:11788',1),
(31740,'Stamps',3,3122,'14339:3122',1),
(31744,'Animals, Insects',4,83756,'220:11731:83756',1),
(31745,'Astronomy',4,83756,'220:11731:83756',1),
(31751,'Bath Oils',3,11838,'26395:11838',1),
(31752,'Body Exfoliants & Scrubs',3,11838,'26395:11838',1),
(31753,'Body Sprays & Mists',3,11838,'26395:11838',1),
(31754,'Body Washes & Shower Gels',3,11838,'26395:11838',1),
(31755,'Bubble Baths',3,11838,'26395:11838',1),
(31762,'Shaving & Hair Removal',2,26395,'26395',0),
(31763,'Shaving Creams, Foams & Gels',3,31762,'26395:31762',1),
(31769,'Dental & Oral Care',2,26395,'26395',0),
(31770,'Electric Toothbrushes',3,31769,'26395:31769',1),
(31772,'Sun Protection & Tanning',2,26395,'26395',0),
(31773,'Sunless Tanning Products',3,31772,'26395:31772',1),
(31774,'Sunscreen',3,31772,'26395:31772',1),
(31776,'Tanning Lotion',3,31772,'26395:31772',1),
(31786,'Makeup',2,26395,'26395',0),
(31787,'Eyeliner',4,172020,'26395:31786:172020',1),
(31788,'Sets & Kits',3,11854,'26395:11854',1),
(31802,'Lip Gloss',4,172027,'26395:31786:172027',1),
(31803,'Lip Liner',4,172027,'26395:31786:172027',1),
(31804,'Lipstick',4,172027,'26395:31786:172027',1),
(31811,'Other Makeup',3,31786,'26395:31786',1),
(31817,'Weight Management',3,180959,'26395:180959',0),
(31821,'Meal Replacement Drinks',4,31817,'26395:180959:31817',1),
(31822,'Other Wholesale Health, Beauty',3,40965,'26395:40965',1),
(32044,'Gift Books, Cards',3,45110,'267:45110',1),
(32050,'Body Piercing Jewellery',3,15124,'281:15124',1),
(32073,'Motorcycles',2,9800,'9800',0),
(32075,'Scooters',3,32073,'9800:32073',1),
(32094,'Mod Chips',4,33739,'131090:6030:33739',1),
(32254,'Beds & Mattresses',3,3197,'11700:3197',0),
(32476,'Russia',4,45148,'11116:58520:45148',1),
(32615,'Pins, Badges, Patches',2,1,'1',0),
(32621,'Other Media',3,161534,'237:161534',1),
(32624,'Engine Modifications',4,33739,'131090:6030:33739',1),
(32626,'Other Quads, Trikes, Buggies',4,161415,'9800:32073:161415',1),
(32633,'Caravans, Motorhomes',2,9800,'9800',1),
(32714,'Sanders',3,64808,'170769:64808',1),
(32806,'Car Audio & Video Installation',3,3270,'131090:3270',0),
(32810,'Power & Speaker Wire',4,32806,'131090:3270:32806',1),
(32834,'Video Cables & Adapters',3,71582,'172176:71582',1),
(32871,'Other Gifts',3,100978,'2984:100978',1),
(32872,'Dummies',3,20400,'2984:20400',1),
(32874,'Shower Curtain Hooks',3,26677,'11700:26677',1),
(32876,'Toilet Paper Holders',4,20601,'11700:3187:20601',1),
(32878,'Dressing Tables',3,3197,'11700:3197',1),
(32882,'Coffee Grinders',2,20710,'20710',1),
(32883,'Dehydrators',3,20667,'20710:20667',1),
(32884,'Cookie Cutters',4,177009,'11700:20625:177009',1),
(32885,'Rolling Pins',4,177009,'11700:20625:177009',1),
(32943,'Telescope Cases & Bags',4,74922,'625:28179:74922',1),
(32987,'Autographs',3,196,'11232:196',1),
(32991,'Apparel',3,196,'11232:196',1),
(32992,'Clippings',3,196,'11232:196',1),
(32994,'Programmes',3,196,'11232:196',1),
(32996,'Clippings',3,1424,'11232:1424',1),
(33021,'Acoustic Guitars',3,3858,'619:3858',1),
(33034,'Electric Guitars',3,3858,'619:3858',1),
(33050,'Capos',4,180009,'619:3858:180009',1),
(33082,'Generators',3,631,'11700:631',1),
(33156,'Wedding Favours',3,11827,'11700:11827',1),
(33161,'Tableware & Serveware',3,11827,'11700:11827',1),
(33164,'Anti-Aging Products',3,11863,'26395:11863',1),
(33235,'Photo Frames',3,66697,'2984:66697',1),
(33485,'Jerseys',4,159178,'888:20862:159178',1),
(33542,'Air Conditioning, Heating',3,6030,'131090:6030',0),
(33543,'AC Compressors',4,33542,'131090:6030:33542',1),
(33545,'AC Controls',4,33542,'131090:6030:33542',1),
(33546,'Blower Motors',4,33542,'131090:6030:33542',1),
(33547,'Condensers, Evaporators',4,33542,'131090:6030:33542',1),
(33548,'Heater Parts',4,33542,'131090:6030:33542',1),
(33549,'Air Intake, Fuel Delivery',3,6030,'131090:6030',0),
(33550,'Carburetors',4,33549,'131090:6030:33549',1),
(33551,'Carburetor Parts',4,33549,'131090:6030:33549',1),
(33552,'Chokes',4,33549,'131090:6030:33549',1),
(33554,'Fuel Injectors',4,33549,'131090:6030:33549',1),
(33555,'Fuel Pumps',4,33549,'131090:6030:33549',1),
(33556,'Fuel Tanks',4,33549,'131090:6030:33549',1),
(33557,'Sensors',4,33549,'131090:6030:33549',1),
(33558,'Throttle Body',4,33549,'131090:6030:33549',1),
(33559,'Brakes & Brake Parts',3,6030,'131090:6030',0),
(33561,'Brake Hoses',4,33559,'131090:6030:33559',1),
(33563,'Caliper Parts',4,33559,'131090:6030:33559',1),
(33564,'Discs',4,33559,'131090:6030:33559',1),
(33565,'Drums',4,33559,'131090:6030:33559',1),
(33566,'Master Cylinders',4,33559,'131090:6030:33559',1),
(33567,'Brake Pads',4,33559,'131090:6030:33559',1),
(33568,'Handbrake Cables',4,33559,'131090:6030:33559',1),
(33571,'Wheel Cylinders',4,33559,'131090:6030:33559',1),
(33572,'Charging, Starting Systems',3,6030,'131090:6030',0),
(33575,'Battery Trays',4,33572,'131090:6030:33572',1),
(33577,'Voltage Regulators',4,33572,'131090:6030:33572',1),
(33578,'Other',4,33572,'131090:6030:33572',1),
(33579,'Suspension, Steering',3,6030,'131090:6030',0),
(33580,'Ball Joints',4,33579,'131090:6030:33579',1),
(33581,'Caster/Camber Kits',4,33579,'131090:6030:33579',1),
(33582,'Coil Springs',4,33579,'131090:6030:33579',1),
(33583,'Control Arms',4,33579,'131090:6030:33579',1),
(33584,'Leaf Springs',4,33579,'131090:6030:33579',1),
(33585,'Lift Kits',4,33579,'131090:6030:33579',1),
(33587,'Pitman & Idler Arms',4,33579,'131090:6030:33579',1),
(33588,'Power Steering Pumps',4,33579,'131090:6030:33579',1),
(33589,'Steering Racks, Gear Boxes',4,33579,'131090:6030:33579',1),
(33590,'Shocks, Struts',4,33579,'131090:6030:33579',1),
(33591,'Strut Bars',4,33579,'131090:6030:33579',1),
(33592,'Sway Bars',4,33579,'131090:6030:33579',1),
(33593,'Tie Rod Ends',4,33579,'131090:6030:33579',1),
(33594,'ECUs, Chips, Cruise Control',3,6030,'131090:6030',0),
(33595,'Cruise Control Units',4,33594,'131090:6030:33594',1),
(33596,'ECUs',4,33594,'131090:6030:33594',1),
(33597,'Performance Chips',4,33594,'131090:6030:33594',1),
(33598,'Other',4,33594,'131090:6030:33594',1),
(33599,'Cooling Systems',3,6030,'131090:6030',0),
(33600,'Fans',4,33599,'131090:6030:33599',1),
(33601,'Clamps, Hoses',4,33599,'131090:6030:33599',1),
(33602,'Radiators',4,33599,'131090:6030:33599',1),
(33603,'Thermostats',4,33599,'131090:6030:33599',1),
(33604,'Water Pumps',4,33599,'131090:6030:33599',1),
(33612,'Engines, Components',3,6030,'131090:6030',0),
(33613,'Block Parts',4,33612,'131090:6030:33612',1),
(33614,'Camshafts, Lifters & Parts',4,33612,'131090:6030:33612',1),
(33615,'Complete Engines',4,33612,'131090:6030:33612',1),
(33616,'Crankshafts & Parts',4,33612,'131090:6030:33612',1),
(33617,'Cylinder Heads & Parts',4,33612,'131090:6030:33612',1),
(33619,'Engine Bearings',4,33612,'131090:6030:33612',1),
(33620,'Engine Rebuilding Kits',4,33612,'131090:6030:33612',1),
(33621,'Valves & Parts',4,33612,'131090:6030:33612',1),
(33622,'Oil Filler Caps',4,33612,'131090:6030:33612',1),
(33623,'Pistons, Rings, Rods & Parts',4,33612,'131090:6030:33612',1),
(33624,'Rocker Arms & Parts',4,33612,'131090:6030:33612',1),
(33625,'Timing Components',4,33612,'131090:6030:33612',1),
(33626,'Vacuum Pumps',4,33612,'131090:6030:33612',1),
(33627,'Valve Covers',4,33612,'131090:6030:33612',1),
(33628,'Exhausts',3,6030,'131090:6030',0),
(33629,'Cat Converters',4,33628,'131090:6030:33628',1),
(33630,'Exhaust Systems',4,33628,'131090:6030:33628',1),
(33632,'Manifolds & Headers',4,33628,'131090:6030:33628',1),
(33633,'Pipes & Tips',4,33628,'131090:6030:33628',1),
(33636,'Mufflers',4,33628,'131090:6030:33628',1),
(33637,'Exterior',3,6030,'131090:6030',0),
(33638,'Spoilers, Wings',4,33637,'131090:6030:33637',1),
(33639,'Antennas',4,33637,'131090:6030:33637',1),
(33640,'Bumper Bars',4,33637,'131090:6030:33637',1),
(33644,'Fenders',4,33637,'131090:6030:33637',1),
(33645,'Grills',4,33637,'131090:6030:33637',1),
(33646,'Bonnets',4,33637,'131090:6030:33637',1),
(33647,'Tailgates & Liftgates',4,33637,'131090:6030:33637',1),
(33648,'Lock Mechanisms',4,33637,'131090:6030:33637',1),
(33649,'Mirrors',4,33637,'131090:6030:33637',1),
(33650,'Running Boards',4,33637,'131090:6030:33637',1),
(33651,'Racks',4,33637,'131090:6030:33637',1),
(33652,'Sunroofs',4,33637,'131090:6030:33637',1),
(33653,'Tow Bars & Winches',4,33637,'131090:6030:33637',1),
(33654,'Mouldings, Trim',4,33637,'131090:6030:33637',1),
(33656,'Boot Lids & Parts',4,33637,'131090:6030:33637',1),
(33657,'Windshield Wipers',4,33637,'131090:6030:33637',1),
(33658,'Filters',3,6030,'131090:6030',0),
(33659,'Air',4,33658,'131090:6030:33658',1),
(33660,'Fuel',4,33658,'131090:6030:33658',1),
(33661,'Oil',4,33658,'131090:6030:33658',1),
(33662,'Transmission',4,33658,'131090:6030:33658',1),
(33663,'Other',4,33658,'131090:6030:33658',1),
(33664,'Gaskets',3,6030,'131090:6030',0),
(33665,'Head Gaskets',4,33664,'131090:6030:33664',1),
(33666,'Exhaust Gaskets',4,33664,'131090:6030:33664',1),
(33667,'Full Gasket Sets',4,33664,'131090:6030:33664',1),
(33672,'Gauges',3,6030,'131090:6030',0),
(33673,'Clocks',4,33672,'131090:6030:33672',1),
(33674,'Fuel Gauges',4,33672,'131090:6030:33672',1),
(33675,'Instrument Clusters',4,33672,'131090:6030:33672',1),
(33676,'Oil Pressure Gauges',4,33672,'131090:6030:33672',1),
(33677,'Panel Gauges',4,33672,'131090:6030:33672',1),
(33678,'Speedometers',4,33672,'131090:6030:33672',1),
(33679,'Tachometers',4,33672,'131090:6030:33672',1),
(33680,'Vacuum Gauges',4,33672,'131090:6030:33672',1),
(33681,'Volt Meters',4,33672,'131090:6030:33672',1),
(33682,'Temp Gauges',4,33672,'131090:6030:33672',1),
(33683,'Glass',3,6030,'131090:6030',0),
(33684,'Windows',4,33683,'131090:6030:33683',1),
(33685,'Seals',4,33683,'131090:6030:33683',1),
(33686,'Windshields',4,33683,'131090:6030:33683',1),
(33687,'Ignition Systems',3,6030,'131090:6030',0),
(33688,'Caps, Rotors, Contacts',4,33687,'131090:6030:33687',1),
(33689,'Coils, Modules, Pickups',4,33687,'131090:6030:33687',1),
(33690,'Distributors',4,33687,'131090:6030:33687',1),
(33692,'Ignition Wires',4,33687,'131090:6030:33687',1),
(33693,'Spark Plugs & Glow Plugs',4,33687,'131090:6030:33687',1),
(33694,'Interior',3,6030,'131090:6030',0),
(33695,'Consoles',4,33694,'131090:6030:33694',1),
(33696,'Interior Door Panels & Parts',4,33694,'131090:6030:33694',1),
(33697,'Floor Mats, Carpets',4,33694,'131090:6030:33694',1),
(33698,'Glove Boxes',4,33694,'131090:6030:33694',1),
(33699,'Mirrors',4,33694,'131090:6030:33694',1),
(33700,'Pedals',4,33694,'131090:6030:33694',1),
(33701,'Seats',4,33694,'131090:6030:33694',1),
(33702,'Seat Covers',4,33694,'131090:6030:33694',1),
(33703,'Shift Knobs, Boots',4,33694,'131090:6030:33694',1),
(33704,'Steering Wheels & Horns',4,33694,'131090:6030:33694',1),
(33705,'Trim',4,33694,'131090:6030:33694',1),
(33706,'Window Motors',4,33694,'131090:6030:33694',1),
(33707,'Lights, Indicators',3,6030,'131090:6030',0),
(33708,'Corner Lights',4,33707,'131090:6030:33707',1),
(33709,'Fog/Exterior Lights',4,33707,'131090:6030:33707',1),
(33710,'Headlights',4,33707,'131090:6030:33707',1),
(33711,'Dash Lights',4,33707,'131090:6030:33707',1),
(33712,'Interior Lights',4,33707,'131090:6030:33707',1),
(33713,'LED Lights',4,33707,'131090:6030:33707',1),
(33714,'Neon Lights',4,33707,'131090:6030:33707',1),
(33716,'Tail Lights',4,33707,'131090:6030:33707',1),
(33717,'Turn Signals',4,33707,'131090:6030:33707',1),
(33718,'Safety, Security',3,6030,'131090:6030',0),
(33720,'Anti-Theft Devices',4,33718,'131090:6030:33718',1),
(33721,'Car Alarms',4,33718,'131090:6030:33718',1),
(33722,'Fire Extinguishers',4,33718,'131090:6030:33718',1),
(33723,'Keyless Entry Remotes/Fobs',4,33718,'131090:6030:33718',1),
(33725,'Seat Belts',4,33718,'131090:6030:33718',1),
(33726,'Transmission',3,6030,'131090:6030',0),
(33727,'Automatic Transmission',4,33726,'131090:6030:33726',1),
(33728,'Axle Parts',4,33726,'131090:6030:33726',1),
(33729,'CV Joints',4,33726,'131090:6030:33726',1),
(33730,'Clutches',4,33726,'131090:6030:33726',1),
(33731,'Differentials',4,33726,'131090:6030:33726',1),
(33733,'Manual Transmission',4,33726,'131090:6030:33726',1),
(33735,'Pressure Plates',4,33726,'131090:6030:33726',1),
(33736,'Shifters',4,33726,'131090:6030:33726',1),
(33738,'Universal Joints, Driveshafts',4,33726,'131090:6030:33726',1),
(33739,'Performance Parts',3,6030,'131090:6030',0),
(33742,'Turbo Chargers & Parts',4,33739,'131090:6030:33739',1),
(33743,'Wheels, Tyres',3,6030,'131090:6030',0),
(33744,'Hub Caps',4,33743,'131090:6030:33743',1),
(33746,'Tyre Accessories',4,33743,'131090:6030:33743',1),
(33747,'Valve Stems, Caps',4,33743,'131090:6030:33743',1),
(33875,'Albums & Refills',5,183248,'14339:11788:31253:183248',1),
(33914,'Tattoos & Body Art',2,26395,'26395',0),
(33915,'Tattoo Flash',3,33914,'26395:33914',1),
(33916,'Piercing Supplies & Kits',3,33914,'26395:33914',1),
(33917,'Tattoo Machines & Guns',3,33914,'26395:33914',1),
(33918,'Tattoo Supplies',3,33914,'26395:33914',1),
(33919,'Temporary Tattoos',3,33914,'26395:33914',1),
(33929,'Cordless Telephones',3,164874,'15032:164874',1),
(33963,'Keyboards & Keypads',3,3676,'58058:3676',1),
(33968,'Carnival',3,50693,'870:50693',1),
(33973,'Fly Fishing Combos',4,179953,'888:1492:179953',1),
(34002,'Scrapbooking Stickers',5,183591,'14339:11788:31253:183591',1),
(34017,'Cross Stitch Kits',5,183197,'14339:160706:28141:183197',1),
(34032,'Cross Stitch Patterns',5,183199,'14339:160706:28141:183199',1),
(34054,'Control Line & Free Flight',3,2562,'220:2562',1),
(34058,'Boats & Watercraft',5,182203,'220:2562:182187:182203',1),
(34061,'Cars & Motorcycles',5,182203,'220:2562:182187:182203',1),
(34071,'Sets',3,110633,'281:110633',1),
(34082,'Tools',3,164352,'281:164352',0),
(34084,'Loupes, Magnifiers',4,34082,'281:164352:34082',1),
(34085,'Pliers',4,34082,'281:164352:34082',1),
(34086,'Ring Sizers',4,34082,'281:164352:34082',1),
(34095,'Welding',3,182941,'170769:182941',0),
(34097,'Welding Rods & Wires',5,182905,'170769:182941:34095:182905',1),
(34210,'Media',4,50428,'131090:6747:50428',1),
(34235,'Media',4,34352,'131090:6747:34352',1),
(34352,'Motorcycle Merchandise',3,6747,'131090:6747',0),
(34355,'Other',4,34352,'131090:6747:34352',1),
(34942,'Other',4,177655,'11116:178078:177655',1),
(34943,'Palladium',3,178078,'11116:178078',1),
(34998,'Tools',3,6030,'131090:6030',0),
(34999,'Air Tools',4,34998,'131090:6030:34998',1),
(35000,'Power Tools',4,34998,'131090:6030:34998',1),
(35001,'Toolboxes',4,34998,'131090:6030:34998',1),
(35029,'Autographs',3,1424,'11232:1424',1),
(35061,'Calendars',3,196,'11232:196',1),
(35190,'Mounts & Holders',3,9394,'15032:9394',1),
(35227,'Passenger Vehicles',3,29690,'9800:29690',1),
(35284,'Estonia',3,4742,'260:4742',1),
(35285,'Latvia',3,4742,'260:4742',1),
(35286,'Lithuania',3,4742,'260:4742',1),
(35288,'Bulgaria',3,4742,'260:4742',1),
(35289,'Denmark & Faroe Islands',3,4742,'260:4742',1),
(35558,'Classic, Vintage Parts',3,14780,'131090:14780',1),
(35576,'Salvage Motorcycles',3,32073,'9800:32073',1),
(35711,'Decanters',3,3265,'1:3265',1),
(35713,'Drinkware',3,3265,'1:3265',1),
(35716,'Advertising',3,562,'1:562',1),
(35717,'Clocks',3,562,'1:562',1),
(35728,'Playing Cards',3,562,'1:562',1),
(35729,'Posters, Prints',3,562,'1:562',1),
(35730,'Taps, Knobs',3,562,'1:562',1),
(35733,'Bar Towels',3,562,'1:562',1),
(35863,'Dragons',3,10860,'1:10860',0),
(35867,'Candles, Incense',4,35863,'1:10860:35863',1),
(35869,'Statues',4,35863,'1:10860:35863',1),
(35874,'Fairies',3,10860,'1:10860',1),
(35878,'Floor',5,4053,'1:13905:1404:4053',1),
(35889,'Greeting Cards',3,124,'1:124',1),
(35929,'Books, Manuals',4,50428,'131090:6747:50428',1),
(35979,'Compacts',3,597,'1:597',1),
(35982,'Perfumes',3,597,'1:597',1),
(36019,'Decorative Plates & Bowls',3,10033,'11700:10033',1),
(36021,'Door Knockers',4,38217,'11700:10033:38217',1),
(36022,'Door Stops',4,38217,'11700:10033:38217',1),
(36024,'Hooks & Hangers',4,43502,'11700:299:43502',1),
(36025,'Sculptures & Figurines',3,10033,'11700:10033',1),
(36026,'Coasters',4,20687,'11700:20625:20687',1),
(36027,'Dinnerware',3,20625,'11700:20625',0),
(36028,'Bowls',4,36027,'11700:20625:36027',1),
(36029,'Cups & Saucers',4,36027,'11700:20625:36027',1),
(36030,'Plates',4,36027,'11700:20625:36027',1),
(36032,'Dinner Sets',4,36027,'11700:20625:36027',1),
(36060,'1961 - 1975 (Vietnam)',3,13956,'1:13956',1),
(36066,'Modern, Current',3,13956,'1:13956',1),
(36075,'Surplus',3,13956,'1:13956',1),
(36096,'Points & Arrowheads',4,181307,'888:20835:181307',1),
(36098,'Accessories',3,20835,'888:20835',0),
(36099,'Arrow Rests',4,36098,'888:20835:36098',1),
(36109,'Other',4,181378,'888:16034:181378',1),
(36114,'Sleeping Mats',4,181403,'888:16034:181403',1),
(36120,'Tent & Canopy Accessories',4,181404,'888:16034:181404',1),
(36122,'Kayaks',4,166101,'888:23806:166101',1),
(36124,'Jackets',4,22682,'888:7294:22682',1),
(36137,'Pedals',4,57262,'888:7294:57262',1),
(36141,'Trainers & Rollers',4,177832,'888:7294:177832',1),
(36147,'Spinning Reels',4,179950,'888:1492:179950',1),
(36149,'Casting Rods',4,179946,'888:1492:179946',1),
(36150,'Spinning Rods',4,179946,'888:1492:179946',1),
(36151,'Downrigger, Outrigger Gear',4,179985,'888:1492:179985',1),
(36153,'Saltwater Lures',4,179961,'888:1492:179961',1),
(36155,'Belts',4,28066,'888:15273:28066',1),
(36169,'Lures',4,180001,'888:1492:180001',1),
(36175,'Reels',4,180001,'888:1492:180001',1),
(36192,'Other Golf Club Components',4,47323,'888:1513:47323',1),
(36234,'Putting Greens & Aids',4,181129,'888:1513:181129',1),
(36239,'Clothing, Shoes & Accessories',3,7301,'888:7301',0),
(36259,'Skiing, Snowboarding',2,888,'888',0),
(36260,'Ski & Snowboard Helmets',3,36259,'888:36259',1),
(36261,'Pants & Salopettes',4,21233,'888:36259:21233',1),
(36269,'Other',3,74050,'888:74050',1),
(36270,'Batting Helmets & Face Guards',4,73910,'888:16021:73910',1),
(36275,'Air Hockey',2,888,'888',1),
(36276,'Foosball',2,888,'888',1),
(36277,'Bats',3,97072,'888:97072',1),
(36292,'Boots',4,21247,'888:36259:21247',1),
(36314,'Data Acquisition & Loggers',5,181940,'170769:92074:181939:181940',0),
(36315,'Test Equipment Parts & Accs',4,181939,'170769:92074:181939',0),
(36327,'Prototyping & Breadboards',4,182412,'170769:92074:182412',1),
(36328,'General Purpose Relays',5,181686,'170769:42892:181678:181686',1),
(36330,'Semiconductors & Actives',4,182412,'170769:92074:182412',0),
(36332,'Other Semiconductors & Actives',5,36330,'170769:92074:182412:36330',1),
(36407,'Rollers & Curlers',3,11854,'26395:11854',1),
(36409,'Makeup Tools & Accessories',3,31786,'26395:31786',0),
(36413,'Makeup Bags & Cases',3,31786,'26395:31786',1),
(36430,'Spas, Baths & Supplies',3,47945,'26395:47945',1),
(36431,'Foot Creams & Treatments',3,67588,'26395:67588',1),
(36432,'Hand & Nail Treatment Creams',3,47945,'26395:47945',1),
(36437,'Pregnancy Tests',4,176992,'26395:67588:176992',1),
(36440,'Incontinence Aids',4,182118,'26395:11778:182118',1),
(36447,'Massage',2,26395,'26395',0),
(36448,'Electric Massage Chairs',3,36447,'26395:36447',1),
(36449,'Massagers',3,36447,'26395:36447',1),
(36453,'Massage Oils & Lotions',3,36447,'26395:36447',1),
(36454,'Massage Tables & Chairs',3,36447,'26395:36447',1),
(36455,'Weight Loss Kits & Accs',4,31817,'26395:180959:31817',1),
(36475,'Body Kits',4,33637,'131090:6030:33637',1),
(36476,'Xenon Lights',4,33707,'131090:6030:33707',1),
(36547,'Bratz',3,238,'237:238',1),
(36548,'Zapf Creations',3,238,'237:238',1),
(36589,'Yarn',3,160706,'14339:160706',1),
(36601,'Roving Wool & Fibers',4,183209,'14339:160706:183209',1),
(36602,'Spindles',5,183218,'14339:160706:183209:183218',1),
(36624,'Bearings',4,159073,'888:16262:159073',1),
(36627,'Other',2,131090,'131090',1),
(36632,'Trailer Parts',2,131090,'131090',1),
(36655,'Sailing Winches',4,181461,'131090:26443:181461',1),
(36680,'Air Filters, Induction Kits',4,33739,'131090:6030:33739',1),
(36802,'Other Automation Equipment',3,42892,'170769:42892',1),
(36865,'Eye Shadow',4,172020,'26395:31786:172020',1),
(36870,'Lip Balm & Treatments',3,11863,'26395:11863',1),
(36956,'Rug Pads & Accessories',3,20571,'11700:20571',1),
(37152,'Italy',4,45148,'11116:58520:45148',1),
(37557,'Attributes',3,14112,'99:14112',0),
(37558,'Attributes1',4,37557,'99:14112:37557',1),
(37559,'Attributes2',4,37557,'99:14112:37557',1),
(37560,'Attributes3',4,37557,'99:14112:37557',1),
(37561,'Attributes4',4,37557,'99:14112:37557',1),
(37562,'Attributes5',4,37557,'99:14112:37557',1),
(37563,'Attributes10',4,37557,'99:14112:37557',1),
(37565,'Attributes9',4,37557,'99:14112:37557',1),
(37566,'Attributes6',4,37557,'99:14112:37557',1),
(37567,'Attributes7',4,37557,'99:14112:37557',1),
(37568,'Attributes8',4,37557,'99:14112:37557',1),
(37631,'Toilet Training',2,2984,'2984',1),
(37632,'Mats, Rugs',3,66697,'2984:66697',1),
(37633,'Wall Décor',3,66697,'2984:66697',1),
(37637,'Toilet Seats',4,20601,'11700:3187:20601',1),
(37644,'Quilt Covers',3,20444,'11700:20444',1),
(37795,'Boxing Cards',3,212,'888:212',1),
(37802,'Epilators & Electrolysis',3,31762,'26395:31762',1),
(37821,'Hearing Assistance',4,182118,'26395:11778:182118',1),
(37822,'Acupuncture',3,67659,'26395:67659',1),
(37828,'Print Advertising',3,34,'1:34',1),
(37893,'Trading Card Singles',4,182983,'1:182982:182983',1),
(37894,'Trading Card Singles',4,183024,'1:182982:183024',1),
(37920,'Baskets',3,20082,'20081:20082',1),
(37925,'Chests',3,20082,'20081:20082',1),
(37941,'Woodenware',3,20086,'20081:20086',1),
(37945,'African',3,2207,'20081:2207',1),
(37958,'Maps, Atlases, Globes',2,20081,'20081',0),
(37965,'Maritime',2,20081,'20081',0),
(37967,'Compasses',3,37965,'20081:37965',1),
(37968,'Fishing Nets & Floats',3,37965,'20081:37965',1),
(37971,'Sextants',3,37965,'20081:37965',1),
(37972,'Telescopes',3,37965,'20081:37965',1),
(37975,'Keyboard',3,181726,'20081:181726',1),
(37976,'Percussion',3,181726,'20081:181726',1),
(37977,'Wind',3,181726,'20081:181726',1),
(37978,'Rugs & Carpets',2,20081,'20081',1),
(38016,'Keyrings',2,1,'1',1),
(38032,'Tube Radios',4,931,'1:29832:931',1),
(38036,'Telephone',3,29832,'1:29832',1),
(38039,'Cases',3,593,'1:593',1),
(38052,'Signs',3,593,'1:593',1),
(38053,'Tins',3,593,'1:593',1),
(38069,'Drum Machines',4,181227,'619:180012:181227',1),
(38070,'Samplers & Sequencers',3,180014,'619:180014',1),
(38071,'Synthesisers',3,180014,'619:180014',1),
(38072,'Guitar Amplifiers',3,3858,'619:3858',1),
(38088,'Electronic Keyboards',3,180010,'619:180010',1),
(38093,'Bass Drums',4,181227,'619:180012:181227',1),
(38095,'Snare Drums',4,181227,'619:180012:181227',1),
(38096,'Toms',4,181227,'619:180012:181227',1),
(38097,'Drum Kits',4,181227,'619:180012:181227',1),
(38101,'Keyboard & Piano',3,182150,'619:182150',1),
(38102,'Strings',3,182150,'619:182150',1),
(38107,'Violins',4,181281,'619:180016:181281',1),
(38134,'Canisters',3,13905,'1:13905',1),
(38148,'Mugs',3,13905,'1:13905',1),
(38151,'Forks',4,978,'1:13905:978',1),
(38152,'Knives',4,978,'1:13905:978',1),
(38153,'Spoons',4,978,'1:13905:978',1),
(38154,'Serving Pieces',4,978,'1:13905:978',1),
(38155,'Mixed Tableware',4,978,'1:13905:978',1),
(38172,'Beer & Wine Making',4,20687,'11700:20625:20687',1),
(38173,'Chocolate, Sweets',2,14308,'14308',1),
(38178,'Coffee',2,14308,'14308',1),
(38181,'Tea',2,14308,'14308',1),
(38182,'Wines (Red)',4,26270,'14308:179836:26270',1),
(38183,'Wines (White)',4,26270,'14308:179836:26270',1),
(38199,'Bedside Tables',3,3197,'11700:3197',1),
(38204,'Tables',3,3197,'11700:3197',1),
(38208,'Sofas & Couches',3,3197,'11700:3197',1),
(38217,'Door Accessories',3,10033,'11700:10033',0),
(38218,'Other Door Accessories',4,38217,'11700:10033:38217',1),
(38219,'Fireplaces & Accessories',2,11700,'11700',0),
(38220,'Decorative Logs & Stones',3,38219,'11700:38219',1),
(38221,'Fireplace Screens',3,38219,'11700:38219',1),
(38222,'Pokers, Tools & Sets',3,38219,'11700:38219',1),
(38223,'Magazine Racks',4,43502,'11700:299:43502',1),
(38237,'Tapestries, Material',3,10033,'11700:10033',1),
(38252,'Cappuccino & Espresso Machines',2,20710,'20710',1),
(38292,'MTG Individual Cards',4,19107,'220:2536:19107',1),
(38326,'Other',3,37958,'20081:37958',1),
(38331,'PDAs',3,14948,'293:14948',1),
(38583,'Video Game Merchandise',2,1249,'1249',1),
(38630,'Fish Finders, Depth Sounders',4,31274,'131090:26443:31274',1),
(38631,'GPS, Chartplotters',4,31274,'131090:26443:31274',1),
(38634,'Air Intake Systems',4,33549,'131090:6030:33549',1),
(38656,'Belts, Pulleys & Brackets',4,33612,'131090:6030:33612',1),
(38657,'Oil Pans',4,33612,'131090:6030:33612',1),
(38660,'Boost Gauges',4,33672,'131090:6030:33672',1),
(38661,'Covers',4,33707,'131090:6030:33707',1),
(38682,'Memorabilia',3,26443,'131090:26443',1),
(39019,'Log Splitters',4,29518,'11700:159912:29518',1),
(39178,'Singing Bowls',4,181246,'619:180012:181246',1),
(39179,'Hearing Protection',3,180008,'619:180008',1),
(39444,'Lace, Crochet, Doilies',3,181677,'20081:181677',0),
(39445,'Doilies',4,39444,'20081:181677:39444',1),
(39446,'Table Runners',4,39444,'20081:181677:39444',1),
(39447,'Table Cloths',4,39444,'20081:181677:39444',1),
(39475,'Albums, Folders',3,83274,'11116:83274',1),
(39476,'Holders',3,83274,'11116:83274',1),
(39477,'Coin Tubes',3,83274,'11116:83274',1),
(39478,'Magnifiers',3,83274,'11116:83274',1),
(39479,'Austria',4,45148,'11116:58520:45148',1),
(39481,'Spain',4,45148,'11116:58520:45148',1),
(39486,'Other Metal',3,178078,'11116:178078',1),
(39487,'Silver',3,178078,'11116:178078',0),
(39489,'Bars',4,39487,'11116:178078:39487',1),
(39491,'Bottles',3,29797,'1:29797',1),
(39538,'Betty Boop',3,13658,'1:13658',1),
(39549,'South Park',3,13658,'1:13658',1),
(39568,'Hello Kitty',4,11118,'1:13658:11118',1),
(39623,'Bells',4,13777,'1:13905:13777',1),
(39630,'Royalty',3,13877,'1:13877',0),
(39632,'Prince Charles',5,153170,'1:13877:39630:153170',1),
(39633,'Princess Diana',5,153170,'1:13877:39630:153170',1),
(39634,'Queen Elizabeth II',5,153170,'1:13877:39630:153170',1),
(39642,'Flags',2,1,'1',1),
(39724,'Rescue, Emergency',3,13877,'1:13877',1),
(39728,'Blowtorch, Soldering',3,13849,'1:13849',1),
(39729,'Axes, Hatchets',3,13849,'1:13849',1),
(39730,'Hammers',3,13849,'1:13849',1),
(39746,'Car CD Changers',4,175716,'131090:3270:175716',1),
(39754,'Car Audio In-Dash Units',4,175716,'131090:3270:175716',1),
(39803,'Signal Amplifiers & Filters',3,71582,'172176:71582',1),
(39976,'Tape & Data Cartridge Drives',3,165,'58058:165',1),
(39989,'Memorabilia',3,22709,'888:22709',1),
(39991,'Other Sports Memorabilia',2,888,'888',0),
(39996,'Vintage Manuals',5,175741,'293:183077:175740:175741',1),
(40004,'Other Test & Measurement',4,181939,'170769:92074:181939',1),
(40016,'Key Blanks',4,33687,'131090:6030:33687',1),
(40017,'Dash Parts',4,33694,'131090:6030:33694',1),
(40018,'Window Cranks',4,33694,'131090:6030:33694',1),
(40019,'Wholesale, Bulk Lots',3,6030,'131090:6030',1),
(40051,'Manufacturers',4,14049,'1:417:14049',1),
(40052,'Books',4,1444,'1:417:1444',1),
(40054,'CB Radios',3,1500,'293:1500',1),
(40059,'Other Radio Communication Accs',4,183503,'293:1500:183503',1),
(40065,'Ham Radio Transceivers',4,4670,'293:1500:4670',1),
(40088,'Lightening Creams',3,11863,'26395:11863',1),
(40101,'Other Sleeping Aids',4,82593,'26395:67588:82593',1),
(40131,'Wholesale, Bulk Lots',2,281,'281',0),
(40132,'Gemstones, Loose',3,40131,'281:40131',1),
(40134,'Software',3,159260,'58058:159260',1),
(40141,'Other Sports Equipment',2,888,'888',0),
(40144,'Home Décor',3,31605,'11700:31605',1),
(40145,'Lawn & Garden',3,31605,'11700:31605',1),
(40149,'Wholesale, Bulk Lots',2,220,'220',0),
(40150,'Action Figures',3,40149,'220:40149',1),
(40154,'Ice Hockey',2,888,'888',1),
(40176,'Desktop Computers',3,159260,'58058:159260',1),
(40177,'Laptop & Tablet Computers',3,159260,'58058:159260',1),
(40370,'Bosnia and Herzegovina',3,4742,'260:4742',1),
(40395,'Aland',3,4742,'260:4742',1),
(40411,'Liechtenstein',3,4742,'260:4742',1),
(40413,'Netherlands & Colonies',3,4742,'260:4742',1),
(40417,'Poland',3,4742,'260:4742',1),
(40419,'Portugal & Colonies',3,4742,'260:4742',1),
(40422,'Russia & Soviet Union',3,4742,'260:4742',1),
(40587,'Towels & Washcloths',3,26677,'11700:26677',1),
(40605,'Seeds & Bulbs',4,181003,'11700:159912:181003',0),
(40606,'Houseplant Seeds',5,40605,'11700:159912:181003:40605',1),
(40608,'Roses',5,19617,'11700:159912:181003:19617',1),
(40609,'Other Plants & Seedlings',5,19617,'11700:159912:181003:19617',1),
(40700,'Batteries',5,19839,'220:2562:182187:19839',1),
(40703,'Receivers & Transmitters',5,19839,'220:2562:182187:19839',1),
(40711,'Asia',3,58520,'11116:58520',0),
(40712,'China',4,40711,'11116:58520:40711',1),
(40713,'India',4,40711,'11116:58520:40711',1),
(40715,'Singapore',4,40711,'11116:58520:40711',1),
(40717,'Thailand',4,40711,'11116:58520:40711',1),
(40852,'Chess',3,233,'220:233',0),
(40856,'Contemporary Chess',4,40852,'220:233:40852',1),
(40883,'Women\'s Clothing',4,158913,'888:15273:158913',0),
(40884,'Men\'s Clothing',4,158913,'888:15273:158913',0),
(40892,'Other',5,40884,'888:15273:158913:40884',1),
(40965,'Wholesale Beauty, Health',2,26395,'26395',0),
(40967,'Medical, Special Needs',3,40965,'26395:40965',1),
(40968,'Health Care',3,40965,'26395:40965',1),
(40979,'Scanners',3,1500,'293:1500',1),
(41168,'Figurines',4,13777,'1:13905:13777',1),
(41181,'Other Collectable Blade Accs',4,182970,'1:1401:182970',1),
(41182,'Tactical Axes & Hatchets',3,1401,'1:1401',1),
(41183,'Calendars',3,124,'1:124',1),
(41187,'Ephemera',3,124,'1:124',1),
(41199,'Feathers',4,160704,'14339:28102:160704',1),
(41200,'Styrofoam Forms',4,160704,'14339:28102:160704',1),
(41201,'Gourds',4,160704,'14339:28102:160704',1),
(41203,'Calligraphy Sets',4,183081,'14339:11783:183081',1),
(41204,'Easels',4,28110,'14339:11783:28110',1),
(41214,'Stencils',3,183126,'14339:183126',1),
(41215,'Tole Decals & Transfers',3,183126,'14339:183126',1),
(41217,'Mosaic Tiles',3,11787,'14339:11787',1),
(41220,'Glass',3,11787,'14339:11787',1),
(41226,'Mirrors',3,11787,'14339:11787',1),
(41227,'Mosaic Pebbles, Stones',3,11787,'14339:11787',1),
(41228,'Patterns-Contemporary',4,3094,'14339:160706:3094',1),
(41243,'Bobbins',4,180929,'14339:160737:180929',1),
(41245,'Feet',4,180929,'14339:160737:180929',1),
(41246,'Sewing Manuals & Instruction',4,180929,'14339:160737:180929',1),
(41247,'Sewing Machine Needles',4,180929,'14339:160737:180929',1),
(41248,'Machine Parts & Attachments',4,180929,'14339:160737:180929',1),
(41372,'Tools, Kits, Patterns',3,11787,'14339:11787',1),
(41373,'Corded Telephones',3,164874,'15032:164874',1),
(41383,'Design Cards & CDs',5,160724,'14339:160706:28141:160724',1),
(41384,'Hoops & Placement Tools',5,160724,'14339:160706:28141:160724',1),
(41385,'Embroidery Ribbon',5,160720,'14339:160706:28141:160720',1),
(41386,'Stabilisers',5,160724,'14339:160706:28141:160724',1),
(41396,'Cornets',3,16212,'619:16212',1),
(41404,'Metronomes',3,180008,'619:180008',1),
(41406,'Bodies',5,181223,'619:3858:180009:181223',1),
(41407,'Bridges',5,181223,'619:3858:180009:181223',1),
(41408,'Cases',4,180009,'619:3858:180009',1),
(41411,'Bass',5,181222,'619:3858:180009:181222',1),
(41412,'Boards & Cases',5,181222,'619:3858:180009:181222',1),
(41413,'Chorus',5,181222,'619:3858:180009:181222',1),
(41414,'Compressors & Sustainers',5,181222,'619:3858:180009:181222',1),
(41415,'Delay, Echo & Reverb',5,181222,'619:3858:180009:181222',1),
(41416,'Distortion & Overdrive',5,181222,'619:3858:180009:181222',1),
(41417,'Flangers',5,181222,'619:3858:180009:181222',1),
(41418,'Fuzz',5,181222,'619:3858:180009:181222',1),
(41419,'Multi-Effects',5,181222,'619:3858:180009:181222',1),
(41420,'Phasers & Shifters',5,181222,'619:3858:180009:181222',1),
(41421,'Processors',5,181222,'619:3858:180009:181222',1),
(41422,'Wah & Volume',5,181222,'619:3858:180009:181222',1),
(41423,'Necks',5,181223,'619:3858:180009:181223',1),
(41424,'Pickguards',5,181223,'619:3858:180009:181223',1),
(41431,'Strings',4,180009,'619:3858:180009',1),
(41434,'Tuning Pegs',5,181223,'619:3858:180009:181223',1),
(41440,'Bells & Chimes',4,181249,'619:180012:181249',1),
(41441,'Cymbals',3,180012,'619:180012',1),
(41449,'Bags & Cases',4,181254,'619:180012:181254',1),
(41450,'Skins & Heads',4,181254,'619:180012:181254',1),
(41451,'Hoops & Rims',4,181254,'619:180012:181254',1),
(41452,'Pedals',4,181254,'619:180012:181254',1),
(41453,'Stands',4,181254,'619:180012:181254',1),
(41456,'Sticks, Brushes & Mallets',4,181254,'619:180012:181254',1),
(41457,'Tambourines',4,181246,'619:180012:181246',1),
(41458,'Mallet Percussion',4,181249,'619:180012:181249',1),
(41459,'Cables, Snakes & Interconnects',3,180014,'619:180014',1),
(41484,'Hydraulics',3,41489,'170769:41489',1),
(41485,'Tyres, Wheels',3,41489,'170769:41489',1),
(41488,'Forks',4,177647,'170769:41489:177647',1),
(41489,'Heavy Machinery Parts',2,170769,'170769',0),
(41490,'Construction Equip Parts',3,41489,'170769:41489',1),
(41492,'Compactors',3,177641,'170769:177641',1),
(41498,'Building Materials',2,170769,'170769',0),
(41500,'Other',3,42901,'170769:42901',1),
(41501,'Windows, Glass',3,41498,'170769:41498',1),
(41511,'Posters & Prints',3,10033,'11700:10033',1),
(41519,'Components Books & Manuals',4,182412,'170769:92074:182412',1),
(41676,'Other Formats',2,11232,'11232',1),
(41778,'Brass',3,182150,'619:182150',1),
(41779,'Guitar',3,182150,'619:182150',1),
(41782,'Percussion',3,182150,'619:182150',1),
(41788,'Wind & Woodwind',3,182150,'619:182150',1),
(41859,'Image, Video & Audio',3,18793,'58058:18793',1),
(41939,'Digital Readouts',4,25283,'170769:41489:25283',1),
(41941,'Circuit Boards',4,25283,'170769:41489:25283',1),
(41942,'Motors',4,25283,'170769:41489:25283',1),
(41945,'Clamps',3,177644,'170769:177644',1),
(41949,'Media',3,177644,'170769:177644',1),
(41952,'Phase Converters',4,100182,'170769:92074:100182',1),
(41957,'Press Brakes',3,177641,'170769:177641',1),
(41964,'Wholesale, Bulk Lots',2,11450,'11450',0),
(41968,'Home, Personal Security',2,11700,'11700',0),
(41969,'Alarms',3,41968,'11700:41968',1),
(41971,'Cabinets & Cabinet Hardware',3,3187,'11700:3187',0),
(41973,'Cabinet Hinges',4,41971,'11700:3187:41971',1),
(41976,'Doors & Door Hardware',3,3187,'11700:3187',0),
(41979,'Solar',2,293,'293',0),
(41980,'Chargers, Inverters',3,41979,'293:41979',1),
(41981,'Solar Panels',3,41979,'293:41979',1),
(41986,'Heating, Cooling & Air',3,3187,'11700:3187',1),
(41987,'Furnaces & Heating Systems',3,69197,'20710:69197',1),
(41989,'Painting Supplies',3,3187,'11700:3187',0),
(41990,'Paint Brushes',4,41989,'11700:3187:41989',1),
(41991,'Paint Guns & Sprayers',4,41989,'11700:3187:41989',1),
(41992,'Painting Rollers & Sponges',4,41989,'11700:3187:41989',1),
(42000,'Fans, Heat Sinks & Cooling',3,175673,'58058:175673',0),
(42014,'Computer Cases',4,175674,'58058:175673:175674',1),
(42017,'Power Supplies',3,175673,'58058:175673',1),
(42024,'Faucets',4,20601,'11700:3187:20601',1),
(42025,'Bathtubs',4,20601,'11700:3187:20601',1),
(42130,'Building Plans & Blueprints',3,3187,'11700:3187',1),
(42136,'Wallpaper Borders',4,180981,'11700:3187:180981',1),
(42146,'Vacuum Parts, Accessories',3,170737,'20710:170737',1),
(42147,'Metal Bending Machines',3,177641,'170769:177641',1),
(42154,'Outdoor Lighting',3,159912,'11700:159912',0),
(42190,'Laptop Add-On Cards',3,31530,'58058:31530',0),
(42196,'Laptop Network Cards',4,42190,'58058:31530:42190',1),
(42211,'Cacti & Succulents',5,19617,'11700:159912:181003:19617',1),
(42214,'Herbs',5,19617,'11700:159912:181003:19617',1),
(42215,'Herb Seeds',5,40605,'11700:159912:181003:40605',1),
(42218,'Orchids',5,19617,'11700:159912:181003:19617',1),
(42220,'Ornamental Grasses',5,19617,'11700:159912:181003:19617',1),
(42221,'Vegetable Seeds',5,40605,'11700:159912:181003:40605',1),
(42226,'Chainsaws',4,29518,'11700:159912:29518',1),
(42228,'Chippers, Shredders, Mulchers',4,29518,'11700:159912:29518',1),
(42229,'Manuals & Guides',4,29518,'11700:159912:29518',1),
(42230,'Snow Blowers',4,29518,'11700:159912:29518',1),
(42231,'Washers, Dryers',2,20710,'20710',0),
(42239,'Pool Heaters & Solar Panels',5,181067,'11700:159912:20727:181067',1),
(42241,'Nailers',4,22659,'11700:631:22659',1),
(42245,'Air Drills',4,22659,'11700:631:22659',1),
(42247,'Parts & Accessories',4,22659,'11700:631:22659',1),
(42255,'Screwdrivers',4,3244,'11700:631:3244',1),
(42275,'Grinders',4,3247,'11700:631:3247',0),
(42276,'Angle Grinders',5,42275,'11700:631:3247:42275',1),
(42277,'Bench Grinders',5,42275,'11700:631:3247:42275',1),
(42292,'Jackets',3,63908,'170769:63908',1),
(42296,'Other',5,20783,'11700:631:3247:20783',1),
(42297,'Surveying',2,170769,'170769',0),
(42299,'Tripods',3,42297,'170769:42297',1),
(42305,'Drives, Storage & Blank Media',3,159260,'58058:159260',1),
(42306,'Printer Supplies & Accessories',3,159260,'58058:159260',1),
(42320,'Chains',4,57262,'888:7294:57262',1),
(42323,'Laptop Port Expansion Cards',4,42190,'58058:31530:42190',1),
(42326,'Protective Pads & Armor',4,177864,'888:7294:177864',1),
(42335,'Cables & Housing',4,57262,'888:7294:57262',1),
(42337,'Other',3,46576,'170769:46576',1),
(42338,'Building Materials',3,31605,'11700:31605',1),
(42339,'Tools',3,31605,'11700:31605',1),
(42351,'Trees',5,19617,'11700:159912:181003:19617',1),
(42361,'Toolboxes & Storage',4,164613,'11700:631:164613',1),
(42425,'Other Mobile Accessories',3,9394,'15032:9394',1),
(42428,'Other Phones & Accessories',2,15032,'15032',1),
(42574,'Knives',3,7301,'888:7301',1),
(42583,'UV Sterilisers & Ionizers',4,93632,'11700:159912:93632',1),
(42604,'Other',4,33549,'131090:6030:33549',1),
(42605,'Other',4,33559,'131090:6030:33559',1),
(42609,'Other',4,33579,'131090:6030:33579',1),
(42610,'Other',4,33628,'131090:6030:33628',1),
(42611,'Other',4,33637,'131090:6030:33637',1),
(42612,'Other',4,33694,'131090:6030:33694',1),
(42613,'Other',4,33707,'131090:6030:33707',1),
(42614,'Other',4,33743,'131090:6030:33743',1),
(42814,'Skis',4,16059,'888:36259:16059',1),
(42829,'San Marino',3,4742,'260:4742',1),
(42886,'Electrical Boxes & Enclosures',5,181917,'170769:92074:100182:181917',1),
(42887,'Conduit',6,117489,'170769:92074:100016:73136:117489',1),
(42889,'Electrical Tool Kits',6,66984,'170769:92074:100016:73136:66984',1),
(42892,'Automation, Motors & Drives',2,170769,'170769',0),
(42894,'General Purpose AC Drives',5,78188,'170769:42892:78186:78188',1),
(42901,'Fasteners',2,170769,'170769',0),
(42902,'Bolts',3,42901,'170769:42901',1),
(42903,'Nuts',3,42901,'170769:42901',1),
(42913,'Conveyors',2,170769,'170769',1),
(42928,'Pumps',2,170769,'170769',1),
(42935,'Woodworking',2,170769,'170769',0),
(42938,'Other Woodworking Equipment',3,42935,'170769:42935',1),
(43015,'Hand Dryers',3,170639,'170638:170639',1),
(43205,'Anklets',3,10968,'281:10968',1),
(43217,'Armour & Shields',3,1401,'1:1401',1),
(43219,'Stands, Hangers & Plaques',4,182970,'1:1401:182970',1),
(43220,'Blade Sharpeners & Stones',4,182970,'1:1401:182970',1),
(43221,'Sheaths',4,182970,'1:1401:182970',1),
(43304,'Mobile Phone Parts',2,15032,'15032',1),
(43307,'Manuals & Guides',3,9394,'15032:9394',1),
(43320,'Vintage Fixed Blade Knives',4,182973,'1:1401:182973',0),
(43321,'Custom & Handmade',5,43320,'1:1401:182973:43320',1),
(43322,'Factory Manufactured',5,43320,'1:1401:182973:43320',1),
(43324,'Modern Fixed Blade',4,182973,'1:1401:182973',0),
(43325,'Custom & Handmade',5,43324,'1:1401:182973:43324',1),
(43329,'Vintage Folding Knives',4,182981,'1:1401:182981',0),
(43330,'Custom & Handmade',5,43329,'1:1401:182981:43329',1),
(43333,'Modern Folding Knives',4,182981,'1:1401:182981',0),
(43334,'Custom & Handmade',5,43333,'1:1401:182981:43333',1),
(43336,'Swords & Sabres',3,1401,'1:1401',0),
(43339,'Medieval',5,182975,'1:1401:43336:182975',1),
(43363,'Horse Racing Cards',3,212,'888:212',1),
(43371,'Tennis Cards',3,212,'888:212',1),
(43376,'Grand & Baby Grand Pianos',4,181225,'619:180010:181225',1),
(43377,'Upright Pianos',4,181225,'619:180010:181225',1),
(43399,'Pate, Soups',2,14308,'14308',1),
(43400,'Vegetables',2,14308,'14308',1),
(43401,'Gourmet Specialties',2,14308,'14308',1),
(43420,'Can Openers',4,20635,'11700:20625:20635',1),
(43424,'Lava Lamps',3,20697,'11700:20697',1),
(43440,'Camera & Camcorder Lights',3,15200,'625:15200',1),
(43448,'Memory Card Readers & Adapters',3,15200,'625:15200',1),
(43479,'Other Film Photography',3,69323,'625:69323',1),
(43502,'Home Organisation',3,299,'11700:299',0),
(43503,'Closet Organisers',4,43502,'11700:299:43502',1),
(43504,'Storage Bags',4,43502,'11700:299:43502',1),
(43506,'Shoe Organisers',4,43502,'11700:299:43502',1),
(43507,'Wines (Mixed Cases)',4,26270,'14308:179836:26270',1),
(43509,'Air Filters',3,69197,'20710:69197',1),
(43510,'Air Purifiers',3,69197,'20710:69197',1),
(43512,'Ironing Boards',3,170737,'20710:170737',1),
(43513,'Irons & Press Irons',2,20710,'20710',1),
(43516,'Laundry Bags',4,20620,'11700:299:20620',1),
(43517,'Laundry Baskets',4,20620,'11700:299:20620',1),
(43526,'Other Vacuum Cleaners',3,20614,'20710:20614',1),
(43533,'Flags',4,20498,'11700:159912:20498',1),
(43536,'Flag Poles & Parts',4,20498,'11700:159912:20498',1),
(43538,'Trellises',4,177032,'11700:159912:177032',1),
(43554,'Hydroponics & Seed Starting',4,2032,'11700:159912:2032',0),
(43560,'Lawnmowers',3,159912,'11700:159912',0),
(43566,'Rangehood & Oven Parts',3,170737,'20710:170737',1),
(43614,'Safety, Protective Gear',3,631,'11700:631',0),
(43615,'Glasses, Goggles & Shields',4,43614,'11700:631:43614',1),
(43616,'Gloves & Pads',4,43614,'11700:631:43614',1),
(43617,'Masks, Respirators & Helmets',4,43614,'11700:631:43614',1),
(43811,'Memorabilia',4,34352,'131090:6747:34352',1),
(43813,'Royal Doulton',3,24,'870:24',0),
(43822,'Aboriginal',3,3913,'1:3913',1),
(43953,'Wheels',4,33743,'131090:6030:33743',1),
(43986,'Air Compressors',4,34998,'131090:6030:34998',1),
(43989,'Diagnostic Tools',4,34998,'131090:6030:34998',1),
(43992,'Screwdrivers, Pliers',4,34998,'131090:6030:34998',1),
(43993,'Sockets, Ratchets',4,34998,'131090:6030:34998',1),
(43994,'Wrenches',4,34998,'131090:6030:34998',1),
(43995,'Tool Sets',4,34998,'131090:6030:34998',1),
(43996,'Hammers, Pullers, Extractors',4,34998,'131090:6030:34998',1),
(43998,'Other',4,34998,'131090:6030:34998',1),
(44001,'HeroClix',4,16486,'220:233:16486',1),
(44005,'Numbers',3,11731,'220:11731',1),
(44011,'Lord of the Rings',4,16486,'220:233:16486',1),
(44075,'Fitness Technology',3,15273,'888:15273',0),
(44076,'Other',4,44075,'888:15273:44075',1),
(44077,'Pedometers',4,44075,'888:15273:44075',1),
(44078,'Body Mass Monitors & Scales',4,44075,'888:15273:44075',1),
(44079,'Exercise Mats',4,28064,'888:15273:28064',1),
(44080,'Step/Riser Sets',4,28064,'888:15273:28064',1),
(44086,'Pilates Accessories',4,158927,'888:15273:158927',1),
(44408,'Warhammer 40K',5,31398,'220:233:16486:31398',0),
(44409,'Warhammer Fantasy Battle',5,31398,'220:233:16486:31398',0),
(44912,'Fly Tying Materials',4,179961,'888:1492:179961',0),
(44913,'Feathers',5,44912,'888:1492:179961:44912',1),
(44914,'Hooks',5,44912,'888:1492:179961:44912',1),
(44915,'Kits',5,44912,'888:1492:179961:44912',1),
(44916,'Fly Tying Vices, Tools',4,179961,'888:1492:179961',1),
(44932,'USB Cables, Hubs & Adapters',3,182094,'58058:182094',1),
(44940,'Internal Modem Cards',4,182088,'58058:175673:182088',1),
(44980,'Sound Cards (Internal)',3,175673,'58058:175673',1),
(44992,'Patch Panels',4,51197,'58058:175698:51197',1),
(44995,'Wireless Routers',3,11176,'58058:11176',1),
(44996,'Other Home Networking',3,11176,'58058:11176',1),
(44999,'USB Bluetooth Adapters/Dongles',3,11176,'58058:11176',1),
(45002,'USB Wi-Fi Adapters/Dongles',3,11176,'58058:11176',1),
(45053,'Men\'s Accessories',3,41964,'11450:41964',1),
(45057,'Mixed Lots',3,41964,'11450:41964',1),
(45065,'Wholesale & Bulk Lots',2,15032,'15032',0),
(45066,'Mobile Accessories',3,45065,'15032:45065',0),
(45067,'Signal Boosters',4,45066,'15032:45065:45066',1),
(45071,'Mobile Phones',3,45065,'15032:45065',1),
(45073,'Other Mobile & Home Phone Lots',3,45065,'15032:45065',1),
(45077,'Wholesale, Lots',2,14339,'14339',1),
(45084,'Fashion Jewellery',3,40131,'281:40131',1),
(45089,'Wholesale, Bulk Lots',2,625,'625',1),
(45110,'Accessories, Gift Books',2,267,'267',0),
(45111,'Address Books',3,45110,'267:45110',1),
(45112,'Diaries, Journals',3,45110,'267:45110',1),
(45114,'Bookmarks',3,45110,'267:45110',1),
(45115,'Other Accessories',3,45110,'267:45110',1),
(45134,'Gold',3,178078,'11116:178078',0),
(45137,'Hong Kong',4,40711,'11116:58520:40711',1),
(45142,'Australian',3,58520,'11116:58520',0),
(45143,'Other Pacific',4,153149,'11116:58520:153149',1),
(45145,'North & Central America',3,58520,'11116:58520',0),
(45148,'Europe',3,58520,'11116:58520',0),
(45150,'Denmark',4,45148,'11116:58520:45148',1),
(45154,'Netherlands',4,45148,'11116:58520:45148',1),
(45160,'South America',3,58520,'11116:58520',1),
(45206,'Other OTC Medicine',4,75036,'26395:67588:75036',1),
(45220,'Hair Accessories',3,4251,'11450:4251',1),
(45230,'Hats',3,4251,'11450:4251',1),
(45238,'Scarves, Wraps',3,4251,'11450:4251',1),
(45246,'Women\'s Sunglasses',2,11450,'11450',1),
(45258,'Wallets',3,4251,'11450:4251',1),
(45279,'Teddies',3,11514,'11450:11514',1),
(45333,'Flats',3,3034,'11450:3034',1),
(45337,'Pacific',3,58507,'11116:58507',0),
(45338,'North & Central America',3,58507,'11116:58507',0),
(45339,'Europe',3,58507,'11116:58507',0),
(45342,'Power Cables & Connectors',3,14961,'293:14961',1),
(45345,'Other Pacific',4,45337,'11116:58507:45337',1),
(45348,'Contemporary Manufacture',4,180276,'220:222:180276',1),
(45354,'Other',4,171127,'220:222:171127',1),
(45444,'Porcelain',3,238,'237:238',1),
(45452,'Health, Grooming',3,20394,'2984:20394',1),
(45453,'Towels, Washcloths',3,20394,'2984:20394',1),
(45454,'Other Bathing, Grooming',3,20394,'2984:20394',1),
(45456,'Wipes',3,26268,'2984:26268',1),
(45503,'Platters',4,36027,'11700:20625:36027',1),
(45505,'Trays',4,36027,'11700:20625:36027',1),
(45510,'Floor Rugs',3,20571,'11700:20571',1),
(45515,'Curtains',3,63514,'11700:63514',1),
(45527,'British',4,955,'870:50693:955',1),
(45596,'Australian Pre-Decimal',5,3472,'260:3468:153383:3472',1),
(45597,'Australian Decimal',5,3472,'260:3468:153383:3472',1),
(45599,'Australian Pre-Decimal',5,3473,'260:3468:153383:3473',1),
(45600,'Australian Decimal',5,3473,'260:3468:153383:3473',1),
(45735,'Body Fat Analyzers',4,31817,'26395:180959:31817',1),
(45794,'Windows',4,180113,'11700:3187:180113',1),
(45800,'Floor & Wall Tiles',4,180983,'11700:3187:180983',1),
(45812,'Window Hardware',4,180113,'11700:3187:180113',1),
(45816,'Braces & Brackets',4,180974,'11700:3187:180974',1),
(45986,'Tanks & Military Vehicles',4,182181,'220:2562:182181',1),
(46076,'Other Riding Boots & Accs',4,27031,'888:3153:27031',1),
(46094,'Other',4,33542,'131090:6030:33542',1),
(46095,'Oil Coolers',4,33599,'131090:6030:33599',1),
(46096,'Other',4,33599,'131090:6030:33599',1),
(46098,'Other',4,33612,'131090:6030:33612',1),
(46099,'Other',4,33664,'131090:6030:33664',1),
(46100,'Other',4,33672,'131090:6030:33672',1),
(46101,'Other',4,33687,'131090:6030:33687',1),
(46102,'Sun Visors',4,33694,'131090:6030:33694',1),
(46103,'Transmission Rebuild Kits',4,33726,'131090:6030:33726',1),
(46104,'Other',4,33726,'131090:6030:33726',1),
(46282,'Cutting Boards',3,20625,'11700:20625',1),
(46283,'Racks, Holders',4,20635,'11700:20625:20635',1),
(46289,'Cages',3,20734,'1281:20734',1),
(46290,'Feeders',3,20734,'1281:20734',1),
(46310,'Filters',3,20754,'1281:20754',1),
(46314,'Lights',3,20754,'1281:20754',1),
(46322,'Thermal Compounds & Supplies',4,42000,'58058:175673:42000',1),
(46435,'Hose Reels & Storage',5,29521,'11700:159912:2032:29521',1),
(46439,'Gravel & Substrate',3,20754,'1281:20754',1),
(46526,'Livestock Supplies, Equipment',3,11748,'170769:11748',0),
(46529,'Other',3,170778,'170769:170778',1),
(46536,'Pressure Cleaners',3,64808,'170769:64808',1),
(46550,'Decals, Emblems, Plates',3,41489,'170769:41489',1),
(46551,'Fuel Systems',3,41489,'170769:41489',1),
(46552,'Gauges',3,41489,'170769:41489',1),
(46555,'Filters',3,41489,'170769:41489',1),
(46556,'Gaskets',3,41489,'170769:41489',1),
(46558,'Pistons, Rings, Rods',3,41489,'170769:41489',1),
(46559,'Radiators',3,41489,'170769:41489',1),
(46562,'Seats',3,41489,'170769:41489',1),
(46563,'Steering, Front Axles',3,41489,'170769:41489',1),
(46564,'Transmissions, Drivetrains',3,41489,'170769:41489',1),
(46570,'Antique & Vintage Implements',4,177647,'170769:41489:177647',1),
(46572,'Marble, Tile, Stone',3,41498,'170769:41498',1),
(46576,'Hand Tools',2,170769,'170769',0),
(46584,'Routers',3,64808,'170769:64808',1),
(46585,'Saws',3,64808,'170769:64808',0),
(46586,'Circular Saws',4,46585,'170769:64808:46585',1),
(46592,'Popcorn Machines',4,25367,'170638:11874:25367',1),
(46677,'Straps',4,180009,'619:3858:180009',1),
(46678,'Other Guitar Parts',5,181223,'619:3858:180009:181223',1),
(46680,'Polishes & Cleaners',4,180009,'619:3858:180009',1),
(46682,'Picks',4,180009,'619:3858:180009',1),
(46689,'Internet Businesses',3,11759,'170638:11759',1),
(46693,'Laminators',2,170638,'170638',1),
(46701,'Other',3,11890,'170638:11890',1),
(46704,'Shelves',4,170652,'170638:11890:170652',1),
(46706,'Barcode Scanners',3,71465,'170638:71465',1),
(46707,'Coin Counters',3,11890,'170638:11890',1),
(46708,'Cash Drawers',3,71465,'170638:71465',1),
(46709,'Pole Displays',3,71465,'170638:71465',1),
(46711,'POS Software',3,71465,'170638:71465',1),
(46712,'Receipt Printers',3,71465,'170638:71465',1),
(46782,'Candles',3,10033,'11700:10033',1),
(46809,'Leggings',3,172378,'2984:172378',1),
(47042,'Stands',4,181224,'619:180010:181224',1),
(47066,'Acoustic Guitar',4,84659,'619:3858:84659',1),
(47067,'Guitar Builder/Luthier Supply',3,3858,'619:3858',1),
(47074,'Electric Guitar Packages',4,84659,'619:3858:84659',1),
(47075,'Cables',4,180009,'619:3858:180009',1),
(47076,'Knobs, Jacks, Switches',5,181223,'619:3858:180009:181223',1),
(47078,'Harmonicas',4,181268,'619:10181:181268',1),
(47084,'Drum Stools',4,181254,'619:180012:181254',1),
(47089,'Mounts & Hardware',4,181254,'619:180012:181254',1),
(47090,'Shakers & Small Percussion',4,181246,'619:180012:181246',1),
(47091,'Speakers & Monitors',3,180014,'619:180014',1),
(47092,'Speaker Drivers & Horns',3,180014,'619:180014',1),
(47096,'Clarinets',4,181267,'619:10181:181267',1),
(47103,'Other Information Products',3,102480,'99:102480',1),
(47104,'Computing, Domain Names',2,316,'316',1),
(47159,'Albania',3,4742,'260:4742',1),
(47160,'Austria',3,4742,'260:4742',1),
(47162,'Czech Republic, Czechoslovakia',3,4742,'260:4742',1),
(47163,'Greece',3,4742,'260:4742',1),
(47164,'Greenland',3,4742,'260:4742',1),
(47165,'Luxembourg',3,4742,'260:4742',1),
(47167,'Norway',3,4742,'260:4742',1),
(47169,'Romania',3,4742,'260:4742',1),
(47170,'Finland',3,4742,'260:4742',1),
(47171,'Sweden',3,4742,'260:4742',1),
(47172,'Iceland',3,4742,'260:4742',1),
(47173,'Collections, Mixture',3,181417,'260:181417',1),
(47176,'Thailand',3,181416,'260:181416',1),
(47268,'Jackets',5,183365,'888:3153:16240:183365',1),
(47269,'Riding Helmets',4,87443,'888:3153:87443',1),
(47277,'Girths',4,3159,'888:3153:3159',1),
(47278,'Martingales & Breastplates',4,3159,'888:3153:3159',1),
(47281,'Saddles',4,3159,'888:3153:3159',1),
(47291,'Saddles',4,3161,'888:3153:3161',1),
(47298,'Breast Collars',4,3161,'888:3153:3161',1),
(47299,'Cinches',4,3161,'888:3153:3161',1),
(47300,'Saddle Bags',4,3161,'888:3153:3161',1),
(47301,'Other Western Tack',4,3161,'888:3153:3161',1),
(47308,'Saddle Pads',4,3161,'888:3153:3161',1),
(47323,'Golf Club Components',3,1513,'888:1513',0),
(47324,'Golf Club Grips',4,47323,'888:1513:47323',1),
(47325,'Golf Club Heads',4,47323,'888:1513:47323',1),
(47326,'Golf Club Shafts',4,47323,'888:1513:47323',1),
(47344,'Inline Skates, Rollerblades',3,106465,'888:106465',1),
(47349,'Electric Scooters',3,11330,'888:11330',1),
(47353,'Spear Guns',3,16052,'888:16052',1),
(47354,'Wet Suits',3,16052,'888:16052',1),
(47357,'Stickers',3,16262,'888:16262',1),
(47363,'Wakeboards',4,166101,'888:23806:166101',1),
(47398,'UK',4,45339,'11116:58507:45339',1),
(47437,'Track',4,19145,'220:180250:19145',1),
(47579,'Practice Pads',4,181254,'619:180012:181254',1),
(47779,'Keyboard & Mouse Bundles',3,3676,'58058:3676',1),
(47920,'Aftershave & Pre-Shave',3,31762,'26395:31762',1),
(47921,'Men\'s Razors',4,179841,'26395:31762:179841',1),
(47925,'Hair Removal Creams & Sprays',3,31762,'26395:31762',1),
(47931,'Men\'s Razor Blades',4,179841,'26395:31762:179841',1),
(47940,'Nail Polish Remover',3,47945,'26395:47945',1),
(47945,'Nail Care, Manicure & Pedicure',2,26395,'26395',0),
(48026,'New Zealand',4,153149,'11116:58520:153149',1),
(48027,'Japan',4,8008,'11116:58507:8008',1),
(48028,'India',4,8008,'11116:58507:8008',1),
(48029,'Vietnam',4,8008,'11116:58507:8008',1),
(48080,'Denture Care',3,31769,'26395:31769',1),
(48090,'Canopies, Netting',3,20444,'11700:20444',1),
(48095,'Ceramic Decals',4,183303,'14339:183302:183303',1),
(48296,'Conchos',4,183127,'14339:28131:183127',1),
(48319,'Bean Bags & Inflatables',3,3197,'11700:3197',1),
(48446,'Multipurpose Batteries & Power',2,293,'293',0),
(48458,'DJ Equipment',2,619,'619',0),
(48460,'DJ Turntables',3,48458,'619:48458',1),
(48479,'UPS Batteries & Components',3,86722,'58058:86722',1),
(48515,'Flashes',3,64353,'625:64353',1),
(48559,'Sunglasses',4,182059,'11450:175759:182059',1),
(48571,'Memory Card Readers & Adapters',3,9394,'15032:9394',1),
(48579,'Vintage, Antique Jewellery',2,281,'281',1),
(48604,'Car Video',3,3270,'131090:3270',0),
(48605,'Other Car Video',4,48604,'131090:3270:48604',1),
(48606,'Car Monitors w/o Player',4,48604,'131090:3270:48604',1),
(48618,'Battery Chargers',3,48446,'293:48446',1),
(48619,'Rechargeable Batteries',3,48446,'293:48446',1),
(48623,'Weather Meters',3,14948,'293:14948',1),
(48643,'Disc Repair & Disc Cleaning',4,94893,'293:14961:94893',1),
(48645,'Cassette Tape Decks',3,14969,'293:14969',1),
(48647,'Record Players/Home Turntables',3,14969,'293:14969',1),
(48649,'Vintage Record Players',4,175740,'293:183077:175740',1),
(48655,'Projector Screens',2,172176,'172176',1),
(48656,'Wall Mounts, Brackets',3,71582,'172176:71582',1),
(48677,'Styluses',3,9394,'15032:9394',1),
(48680,'Other iPod & Audio Player Accs',4,56169,'293:15052:56169',1),
(48692,'CB Radio Antennas',4,183502,'293:1500:183502',1),
(48694,'Mounts',4,183503,'293:1500:183503',1),
(48701,'Meters',4,183503,'293:1500:183503',1),
(48703,'Batteries & Chargers',4,183503,'293:1500:183503',1),
(48704,'Coax. Cables & Connectors',4,183503,'293:1500:183503',1),
(48705,'Headsets & Earpieces',4,183503,'293:1500:183503',1),
(48706,'Code Keyers & Keys',4,183503,'293:1500:183503',1),
(48707,'Microphones',4,183503,'293:1500:183503',1),
(48708,'Power Supplies',4,183503,'293:1500:183503',1),
(48709,'Speakers',4,183503,'293:1500:183503',1),
(48710,'Tubes',4,183503,'293:1500:183503',1),
(48711,'Tuners',4,183503,'293:1500:183503',1),
(48712,'Farm Implement Parts',4,177647,'170769:41489:177647',1),
(48714,'Manuals',3,41489,'170769:41489',1),
(48717,'Terminal Blocks',5,65512,'170769:92074:100016:65512',1),
(48724,'Scales',3,11815,'170769:11815',1),
(48741,'Microscopes',3,11815,'170769:11815',1),
(48748,'Home Phones',3,45065,'15032:45065',1),
(48749,'Wholesale Lots',2,1249,'1249',1),
(48757,'Wholesale, Bulk Lots',2,2984,'2984',1),
(48758,'Bed & Bath',3,31605,'11700:31605',1),
(48759,'Kitchen, Dining, Bar',3,31605,'11700:31605',1),
(48760,'Pet Supplies',3,31605,'11700:31605',1),
(48815,'Factory Manufactured',5,43329,'1:1401:182981:43329',1),
(48818,'Factory Manufactured',5,43333,'1:1401:182981:43333',1),
(48829,'Trading Card Singles',4,183046,'1:182982:183046',1),
(48861,'Other Men\'s Vintage Clothing',4,182044,'11450:175759:182044',1),
(48945,'Shoes',3,329,'237:329',1),
(49018,'Mixed Lots',3,246,'220:246',1),
(49019,'Bean Bag Toys',2,220,'220',0),
(49196,'MTG Player-Built Decks',4,19107,'220:2536:19107',1),
(49203,'Yu-Gi-Oh! Complete Sets',4,31393,'220:2536:31393',1),
(49209,'Yu-Gi-Oh! Mixed Card Lots',4,31393,'220:2536:31393',1),
(49230,'Other Video Game Accessories',3,54968,'1249:54968',1),
(49782,'Batteries',4,179853,'131090:14780:179853',1),
(49790,'Brakes & Suspension',3,14780,'131090:14780',0),
(49831,'Chains, Sprockets & Parts',4,180029,'131090:14780:180029',1),
(49971,'Holly Hobbie',3,238,'237:238',1),
(50067,'Caravan Parts, Accessories',2,131090,'131090',1),
(50101,'Tanning Beds & Booths',3,31772,'26395:31772',1),
(50102,'Tanning Bed Lamps, Bulbs',3,31772,'26395:31772',1),
(50143,'Oil Company Collectables',4,50428,'131090:6747:50428',1),
(50203,'Office Equipment',2,170638,'170638',0),
(50253,'Bear Making, Repair',2,237,'237',1),
(50295,'Air',4,2586,'220:1188:2586',1),
(50305,'Imaginext',4,2524,'220:19169:2524',1),
(50306,'Musical Toys',4,2524,'220:19169:2524',1),
(50307,'Rescue Heroes',4,2524,'220:19169:2524',1),
(50349,'eBay Services',2,316,'316',1),
(50364,'Wallpaper Rolls & Sheets',4,180981,'11700:3187:180981',1),
(50365,'Other Weed & Pest Control',5,181034,'11700:159912:2032:181034',1),
(50382,'Drill Bits',4,164613,'11700:631:164613',1),
(50388,'Pressure Washers',4,29518,'11700:159912:29518',1),
(50419,'Kitchen Scales',3,20625,'11700:20625',1),
(50426,'Hats & Caps',4,34352,'131090:6747:34352',1),
(50427,'Badges & Patches',4,177099,'131090:6747:177099',1),
(50428,'Cars, Trucks',3,6747,'131090:6747',0),
(50431,'Keyrings',4,50428,'131090:6747:50428',1),
(50436,'Boats',3,6747,'131090:6747',1),
(50437,'Electrical, Lighting',3,26443,'131090:26443',1),
(50440,'Inboard Engines & Components',3,26443,'131090:26443',0),
(50441,'Complete Diesel Engines',4,50440,'131090:26443:50440',1),
(50442,'Complete Gas Engines',4,50440,'131090:26443:50440',1),
(50444,'Decals, Badges, Detailing',3,6030,'131090:6030',0),
(50445,'Decals & Stickers',4,50444,'131090:6030:50444',1),
(50450,'Detailing Supplies',4,50444,'131090:6030:50444',1),
(50452,'Other',4,50444,'131090:6030:50444',1),
(50454,'Motor Mounts',4,33612,'131090:6030:33612',1),
(50455,'Splash Guards & Mud Flaps',4,33637,'131090:6030:33637',1),
(50456,'Car Covers',4,33637,'131090:6030:33637',1),
(50458,'Seat Belt Shoulder Pads',4,33718,'131090:6030:33718',1),
(50459,'Switches & Controls',4,33694,'131090:6030:33694',1),
(50503,'Memory Card Cases',3,15200,'625:15200',1),
(50506,'Underwater Cases & Housings',3,15200,'625:15200',1),
(50508,'LCD Hoods',3,15200,'625:15200',1),
(50549,'Connectors & Terminals',4,32806,'131090:3270:32806',1),
(50550,'Distribution Blocks',4,32806,'131090:3270:32806',1),
(50551,'Fuses & Fuse Holders',4,32806,'131090:3270:32806',1),
(50552,'Other Car A/V Installation',4,32806,'131090:3270:32806',1),
(50564,'Speaker/Sub. Enclosures',4,32806,'131090:3270:32806',1),
(50590,'Karaoke Microphones',4,175696,'293:14969:175696',1),
(50595,'Vintage Radios',4,175740,'293:183077:175740',1),
(50596,'Vintage Stereo Receivers',4,175740,'293:183077:175740',1),
(50597,'Vintage Speakers',4,175740,'293:183077:175740',1),
(50602,'Single Use Batteries',3,48446,'293:48446',1),
(50603,'Combos',3,48446,'293:48446',1),
(50608,'Digital Clocks & Clock Radios',3,14948,'293:14948',1),
(50637,'Bracelets',3,10968,'281:10968',1),
(50647,'Earrings',3,10968,'281:10968',1),
(50677,'Brooches',3,10968,'281:10968',1),
(50692,'Sets',3,10968,'281:10968',1),
(50693,'Glass',2,870,'870',0),
(50697,'Children\'s Dishes',3,24,'870:24',1),
(50701,'Dinnerware',3,24,'870:24',1),
(50707,'Wade',3,24,'870:24',1),
(50728,'Yu Gi Oh',4,11118,'1:13658:11118',1),
(50731,'Ashtrays',3,562,'1:562',1),
(50732,'Coolers',3,562,'1:562',1),
(50734,'Lighters',3,562,'1:562',1),
(50736,'Clothing, Accessories',3,562,'1:562',1),
(50797,'Softball-Slowpitch',4,181314,'888:16021:181314',1),
(50807,'Equipment Bags',4,159052,'888:16021:159052',1),
(50809,'Batting Cages & Netting',4,181330,'888:16021:181330',1),
(50811,'Pins',3,20846,'888:20846',1),
(50814,'Carabiners',3,30105,'888:30105',1),
(50815,'Harnesses',3,30105,'888:30105',1),
(50816,'Ropes, Cords & Slings',3,30105,'888:30105',1),
(50876,'Nets, Cages & Mats',4,181129,'888:1513:181129',1),
(50877,'Other Vintage Golf Equipment',4,83041,'888:1513:83041',1),
(50882,'Dive Computers',3,16052,'888:16052',1),
(50883,'Shoes',3,16262,'888:16262',1),
(50903,'Cement Mixers',3,64808,'170769:64808',1),
(50908,'Buckets & Accessories',3,41489,'170769:41489',1),
(50924,'Industrial Robotic Arms',3,42892,'170769:42892',1),
(50935,'Clothing',3,11874,'170638:11874',0),
(50936,'Aprons',4,50935,'170638:11874:50935',1),
(50938,'Hats',4,50935,'170638:11874:50935',1),
(50951,'Mannequins',3,11890,'170638:11890',1),
(50955,'Shrink, Stretch Wrap',3,19273,'170638:19273',1),
(50960,'Electric Circuit & Multimeters',5,181968,'170769:92074:181939:181968',0),
(50965,'Gas Detectors & Monitors',5,181968,'170769:92074:181939:181968',1),
(50966,'Test Equipment Plug-Ins',5,36315,'170769:92074:181939:36315',1),
(50975,'Men\'s Clothing',3,41964,'11450:41964',1),
(50980,'Women\'s Accessories',3,41964,'11450:41964',1),
(50985,'Women\'s Clothing',3,41964,'11450:41964',1),
(51005,'Beauty, Personal Care',3,40965,'26395:40965',1),
(51020,'Watches',3,40131,'281:40131',1),
(51023,'Diecast Cars',3,40149,'220:40149',1),
(51024,'Games',3,40149,'220:40149',1),
(51027,'Novelty',3,40149,'220:40149',1),
(51028,'Pretend Play, Preschool',3,40149,'220:40149',1),
(51029,'Radio Control',3,40149,'220:40149',1),
(51030,'Plush',3,40149,'220:40149',1),
(51052,'Monitor Mounts & Stands',3,162497,'58058:162497',1),
(51064,'Case Accessories & Tool Kits',4,175674,'58058:175673:175674',1),
(51071,'USB Flash Drives',3,165,'58058:165',1),
(51082,'Memory Card Readers & Adapters',3,31530,'58058:31530',1),
(51086,'Remote Controls & Pointers',3,3676,'58058:3676',1),
(51100,'Computer Components & Parts',3,159260,'58058:159260',1),
(51104,'Computer Accessories',3,159260,'58058:159260',1),
(51167,'Load Balancers',3,175698,'58058:175698',1),
(51168,'Firewall & VPN Devices',3,175698,'58058:175698',1),
(51169,'Cabling Tools',3,182094,'58058:182094',1),
(51197,'Racks, Chassis & Patch Panels',3,175698,'58058:175698',0),
(51199,'Rackmount Cabinets & Frames',4,51197,'58058:175698:51197',1),
(51240,'Server Components',3,175698,'58058:175698',0),
(51268,'Network Switches',4,182091,'58058:175698:182091',1),
(51279,'Other',3,11907,'170638:11907',1),
(51288,'Laser Drums',4,182086,'58058:171961:182086',1),
(51328,'Print Heads',4,182086,'58058:171961:182086',1),
(51330,'Printers & Scanners',3,159260,'58058:159260',1),
(51567,'Swimwear',3,11462,'11450:11462',1),
(51568,'Pants',3,11462,'11450:11462',1),
(51580,'Jackets, Coats',3,11462,'11450:11462',1),
(51581,'Dresses',3,11462,'11450:11462',1),
(51582,'Jumpers',3,11462,'11450:11462',1),
(51583,'Skirts',3,11462,'11450:11462',1),
(51586,'Underwear',3,11462,'11450:11462',1),
(51587,'Other',3,11462,'11450:11462',1),
(51919,'Swimwear',3,11452,'11450:11452',1),
(51920,'Pants',3,11452,'11450:11452',1),
(51933,'Jackets, Coats',3,11452,'11450:11452',1),
(51946,'Jumpers',3,11452,'11450:11452',1),
(51973,'Underwear',3,11452,'11450:11452',1),
(52338,'Mega Bloks',3,183446,'220:183446',1),
(52339,'Rokenbok',3,183446,'220:183446',1),
(52345,'Valances',3,20416,'2984:20416',1),
(52348,'Other Wallpaper',4,180981,'11700:3187:180981',1),
(52357,'Bags, Briefcases',3,4250,'11450:4250',1),
(52365,'Hats',3,4250,'11450:4250',1),
(52382,'Scarves',3,4250,'11450:4250',1),
(52480,'Targets',3,20835,'888:20835',1),
(52482,'Compasses',4,181401,'888:16034:181401',1),
(52534,'Wholesale Lots',3,92074,'170769:92074',1),
(52539,'Monitors & Projectors',3,159260,'58058:159260',1),
(52543,'Magazines',2,267,'267',1),
(52555,'Wholesale, Bulk Lots',2,619,'619',1),
(52762,'Men\'s Costumes',3,163147,'11450:163147',1),
(53112,'Electrical Outlets',5,181926,'170769:92074:100182:181926',1),
(53120,'Dress/Formal',3,93427,'11450:93427',1),
(53145,'Alarms',3,170211,'170638:170211',1),
(53146,'Cameras',3,170211,'170638:170211',1),
(53159,'Tops & Blouses',3,15724,'11450:15724',1),
(53185,'Coffee, Tea Equipment',3,11874,'170638:11874',0),
(53187,'Coffee Machines',4,53185,'170638:11874:53185',1),
(53188,'Tea Equipment',4,53185,'170638:11874:53185',1),
(53216,'Grills',4,25367,'170638:11874:25367',1),
(53217,'Ovens',4,25367,'170638:11874:25367',1),
(53225,'Refrigerators',4,25367,'170638:11874:25367',1),
(53237,'Clamps, Vices',3,42935,'170769:42935',1),
(53288,'Signage',3,11897,'170769:11897',1),
(53305,'Grinders',4,53185,'170638:11874:53185',1),
(53369,'Women\'s Costumes',3,163147,'11450:163147',1),
(53447,'Jumpsuits',3,172378,'2984:172378',1),
(53548,'Occupational',3,3034,'11450:3034',1),
(53557,'Boots',3,3034,'11450:3034',1),
(53591,'Postcards',3,196,'11232:196',1),
(53593,'Figurines',3,196,'11232:196',1),
(53656,'Memorabilia',3,21563,'888:21563',1),
(53700,'Microphones',3,14969,'293:14969',1),
(53724,'Series Ware',4,43813,'870:24:43813',1),
(53725,'Characters, Figurines',4,43813,'870:24:43813',1),
(53726,'Dinner Ware',4,43813,'870:24:43813',1),
(53728,'Bendigo',3,170518,'870:170518',1),
(53729,'Boyd',3,170518,'870:170518',1),
(53730,'Campbell, McHugh',3,170518,'870:170518',1),
(53731,'Diana',3,170518,'870:170518',1),
(53732,'Pates',3,170518,'870:170518',1),
(53733,'Remued',3,170518,'870:170518',1),
(53734,'Studio Anna, Florenz',3,170518,'870:170518',1),
(53735,'Wembley',3,170518,'870:170518',1),
(54075,'Bath Caddies & Storage',3,26677,'11700:26677',1),
(54235,'Chairs',3,3197,'11700:3197',1),
(54257,'Pillow Cases',3,20444,'11700:20444',1),
(54829,'Gold & Metal Leafing Sheets',4,160704,'14339:28102:160704',1),
(54919,'Palette Knives',5,183098,'14339:11783:28110:183098',1),
(54922,'Painting Supplies Storage',5,183098,'14339:11783:28110:183098',1),
(54968,'Video Game Accessories',2,1249,'1249',0),
(55793,'Heels',3,3034,'11450:3034',1),
(55805,'Modular & Pre-Fab Buildings',2,170769,'170769',1),
(55807,'Theodolites',3,42297,'170769:42297',1),
(55824,'Electrical Panels & Boards',5,181917,'170769:92074:100182:181917',1),
(55826,'Linear Actuators',4,181736,'170769:42892:181736',1),
(55846,'Credit Card Terminals, Readers',3,71465,'170638:71465',1),
(56083,'Internal Hard Disk Drives',4,182085,'58058:165:182085',1),
(56088,'Server CPUs/Processors',4,51240,'58058:175698:51240',1),
(56090,'Server Power Supplies',4,51240,'58058:175698:51240',1),
(56091,'Disk Controllers/RAID Cards',4,51240,'58058:175698:51240',1),
(56092,'Other Ent. Server Components',4,51240,'58058:175698:51240',1),
(56141,'Lamps, Lighting, Fans',3,31605,'11700:31605',1),
(56169,'iPod, Audio Player Accessories',3,15052,'293:15052',0),
(56170,'Cases, Covers & Skins',4,56169,'293:15052:56169',1),
(56172,'Cables & Adapters',4,56169,'293:15052:56169',1),
(56183,'Jerseys',4,22682,'888:7294:22682',1),
(56185,'Sunglasses, Goggles',3,7294,'888:7294',1),
(56197,'Vintage Bicycle Parts',4,158999,'888:7294:158999',1),
(56279,'Tazo Pickers, Dizks',3,158356,'1:158356',1),
(56281,'Yowies',3,158356,'1:158356',1),
(56420,'Flags & Poles',4,183544,'131090:25622:183544',1),
(56605,'Chargers',5,19839,'220:2562:182187:19839',1),
(56615,'Servos & Servo Accessories',5,19839,'220:2562:182187:19839',1),
(56732,'Trolling Rods',4,179946,'888:1492:179946',1),
(56734,'Surf Rods',4,179946,'888:1492:179946',1),
(56996,'Storage Containers',3,57004,'170769:57004',1),
(57004,'Storage',2,170769,'170769',0),
(57005,'Bins & Cabinets',3,57004,'170769:57004',1),
(57006,'Pallets & Pallet Racking',3,57004,'170769:57004',1),
(57012,'Other Solder & Desolder Accs',4,182942,'170769:182941:182942',1),
(57019,'Fire Extinguishers',3,11897,'170769:11897',1),
(57020,'Fire Hoses',3,11897,'170769:11897',1),
(57021,'Smoke Detectors',3,11897,'170769:11897',1),
(57023,'Gears',4,25283,'170769:41489:25283',1),
(57070,'Coffee Roasters',4,53185,'170638:11874:53185',1),
(57081,'Rotisseries',4,163493,'170638:11874:163493',1),
(57093,'Furniture',3,11874,'170638:11874',0),
(57096,'Other',4,57093,'170638:11874:57093',1),
(57098,'Décor',3,11874,'170638:11874',1),
(57107,'Dishwashers',4,25367,'170638:11874:25367',1),
(57120,'Equipment, Machinery',3,42935,'170769:42935',1),
(57125,'Carving Tools, Chisels',3,42935,'170769:42935',1),
(57202,'Tatting & Lacemaking Kits',4,183231,'14339:160706:183231',1),
(57208,'Art Paper',4,183081,'14339:11783:183081',1),
(57209,'Artists Brushes',4,28110,'14339:11783:28110',1),
(57215,'Electrical',3,3187,'11700:3187',0),
(57223,'Vines',5,19617,'11700:159912:181003:19617',1),
(57224,'Vine Seeds',5,40605,'11700:159912:181003:40605',1),
(57230,'Other Ponds & Water Features',4,93632,'11700:159912:93632',1),
(57231,'Kitchen Units, Sets',3,20625,'11700:20625',1),
(57261,'Bats',3,21557,'888:21557',1),
(57262,'Bicycle Components & Parts',3,7294,'888:7294',0),
(57267,'Other',4,57262,'888:7294:57262',1),
(57268,'Horse Wear',3,3153,'888:3153',0),
(57270,'Body Protectors',4,87443,'888:3153:87443',1),
(57273,'Toning Belts',4,28064,'888:15273:28064',1),
(57275,'Trampolines',4,28064,'888:15273:28064',1),
(57277,'Gloves',4,159178,'888:20862:159178',1),
(57516,'Control Systems & PLCs',3,42892,'170769:42892',0),
(57520,'Other Sensors',4,181784,'170769:42892:181784',1),
(57586,'Tattoo Inks',3,33914,'26395:33914',1),
(57589,'Tattoo Complete Kits',3,33914,'26395:33914',1),
(57714,'Bezels, Inserts',5,63200,'281:14324:173696:63200',1),
(57715,'Crystals',5,63200,'281:14324:173696:63200',1),
(57720,'Movements',5,63200,'281:14324:173696:63200',1),
(57738,'Other',3,71183,'14339:71183',1),
(57740,'Weaving Books & Patterns',4,183233,'14339:160706:183233',1),
(57741,'Weaving Looms',4,183233,'14339:160706:183233',1),
(57749,'Socks',4,163397,'2984:3082:163397',1),
(57784,'One-Pieces',4,147317,'2984:3082:147317',1),
(57793,'Bottoms',4,147317,'2984:3082:147317',1),
(57847,'One-Pieces',4,147192,'2984:3082:147192',1),
(57875,'Other',4,163397,'2984:3082:163397',1),
(57881,'Boy\'s Accessories',2,11450,'11450',0),
(57882,'Backpacks, Bags',3,57881,'11450:57881',1),
(57883,'Belts, Belt Buckles',3,57881,'11450:57881',1),
(57884,'Hats',3,57881,'11450:57881',1),
(57885,'Gloves, Mittens',3,57881,'11450:57881',1),
(57886,'Ties',3,57881,'11450:57881',1),
(57887,'Wallets',3,57881,'11450:57881',1),
(57917,'Backpacks',3,15628,'11450:15628',1),
(57918,'Belts & Belt Buckles',3,15628,'11450:15628',1),
(57920,'Hair Accessories',3,15628,'11450:15628',1),
(57927,'Scarves & Wraps',3,15628,'11450:15628',1),
(57929,'Boy\'s Shoes',2,11450,'11450',1),
(57974,'Girl\'s Shoes',2,11450,'11450',1),
(57988,'Coats, Jackets',3,1059,'11450:1059',1),
(57989,'Pants',3,1059,'11450:1059',1),
(57990,'Casual Shirts',3,1059,'11450:1059',1),
(57991,'Business, Formal Shirts',3,1059,'11450:1059',1),
(58042,'Vintage Calculators',3,183077,'293:183077',1),
(58049,'Other',3,139836,'293:139836',1),
(58058,'Computers/Tablets & Networking',1,-1,'',0),
(58061,'Pitching Machines',4,181330,'888:16021:181330',1),
(58100,'Locks & Security',4,177832,'888:7294:177832',1),
(58101,'Seatposts',4,57262,'888:7294:57262',1),
(58102,'Exercise Bikes',4,28059,'888:15273:28059',1),
(58105,'Gliders',4,28059,'888:15273:28059',1),
(58106,'Thigh Exercisers',4,28064,'888:15273:28064',1),
(58128,'Books & Video',3,16262,'888:16262',1),
(58129,'Poles',4,16059,'888:36259:16059',1),
(58134,'Media',3,22709,'888:22709',1),
(58145,'Lighting',3,41498,'170769:41498',1),
(58148,'Lumber, Millwork',3,41498,'170769:41498',1),
(58162,'Buzzers & Speakers',5,36330,'170769:92074:182412:36330',1),
(58163,'Potentiometer Knobs',5,182415,'170769:92074:182412:182415',1),
(58166,'Pushbutton Switches',5,181845,'170769:92074:100016:181845',1),
(58167,'Rocker Switches',5,181845,'170769:92074:100016:181845',1),
(58168,'Rotary Switches',5,181845,'170769:92074:100016:181845',1),
(58260,'Welding Aprons',5,67044,'170769:182941:34095:67044',1),
(58271,'Stationery',2,170638,'170638',0),
(58277,'Multimeters',6,50960,'170769:92074:181939:181968:50960',1),
(58278,'Panel Meters',5,181968,'170769:92074:181939:181968',1),
(58284,'Test Equipment Software',5,36315,'170769:92074:181939:36315',1),
(58289,'Radiation Detectors',5,181968,'170769:92074:181939:181968',1),
(58297,'Modems',3,11176,'58058:11176',1),
(58300,'Computer Cable Testers',3,182094,'58058:182094',1),
(58317,'SAN Disk Arrays',4,182093,'58058:175698:182093',1),
(58319,'Switch Modules',4,182091,'58058:175698:182091',1),
(58320,'Switch Power Supplies',4,182091,'58058:175698:182091',1),
(58321,'Other Ent. Switches & Hubs',4,182091,'58058:175698:182091',1),
(58322,'Disk Array Components',4,182093,'58058:175698:182093',1),
(58353,'Cords, Jacks & Plugs',3,164874,'15032:164874',1),
(58507,'Notes',2,11116,'11116',0),
(58516,'Middle East',3,58507,'11116:58507',1),
(58520,'Coins',2,11116,'11116',0),
(58532,'Middle East',3,58520,'11116:58520',1),
(58534,'Tokens',3,3452,'11116:3452',1),
(58540,'Screen Protectors',3,9394,'15032:9394',1),
(58543,'Accessory Bundles',3,9394,'15032:9394',1),
(58730,'Pillows',3,93838,'11730:93838',1),
(58799,'Marbles',3,19016,'220:19016',1),
(59042,'Other Paving & Decking',6,118858,'11700:159912:2032:181027:118858',1),
(59273,'Track Suits',5,40883,'888:15273:158913:40883',1),
(59280,'Pants',5,40883,'888:15273:158913:40883',1),
(59285,'Jackets & Vests',5,40883,'888:15273:158913:40883',1),
(59307,'Shorts',5,40883,'888:15273:158913:40883',1),
(59315,'Sport Bras',5,40883,'888:15273:158913:40883',1),
(59325,'Hoodies & Sweatshirts',5,40883,'888:15273:158913:40883',1),
(59333,'Shirts',5,40883,'888:15273:158913:40883',1),
(59339,'Track Suits',5,40884,'888:15273:158913:40884',1),
(59347,'Pants',5,40884,'888:15273:158913:40884',1),
(59353,'Jackets & Vests',5,40884,'888:15273:158913:40884',1),
(59368,'Shirts',5,40884,'888:15273:158913:40884',1),
(59375,'Shorts',5,40884,'888:15273:158913:40884',1),
(59392,'Hoodies & Sweatshirts',5,40884,'888:15273:158913:40884',1),
(59698,'Ornaments',3,16086,'11700:16086',1),
(59700,'Lighting',3,16086,'11700:16086',1),
(59905,'Windchimes',3,10033,'11700:10033',1),
(59907,'Sets',4,20652,'11700:20625:20652',1),
(59908,'Table Decorations',3,20625,'11700:20625',1),
(59976,'Playgro',3,19169,'220:19169',1),
(59980,'Pretend Parents',3,19169,'220:19169',1),
(60120,'Money Clips',3,10290,'281:10290',1),
(60207,'Car Electronics Accessories',3,3270,'131090:3270',0),
(60208,'Adaptors',4,60207,'131090:3270:60207',1),
(60225,'Lord of the Rings Movie Cards',3,182982,'1:182982',0),
(60226,'Trading Card Singles',4,183014,'1:182982:183014',1),
(60232,'Trading Card Singles',4,183010,'1:182982:183010',1),
(60235,'Trading Card Singles',4,183001,'1:182982:183001',1),
(60240,'Trading Card Singles',4,183036,'1:182982:183036',1),
(60344,'Wardrobe',3,196,'11232:196',1),
(60359,'Props',3,196,'11232:196',1),
(60380,'Posters',3,1424,'11232:1424',1),
(60432,'Posters',2,550,'550',1),
(60435,'Direct from the Artist',2,550,'550',0),
(60436,'Drawings',3,60435,'550:60435',1),
(60437,'Paintings',3,60435,'550:60435',1),
(60442,'Sculptures',3,60435,'550:60435',1),
(60595,'Memorabilia',3,16021,'888:16021',1),
(60645,'Tins',3,34,'1:34',1),
(60798,'Trading Card Singles',4,60225,'1:182982:60225',1),
(60801,'Trading Card Singles',4,182992,'1:182982:182992',1),
(60808,'Trading Card Singles',4,183028,'1:182982:183028',1),
(60811,'Phone Cards',2,1,'1',1),
(60890,'Henna Paste & Powder',3,33914,'26395:33914',1),
(61091,'Badges',3,196,'11232:196',1),
(61312,'Remote Controls',3,71582,'172176:71582',1),
(61395,'Other',3,14961,'293:14961',1),
(61494,'Wholesale, Bulk Lots',2,293,'293',1),
(61568,'Graders',3,177641,'170769:177641',1),
(61677,'Chairs',3,11828,'170638:11828',1),
(61681,'Cubicles',3,11828,'170638:11828',1),
(61739,'Brake Shoes',4,33559,'131090:6030:33559',1),
(61770,'Whiteboards',2,170638,'170638',1),
(61792,'Plastics & Rubbers',4,182919,'170769:177644:182919',0),
(61816,'Boosters, Extenders & Antennas',3,11176,'58058:11176',1),
(61839,'VoIP Business Phones/IP PBX',3,175698,'58058:175698',1),
(61840,'VoIP Home Phones',3,11176,'58058:11176',1),
(62041,'Voice Recorders, Dictaphones',3,14948,'293:14948',1),
(62107,'Sandals, Flip-Flops',3,3034,'11450:3034',1),
(62118,'MREs & Freeze-Dried Food',4,181381,'888:16034:181381',1),
(62124,'Jerseys',4,158963,'888:21194:158963',1),
(62125,'Shorts, Pants',4,158963,'888:21194:158963',1),
(62132,'Water Bottles & Cages',4,177832,'888:7294:177832',1),
(62134,'Skip, Jump Ropes',4,28064,'888:15273:28064',1),
(62143,'Novelties & Gifts',3,1492,'888:1492',1),
(62153,'Rod Building, Repair',4,179946,'888:1492:179946',1),
(62155,'Publications & Video',3,1492,'888:1492',1),
(62166,'Squash, Racquetball',2,888,'888',0),
(62169,'Racquets',3,62166,'888:62166',1),
(62170,'Ski & Snowboard Wax',4,119236,'888:36259:119236',1),
(62172,'Gloves',4,21233,'888:36259:21233',1),
(62175,'Hats & Headwear',4,21233,'888:36259:21233',1),
(62178,'Ski Suits',4,21233,'888:36259:21233',1),
(62230,'Shoes',3,13340,'888:13340',1),
(62250,'Battery Chargers',3,25622,'131090:25622',1),
(63034,'Feeders',3,20754,'1281:20754',1),
(63057,'Collars',3,20742,'1281:20742',1),
(63071,'Cat Treats',3,20737,'1281:20737',1),
(63073,'Food',3,20737,'1281:20737',1),
(63200,'Parts',4,173696,'281:14324:173696',0),
(63503,'Bottle Stoppers',4,20687,'11700:20625:20687',1),
(63504,'Cocktail Shakers & Sets',4,20687,'11700:20625:20687',1),
(63505,'Flasks',4,20687,'11700:20625:20687',1),
(63506,'Ice Buckets',4,20687,'11700:20625:20687',1),
(63514,'Curtains & Blinds',2,11700,'11700',0),
(63521,'Ceramics, Porcelain',3,20086,'20081:20086',0),
(63522,'Bowls',4,63521,'20081:20086:63521',1),
(63525,'Cups, Saucers',4,63521,'20081:20086:63521',1),
(63526,'Figurines',4,63521,'20081:20086:63521',1),
(63527,'Jars',4,63521,'20081:20086:63521',1),
(63528,'Pitchers',4,63521,'20081:20086:63521',1),
(63530,'Vases',4,63521,'20081:20086:63521',1),
(63534,'Teapots, Sets',4,63521,'20081:20086:63521',1),
(63537,'Clocks',3,20086,'20081:20086',1),
(63538,'Glass',3,20086,'20081:20086',0),
(63539,'Bowls',4,63538,'20081:20086:63538',1),
(63540,'Jars',4,63538,'20081:20086:63538',1),
(63544,'Plates',4,63538,'20081:20086:63538',1),
(63545,'Stemware',4,63538,'20081:20086:63538',1),
(63546,'Vases',4,63538,'20081:20086:63538',1),
(63547,'Lamps',3,20086,'20081:20086',1),
(63548,'Tin',4,1211,'20081:20086:1211',1),
(63549,'Beds',3,20091,'20081:20091',1),
(63561,'Cabinets, Cupboards',3,20091,'20081:20091',1),
(63565,'Chairs',3,20091,'20081:20091',1),
(63569,'Desks',3,20091,'20081:20091',1),
(63573,'Dining',3,20091,'20081:20091',1),
(63581,'Sofas, Chaises',3,20091,'20081:20091',1),
(63585,'Tables',3,20091,'20081:20091',1),
(63589,'Other Furniture',3,20091,'20081:20091',1),
(63624,'Pillows',3,181677,'20081:181677',1),
(63627,'Quilts',3,181677,'20081:181677',1),
(63676,'Aircraft',2,9800,'9800',0),
(63677,'Single Engine Airplanes',3,63676,'9800:63676',1),
(63689,'Window Tint',4,33683,'131090:6030:33683',1),
(63691,'Cup Holders',4,33694,'131090:6030:33694',1),
(63692,'Torque Converters',4,33726,'131090:6030:33726',1),
(63694,'Shop Equipment',4,34998,'131090:6030:34998',1),
(63697,'Lifts, Hoists, Jacks',4,34998,'131090:6030:34998',1),
(63702,'Body Shop Supplies',4,34998,'131090:6030:34998',1),
(63722,'Ultralights',3,63676,'9800:63676',1),
(63728,'Sailboats',3,26429,'9800:26429',1),
(63783,'Wall Hangings',4,13777,'1:13905:13777',1),
(63784,'Baking Forms',4,106191,'11700:20625:106191',1),
(63787,'Measuring Sets',4,106191,'11700:20625:106191',1),
(63788,'Modular Mates',4,106191,'11700:20625:106191',1),
(63808,'Art',4,914,'1:124:914',1),
(63821,'Film Stock',2,11232,'11232',1),
(63850,'Mixed Items',3,93427,'11450:93427',1),
(63853,'Bras',3,11514,'11450:11514',1),
(63854,'Panties',3,11514,'11450:11514',1),
(63855,'Sleepwear',3,15724,'11450:15724',1),
(63856,'Coats, Jackets',3,172378,'2984:172378',1),
(63857,'Pants',3,172378,'2984:172378',1),
(63858,'Tops, Blouses',3,172378,'2984:172378',1),
(63859,'T-Shirts',3,172378,'2984:172378',1),
(63861,'Dresses',3,15724,'11450:15724',1),
(63862,'Coats, Jackets',3,15724,'11450:15724',1),
(63863,'Pants',3,15724,'11450:15724',1),
(63864,'Skirts',3,15724,'11450:15724',1),
(63865,'Suits, Blazers',3,15724,'11450:15724',1),
(63866,'Jumpers, Cardigans',3,15724,'11450:15724',1),
(63867,'Swimwear',3,15724,'11450:15724',1),
(63869,'T-Shirts',3,15724,'11450:15724',1),
(63889,'Mixed Items',3,3034,'11450:3034',1),
(63890,'Doors, Fixtures',3,41498,'170769:41498',1),
(63894,'Insulation',3,41498,'170769:41498',1),
(63896,'Plumbing',3,41498,'170769:41498',1),
(63897,'Taps, Mixers',4,20601,'11700:3187:20601',1),
(63908,'Protective Gear',2,170769,'170769',0),
(63909,'Hard Hats',3,63908,'170769:63908',1),
(63910,'Gloves',3,63908,'170769:63908',1),
(63911,'Pants, Overalls',3,63908,'170769:63908',1),
(63912,'Other',3,63908,'170769:63908',1),
(63917,'Screwdrivers',3,46576,'170769:46576',1),
(63918,'Combos',3,64808,'170769:64808',1),
(63924,'Wood Chippers & Stump Grinders',3,177641,'170769:177641',1),
(63940,'Levels',3,42297,'170769:42297',1),
(63991,'Dental Equipment',3,11815,'170769:11815',1),
(64035,'Ethernet Cables (RJ-45/8P8C)',4,20311,'58058:182094:20311',1),
(64043,'Fibre Optic Cables',4,20311,'58058:182094:20311',1),
(64052,'Print Servers',4,175700,'58058:175698:175700',1),
(64061,'Rackmount Cases & Chassis',4,51197,'58058:175698:51197',1),
(64069,'NAS Disk Arrays',4,182093,'58058:175698:182093',1),
(64343,'Straps & Hand Grips',3,15200,'625:15200',1),
(64345,'Remotes & Shutter Releases',3,15200,'625:15200',1),
(64352,'Digital Camera Parts',3,182074,'625:182074',1),
(64353,'Flashes & Flash Accessories',2,625,'625',0),
(64354,'Other Flashes & Flash Accs',3,64353,'625:64353',1),
(64356,'Batteries',4,45066,'15032:45065:45066',1),
(64357,'Chargers & Cradles',4,45066,'15032:45065:45066',1),
(64374,'Flugelhorns',3,16212,'619:16212',1),
(64388,'Tuners',3,180008,'619:180008',1),
(64398,'Bass Guitar',4,84659,'619:3858:84659',1),
(64498,'Body Jewellery',3,40131,'281:40131',1),
(64516,'Jewellery Findings, Supplies',3,40131,'281:40131',1),
(64578,'Wire Harnesses',4,32806,'131090:3270:32806',1),
(64602,'Complete Karaoke Systems',4,175696,'293:14969:175696',1),
(64604,'Karaoke CDGs, DVDs & Media',4,175696,'293:14969:175696',1),
(64605,'Karaoke Mixers',4,175696,'293:14969:175696',1),
(64606,'Players & Mic-Based Players',4,175696,'293:14969:175696',1),
(64619,'Turntable Parts',3,14969,'293:14969',1),
(64627,'Vintage Tubes & Tube Sockets',5,175741,'293:183077:175740:175741',1),
(64642,'Training Aids',3,21194,'888:21194',1),
(64657,'Go Kart Accessories',2,131090,'131090',1),
(64808,'Hardware',2,170769,'170769',0),
(64840,'Barbie',3,238,'237:238',1),
(64849,'Baby Born',3,238,'237:238',1),
(64853,'Babushka Dolls',2,237,'237',1),
(64960,'Crested China',4,64981,'870:24:64981',1),
(64961,'Royal Albert',3,24,'870:24',0),
(64962,'Decorative, Ornamental',4,64961,'870:24:64961',1),
(64964,'Animals',4,43813,'870:24:43813',1),
(64966,'Bunnykins',4,43813,'870:24:43813',1),
(64967,'Character, Toby Jugs',4,43813,'870:24:43813',1),
(64979,'Wedgwood',3,24,'870:24',0),
(64980,'Decorative, Ornamental',4,64979,'870:24:64979',1),
(64981,'Unmarked Pieces',3,24,'870:24',0),
(64982,'Other Unmarked Pieces',4,64981,'870:24:64981',1),
(65020,'Staffordshire',3,24,'870:24',0),
(65021,'Decorative, Ornamental',4,65020,'870:24:65020',1),
(65026,'Stoneware',2,870,'870',1),
(65174,'British Colonies & Territories',2,260,'260',1),
(65182,'Turkey',3,4742,'260:4742',1),
(65183,'Yugoslavia',3,4742,'260:4742',1),
(65184,'Postal History',3,181420,'260:181420',1),
(65203,'Nature & Plants',3,4752,'260:4752',1),
(65207,'Medical & Red Cross',3,4752,'260:4752',1),
(65208,'Sports',3,4752,'260:4752',1),
(65210,'Aviation',4,181418,'260:4752:181418',1),
(65211,'Ships & Boats',4,181418,'260:4752:181418',1),
(65212,'Motor Vehicles',4,181418,'260:4752:181418',1),
(65213,'Space',3,4752,'260:4752',1),
(65214,'Trains & Railroads',4,181418,'260:4752:181418',1),
(65309,'Other Exhaust & Systems',4,182307,'131090:84149:182307',1),
(65310,'Other Lighting & Indicators',4,182333,'131090:84149:182333',1),
(65317,'Other Brake Parts',4,182255,'131090:84149:182255',1),
(65329,'Other Suspension & Handling',4,182355,'131090:84149:182355',1),
(65336,'Other Electrical & Ignition',4,182278,'131090:84149:182278',1),
(65344,'Other Instruments & Gauges',4,182324,'131090:84149:182324',1),
(65353,'Other Handlebars',4,182316,'131090:84149:182316',1),
(65361,'Engines & Engine Parts',3,84149,'131090:84149',0),
(65368,'Frames',4,135847,'131090:84149:135847',1),
(65375,'Other Seating',4,182348,'131090:84149:182348',1),
(65380,'Fuel Tanks',4,182240,'131090:84149:182240',1),
(65385,'Fairings & Parts',4,135847,'131090:84149:135847',1),
(65452,'Gearmotors',4,181730,'170769:42892:181730',1),
(65455,'Rotary Encoders',4,181784,'170769:42892:181784',1),
(65456,'Pressure Sensors',4,181784,'170769:42892:181784',1),
(65458,'Level Sensors',4,181784,'170769:42892:181784',1),
(65459,'Proximity Sensors',4,181784,'170769:42892:181784',1),
(65460,'Temperature & Humidity Sensors',4,181784,'170769:42892:181784',1),
(65464,'Safety Relays',5,181686,'170769:42892:181678:181686',1),
(65489,'Electronic Component Fans',4,182017,'170769:92074:182017',1),
(65507,'Development Kits & Boards',5,36330,'170769:92074:182412:36330',1),
(65509,'Cable Cleats, Clamps & Ties',6,181812,'170769:92074:100016:73136:181812',1),
(65511,'Fibre Optic Cable',5,73136,'170769:92074:100016:73136',1),
(65512,'Connectors',4,100016,'170769:92074:100016',0),
(65635,'Coffee Makers (Automatic)',2,20710,'20710',1),
(65965,'Insect Nets & Repellents',4,181411,'888:16034:181411',1),
(65974,'Gloves',4,179978,'888:1492:179978',1),
(65976,'Jackets & Coats',4,179978,'888:1492:179978',1),
(65982,'Vests',4,179978,'888:1492:179978',1),
(66002,'Hand Warmers',4,181411,'888:16034:181411',1),
(66078,'Socks',5,40883,'888:15273:158913:40883',1),
(66095,'Socks',5,40884,'888:15273:158913:40884',1),
(66468,'Trailers',2,9800,'9800',1),
(66469,'Trailers',3,26443,'131090:26443',1),
(66471,'Tyres',4,33743,'131090:6030:33743',1),
(66479,'Wheel & Tyre Packages',4,33743,'131090:6030:33743',1),
(66518,'Miniatures',4,13777,'1:13905:13777',1),
(66638,'Other Maritime',3,37965,'20081:37965',1),
(66674,'Change Mats & Covers',3,26268,'2984:26268',1),
(66675,'Pillows',3,20400,'2984:20400',1),
(66676,'Breast Pumps',3,20400,'2984:20400',1),
(66690,'Rockers, Bouncers',3,20422,'2984:20422',1),
(66692,'Car Seats, Accessories',2,2984,'2984',0),
(66693,'Accessories',3,66692,'2984:66692',1),
(66694,'Boosters',3,66692,'2984:66692',1),
(66695,'Convertible Seats',3,66692,'2984:66692',1),
(66696,'Car Seats',3,66692,'2984:66692',1),
(66697,'Nursery Décor',2,2984,'2984',0),
(66698,'Prams, Strollers & Accs',2,2984,'2984',0),
(66700,'Prams & Strollers',3,66698,'2984:66698',1),
(66722,'Non-Slip Appliques & Mats',3,26677,'11700:26677',1),
(66723,'Toilet Brushes & Sets',3,26677,'11700:26677',1),
(66737,'Bed & Waterbed Accessories',4,32254,'11700:3197:32254',1),
(66738,'Cameras',3,41968,'11700:41968',1),
(66739,'Door Hinges',4,41976,'11700:3187:41976',1),
(66741,'Children\'s Furniture',3,3197,'11700:3197',0),
(66742,'Bedroom Furniture',4,66741,'11700:3197:66741',1),
(66743,'Tables & Chairs',4,66741,'11700:3197:66741',1),
(66744,'Other Children\'s Furniture',4,66741,'11700:3197:66741',1),
(66749,'Fondue Sets',3,20667,'20710:20667',1),
(66751,'Mincers',3,20667,'20710:20667',1),
(66752,'Popcorn Poppers',3,20667,'20710:20667',1),
(66762,'Beds',3,20737,'1281:20737',1),
(66763,'Collars & Tags',3,20737,'1281:20737',1),
(66780,'Food',3,20742,'1281:20742',1),
(66789,'Decorations',3,20754,'1281:20754',1),
(66799,'Shutters',3,63514,'11700:63514',1),
(66814,'Golf Spikes',4,181128,'888:1513:181128',1),
(66841,'Swords (Japanese)',3,20082,'20081:20082',1),
(66876,'Box Blades & Snow Plows',4,177647,'170769:41489:177647',1),
(66877,'Mower Decks',4,177647,'170769:41489:177647',1),
(66879,'Balers',4,177647,'170769:41489:177647',1),
(66880,'Mowers & Mower Conditioners',4,177647,'170769:41489:177647',1),
(66881,'Hay Rakes',4,177647,'170769:41489:177647',1),
(66883,'Planters',4,177647,'170769:41489:177647',1),
(66884,'Seeders & Spreaders',4,177647,'170769:41489:177647',1),
(66886,'Cultivators',4,177647,'170769:41489:177647',1),
(66887,'Disc Harrows',4,177647,'170769:41489:177647',1),
(66889,'Tillers',4,177647,'170769:41489:177647',1),
(66917,'Drill Presses',3,64808,'170769:64808',1),
(66926,'Backhoe Attachments',4,177647,'170769:41489:177647',1),
(66927,'Augers',3,41489,'170769:41489',1),
(66938,'Winches',3,64808,'170769:64808',1),
(66946,'Heat Sinks',4,182017,'170769:92074:182017',1),
(66966,'Soap Dispensers',3,170639,'170638:170639',1),
(66968,'Sweepers & Scrubbers',3,64808,'170769:64808',1),
(66981,'Disconnect Switches',5,181845,'170769:92074:100016:181845',1),
(66984,'Wire & Cable Tools',5,73136,'170769:92074:100016:73136',0),
(66985,'Conduit Benders',6,66984,'170769:92074:100016:73136:66984',1),
(66986,'Cable Pullers',6,66984,'170769:92074:100016:73136:66984',1),
(66987,'Hand Crimpers & Strippers',6,66984,'170769:92074:100016:73136:66984',1),
(66988,'Crimping Dies',6,66984,'170769:92074:100016:73136:66984',1),
(66990,'Other Electrical Tools',6,66984,'170769:92074:100016:73136:66984',1),
(66991,'Electrical Usage Meters',4,100182,'170769:92074:100182',1),
(66994,'Other Fuse Accessories',5,181832,'170769:92074:181814:181832',1),
(66995,'Uninterruptible Power Supplies',5,181921,'170769:92074:100182:181921',1),
(67044,'Welding Protective Gear',4,34095,'170769:182941:34095',0),
(67045,'Welding Gloves',5,67044,'170769:182941:34095:67044',1),
(67046,'Welding Goggles',5,67044,'170769:182941:34095:67044',1),
(67051,'Welding Jackets',5,67044,'170769:182941:34095:67044',1),
(67052,'Other Welding Protective Gear',5,67044,'170769:182941:34095:67044',1),
(67053,'Welding Carts',4,34095,'170769:182941:34095',1),
(67054,'MIG Guns & Torches',5,182897,'170769:182941:34095:182897',1),
(67062,'TIG Torches',5,182897,'170769:182941:34095:182897',1),
(67063,'Tungsten Electrodes',5,182905,'170769:182941:34095:182905',1),
(67073,'Cleaning Kits',3,67076,'170638:67076',1),
(67074,'Other',3,67076,'170638:67076',1),
(67076,'Photocopier Accessories, Parts',2,170638,'170638',0),
(67094,'Overhead Projectors',2,170638,'170638',1),
(67095,'Paper Shredders',3,50203,'170638:50203',1),
(67167,'Ice Cream Machines',4,25367,'170638:11874:25367',1),
(67171,'Ice Machines',4,25367,'170638:11874:25367',1),
(67172,'Seats',4,57093,'170638:11874:57093',1),
(67216,'Advertising Inventory',3,11759,'170638:11759',1),
(67243,'Router Bits',3,170798,'170769:170798',1),
(67262,'Powerline Networking',3,11176,'58058:11176',1),
(67276,'Splitters, Couplers & Adapters',4,20311,'58058:182094:20311',1),
(67279,'Plugs, Jacks & Wall Plates',4,20311,'58058:182094:20311',1),
(67286,'Router Modules/Cards/Adapters',4,182092,'58058:175698:182092',1),
(67287,'Router Power Supplies',4,182092,'58058:175698:182092',1),
(67292,'Router Memory',4,182092,'58058:175698:182092',1),
(67339,'Camcorder Tapes & Discs',3,15200,'625:15200',1),
(67391,'Bath Sets & Kits',3,11838,'26395:11838',1),
(67408,'Clippers & Trimmers',3,31762,'26395:31762',1),
(67416,'Tweezers',3,31762,'26395:31762',1),
(67421,'Standard Toothbrushes',3,31769,'26395:31769',1),
(67422,'Toothpaste',3,31769,'26395:31769',1),
(67500,'Skin Care Sets & Kits',3,11863,'26395:11863',1),
(67588,'Health Care',2,26395,'26395',0),
(67589,'Other Health Care',3,67588,'26395:67588',1),
(67653,'Nail Dryers & UV/LED Lamps',3,47945,'26395:47945',1),
(67659,'Natural & Alternative Remedies',2,26395,'26395',0),
(67661,'Massage Stones & Rocks',3,36447,'26395:36447',1),
(67670,'Reading Glasses',3,31414,'26395:31414',1),
(67678,'Low Vision Magnifiers',3,31414,'26395:31414',1),
(67681,'Rings',3,10968,'281:10968',1),
(67696,'Gift Boxes',3,11890,'170638:11890',1),
(67712,'Pins & Needles',4,164353,'281:164352:164353',1),
(67713,'Spacers',4,164353,'281:164352:164353',1),
(67714,'Wire',4,164353,'281:164352:164353',1),
(67715,'Bead Caps',4,164353,'281:164352:164353',1),
(67716,'Clasps & Hooks',4,164353,'281:164352:164353',1),
(67717,'Connectors',4,164353,'281:164352:164353',1),
(67718,'Cord',4,164353,'281:164352:164353',1),
(67720,'Cleaners & Polish',3,164352,'281:164352',1),
(67725,'Rings',3,4196,'281:4196',1),
(67773,'Speaker/Sub. Grills & Accs',4,32806,'131090:3270:32806',1),
(67779,'Surge Protectors, Power Strips',3,48446,'293:48446',1),
(67807,'Vintage Preamps & Tube Preamps',4,175740,'293:183077:175740',1),
(67815,'Vintage Transformers',5,175741,'293:183077:175740:175741',1),
(67850,'MiniDisc Players',3,14969,'293:14969',1),
(67857,'DSL/Phone Cables (RJ-11)',4,20311,'58058:182094:20311',1),
(67858,'Cable Ties & Organisers',3,182094,'58058:182094',1),
(67870,'USB Lights & Gadgets',3,31530,'58058:31530',1),
(67880,'Satellite Signal Multiswitches',3,71582,'172176:71582',1),
(67882,'Signal Finders',3,71582,'172176:71582',1),
(67895,'Film Cells',3,196,'11232:196',1),
(68004,'Andorra',3,4742,'260:4742',1),
(68030,'Signal Boosters',3,9394,'15032:9394',1),
(68096,'Celebrities',3,4752,'260:4752',1),
(68114,'China',3,181416,'260:181416',1),
(68362,'Memorabilia',3,19292,'888:19292',1),
(68407,'RC Tools & Sets',4,182187,'220:2562:182187',1),
(68816,'Gym Bags',3,15273,'888:15273',1),
(69148,'Smoky Quartz',5,181097,'281:491:181077:181097',1),
(69149,'Rose Quartz',5,181097,'281:491:181077:181097',1),
(69163,'Cat\'s Eye Quartz',5,181097,'281:491:181077:181097',1),
(69173,'Haematite',4,181077,'281:491:181077',1),
(69179,'Sodalite',4,181077,'281:491:181077',1),
(69181,'Sugilite',4,181077,'281:491:181077',1),
(69183,'White & Precious Opals',5,10239,'281:491:181077:10239',1),
(69184,'Fire Opals',5,10239,'281:491:181077:10239',1),
(69197,'Heating, Cooling & Air',2,20710,'20710',0),
(69202,'Air Conditioners',3,69197,'20710:69197',1),
(69323,'Film Photography',2,625,'625',0),
(69341,'Lighting Units',4,19590,'625:30078:19590',1),
(69573,'Flash Adapters',3,64353,'625:64353',1),
(69616,'Patches',3,32615,'1:32615',1),
(69693,'Posters',3,170281,'1:170281',1),
(69812,'Locomotives',4,19119,'220:180250:19119',1),
(69813,'Track',4,19119,'220:180250:19119',1),
(69814,'Carriages',4,19119,'220:180250:19119',1),
(69818,'Buildings, Tunnels & Bridges',5,180314,'220:180250:122601:180314',1),
(69820,'Track',4,122601,'220:180250:122601',1),
(69959,'Fashion Dolls',3,238,'237:238',1),
(69960,'Atmospheric Effects Machines',3,12922,'619:12922',1),
(70034,'1930 - 1949',3,50693,'870:50693',1),
(70038,'Datelined Ceramics',2,870,'870',1),
(70054,'Lladro, Nao',3,24,'870:24',0),
(70055,'Animals',4,70054,'870:24:70054',1),
(70056,'Other Lladro, Nao',4,70054,'870:24:70054',1),
(70063,'Clarice Cliff',3,24,'870:24',1),
(70071,'Carlton Ware',3,24,'870:24',0),
(70072,'Decorative, Ornamental',4,70071,'870:24:70071',1),
(70089,'New Zealand',3,181424,'260:181424',1),
(70097,'Music',3,4752,'260:4752',1),
(70574,'Parts & Accessories',3,69197,'20710:69197',1),
(70810,'Hats & Headwear',4,179978,'888:1492:179978',1),
(70897,'Other Media',3,164580,'11233:164580',1),
(70898,'Clothing',3,13340,'888:13340',1),
(70908,'Bakewells, Newtone',3,170518,'870:170518',1),
(70909,'Brownie Downing',3,170518,'870:170518',1),
(70910,'MCP Mingay',3,170518,'870:170518',1),
(70911,'Helmets',4,177864,'888:7294:177864',1),
(70955,'Astro Boy',4,11118,'1:13658:11118',1),
(71089,'Softball-Fastpitch',4,181314,'888:16021:181314',1),
(71154,'Roller Skates',3,106465,'888:106465',1),
(71161,'Masks',3,16052,'888:16052',1),
(71163,'Snorkels',3,16052,'888:16052',1),
(71164,'Accessories',3,22709,'888:22709',0),
(71167,'Other',4,71164,'888:22709:71164',1),
(71168,'Bodyboards',4,166201,'888:22709:166201',1),
(71170,'Water Skiing Equipment',4,166096,'888:23806:166096',1),
(71176,'Badge & Button Makers',4,183171,'14339:28102:183171',1),
(71177,'Wine Corks',4,160704,'14339:28102:160704',1),
(71178,'Wooden Pieces & Craft Sticks',4,160704,'14339:28102:160704',1),
(71180,'Sequins',4,183270,'14339:160737:183270',1),
(71183,'Handcrafted Arts',2,14339,'14339',0),
(71186,'Handpainted Items',3,71183,'14339:71183',1),
(71187,'Leather Lacing & Thongs',4,183127,'14339:28131:183127',1),
(71188,'Studs, Rivets & Tacks',4,183127,'14339:28131:183127',1),
(71189,'Finished Cross Stitch Pieces',5,183220,'14339:160706:28141:183220',1),
(71196,'Embroidery Machines',4,28141,'14339:160706:28141',1),
(71197,'Digitising Software',5,160724,'14339:160706:28141:160724',1),
(71215,'Knitting Needles',4,3094,'14339:160706:3094',1),
(71224,'Ribbon',4,160704,'14339:28102:160704',1),
(71235,'Turning Blanks',4,183155,'14339:3127:183155',1),
(71237,'Linen',3,20625,'11700:20625',0),
(71239,'Other Linen, Napkins',4,71237,'11700:20625:71237',1),
(71240,'Humidifiers',3,69197,'20710:69197',1),
(71246,'Cooktops',2,20710,'20710',1),
(71250,'Ranges & Stoves',2,20710,'20710',1),
(71253,'Rangehoods',2,20710,'20710',1),
(71254,'Dryers',3,42231,'20710:42231',1),
(71256,'Washing Machines',3,42231,'20710:42231',1),
(71257,'Combination',3,42231,'20710:42231',1),
(71259,'Alcohol Accessories',3,179836,'14308:179836',0),
(71260,'Freezers',3,149229,'20710:149229',1),
(71264,'Fridge, Freezer Parts',4,71259,'14308:179836:71259',1),
(71266,'Edgers',4,29518,'11700:159912:29518',1),
(71272,'Push Mowers',4,43560,'11700:159912:43560',1),
(71273,'Leaf Blowers & Vacuums',4,29518,'11700:159912:29518',1),
(71277,'String Trimmers',4,29518,'11700:159912:29518',1),
(71278,'String Trimmer Parts & Accs',4,29518,'11700:159912:29518',1),
(71282,'Shower Heads',4,20601,'11700:3187:20601',1),
(71283,'Sinks, Basins',4,20601,'11700:3187:20601',1),
(71284,'Toilets',4,20601,'11700:3187:20601',1),
(71306,'Belts',4,164613,'11700:631:164613',1),
(71318,'Ovens',2,20710,'20710',1),
(71393,'Speed Controls',5,78188,'170769:42892:78186:78188',1),
(71394,'Stepper Controls & Drives',5,78188,'170769:42892:78186:78188',1),
(71465,'Cash Register & Accessories',2,170638,'170638',0),
(71466,'Money Handling & Counting',3,71465,'170638:71465',0),
(71467,'Note Counters',4,71466,'170638:71465:71466',1),
(71472,'Receipt Rolls',3,71465,'170638:71465',1),
(71474,'Other',3,71465,'170638:71465',1),
(71475,'POS Scales',3,71465,'170638:71465',1),
(71478,'Card Encoders & Readers',3,71465,'170638:71465',1),
(71483,'Shopping Trolleys, Baskets',3,11890,'170638:11890',1),
(71509,'Server Boards',4,51240,'58058:175698:51240',1),
(71527,'Amplifier Kits',4,32806,'131090:3270:32806',1),
(71535,'Replacement Faceplates',4,60207,'131090:3270:60207',1),
(71573,'Vintage Capacitors',5,175741,'293:183077:175740:175741',1),
(71574,'Vintage Cassette Decks',4,175740,'293:183077:175740',1),
(71582,'Television Accessories',2,172176,'172176',0),
(71583,'Projector Lamps & Bulbs',3,71582,'172176:71582',1),
(71585,'Other',3,71582,'172176:71582',1),
(72176,'Sculptures',2,550,'550',1),
(72182,'Prints',3,60435,'550:60435',1),
(72183,'Badges, Posters, Patches',4,50428,'131090:6747:50428',0),
(72184,'Automotive Club',5,72183,'131090:6747:50428:72183',1),
(72185,'Car Related',5,72183,'131090:6747:50428:72183',1),
(72186,'Mascots',5,72183,'131090:6747:50428:72183',1),
(72200,'Car Care & Cleaning',3,6030,'131090:6030',0),
(72201,'Cleaning, Waxing & Valeting',4,72200,'131090:6030:72200',1),
(72203,'Touch-Up Materials',4,72200,'131090:6030:72200',1),
(72211,'Badges',4,50444,'131090:6030:50444',1),
(72359,'Packing Paper',4,109699,'170638:19273:109699',1),
(72406,'Home Theatre Systems',2,172176,'172176',1),
(72531,'Buckles & Belts',4,34352,'131090:6747:34352',1),
(72536,'Personal Watercraft',3,26429,'9800:26429',1),
(72539,'Other Safety Equipment',4,26450,'131090:26443:26450',1),
(72567,'Balls',3,21557,'888:21557',1),
(72568,'Pads',3,21557,'888:21557',1),
(72569,'Fenders',4,177832,'888:7294:177832',1),
(72575,'Darts',2,888,'888',0),
(72576,'Boards',3,72575,'888:72575',1),
(72577,'Darts',3,72575,'888:72575',1),
(72578,'Flights',3,72575,'888:72575',1),
(72579,'Bridles',4,3159,'888:3153:3159',1),
(72585,'Bridle Parts & Accessories',4,3159,'888:3153:3159',1),
(72586,'Harnesses',4,85178,'888:3153:85178',1),
(72596,'Jackets',5,183371,'888:3153:16240:183371',1),
(72597,'Jackets',5,183359,'888:3153:16240:183359',1),
(72599,'Jodhpurs & Breeches',5,183371,'888:3153:16240:183371',1),
(72600,'Jodhpurs & Breeches',5,183359,'888:3153:16240:183359',1),
(72602,'Elliptical Trainers',4,28059,'888:15273:28059',1),
(72638,'Bite Alarms',4,179985,'888:1492:179985',1),
(72665,'Rod Rests & Holders',4,179985,'888:1492:179985',1),
(72667,'Scales',4,179985,'888:1492:179985',1),
(72671,'Golf Buggy & Trolley Add-ons',4,181153,'888:1513:181153',1),
(72759,'Bath Bombs & Fizzies',3,11838,'26395:11838',1),
(72873,'Diabetic Aids',4,30115,'26395:11778:30115',0),
(72874,'Glucose Monitors',5,72873,'26395:11778:30115:72873',1),
(72875,'Lancets',5,72873,'26395:11778:30115:72873',1),
(72876,'Monitoring Kits',5,72873,'26395:11778:30115:72873',1),
(72877,'Test Strips',5,72873,'26395:11778:30115:72873',1),
(72891,'Clothing',3,16034,'888:16034',0),
(73017,'Shirts',3,21563,'888:21563',1),
(73094,'Combines',3,177641,'170769:177641',1),
(73111,'Drywall Tools',2,170769,'170769',1),
(73120,'Directional Drills',3,177641,'170769:177641',1),
(73121,'Pavers - Asphalt & Concrete',3,177641,'170769:177641',1),
(73129,'Indicators',5,181794,'170769:42892:181793:181794',1),
(73135,'Electrical Power Plugs',5,181926,'170769:92074:100182:181926',1),
(73136,'Wire & Cable',4,100016,'170769:92074:100016',0),
(73138,'Multiple Conductor Cable',5,73136,'170769:92074:100016:73136',1),
(73139,'Hookup & Lead Wire',5,73136,'170769:92074:100016:73136',1),
(73141,'Crimp Connectors',5,65512,'170769:92074:100016:65512',1),
(73144,'Varistors',5,182415,'170769:92074:182412:182415',1),
(73160,'Capacitance & ESR Meters',5,181968,'170769:92074:181939:181968',1),
(73162,'Light & Lux Meters',5,181968,'170769:92074:181939:181968',1),
(73166,'Connector Adapters',5,65512,'170769:92074:100016:65512',1),
(73167,'Test Equipment Cases',5,36315,'170769:92074:181939:36315',1),
(73169,'Splitters',5,65512,'170769:92074:100016:65512',1),
(73170,'SMA, SMB & SMC Connectors',5,65512,'170769:92074:100016:65512',1),
(73181,'Chalk',4,75184,'888:21567:75184',1),
(73240,'Tuvalu',3,181424,'260:181424',1),
(73248,'Geomag',3,183446,'220:183446',1),
(73260,'Sets',3,2616,'220:2616',1),
(73263,'Tracks',3,2616,'220:2616',1),
(73329,'Tapes & Data Cartridges',4,80133,'58058:165:80133',1),
(73340,'LED Light Key Chains',3,14948,'293:14948',1),
(73348,'Antennas',3,139836,'293:139836',1),
(73353,'Holders, Mounts',3,139836,'293:139836',1),
(73368,'Vintage Amplifiers & Tube Amps',4,175740,'293:183077:175740',1),
(73372,'Vintage Speaker & Horn Drivers',5,175741,'293:183077:175740:175741',1),
(73374,'Vintage Televisions',4,175740,'293:183077:175740',1),
(73382,'Vintage Tuners & Tube Tuners',4,175740,'293:183077:175740',1),
(73452,'Printer Photo Paper',4,11195,'58058:171961:11195',1),
(73459,'Photo Albums & Boxes',4,182075,'625:15200:182075',1),
(73467,'Other Decorative Arts',3,20086,'20081:20086',1),
(73479,'Sesame Street',3,13658,'1:13658',1),
(73503,'Ornaments',4,13777,'1:13905:13777',1),
(73521,'Boxes, Cases & Pouches',4,182970,'1:1401:182970',1),
(73522,'Factory Manufactured',5,43324,'1:1401:182973:43324',1),
(73570,'Trading Card Singles',4,183006,'1:182982:183006',1),
(73572,'Watches',4,50428,'131090:6747:50428',1),
(73834,'Accessory Bundles',4,56169,'293:15052:56169',1),
(73835,'Cassette Adapters',4,56169,'293:15052:56169',1),
(73836,'FM Transmitters',4,56169,'293:15052:56169',1),
(73839,'iPods & MP3 Players',3,15052,'293:15052',1),
(73893,'Baseballs',4,181313,'888:16021:181313',1),
(73897,'Baseball-Youth',4,181314,'888:16021:181314',1),
(73910,'Protective Gear',3,16021,'888:16021',0),
(73911,'Catcher\'s Protection',4,73910,'888:16021:73910',1),
(73916,'Radar Guns & Speed Sensors',4,181330,'888:16021:181330',1),
(73931,'Shoes',4,158963,'888:21194:158963',1),
(73934,'Horse Trailers & Floats',3,3153,'888:3153',1),
(73963,'Holsters, Belts & Pouches',3,7301,'888:7301',1),
(73980,'Clothing, Shoes & Accessories',3,179767,'888:179767',0),
(73981,'Belts & Sashes',4,73980,'888:179767:73980',1),
(73982,'Shorts',4,73980,'888:179767:73980',1),
(73983,'Shirts',4,73980,'888:179767:73980',1),
(73988,'Other',4,73980,'888:179767:73980',1),
(73989,'Shoes & Footwear',4,73980,'888:179767:73980',1),
(73990,'Patches',4,73980,'888:179767:73980',1),
(73991,'Media',3,179767,'888:179767',1),
(73994,'Dry Suits',3,16052,'888:16052',1),
(73999,'Flags',3,16052,'888:16052',1),
(74000,'Gauges',3,16052,'888:16052',1),
(74004,'Weight Belts',3,16052,'888:16052',1),
(74049,'Other Clothing',4,151563,'888:22709:151563',1),
(74050,'Swimming',2,888,'888',0),
(74051,'Goggles',3,74050,'888:74050',1),
(74312,'Speed Controllers',5,19839,'220:2562:182187:19839',1),
(74469,'Electric Bicycles',3,7294,'888:7294',1),
(74922,'Telescope Parts & Accessories',3,28179,'625:28179',0),
(74923,'Telescope Filters',4,74922,'625:28179:74922',1),
(74925,'Telescope Mirrors & Prisms',4,74922,'625:28179:74922',1),
(74926,'Other Telescope Parts & Accs',4,74922,'625:28179:74922',1),
(74927,'Telescopes',3,28179,'625:28179',1),
(74941,'Drive Cables & Adapters',3,182094,'58058:182094',1),
(74953,'Laptop Modem Cards',4,42190,'58058:31530:42190',1),
(74962,'Bags, Handbags & Cases',4,182059,'11450:175759:182059',1),
(74969,'Women\'s Hats',4,182059,'11450:175759:182059',1),
(74976,'Women\'s Vintage Shoes',3,175759,'11450:175759',1),
(74990,'Bath Brushes & Sponges',3,11838,'26395:11838',1),
(74994,'Scar & Stretch Mark Reducers',3,11838,'26395:11838',1),
(74996,'After Sun Skin Care',3,31772,'26395:31772',1),
(75006,'Blotting Paper',3,11863,'26395:11863',1),
(75034,'Bandages, Gauze & Dressings',4,180931,'26395:67588:180931',1),
(75035,'Kits & Bags',4,180931,'26395:67588:180931',1),
(75036,'Over-the-Counter Medicine',3,67588,'26395:67588',0),
(75037,'Allergy & Antihistamines',4,75036,'26395:67588:75036',1),
(75038,'Cold & Flu',4,75036,'26395:67588:75036',1),
(75039,'Digestion, Nausea',4,75036,'26395:67588:75036',1),
(75040,'Pain & Fever Relief',4,75036,'26395:67588:75036',1),
(75041,'Pill Boxes',3,67588,'26395:67588',1),
(75042,'Smoking Cessation',3,67588,'26395:67588',0),
(75043,'Alternative Therapies',4,75042,'26395:67588:75042',1),
(75044,'Gum & Lozenges',4,75042,'26395:67588:75042',1),
(75046,'Patches',4,75042,'26395:67588:75042',1),
(75047,'Other Smoking Cessation',4,75042,'26395:67588:75042',1),
(75053,'Rolling Makeup Cases',3,177731,'26395:177731',1),
(75066,'Stairlifts & Elevators',4,28175,'26395:11778:28175',1),
(75067,'Access Ramps',4,182113,'26395:11778:182113',1),
(75068,'Mobility Scooters',4,28175,'26395:11778:28175',1),
(75072,'Blood Pressure Monitoring',4,30115,'26395:11778:30115',1),
(75075,'Thermometers',4,30115,'26395:11778:30115',1),
(75184,'Accessories, Décor',3,21567,'888:21567',0),
(75185,'Racks',4,75184,'888:21567:75184',1),
(75188,'Cue Tips',4,75184,'888:21567:75184',1),
(75189,'Lighting',4,75184,'888:21567:75184',1),
(75190,'Posters',4,75184,'888:21567:75184',1),
(75192,'Balls',3,21567,'888:21567',1),
(75195,'Media',3,21567,'888:21567',1),
(75204,'Climbing Holds',3,30105,'888:30105',1),
(75205,'Bags',3,30105,'888:30105',1),
(75207,'Golf Buggies & Trolleys',4,181153,'888:1513:181153',1),
(75208,'Other Golf Car Parts',3,170140,'131090:170140',1),
(75211,'Petrol Scooters',3,11330,'888:11330',1),
(75230,'GPS & Running Watches',4,44075,'888:15273:44075',1),
(75232,'Tools',3,16034,'888:16034',0),
(75233,'Camp Shovels',4,75232,'888:16034:75232',1),
(75234,'Hatchets & Axes',4,75232,'888:16034:75232',1),
(75236,'Multi-Tools',4,75232,'888:16034:75232',1),
(75237,'Saws',4,75232,'888:16034:75232',1),
(75386,'Capacitors',4,32806,'131090:3270:32806',1),
(75518,'Sound Cards (External)',3,31530,'58058:31530',1),
(75557,'Bugles',3,16212,'619:16212',1),
(75564,'Other Multi-Purpose Crafting',3,28102,'14339:28102',1),
(75566,'Stamped Linens',5,183195,'14339:160706:28141:183195',1),
(75567,'Other Embroidery',4,28141,'14339:160706:28141',1),
(75573,'Other Scrapbooking Supplies',3,11788,'14339:11788',1),
(75576,'Other Crafts',2,14339,'14339',1),
(75592,'Garden Plaques & Signs',4,20498,'11700:159912:20498',1),
(75593,'Rain Gauges',4,20498,'11700:159912:20498',1),
(75601,'Outdoor Thermometers',4,20498,'11700:159912:20498',1),
(75606,'Ferns',5,19617,'11700:159912:181003:19617',1),
(75664,'Bonsai Tools',5,181033,'11700:159912:2032:181033',1),
(75668,'Tool Carriers, Aprons & Belts',5,159473,'11700:159912:2032:159473',1),
(75669,'Garden Kneelers, Pads & Seats',5,159473,'11700:159912:2032:159473',1),
(75670,'Moisture & pH Meters',5,179308,'11700:159912:2032:179308',1),
(75671,'Wheelbarrows, Carts & Wagons',5,181033,'11700:159912:2032:181033',1),
(75672,'Watering Timers & Controllers',5,29521,'11700:159912:2032:29521',1),
(75673,'Valves',5,29521,'11700:159912:2032:29521',1),
(75708,'TV, Movie & Video Games',3,246,'220:246',1),
(77118,'Baby Proofing',3,20433,'2984:20433',1),
(77285,'Toasters',3,20667,'20710:20667',1),
(77305,'Scales',4,31817,'26395:180959:31817',1),
(77411,'Jeans',3,11462,'11450:11462',1),
(77475,'Jeans',3,11452,'11450:11452',1),
(77641,'Water Pumps',3,20754,'1281:20754',1),
(77658,'Reverse Osmosis & Deionization',3,20754,'1281:20754',1),
(77659,'Water Tests & Treatment',3,20754,'1281:20754',1),
(77695,'Other Horse Feed',4,139576,'888:3153:139576',1),
(77696,'Other Horse Care & Grooming',4,139580,'888:3153:139580',1),
(77984,'Sugar Bowls',4,64981,'870:24:64981',1),
(78049,'Noritake',3,24,'870:24',1),
(78089,'Eyebrow Liner & Definition',4,172020,'26395:31786:172020',1),
(78186,'Drives & Motion Control',3,42892,'170769:42892',0),
(78188,'Motor Drives & Controls',4,78186,'170769:42892:78186',0),
(78190,'General Purpose DC Drives',5,78188,'170769:42892:78186:78188',1),
(78191,'Servo Drives & Amplifiers',5,78188,'170769:42892:78186:78188',1),
(78192,'Variable Frequency Drives',5,78188,'170769:42892:78186:78188',1),
(78193,'Other Motor Controls',5,78188,'170769:42892:78186:78188',1),
(78827,'Bulbs, Components',3,14948,'293:14948',1),
(78830,'Anti-roll Pillows, Supports',3,20433,'2984:20433',1),
(78867,'Decorative Boxes',3,10033,'11700:10033',1),
(78868,'Feng Shui',3,10033,'11700:10033',1),
(78869,'Runners',3,10033,'11700:10033',1),
(78997,'Lenses & Filters',2,625,'625',0),
(78999,'Lens Hoods',3,78997,'625:78997',1),
(79000,'Other Lenses & Filters',3,78997,'625:78997',1),
(79001,'Lens Caps',3,78997,'625:78997',1),
(79003,'Background Material',3,30078,'625:30078',1),
(79007,'Light Controls & Modifiers',3,30078,'625:30078',0),
(79008,'Softboxes & Diffusers',4,79007,'625:30078:79007',1),
(79009,'Studio Umbrellas',4,79007,'625:30078:79007',1),
(79010,'Other Light Controls & Mods',4,79007,'625:30078:79007',1),
(79095,'Wines (Fortified)',4,26270,'14308:179836:26270',1),
(79108,'Work Benches',4,164613,'11700:631:164613',1),
(79110,'Curtains, Blinds',3,31605,'11700:31605',1),
(79111,'Regal Mashman',3,170518,'870:170518',1),
(79112,'Shorter & Son',3,24,'870:24',1),
(79114,'Bathtime Toys',3,19169,'220:19169',1),
(79621,'Dehumidifiers',3,69197,'20710:69197',1),
(79626,'Wallpaper Murals',4,180981,'11700:3187:180981',1),
(79648,'Grates & Andirons',3,38219,'11700:38219',1),
(79649,'Log Holders & Carriers',3,38219,'11700:38219',1),
(79650,'Fireplace Mantels & Surrounds',3,38219,'11700:38219',1),
(79654,'Photo Frames',3,10033,'11700:10033',1),
(79656,'Steam Products',4,20605,'11700:299:20605',1),
(79676,'Pool Liners',5,181067,'11700:159912:20727:181067',1),
(79678,'Benches',4,25863,'11700:159912:25863',1),
(79682,'Chairs',4,25863,'11700:159912:25863',1),
(79686,'BBQ Covers',4,149242,'11700:159912:149242',1),
(79692,'Picnicware',4,149242,'11700:159912:149242',0),
(79702,'Paint Sprayers',4,22659,'11700:631:22659',1),
(79720,'Men\'s Sunglasses',2,11450,'11450',1),
(79759,'Resistance Trainers',4,28064,'888:15273:28064',1),
(79795,'Wrestling',2,888,'888',1),
(79834,'Video In-Dash Units w/GPS',4,48604,'131090:3270:48604',1),
(79835,'Video In-Dash Units w/o GPS',4,48604,'131090:3270:48604',1),
(79839,'Signal Processors',4,175716,'131090:3270:175716',1),
(79845,'Battery Testers',3,48446,'293:48446',1),
(79846,'Other Multipurpose Batteries',3,48446,'293:48446',1),
(79877,'Remotes',4,56169,'293:15052:56169',1),
(80015,'Hobbies & Leisure',3,18793,'58058:18793',1),
(80053,'Monitors',3,162497,'58058:162497',1),
(80077,'Headsets',3,9394,'15032:9394',1),
(80109,'Other Australian',3,3468,'260:3468',1),
(80121,'Collections, Mixture',3,4742,'260:4742',1),
(80133,'Blank Media & Accessories',3,165,'58058:165',0),
(80135,'CD, DVD & Blu-ray Discs',4,80133,'58058:165:80133',1),
(80136,'Floppy, Zip & Jaz Disks',4,80133,'58058:165:80133',1),
(80151,'Video Card/GPU Cooling',4,42000,'58058:175673:42000',1),
(80183,'Headsets',3,31530,'58058:31530',1),
(80216,'Other Ent. Networking Racks',4,51197,'58058:175698:51197',1),
(80225,'CSUs/DSUs',3,175698,'58058:175698',1),
(80356,'Servers, Development & DBMS',3,18793,'58058:18793',1),
(80390,'Auxiliary/Conversion Lenses',3,78997,'625:78997',1),
(80913,'Boy\'s Costumes',3,163147,'11450:163147',1),
(80914,'Girl\'s Costumes',3,163147,'11450:163147',1),
(80979,'Parts & Accessories',4,19151,'220:180250:19151',0),
(80981,'Scenery & Trees',5,80979,'220:180250:19151:80979',1),
(80984,'Lamps & Lights',5,80979,'220:180250:19151:80979',1),
(80985,'Catenaries',5,80979,'220:180250:19151:80979',1),
(80987,'Signals',5,80979,'220:180250:19151:80979',1),
(80989,'Figures & People',5,80979,'220:180250:19151:80979',1),
(80990,'Starter Sets & Packs',4,19151,'220:180250:19151',1),
(80991,'Locomotives',4,180509,'220:180250:180509',1),
(80996,'Carriages',4,180509,'220:180250:180509',1),
(80997,'Passenger Cars',4,180509,'220:180250:180509',1),
(80998,'Starter Sets & Packs',4,180509,'220:180250:180509',1),
(81012,'Locomotives',4,13290,'220:180250:13290',1),
(81017,'Carriages',4,13290,'220:180250:13290',1),
(81018,'Passenger Cars',4,13290,'220:180250:13290',1),
(81021,'Starter Sets & Packs',4,13290,'220:180250:13290',1),
(81022,'Parts & Accessories',4,13290,'220:180250:13290',0),
(81023,'Scenery & Trees',5,81022,'220:180250:13290:81022',1),
(81026,'Lamps & Lights',5,81022,'220:180250:13290:81022',1),
(81027,'Catenaries',5,81022,'220:180250:13290:81022',1),
(81029,'Signals',5,81022,'220:180250:13290:81022',1),
(81031,'Figures & People',5,81022,'220:180250:13290:81022',1),
(81034,'Other',5,81022,'220:180250:13290:81022',1),
(81042,'Starter Sets & Packs',4,19145,'220:180250:19145',1),
(81043,'Parts & Accessories',4,19145,'220:180250:19145',0),
(81045,'Scenery & Trees',5,81043,'220:180250:19145:81043',1),
(81048,'Lamps & Lights',5,81043,'220:180250:19145:81043',1),
(81049,'Catenaries',5,81043,'220:180250:19145:81043',1),
(81051,'Signals',5,81043,'220:180250:19145:81043',1),
(81053,'Figures & People',5,81043,'220:180250:19145:81043',1),
(81055,'Parts & Accessories',4,19119,'220:180250:19119',0),
(81056,'Locomotives',4,30654,'220:180250:30654',1),
(81061,'Carriages',4,30654,'220:180250:30654',1),
(81062,'Passenger Cars',4,30654,'220:180250:30654',1),
(81063,'Starter Sets & Packs',4,30654,'220:180250:30654',1),
(81064,'Parts & Accessories',4,30654,'220:180250:30654',0),
(81068,'Lamps & Lights',5,81064,'220:180250:30654:81064',1),
(81069,'Catenaries',5,81064,'220:180250:30654:81064',1),
(81071,'Signals',5,81064,'220:180250:30654:81064',1),
(81073,'Figures & People',5,81064,'220:180250:30654:81064',1),
(81083,'Parts & Accessories',4,19116,'220:180250:19116',0),
(81084,'Scenery & Trees',5,81083,'220:180250:19116:81083',1),
(81087,'Lamps & Lights',5,81083,'220:180250:19116:81083',1),
(81088,'Catenaries',5,81083,'220:180250:19116:81083',1),
(81090,'Signals',5,81083,'220:180250:19116:81083',1),
(81092,'Figures & People',5,81083,'220:180250:19116:81083',1),
(81094,'Starter Sets & Packs',4,19116,'220:180250:19116',1),
(81458,'Nets',4,179985,'888:1492:179985',1),
(81473,'Rod Cases, Tubes & Racks',4,179985,'888:1492:179985',1),
(81741,'Other Home Stereo Components',3,14969,'293:14969',1),
(81967,'Gobos, Gels, Filters & Lenses',3,12922,'619:12922',1),
(81970,'Replacement Bulbs & Lamps',3,12922,'619:12922',1),
(82161,'Other',4,155344,'11450:163147:155344',1),
(82182,'Complete Engines',4,65361,'131090:84149:65361',1),
(82183,'Gearboxes & Gearbox Parts',4,182266,'131090:84149:182266',1),
(82190,'Publications',2,11116,'11116',1),
(82191,'Other Drivetrain/Transmission',4,182266,'131090:84149:182266',1),
(82198,'Engine Mounts',4,65361,'131090:84149:65361',1),
(82205,'Carburetors & Parts',4,182240,'131090:84149:182240',1),
(82212,'Cylinder Heads & Valve Covers',4,65361,'131090:84149:65361',1),
(82219,'Complete Cylinders',4,65361,'131090:84149:65361',1),
(82226,'Other Engine Parts',4,65361,'131090:84149:65361',1),
(82248,'Parts & Accessories',4,43560,'11700:159912:43560',1),
(82251,'Pliers',4,3244,'11700:631:3244',1),
(82290,'Hooks',4,179973,'888:1492:179973',1),
(82321,'Accessories',3,84149,'131090:84149',1),
(82515,'Shells',3,3213,'1:3213',1),
(82565,'Waxing Supplies',3,31762,'26395:31762',1),
(82591,'Hair Ties & Styling Accs',3,11854,'26395:11854',1),
(82592,'Ointments, Creams & Oils',4,180931,'26395:67588:180931',1),
(82593,'Sleeping Aids',3,67588,'26395:67588',0),
(82594,'Sound Therapy',4,82593,'26395:67588:82593',1),
(82596,'Bronzers & Highlighters',4,172025,'26395:31786:172025',1),
(82597,'Brushes',4,36409,'26395:31786:36409',1),
(82599,'Eyelash Tools',4,36409,'26395:31786:36409',1),
(82610,'Cuticle Treatments',3,47945,'26395:47945',1),
(82616,'Weight Loss Program Foods',4,31817,'26395:180959:31817',1),
(82720,'Other Books, Magazines',3,166018,'14339:166018',1),
(82978,'Protective Envelopes',3,181421,'260:181421',1),
(83037,'Swing Trainers',4,181129,'888:1513:181129',1),
(83041,'Vintage Golf Equipment',3,1513,'888:1513',0),
(83042,'Vintage Golf Balls',4,83041,'888:1513:83041',1),
(83043,'Vintage Golf Clubs & Shafts',4,83041,'888:1513:83041',1),
(83274,'Supplies',2,11116,'11116',0),
(83549,'Fowler',3,170518,'870:170518',1),
(83550,'Raynham',3,170518,'870:170518',1),
(83606,'Lights',4,31710,'888:7301:31710',1),
(83633,'Complete Outfits',4,159178,'888:20862:159178',1),
(83732,'Transformers & Robots',3,246,'220:246',1),
(83738,'Pull Toys',4,2524,'220:19169:2524',1),
(83739,'Musical Toys',3,19169,'220:19169',1),
(83755,'Battery Operated',3,11731,'220:11731',1),
(83756,'Science',3,11731,'220:11731',0),
(83757,'Wooden',3,11731,'220:11731',1),
(83852,'Anchors',4,180974,'11700:3187:180974',1),
(83857,'Microphones',3,15200,'625:15200',1),
(83874,'Projection Lenses',4,15250,'625:69323:15250',1),
(83876,'Slide Trays & Carousels',4,15250,'625:69323:15250',1),
(83877,'Slide Viewers',4,15250,'625:69323:15250',1),
(83880,'Binoculars & Monoculars',3,28179,'625:28179',1),
(83888,'Raffia, Wire & Cord',4,160704,'14339:28102:160704',1),
(83891,'Pendants',3,31723,'14339:31723',1),
(83892,'Pliers, Tools',3,31723,'14339:31723',1),
(83894,'Wire, Thread, Cord',3,31723,'14339:31723',1),
(83898,'Slip Casting Moulds & Kits',4,183303,'14339:183302:183303',1),
(83899,'Ready-to-Paint Pottery',4,183303,'14339:183302:183303',1),
(83902,'Cushions, Pillows',3,71183,'14339:71183',1),
(83903,'Bags',3,71183,'14339:71183',1),
(83904,'Wall Hangings',3,71183,'14339:71183',1),
(83905,'Dolls',3,71183,'14339:71183',1),
(83906,'Crochet Thread',4,3094,'14339:160706:3094',1),
(83907,'Crocheted Doilies',3,71183,'14339:71183',1),
(83920,'Machine Bobbins & Thread',5,160724,'14339:160706:28141:160724',1),
(83927,'Totes & Cases',4,3094,'14339:160706:3094',1),
(83931,'Palettes',5,183098,'14339:11783:28110:183098',1),
(83938,'Leather Hides & Fur Pelts',3,28131,'14339:28131',1),
(83946,'Finished Needlepoint Pieces',5,183220,'14339:160706:28141:183220',1),
(83957,'Quilt Patterns',4,180930,'14339:160737:180930',1),
(83959,'Quilt Hangers & Stands',4,180930,'14339:160737:180930',1),
(83965,'Sewing Boxes & Storage',3,160737,'14339:160737',1),
(83981,'Scrapbooking Tools',4,31253,'14339:11788:31253',0),
(83982,'Craft Knives & Blades',5,183173,'14339:28102:183171:183173',1),
(83986,'Scissors & Paper Trimmers',5,83981,'14339:11788:31253:83981',1),
(83987,'Sets',5,183173,'14339:28102:183171:183173',1),
(83990,'Decorative Brads',5,183591,'14339:11788:31253:183591',1),
(84000,'Mixed Lots',4,183180,'14339:28102:183180',1),
(84009,'Embossing Stencils & Folders',4,183239,'14339:11788:183239',1),
(84011,'Woodworking Timber',4,183155,'14339:3127:183155',1),
(84059,'Varnishes & Stains',4,180979,'11700:3187:180979',1),
(84078,'Stands, Racks',3,15052,'293:15052',1),
(84079,'Headsets',3,164874,'15032:164874',1),
(84149,'Scooter Parts',2,131090,'131090',0),
(84184,'Heating Stoves',3,38219,'11700:38219',1),
(84211,'Spas & Hot Tubs',4,20727,'11700:159912:20727',1),
(84221,'Wood Flooring',4,180983,'11700:3187:180983',1),
(84275,'Mixed Items',3,15724,'11450:15724',1),
(84432,'Toy Trains',3,180250,'220:180250',1),
(84434,'Mixed Items',3,1059,'11450:1059',1),
(84544,'Sleepwear',3,11452,'11450:11452',1),
(84605,'Children\'s Jewellery',2,281,'281',0),
(84606,'Bracelets',3,84605,'281:84605',1),
(84607,'Necklaces, Pendants',3,84605,'281:84605',1),
(84608,'Other Children\'s Jewellery',3,84605,'281:84605',1),
(84631,'Berenguer, Berjusa',3,238,'237:238',1),
(84639,'Strawberry Shortcake',3,238,'237:238',1),
(84659,'Beginner Packages',3,3858,'619:3858',0),
(84912,'Remote-Controlled Toys',3,2562,'220:2562',1),
(85040,'Trailers',4,177832,'888:7294:177832',1),
(85045,'Arm, Knee & Leg Warmers',4,22682,'888:7294:22682',1),
(85068,'Socks',4,22682,'888:7294:22682',1),
(85178,'Driving Equipment',3,3153,'888:3153',0),
(85180,'Driving Reins',4,85178,'888:3153:85178',1),
(85214,'Stable Accessories',3,3153,'888:3153',0),
(85259,'Bandages',4,57268,'888:3153:57268',1),
(85260,'Horse Boots',4,57268,'888:3153:57268',1),
(85273,'Spurs',4,27031,'888:3153:27031',1),
(85275,'Horse Rugs & Sheets',4,57268,'888:3153:57268',1),
(85757,'Pond Filter Media & Accs',4,93632,'11700:159912:93632',1),
(85764,'My Child',3,238,'237:238',1),
(85806,'Dashboard Installation Kits',4,32806,'131090:3270:32806',1),
(85856,'Plates',5,181223,'619:3858:180009:181223',1),
(85857,'Slides',4,180009,'619:3858:180009',1),
(85860,'Digital Pianos',4,181225,'619:180010:181225',1),
(85879,'Cabinets',4,41971,'11700:3187:41971',1),
(85892,'Doors',4,41976,'11700:3187:41976',1),
(85898,'Opener Systems',4,180972,'11700:3187:180972',1),
(85899,'Garage Door Remotes',4,180972,'11700:3187:180972',1),
(85914,'Laminate & Vinyl Flooring',4,180983,'11700:3187:180983',1),
(85915,'Chainsaw Parts & Accessories',4,29518,'11700:159912:29518',1),
(86175,'Tissue Paper',4,109699,'170638:19273:109699',1),
(86207,'Unisex Costumes',3,163147,'11450:163147',1),
(86647,'Belt Buckles',3,4250,'11450:4250',1),
(86720,'Directional Antennas',3,175698,'58058:175698',1),
(86722,'Power Protection, Distribution',2,58058,'58058',0),
(86723,'Power Distribution Units',3,86722,'58058:86722',1),
(86728,'Printer Paper',4,11195,'58058:171961:11195',1),
(86953,'Military',4,14049,'1:417:14049',1),
(86975,'Boots',3,21563,'888:21563',1),
(86976,'Protective Gear',3,21563,'888:21563',1),
(86977,'Shorts',3,21563,'888:21563',1),
(87090,'Inflatables',4,166101,'888:23806:166101',1),
(87091,'Paddles',4,166096,'888:23806:166096',1),
(87096,'Body, Wing, Tail',5,44912,'888:1492:179961:44912',1),
(87097,'Threads, Floss, Wire',5,44912,'888:1492:179961:44912',1),
(87098,'Fly Fishing Accessories',4,179985,'888:1492:179985',1),
(87099,'Cots',4,181403,'888:16034:181403',1),
(87100,'Sleeping Bags',4,181403,'888:16034:181403',1),
(87122,'Daypacks',4,181378,'888:16034:181378',1),
(87125,'Hydration Packs',4,181378,'888:16034:181378',1),
(87133,'Camping Cooking Utensils',4,181381,'888:16034:181381',1),
(87141,'Camping Cookware',4,181381,'888:16034:181381',1),
(87443,'Helmets & Protective Gear',3,3153,'888:3153',0),
(87446,'Other Protective Gear',4,87443,'888:3153:87443',1),
(87480,'Boats & Watercraft',4,182181,'220:2562:182181',1),
(87635,'Flash Lighting Kits',4,124848,'625:30078:124848',1),
(87637,'Monolight Flashes',4,124848,'625:30078:124848',1),
(88057,'Desks & Home Office Furniture',3,3197,'11700:3197',1),
(88433,'Other',2,99,'99',1),
(88468,'Car Speakerphones',3,9394,'15032:9394',1),
(88533,'Wheels & Tyre Packages',4,180035,'131090:14780:180035',1),
(88545,'Engine Gaskets & Seals',4,65361,'131090:84149:65361',1),
(88665,'Light Stands & Booms',3,30078,'625:30078',1),
(88667,'Light Stand & Boom Accessories',3,30078,'625:30078',1),
(88668,'Light Meters',3,30078,'625:30078',1),
(88739,'Funeral, Cemetery',2,99,'99',1),
(88758,'Multipurpose AC to DC Adapters',3,48446,'293:48446',1),
(88759,'Travel Adapters & Converters',3,48446,'293:48446',1),
(88873,'Comic Book Figurines',3,13658,'1:13658',1),
(88903,'Daggers',3,1401,'1:1401',1),
(88922,'Chinese',5,182979,'1:1401:43336:182979',1),
(88923,'Final Fantasy',4,11118,'1:13658:11118',1),
(88930,'Pucca',4,11118,'1:13658:11118',1),
(89161,'Flash Brackets',3,64353,'625:64353',1),
(90634,'Umbrellas',3,4250,'11450:4250',1),
(90715,'Disk Controllers/RAID Cards',4,182088,'58058:175673:182088',1),
(90718,'Internal Port Expansion Cards',4,182088,'58058:175673:182088',1),
(90719,'Other Interface/Add-On Cards',4,182088,'58058:175673:182088',1),
(90736,'Novelties',3,196,'11232:196',1),
(90740,'Diet Food',2,14308,'14308',1),
(90753,'Bangles',3,10968,'281:10968',1),
(90849,'Didgeridoos',4,181268,'619:10181:181268',1),
(90855,'Royal Doulton',5,153371,'870:50693:170514:153371',1),
(90856,'Webb Corbett',5,153371,'870:50693:170514:153371',1),
(90865,'Scorecards & Holders',4,181128,'888:1513:181128',1),
(90872,'Knives',5,179990,'888:1492:179985:179990',1),
(90928,'Boys Clothing',3,41964,'11450:41964',1),
(90936,'Girls Clothing',3,41964,'11450:41964',1),
(90944,'40K Rulebooks & Publications',6,44408,'220:233:16486:31398:44408',1),
(90946,'WFB Rulebooks & Publications',6,44409,'220:233:16486:31398:44409',1),
(91012,'Asian, Oriental',3,24,'870:24',0),
(91022,'Crinoline',3,24,'870:24',1),
(91023,'Foley',3,24,'870:24',1),
(91025,'Queen Anne',3,24,'870:24',1),
(91026,'Royal Vale',3,24,'870:24',1),
(91158,'Atlases',3,171273,'267:171273',1),
(91247,'Other Vintage Clothing & Accs.',3,175759,'11450:175759',1),
(91324,'Angels',3,10860,'1:10860',1),
(91384,'DJ CD/MP3 Players',3,48458,'619:48458',1),
(91421,'Leather, Fur & Sheepskin Rugs',3,20571,'11700:20571',1),
(91427,'Engagement & Wedding',2,281,'281',0),
(91502,'Whistles',4,181268,'619:10181:181268',1),
(91527,'Stuart',5,153371,'870:50693:170514:153371',1),
(91528,'Bohemian, Czech',5,153371,'870:50693:170514:153371',1),
(91565,'Ramps',3,16262,'888:16262',1),
(91569,'Table Covers',4,75184,'888:21567:75184',1),
(91577,'Nepal',3,181416,'260:181416',1),
(91578,'Philippines',3,181416,'260:181416',1),
(91579,'Taiwan',3,181416,'260:181416',1),
(91580,'Vietnam',3,181416,'260:181416',1),
(91581,'Croatia',3,4742,'260:4742',1),
(91583,'Collections, Mixture',3,4752,'260:4752',1),
(91954,'Harvesting Equipment',4,177647,'170769:41489:177647',1),
(92074,'Electrical & Test Equipment',2,170769,'170769',0),
(92078,'Other Electrical & Test Equip.',3,92074,'170769:92074',1),
(92082,'Equipment, Machinery',3,177644,'170769:177644',1),
(92090,'Welding Helmets',5,67044,'170769:182941:34095:67044',1),
(92738,'Charms',3,10968,'281:10968',0),
(92744,'Charm Bracelets',3,10968,'281:10968',0),
(92756,'Other',4,92744,'281:10968:92744',1),
(92842,'Wedding, Anniversary Bands',3,91427,'281:91427',1),
(92905,'Engagement Rings',3,91427,'281:91427',1),
(92908,'Engagement/Wedding Ring Sets',3,91427,'281:91427',1),
(93427,'Men\'s Shoes',2,11450,'11450',0),
(93606,'Drawing Supplies Storage',5,183084,'14339:11783:183081:183084',1),
(93632,'Ponds & Water Features',3,159912,'11700:159912',0),
(93707,'Mixed Lots',4,181077,'281:491:181077',1),
(93720,'Manuals, Catalogues, Brochures',4,173696,'281:14324:173696',1),
(93771,'Bodhráns/Irish Drums',4,181228,'619:180012:181228',1),
(93825,'Snowboards',4,21247,'888:36259:21247',1),
(93838,'Travel Accessories',2,11730,'11730',0),
(93839,'Other Accessories',3,93838,'11730:93838',1),
(94844,'Interconnect Cables',4,32806,'131090:3270:32806',1),
(94861,'Dictionaries & Translators',3,14948,'293:14948',1),
(94864,'Translators',3,93838,'11730:93838',1),
(94893,'Blank Media, Care & Storage',3,14961,'293:14961',0),
(94932,'Toy Boxes',4,66741,'11700:3197:66741',1),
(94939,'Outdoor Wall & Porch Lights',4,42154,'11700:159912:42154',1),
(94940,'Landscape & Walkway Lights',4,42154,'11700:159912:42154',1),
(95072,'Baking Equipment',4,25367,'170638:11874:25367',1),
(95075,'Sausage Fillers',4,25367,'170638:11874:25367',1),
(95096,'Wristbands',4,158963,'888:21194:158963',1),
(95101,'Wristbands',4,22682,'888:7294:22682',1),
(95104,'Riding Gloves',4,16240,'888:3153:16240',1),
(95131,'Japanese',5,182979,'1:1401:43336:182979',1),
(95168,'Watches, Pocket Watches',3,13905,'1:13905',1),
(95216,'Foundation Primer',4,172025,'26395:31786:172025',1),
(95493,'Diggers',3,177641,'170769:177641',1),
(95494,'Skid Steer Loaders',3,177641,'170769:177641',1),
(95495,'Trailers',3,177641,'170769:177641',1),
(95672,'Athletic',3,3034,'11450:3034',1),
(96428,'Styling Capes & Gowns',3,177731,'26395:177731',1),
(96757,'Stands',3,20091,'20081:20091',1),
(96856,'Locomotives',4,19116,'220:180250:19116',1),
(96907,'Surge Protectors, Power Strips',3,86722,'58058:86722',1),
(96913,'Other Laptop Add-On Cards',4,42190,'58058:31530:42190',1),
(96915,'Laptop Cooling Pads',3,31530,'58058:31530',1),
(96954,'Portable AM/FM Radios',3,15052,'293:15052',1),
(96964,'Digital Set Top Boxes',2,172176,'172176',1),
(96966,'Other Ham Radio Equipment',4,4670,'293:1500:4670',1),
(96969,'Satellite TV Receivers',2,172176,'172176',1),
(96991,'Memory Cards',3,9394,'15032:9394',1),
(97033,'Sports Supplements',3,15273,'888:15273',0),
(97034,'Protein Shakes & Bodybuilding',4,97033,'888:15273:97033',1),
(97035,'Vitamins & Minerals',4,97033,'888:15273:97033',1),
(97036,'Other Sports Supplements',4,97033,'888:15273:97033',1),
(97042,'Gloves - Martial Arts',3,179767,'888:179767',1),
(97058,'Other',4,23825,'888:16262:23825',1),
(97064,'Socks',4,21233,'888:36259:21233',1),
(97072,'Table Tennis',2,888,'888',0),
(97073,'Balls',3,97072,'888:97072',1),
(97075,'Tables',3,97072,'888:97072',1),
(97076,'Other Table Tennis',3,97072,'888:97072',1),
(97121,'Crawler Dozers & Loaders',3,177641,'170769:177641',1),
(97122,'Excavators',3,177641,'170769:177641',1),
(97123,'Lifts',3,177641,'170769:177641',1),
(97125,'Trenchers',3,177641,'170769:177641',1),
(97126,'Other',3,41489,'170769:41489',1),
(97136,'RF Communication Test Sets',5,181940,'170769:92074:181939:181940',1),
(97138,'Lineman\'s Handsets/Butt Sets',5,181998,'170769:92074:181939:181998',1),
(97139,'Cable Testers & Trackers',5,181998,'170769:92074:181939:181998',1),
(97142,'Time-Domain Reflectometers',6,181974,'170769:92074:181939:181968:181974',1),
(97146,'LAN/WAN & Protocol Analysers',5,181940,'170769:92074:181939:181940',1),
(97168,'Track',4,19128,'220:180250:19128',1),
(97170,'Locomotives',4,19128,'220:180250:19128',1),
(97185,'Forklifts',3,177641,'170769:177641',1),
(97196,'Function & Waveform Generators',5,181992,'170769:92074:181939:181992',1),
(97197,'Pulse Generators',5,181992,'170769:92074:181939:181992',1),
(97200,'Other Signal Sources',5,181992,'170769:92074:181939:181992',1),
(97201,'Signal & Spectrum Analysers',5,181940,'170769:92074:181939:181940',1),
(97230,'Lathes',3,177641,'170769:177641',1),
(97231,'Logic Analysers',5,181940,'170769:92074:181939:181940',1),
(97658,'Network Analysers',5,181940,'170769:92074:181939:181940',1),
(98468,'Globes',3,37958,'20081:37958',1),
(98473,'Other Nursery Décor',3,66697,'2984:66697',1),
(98476,'Earrings',3,84605,'281:84605',1),
(98477,'Rings',3,84605,'281:84605',1),
(98478,'Sets',3,84605,'281:84605',1),
(98526,'Body Chains',3,15124,'281:15124',1),
(98542,'Retainers',3,15124,'281:15124',1),
(98624,'Watch Bands',3,14324,'281:14324',1),
(98625,'Watch Batteries',3,14324,'281:14324',1),
(98733,'Confetti',3,11827,'11700:11827',1),
(98841,'Other Painting Supplies',4,41989,'11700:3187:41989',1),
(98851,'Coffee Presses',2,20710,'20710',1),
(98852,'Timers',4,20635,'11700:20625:20635',1),
(98853,'Mortar & Pestles',4,20635,'11700:20625:20635',1),
(98855,'Locks',3,41968,'11700:41968',1),
(98863,'Other',2,281,'281',1),
(98923,'35mm Cameras',4,101643,'625:3326:101643',1),
(98924,'Rangefinder Cameras',4,101643,'625:3326:101643',1),
(98956,'Mountain, Kiteboarding',3,40141,'888:40141',1),
(98968,'Money Belts',3,93838,'11730:93838',1),
(98972,'Flight Socks',3,93838,'11730:93838',1),
(98978,'Trolleys',3,16080,'11730:16080',1),
(99003,'Beads',3,40131,'281:40131',1),
(99005,'Fine Jewellery',3,40131,'281:40131',1),
(99231,'Projector Parts & Accessories',3,162497,'58058:162497',1),
(99265,'Uninterruptible Power Supplies',3,86722,'58058:86722',1),
(99269,'VoIP Phone Adapters',3,11176,'58058:11176',1),
(99319,'Ink Refills & Kits',4,11195,'58058:171961:11195',1),
(99654,'Toothbrush Replacement Heads',3,31769,'26395:31769',1),
(99735,'Sleepwear',3,11462,'11450:11462',1),
(99791,'Buildings, Tunnels & Bridges',5,81022,'220:180250:13290:81022',1),
(99797,'Track',4,13290,'220:180250:13290',1),
(99807,'Buildings, Tunnels & Bridges',5,81043,'220:180250:19145:81043',1),
(99814,'Buildings, Tunnels & Bridges',5,81055,'220:180250:19119:81055',1),
(99825,'Track',4,30654,'220:180250:30654',1),
(99830,'Buildings, Tunnels & Bridges',5,81064,'220:180250:30654:81064',1),
(99847,'Catalogues',4,9047,'220:180250:9047',1),
(99856,'Magazines',4,9047,'220:180250:9047',1),
(99962,'Gnomes',3,10860,'1:10860',1),
(99978,'Trading Card Singles',4,182987,'1:182982:182987',1),
(99980,'Complete Trading Card Sets',4,100899,'1:182982:100899',1),
(100016,'Connectors, Switches & Wire',3,92074,'170769:92074',0),
(100058,'Electric Motors',5,182188,'220:2562:182187:182188',1),
(100179,'Telecom Wire & Cable',5,73136,'170769:92074:100016:73136',1),
(100180,'Magnet/Enamelled Wire',5,73136,'170769:92074:100016:73136',1),
(100182,'Electrical Supply Equipment',3,92074,'170769:92074',0),
(100183,'Electr. Supply Books & Manuals',4,100182,'170769:92074:100182',1),
(100184,'Other Electr. Supply Equipment',4,100182,'170769:92074:100182',1),
(100221,'Bathing Accessories',3,20394,'2984:20394',1),
(100227,'Educational Toys',3,19068,'2984:19068',1),
(100237,'Other Tools',4,75232,'888:16034:75232',1),
(100245,'Brake Levers',4,57262,'888:7294:57262',1),
(100253,'Paddock & Jodhpur Boots',4,27031,'888:3153:27031',1),
(100345,'CO2 Equipment',3,20754,'1281:20754',1),
(100351,'Air Pumps',3,20754,'1281:20754',1),
(100355,'Air Stones',3,20754,'1281:20754',1),
(100411,'Litter Trays',3,20737,'1281:20737',1),
(100899,'Star Wars Trading Cards',3,182982,'1:182982',0),
(100978,'Gifts',2,2984,'2984',0),
(100979,'Christening Gifts',3,100978,'2984:100978',1),
(100980,'Baby Jewellery',3,100978,'2984:100978',1),
(100981,'Ornaments',3,100978,'2984:100978',1),
(100982,'Carriers, Slings & Backpacks',2,2984,'2984',1),
(100989,'Sleeping Bags & Sleepsacks',3,20416,'2984:20416',1),
(100991,'Cotbeds',3,20422,'2984:20422',1),
(101270,'Modem-Router Combos',3,11176,'58058:11176',1),
(101282,'Other Networking Cables',4,20311,'58058:182094:20311',1),
(101356,'Power Supplies',4,182086,'58058:171961:182086',1),
(101376,'Vintage',3,238,'237:238',1),
(101405,'Bidets',4,20601,'11700:3187:20601',1),
(101406,'Hot Water Bottles & Covers',4,180951,'26395:67588:180951',1),
(101415,'Vases',3,10033,'11700:10033',1),
(101416,'Roofing',3,3187,'11700:3187',1),
(101423,'Chopsticks',4,20637,'11700:20625:20637',1),
(101428,'Lunchboxes & Bags',4,106191,'11700:20625:106191',1),
(101434,'Kennels',3,20742,'1281:20742',1),
(101437,'Anklets',3,4196,'281:4196',1),
(101554,'Tenor Horns',3,16212,'619:16212',1),
(101555,'Music Stands',3,180008,'619:180008',1),
(101567,'Bouzoukis & Mandolas',4,181282,'619:180016:181282',1),
(101642,'Vintage Lenses',3,3326,'625:3326',1),
(101643,'Vintage Cameras',3,3326,'625:3326',0),
(101644,'Subminiature Cameras',4,101643,'625:3326:101643',1),
(101661,'John Maddock & Sons',3,24,'870:24',1),
(101688,'Gloves',3,21557,'888:21557',1),
(101689,'Helmets',3,21557,'888:21557',1),
(101690,'Stumps, Bails',3,21557,'888:21557',1),
(101691,'Other',3,117103,'888:117103',1),
(101769,'Rugs',3,93838,'11730:93838',1),
(101893,'Collector Cars',3,29690,'9800:29690',0),
(101894,'Pre-1940',4,101893,'9800:29690:101893',1),
(101895,'1940 - 1970',4,101893,'9800:29690:101893',1),
(101915,'Scissors & Shears',3,177731,'26395:177731',1),
(101925,'Microdermabrasion Tools',3,11863,'26395:11863',1),
(101926,'Night Treatments',3,11863,'26395:11863',1),
(101972,'Massage Pillows & Bolsters',3,36447,'26395:36447',1),
(101973,'Filter & Modulation',5,181222,'619:3858:180009:181222',1),
(101974,'Loopers & Samplers',5,181222,'619:3858:180009:181222',1),
(101975,'Power Supplies',5,181222,'619:3858:180009:181222',1),
(101976,'Nuts',5,181223,'619:3858:180009:181223',1),
(101977,'Saddles',5,181223,'619:3858:180009:181223',1),
(102383,'Gift Wrap',3,16086,'11700:16086',1),
(102390,'Bows, Ribbons',3,16086,'11700:16086',1),
(102391,'Cake',3,16086,'11700:16086',1),
(102423,'Aisle Runners',3,11827,'11700:11827',1),
(102424,'Wedding Cake Stands & Plates',3,11827,'11700:11827',1),
(102430,'Venue Decorations',3,11827,'11700:11827',1),
(102466,'Wedding Cake Servers & Knives',3,11827,'11700:11827',1),
(102467,'Toasting Glasses',3,11827,'11700:11827',1),
(102468,'Organisers & Planners',3,11827,'11700:11827',1),
(102469,'Invitations & Place Cards',3,11827,'11700:11827',1),
(102473,'Photo Albums',3,11827,'11700:11827',1),
(102480,'Information Products',2,99,'99',0),
(102502,'Feng Shui, Eastern Beliefs',3,19266,'99:19266',0),
(102503,'Ba Guas',4,102502,'99:19266:102502',1),
(102504,'Coins',4,102502,'99:19266:102502',1),
(102505,'Crystals',4,102502,'99:19266:102502',1),
(102506,'Jewellery',4,102502,'99:19266:102502',1),
(102507,'Goth',3,19266,'99:19266',1),
(102513,'Psychic, Spiritual',3,19266,'99:19266',0),
(102514,'Jewellery',4,102513,'99:19266:102513',1),
(102515,'Ouija Boards',4,102513,'99:19266:102513',1),
(102518,'Reiki',3,19266,'99:19266',1),
(102519,'Runes',3,19266,'99:19266',1),
(102520,'Tarot',3,19266,'99:19266',0),
(102521,'Tarot Decks',4,102520,'99:19266:102520',1),
(102545,'Religious Products',2,99,'99',0),
(102546,'Art',3,102545,'99:102545',1),
(102547,'Clothing',3,102545,'99:102545',1),
(102548,'Communion Accessories',3,102545,'99:102545',1),
(102549,'Crosses',3,102545,'99:102545',1),
(102550,'Jewellery',3,102545,'99:102545',1),
(102552,'Rosaries',3,102545,'99:102545',1),
(102567,'V6',4,33739,'131090:6030:33739',1),
(102579,'Pocket Bikes',2,9800,'9800',1),
(102674,'Trail Bikes',3,32073,'9800:32073',1),
(102680,'Road Bikes',3,32073,'9800:32073',1),
(102690,'Classic, Collector',3,32073,'9800:32073',1),
(102694,'Scale Models & Replicas',4,34352,'131090:6747:34352',1),
(102699,'Inflatable, Semi-Inflatable',3,26429,'9800:26429',1),
(102810,'Gauges, Instruments',3,26443,'131090:26443',1),
(103350,'Stubby Holders',3,562,'1:562',1),
(103353,'Masonic',3,3913,'1:3913',1),
(103354,'Asian',4,13777,'1:13905:13777',1),
(103358,'Floats',4,180001,'888:1492:180001',1),
(103426,'Wall Hooks & Hangers',3,26677,'11700:26677',1),
(103429,'Dispensers',4,20687,'11700:20625:20687',1),
(103430,'Armoires & Wardrobes',3,3197,'11700:3197',1),
(103431,'Benches & Stools',3,3197,'11700:3197',1),
(103438,'Pendant Lighting',3,20697,'11700:20697',1),
(103463,'Roman Blinds',3,63514,'11700:63514',1),
(103479,'Pine Cones',4,160704,'14339:28102:160704',1),
(103480,'Album Corner Protectors',5,183248,'14339:11788:31253:183248',1),
(103481,'Digital Scrapbooking',4,31253,'14339:11788:31253',1),
(103482,'Instruction Books & Media',3,11788,'14339:11788',1),
(104039,'Screwdrivers',3,13849,'1:13849',1),
(104040,'Squares',3,13849,'1:13849',1),
(104041,'Vices, Clamps',3,13849,'1:13849',1),
(104046,'Pokémon Complete Sets',4,183466,'220:2536:183466',1),
(104049,'Pokémon Mixed Card Lots',4,183466,'220:2536:183466',1),
(104168,'People',4,914,'1:124:914',1),
(104216,'Jackhammers',3,64808,'170769:64808',1),
(104247,'Oscilloscopes & Vectorscopes',5,181940,'170769:92074:181939:181940',1),
(105219,'Loving Family',4,2524,'220:19169:2524',1),
(105471,'Bridal Shoes',3,3259,'11450:3259',1),
(105508,'Groom, Ushers',3,3259,'11450:3259',1),
(105559,'Gloves, Mittens',3,4251,'11450:4251',1),
(105569,'Umbrellas',3,4251,'11450:4251',1),
(105811,'Other Media',4,135245,'170769:11748:135245',1),
(105832,'Other',4,163489,'170638:11874:163489',1),
(105835,'Displays, Bain Maries',4,163493,'170638:11874:163493',1),
(105838,'Other',4,163493,'170638:11874:163493',1),
(105848,'Stamps',3,19273,'170638:19273',1),
(105964,'Wardrobes, Drawers',3,20422,'2984:20422',1),
(105965,'Clocks',3,66697,'2984:66697',1),
(106002,'Activity Toys',3,19068,'2984:19068',1),
(106003,'Bathtime Toys',3,19068,'2984:19068',1),
(106004,'Musical Toys',3,19068,'2984:19068',1),
(106005,'Play-Doh, Modelling Clay',3,19068,'2984:19068',1),
(106006,'Playgro',3,19068,'2984:19068',1),
(106007,'Playskool',3,19068,'2984:19068',1),
(106008,'Pull Toys',3,19068,'2984:19068',1),
(106009,'Fisher Price',3,19068,'2984:19068',1),
(106030,'Accessories',3,63514,'11700:63514',1),
(106113,'Wristbands, Bracelets',3,4250,'11450:4250',1),
(106121,'Clothing, Shoe Care',2,11450,'11450',0),
(106123,'Shoe Polish',3,106121,'11450:106121',1),
(106126,'Other',3,106121,'11450:106121',1),
(106127,'Bridal Accessories',3,3259,'11450:3259',0),
(106128,'Other',4,106127,'11450:3259:106127',1),
(106186,'Window Decorations',3,10033,'11700:10033',1),
(106187,'Engravers',3,41968,'11700:41968',1),
(106190,'Stubby Holders',4,20687,'11700:20625:20687',1),
(106191,'Tupperware',3,20625,'11700:20625',0),
(106192,'Spice Containers',4,106191,'11700:20625:106191',1),
(106193,'Squares, Rectangles',4,106191,'11700:20625:106191',1),
(106194,'Utensils',4,106191,'11700:20625:106191',1),
(106208,'Party Gags, Tricks',3,16086,'11700:16086',1),
(106256,'Makeup Mirrors',4,36409,'26395:31786:36409',1),
(106273,'Home Network Storage (NAS)',4,182085,'58058:165:182085',1),
(106315,'Shaving & Grooming Kits & Sets',3,31762,'26395:31762',1),
(106317,'Women\'s Shavers',4,180512,'26395:31762:180512',1),
(106365,'Manure Spreaders',4,177647,'170769:41489:177647',1),
(106395,'Regency',3,24,'870:24',1),
(106396,'Salisbury',3,24,'870:24',1),
(106397,'H&K Tunstall',3,24,'870:24',1),
(106402,'Outdoor Heaters',4,25863,'11700:159912:25863',1),
(106437,'Generators',3,64808,'170769:64808',1),
(106438,'Envelopes',3,19273,'170638:19273',1),
(106454,'Clothing & Uniforms',3,180008,'619:180008',1),
(106460,'Badminton',2,888,'888',1),
(106465,'Skating',2,888,'888',0),
(106484,'Other',3,62166,'888:62166',1),
(106530,'Christmas',5,153384,'260:3468:153383:153384',1),
(106792,'Materials',3,26268,'2984:26268',1),
(106943,'Pegs',4,57262,'888:7294:57262',1),
(106953,'Decals, Stickers',4,177832,'888:7294:177832',1),
(106980,'Sky Diving',2,888,'888',1),
(106983,'Lamps, Torches',3,16034,'888:16034',0),
(106984,'Head Torches',4,106983,'888:16034:106983',1),
(107066,'Other',4,33739,'131090:6030:33739',1),
(107578,'Dining Sets',3,3197,'11700:3197',1),
(107876,'Nail Art Accessories',3,47945,'26395:47945',1),
(107894,'Cases, Bags & Covers',3,15200,'625:15200',1),
(107956,'Makeup Sets & Kits',3,31786,'26395:31786',1),
(107965,'Storage & Empty Containers',3,47945,'26395:47945',1),
(108002,'Electrotherapy Devices',3,67659,'26395:67659',1),
(108139,'Batting Tees',4,181330,'888:16021:181330',1),
(108140,'Plastic Training Balls & Bats',4,181330,'888:16021:181330',1),
(108153,'Baitcaster Reels',4,179950,'888:1492:179950',1),
(108154,'Spincaster Reels',4,179950,'888:1492:179950',1),
(108161,'Topwater',4,179961,'888:1492:179961',1),
(108166,'Divot Tools',4,181128,'888:1513:181128',1),
(108298,'Scales',3,26677,'11700:26677',1),
(108428,'Bean Bags & Inflatables',4,66741,'11700:3197:66741',1),
(108782,'Air Fresheners',4,72200,'131090:6030:72200',1),
(108866,'Wood Items',3,71183,'14339:71183',1),
(108867,'Crochet Kits',4,3094,'14339:160706:3094',1),
(108868,'Knitting Kits',4,3094,'14339:160706:3094',1),
(108898,'Suits, Blazers',3,172378,'2984:172378',1),
(108955,'Signals',5,180314,'220:180250:122601:180314',1),
(109064,'Headboards & Footboards',4,32254,'11700:3197:32254',1),
(109075,'Medicated Hair Treatments',3,11854,'26395:11854',1),
(109092,'Disc Cameras',4,101643,'625:3326:101643',1),
(109108,'Duchess',3,24,'870:24',1),
(109109,'Franklin Mint',3,24,'870:24',1),
(109110,'Miniatures',3,24,'870:24',1),
(109118,'Cranksets',4,57262,'888:7294:57262',1),
(109119,'Rear Shocks',4,57262,'888:7294:57262',1),
(109120,'Build Kits & Gruppos',4,57262,'888:7294:57262',1),
(109124,'Shoes, Spikes',3,21557,'888:21557',1),
(109125,'Bags, Kits',3,21557,'888:21557',1),
(109130,'Fitness DVDs',3,15273,'888:15273',1),
(109134,'Socks',4,159178,'888:20862:159178',1),
(109136,'Shin Pads',4,159178,'888:20862:159178',1),
(109151,'Netball',2,888,'888',1),
(109160,'Balls',3,21563,'888:21563',1),
(109247,'Swings',3,11743,'220:11743',1),
(109251,'Games',3,16086,'11700:16086',1),
(109256,'Portable Satellite Radios',3,15052,'293:15052',1),
(109293,'Hammer Drills',3,64808,'170769:64808',1),
(109296,'Post Hole Diggers',4,177647,'170769:41489:177647',1),
(109419,'Price Labels',3,11890,'170638:11890',1),
(109420,'Tags',3,11890,'170638:11890',1),
(109421,'Price Guns',3,11890,'170638:11890',1),
(109422,'Tag Guns',3,11890,'170638:11890',1),
(109430,'Other',4,170652,'170638:11890:170652',1),
(109444,'Stethoscopes',3,11815,'170769:11815',1),
(109462,'Air Freshners',3,170639,'170638:170639',1),
(109463,'Other',3,170639,'170638:170639',1),
(109489,'Clamps',3,42901,'170769:42901',1),
(109491,'Rivets',3,42901,'170769:42901',1),
(109493,'Nails & Staples',3,42901,'170769:42901',1),
(109538,'Pallet Jacks & Trucks',3,64808,'170769:64808',1),
(109552,'Lifting Slings',3,170798,'170769:170798',1),
(109556,'Soldering Irons',4,182942,'170769:182941:182942',1),
(109557,'Soldering Tips',4,182942,'170769:182941:182942',1),
(109670,'Crystal, Glass',4,13777,'1:13905:13777',1),
(109684,'Photocopiers',3,50203,'170638:50203',1),
(109694,'Bags',3,19273,'170638:19273',1),
(109699,'Packing Materials',3,19273,'170638:19273',0),
(109700,'Bubble Cushioning Wrap',4,109699,'170638:19273:109699',1),
(109704,'Foam Wrap',4,109699,'170638:19273:109699',1),
(109705,'Other',4,109699,'170638:19273:109699',1),
(109734,'Packing Peanuts',4,109699,'170638:19273:109699',1),
(109735,'Packing Tape & Dispensers',3,19273,'170638:19273',0),
(109737,'Strapping',4,109735,'170638:19273:109735',1),
(109738,'Packing Tape Dispensers',4,109735,'170638:19273:109735',1),
(109739,'Other',4,109735,'170638:19273:109735',1),
(109740,'Boxes',3,19273,'170638:19273',1),
(109749,'Scales',3,19273,'170638:19273',1),
(109779,'Badges',3,32615,'1:32615',0),
(109782,'Clubs, Groups',4,109779,'1:32615:109779',1),
(109783,'Music Related',4,109779,'1:32615:109779',1),
(109785,'Special Events',4,109779,'1:32615:109779',1),
(109786,'Sports',4,109779,'1:32615:109779',1),
(109787,'Coronation',5,153170,'1:13877:39630:153170',1),
(109789,'Toilet Paper Dispensers',3,170639,'170638:170639',1),
(109938,'AFL, Australian Rules',2,888,'888',0),
(109939,'Boots',3,109938,'888:109938',1),
(109940,'Clothing',3,109938,'888:109938',1),
(109941,'Balls',3,109938,'888:109938',1),
(109944,'Other Hockey',3,4388,'888:4388',1),
(109995,'Apparel',4,166227,'888:19292:166227',1),
(109996,'Caps',4,166227,'888:19292:166227',1),
(110235,'Contact Lens Cases',3,31414,'26395:31414',1),
(110399,'Other',3,15124,'281:15124',1),
(110633,'Handcrafted Jewellery',2,281,'281',0),
(110634,'Anklets',3,110633,'281:110633',1),
(110635,'Bracelets',3,110633,'281:110633',1),
(110645,'Earrings',3,110633,'281:110633',1),
(110655,'Necklaces & Pendants',3,110633,'281:110633',1),
(110666,'Rings',3,110633,'281:110633',1),
(110786,'Ametrine',4,181077,'281:491:181077',1),
(110787,'Apatite',4,181077,'281:491:181077',1),
(110788,'Aventurine',4,181077,'281:491:181077',1),
(110789,'Beryl',4,181077,'281:491:181077',1),
(110790,'Carnelian',4,181077,'281:491:181077',1),
(110791,'Chalcedony',4,181077,'281:491:181077',1),
(110792,'Chrysoberyl',4,181077,'281:491:181077',1),
(110793,'Coral',4,181077,'281:491:181077',1),
(110794,'Diopside',4,181077,'281:491:181077',1),
(110796,'Fluorite',4,181077,'281:491:181077',1),
(110797,'Jasper',4,181077,'281:491:181077',1),
(110798,'Kunzite',4,181077,'281:491:181077',1),
(110799,'Kyanite',4,181077,'281:491:181077',1),
(110800,'Synthetic Moissanite',4,181077,'281:491:181077',1),
(110801,'Moldavite',4,181077,'281:491:181077',1),
(110802,'Morganite',4,181077,'281:491:181077',1),
(110803,'Obsidian',4,181077,'281:491:181077',1),
(110804,'Demantoid',5,181085,'281:491:181077:181085',1),
(110805,'Hessonite',5,181085,'281:491:181077:181085',1),
(110806,'Pyrope',5,181085,'281:491:181077:181085',1),
(110807,'Rhodolite',5,181085,'281:491:181077:181085',1),
(110808,'Spessartine',5,181085,'281:491:181077:181085',1),
(110809,'Tsavorite',5,181085,'281:491:181077:181085',1),
(110848,'Rough, Specimen',4,181077,'281:491:181077',0),
(110849,'Rough for Cabochons',5,110848,'281:491:181077:110848',1),
(110850,'Rough for Faceting',5,110848,'281:491:181077:110848',1),
(110873,'Spinel',4,181077,'281:491:181077',1),
(111223,'Books',3,161401,'170769:161401',1),
(111261,'Blankets & Liners',4,181403,'888:16034:181403',1),
(111264,'Mirrors',4,177832,'888:7294:177832',1),
(111289,'Rangefinders & Scopes',4,181128,'888:1513:181128',1),
(111418,'Apple Desktops & All-In-Ones',3,171957,'58058:171957',1),
(111422,'Apple Laptops',3,175672,'58058:175672',1),
(111493,'Labels',4,11195,'58058:171961:11195',1),
(111517,'Prep Tables',4,25367,'170638:11874:25367',1),
(111606,'Limit Switches',5,181845,'170769:92074:100016:181845',1),
(111607,'Pressure Switches',5,181845,'170769:92074:100016:181845',1),
(111613,'Cable Cutters',6,66984,'170769:92074:100016:73136:66984',1),
(111614,'Cable Pliers',6,66984,'170769:92074:100016:73136:66984',1),
(111617,'Bearings',4,25283,'170769:41489:25283',1),
(111650,'Satchels',3,19273,'170638:19273',1),
(111694,'Audio Docks & Mini Speakers',4,56169,'293:15052:56169',1),
(111800,'Felt Sheets',4,160704,'14339:28102:160704',1),
(111819,'Lancaster & Sandland',3,24,'870:24',1),
(111830,'Encaustic Painting',4,28110,'14339:11783:28110',1),
(111834,'Rhinestones',4,160704,'14339:28102:160704',1),
(111852,'New South Wales',4,153379,'260:3468:153379',1),
(111853,'Victoria',4,153379,'260:3468:153379',1),
(111854,'Queensland',4,153379,'260:3468:153379',1),
(111855,'South Australia',4,153379,'260:3468:153379',1),
(111856,'Western Australia',4,153379,'260:3468:153379',1),
(111857,'Tasmania',4,153379,'260:3468:153379',1),
(111860,'Decimal',4,153383,'260:3468:153383',0),
(111861,'Individual',5,111860,'260:3468:153383:111860',1),
(111862,'Blocks, Sheets',5,111860,'260:3468:153383:111860',1),
(111863,'Other Decimal',5,111860,'260:3468:153383:111860',1),
(111864,'Christmas',5,3473,'260:3468:153383:3473',1),
(111865,'Olympics',5,3473,'260:3468:153383:3473',1),
(111866,'Pre-Decimal',4,153383,'260:3468:153383',0),
(111867,'Individual',5,111866,'260:3468:153383:111866',1),
(111870,'Norfolk Island',4,153379,'260:3468:153379',1),
(111882,'Glow Products',2,220,'220',0),
(111883,'Flashing Necklaces',3,111882,'220:111882',1),
(111935,'Dress Forms/Tailor\'s Dummies',4,183292,'14339:160737:183292',1),
(112378,'Stroller Boards',4,180911,'2984:66698:180911',1),
(112389,'Bricks',3,41498,'170769:41498',1),
(112410,'Paper Cutters',2,170638,'170638',1),
(112422,'Shipping Containers',2,170769,'170769',1),
(112425,'Dancewear',2,11450,'11450',0),
(112428,'Other',4,175638,'11450:112425:175638',1),
(112505,'Starter Sets & Packs',4,122601,'220:180250:122601',1),
(112529,'Headphones',3,15052,'293:15052',1),
(112541,'Die Cutting Cartridges',4,183239,'14339:11788:183239',1),
(112546,'Prams',3,329,'237:329',1),
(112553,'Shower Enclosures',4,20601,'11700:3187:20601',1),
(112562,'Artificial Nail Tips',3,47945,'26395:47945',1),
(112563,'Nail Practice & Display',3,47945,'26395:47945',1),
(112567,'Ladders',3,3187,'11700:3187',1),
(112568,'Stairs',3,3187,'11700:3187',1),
(112580,'Smoothie Makers',3,20667,'20710:20667',1),
(112581,'Lamps',3,20697,'11700:20697',1),
(112585,'Railway Sleepers',5,181027,'11700:159912:2032:181027',1),
(112590,'Tables',4,25863,'11700:159912:25863',1),
(112601,'Safes',3,41968,'11700:41968',1),
(112626,'Glow Sticks',3,111882,'220:111882',1),
(112661,'Unisex Fragrances',3,180345,'26395:180345',1),
(112676,'Lutes',4,181282,'619:180016:181282',1),
(112677,'Sitars',4,181282,'619:180016:181282',1),
(112678,'Oboes',4,181267,'619:10181:181267',1),
(112869,'Irish',3,24,'870:24',1),
(112870,'Brambly Hedge',4,43813,'870:24:43813',1),
(112871,'Vases',4,43813,'870:24:43813',1),
(112879,'Sunglasses',3,21557,'888:21557',1),
(112953,'Horse Jumps',4,183421,'888:3153:183421',1),
(112954,'Inversion Tables',4,28064,'888:15273:28064',1),
(113015,'Eye Masks',3,93838,'11730:93838',1),
(113337,'Patches',4,183270,'14339:160737:183270',1),
(113339,'Special Occasion',3,71183,'14339:71183',1),
(113341,'Rings',4,183127,'14339:28131:183127',1),
(113343,'Knitting Boards & Looms',4,3094,'14339:160706:3094',1),
(113344,'Die Cut & Embossing Machines',4,183239,'14339:11788:183239',1),
(113357,'Aboriginal',2,550,'550',0),
(113372,'Casting Kits',3,117388,'2984:117388',1),
(113484,'Parts & Accessories',3,180014,'619:180014',1),
(113525,'Warmachine',4,16486,'220:233:16486',1),
(113742,'Fryers',4,25367,'170638:11874:25367',1),
(113752,'Staplers',3,58271,'170638:58271',1),
(113787,'Ellis',3,170518,'870:170518',1),
(113788,'Falcon Ware',3,24,'870:24',1),
(113794,'Books, CDs, DVDs, eBooks',3,19266,'99:19266',1),
(113795,'Crystals, Gems, Rocks',3,19266,'99:19266',0),
(113797,'Natural, Rough Specimens',4,113795,'99:19266:113795',1),
(113798,'Pendulums',4,113795,'99:19266:113795',1),
(113800,'Spheres, Balls',4,113795,'99:19266:113795',1),
(113802,'Herbs',3,19266,'99:19266',1),
(113803,'Incense, Accessories',3,19266,'99:19266',0),
(113804,'Pagan Beliefs',3,19266,'99:19266',1),
(113805,'Wholesale, Bulk Lots',3,19266,'99:19266',1),
(113806,'Incense',4,113803,'99:19266:113803',1),
(113807,'Incense Burners',4,113803,'99:19266:113803',1),
(113808,'Meditation',3,19266,'99:19266',1),
(113809,'Numerology',3,19266,'99:19266',1),
(113811,'Books, CDs, DVDs',3,102545,'99:102545',1),
(113812,'Islamic Items',3,102545,'99:102545',1),
(113814,'Bath Tubs',3,20394,'2984:20394',1),
(113913,'Teeth Whitening',3,31769,'26395:31769',1),
(114236,'Sea Scooters',3,16052,'888:16052',1),
(114263,'Kiteboards',4,166201,'888:22709:166201',1),
(114299,'Storage & Displays',3,180250,'220:180250',1),
(114397,'Dressers & Chests of Drawers',3,3197,'11700:3197',1),
(115100,'Cacti & Succulent Seeds',5,40605,'11700:159912:181003:40605',1),
(115280,'Golf Clubs',4,181153,'888:1513:181153',1),
(115699,'Garage Doors',4,180972,'11700:3187:180972',1),
(115712,'Carriers',4,71259,'14308:179836:71259',1),
(115749,'Bookcases',4,66741,'11700:3197:66741',1),
(115750,'Desks',4,66741,'11700:3197:66741',1),
(115753,'Kitchen Islands/Kitchen Carts',3,3197,'11700:3197',1),
(115772,'Windmills & Wind Spinners',4,20498,'11700:159912:20498',1),
(115773,'Bridges',4,177017,'11700:159912:177017',1),
(115775,'Lawn Aerators',5,181033,'11700:159912:2032:181033',1),
(115940,'Sensors & Motion Detectors',3,41968,'11700:41968',1),
(115942,'Smoke Detectors',3,41968,'11700:41968',1),
(115965,'Hot Water Systems',3,69197,'20710:69197',1),
(115975,'Doorbells',4,41976,'11700:3187:41976',1),
(116005,'Sharpeners',4,20637,'11700:20625:20637',1),
(116012,'Coffee Percolators',2,20710,'20710',1),
(116015,'Paper Lanterns',3,20697,'11700:20697',1),
(116021,'Lighting Remotes',3,20697,'11700:20697',1),
(116022,'String Lights',3,20697,'11700:20697',1),
(116026,'Dishwasher Parts',3,170737,'20710:170737',1),
(116077,'Tanks & Military Vehicles',5,182203,'220:2562:182187:182203',1),
(116107,'Wands',4,113795,'99:19266:113795',1),
(116108,'Single Cards',4,102520,'99:19266:102520',1),
(116109,'Wicca',3,19266,'99:19266',0),
(116110,'Books',4,116109,'99:19266:116109',1),
(116111,'Candles',4,116109,'99:19266:116109',1),
(116112,'Herbs',4,116109,'99:19266:116109',1),
(116113,'Incense',4,116109,'99:19266:116109',1),
(116114,'Kits',4,116109,'99:19266:116109',1),
(116115,'Oils',4,116109,'99:19266:116109',1),
(116116,'Pentacles',4,116109,'99:19266:116109',1),
(116117,'Other Wicca',4,116109,'99:19266:116109',1),
(116118,'Bibles Covers, Accessories',3,102545,'99:102545',1),
(116119,'Educational Materials',3,102545,'99:102545',1),
(116183,'Glasses Cases',3,31414,'26395:31414',1),
(116309,'Microphones',3,31530,'58058:31530',1),
(116346,'Stands, Holders & Car Mounts',3,31530,'58058:31530',1),
(116362,'Carriers',3,20737,'1281:20737',1),
(116363,'Litter',3,20737,'1281:20737',1),
(116391,'Pet Memorials & Urns',2,1281,'1281',1),
(116405,'Above-Ground Pools',5,181053,'11700:159912:20727:181053',1),
(116406,'In-Ground Pools',5,181053,'11700:159912:20727:181053',1),
(116407,'Inflatable & Kid Pools',5,181053,'11700:159912:20727:181053',1),
(116412,'Pool Filters',5,181067,'11700:159912:20727:181067',1),
(116495,'Pottery Kilns',4,183303,'14339:183302:183303',1),
(116496,'Pottery Tools & Sets',4,183303,'14339:183302:183303',1),
(116553,'Footmuffs, Aprons',4,180911,'2984:66698:180911',1),
(116554,'Covers, Canopies & Umbrellas',4,180911,'2984:66698:180911',1),
(116598,'PAT Testers',5,181998,'170769:92074:181939:181998',1),
(116610,'Crewel Embroidery Kits',5,183197,'14339:160706:28141:183197',1),
(116639,'Blown Eggs',4,160704,'14339:28102:160704',1),
(116640,'Craft Bells',4,160704,'14339:28102:160704',1),
(116649,'Quilts',3,71183,'14339:71183',1),
(116650,'Handpainted Signs',3,71183,'14339:71183',1),
(116652,'Kids\' Arts, Crafts',2,14339,'14339',0),
(116653,'Crayons',3,116652,'14339:116652',1),
(116654,'Foam, Felt Shapes',3,116652,'14339:116652',1),
(116655,'Kids Craft Kits',3,116652,'14339:116652',1),
(116656,'Kids Pens, Markers',3,116652,'14339:116652',1),
(116657,'Sand Art',3,116652,'14339:116652',1),
(116673,'Tubes',3,19273,'170638:19273',1),
(116674,'Water Coolers',2,170638,'170638',1),
(116677,'Latch Hooking Patterns',5,157027,'14339:160706:28147:157027',1),
(116678,'Latch Hooking Tools',5,157027,'14339:160706:28147:157027',1),
(116679,'Quilt Batting',4,180930,'14339:160737:180930',1),
(116680,'Quilt Templates & Stencils',4,180930,'14339:160737:180930',1),
(116724,'Masks',4,155344,'11450:163147:155344',1),
(116743,'Hangers',3,106121,'11450:106121',1),
(116744,'Garment Bags',3,106121,'11450:106121',1),
(116745,'Moth Balls',3,106121,'11450:106121',1),
(116848,'Parallel, Serial & PS/2',3,182094,'58058:182094',1),
(116868,'Reel-to-Reel Tape Recorders',4,175740,'293:183077:175740',1),
(116880,'Wall Fixtures',3,20697,'11700:20697',1),
(117029,'Safety Gates',3,20433,'2984:20433',1),
(117035,'Cot & Crib Mattresses',3,20422,'2984:20422',1),
(117039,'Repair Kits, Tools',4,173696,'281:14324:173696',1),
(117042,'Controllers & Attachments',3,54968,'1249:54968',1),
(117044,'Motion Sensors & Cameras',3,54968,'1249:54968',1),
(117045,'Memory Cards & Expansion Packs',3,54968,'1249:54968',1),
(117049,'Stools & Benches',4,181224,'619:180010:181224',1),
(117051,'Music Theory & Ear Training',3,182150,'619:182150',1),
(117102,'Shafts',3,72575,'888:72575',1),
(117103,'Bowls (Lawn)',2,888,'888',0),
(117104,'Bowls',3,117103,'888:117103',1),
(117106,'Clothing',3,117103,'888:117103',1),
(117107,'Shoes',3,117103,'888:117103',1),
(117149,'Kitesurfing Harnesses',4,71164,'888:22709:71164',1),
(117150,'Kitesurfing Kites',4,71164,'888:22709:71164',1),
(117162,'Caps',3,74050,'888:74050',1),
(117211,'Slides',3,11743,'220:11743',1),
(117214,'Boomerangs',3,11743,'220:11743',1),
(117215,'Sandpit Toys',3,11743,'220:11743',1),
(117338,'Backwash Units & Shampoo Bowls',3,177731,'26395:177731',1),
(117369,'Buildings, Tunnels & Bridges',5,180280,'220:180250:19128:180280',1),
(117382,'Cups, Dishes, Utensils',3,20400,'2984:20400',1),
(117388,'Keepsakes, Memory Books',2,2984,'2984',0),
(117389,'Books & Albums',3,117388,'2984:117388',1),
(117400,'Tin & Metal Pieces',4,160704,'14339:28102:160704',1),
(117421,'Doors & Flaps',3,20737,'1281:20737',1),
(117434,'UV Sterilisers',3,20754,'1281:20754',1),
(117435,'Meters & Regulators',3,20754,'1281:20754',1),
(117488,'IC Sockets',5,65512,'170769:92074:100016:65512',1),
(117489,'Conduit, Fittings & Tubing',5,73136,'170769:92074:100016:73136',0),
(117490,'Conduit Fittings',6,117489,'170769:92074:100016:73136:117489',1),
(117503,'Chandeliers & Ceiling Fixtures',3,20697,'11700:20697',1),
(117525,'Time Clocks & Supplies',3,50203,'170638:50203',1),
(117769,'Panties',3,172378,'2984:172378',1),
(117771,'Sleepwear',3,172378,'2984:172378',1),
(118196,'Trays',4,106191,'11700:20625:106191',1),
(118197,'Canisters',4,106191,'11700:20625:106191',1),
(118198,'Cake Takers',4,106191,'11700:20625:106191',1),
(118233,'Glowsticks',3,40149,'220:40149',1),
(118234,'Keyrings',3,40149,'220:40149',1),
(118235,'Novelty Stationery',3,40149,'220:40149',1),
(118261,'Device-Specific Batteries',4,56169,'293:15052:56169',1),
(118851,'Water Pumps & Pressure Tanks',5,29521,'11700:159912:2032:29521',1),
(118858,'Paving & Decking',5,181027,'11700:159912:2032:181027',0),
(118859,'Pavers & Step Stones',6,118858,'11700:159912:2032:181027:118858',1),
(118860,'Decking Boards & Tiles',6,118858,'11700:159912:2032:181027:118858',1),
(118861,'Stones, Gravel & Pebbles',5,181027,'11700:159912:2032:181027',1),
(118863,'Decorative Stepping Stones',4,20498,'11700:159912:20498',1),
(118864,'Rakes',5,181033,'11700:159912:2032:181033',1),
(118867,'Garden Tool Sets',5,181033,'11700:159912:2032:181033',1),
(118868,'Hoes & Cultivators',5,181033,'11700:159912:2032:181033',1),
(118869,'Seeders & Spreaders',5,179308,'11700:159912:2032:179308',1),
(118974,'Vintage Brass',3,181162,'619:181162',0),
(118975,'Trumpets',4,118974,'619:181162:118974',1),
(118976,'Trombones',4,118974,'619:181162:118974',1),
(118977,'Other Vintage Brass',4,118974,'619:181162:118974',1),
(118979,'Acoustic Guitars',4,181163,'619:181162:181163',1),
(118983,'Guitar Amplifiers',4,181163,'619:181162:181163',1),
(118984,'Bass Guitars',4,181163,'619:181162:181163',1),
(118985,'Electric Guitars',4,181163,'619:181162:181163',1),
(118994,'Other Vintage Guitars',4,181163,'619:181162:181163',1),
(119018,'Preamps & Channel Strips',3,180014,'619:180014',1),
(119019,'Vintage Pro Audio',3,180014,'619:180014',1),
(119023,'Vintage String',3,181162,'619:181162',0),
(119024,'Banjos',5,181260,'619:181162:119023:181260',1),
(119025,'Ukuleles',5,181260,'619:181162:119023:181260',1),
(119026,'Violins',5,181255,'619:181162:119023:181255',1),
(119027,'Other Vintage String',4,119023,'619:181162:119023',1),
(119029,'Clarinets',5,181203,'619:181162:181202:181203',1),
(119030,'Saxophones',5,181203,'619:181162:181202:181203',1),
(119095,'Harmonicas',5,181210,'619:181162:181202:181210',1),
(119096,'Hitches',4,177647,'170769:41489:177647',1),
(119142,'Seating',3,26443,'131090:26443',1),
(119236,'Accessories',3,36259,'888:36259',0),
(119237,'Tuning Tools',4,119236,'888:36259:119236',1),
(119544,'Classical Guitars',3,3858,'619:3858',1),
(119636,'Carnivorous Plant Seeds',5,40605,'11700:159912:181003:40605',1),
(119658,'Bamboo',5,19617,'11700:159912:181003:19617',1),
(119683,'Fertilisers',5,179308,'11700:159912:2032:179308',1),
(119688,'Houseplants',5,19617,'11700:159912:181003:19617',1),
(120271,'Carriages',4,19116,'220:180250:19116',1),
(120272,'Track',4,19116,'220:180250:19116',1),
(120273,'Buildings, Tunnels & Bridges',5,81083,'220:180250:19116:81083',1),
(120869,'Reading Lights',3,45110,'267:45110',1),
(120967,'Fruit Seeds',5,40605,'11700:159912:181003:40605',1),
(121274,'Pants',4,50935,'170638:11874:50935',1),
(121464,'Flash Diffusers',3,64353,'625:64353',1),
(121469,'Stackers',3,26268,'2984:26268',1),
(121634,'Pram & Stroller Parts',3,66698,'2984:66698',1),
(121831,'Candles, Holders',3,71183,'14339:71183',1),
(122234,'Other Stickers & Flags',4,183544,'131090:25622:183544',1),
(122306,'Go Karts',2,9800,'9800',1),
(122321,'Scarves',3,57881,'11450:57881',1),
(122339,'Shoelaces',3,106121,'11450:106121',1),
(122340,'Sunglasses',3,15628,'11450:15628',1),
(122564,'Passenger Cars',4,19119,'220:180250:19119',1),
(122569,'Passenger Cars',4,19128,'220:180250:19128',1),
(122570,'Signals',5,180280,'220:180250:19128:180280',1),
(122572,'Carriages',4,19128,'220:180250:19128',1),
(122574,'Buildings, Tunnels & Bridges',5,80979,'220:180250:19151:80979',1),
(122575,'Passenger Cars',4,19151,'220:180250:19151',1),
(122576,'Locomotives',4,19151,'220:180250:19151',1),
(122578,'Track',4,19151,'220:180250:19151',1),
(122580,'Carriages',4,19151,'220:180250:19151',1),
(122586,'Passenger Cars',4,19145,'220:180250:19145',1),
(122591,'Locomotives',4,19145,'220:180250:19145',1),
(122596,'Carriages',4,19145,'220:180250:19145',1),
(122601,'OO Scale',3,180250,'220:180250',0),
(122602,'Passenger Cars',4,122601,'220:180250:122601',1),
(122604,'Locomotives',4,122601,'220:180250:122601',1),
(122605,'Carriages',4,122601,'220:180250:122601',1),
(122608,'Passenger Cars',4,19116,'220:180250:19116',1),
(122649,'Amplifier Parts & Components',3,14969,'293:14969',1),
(122654,'Mini Plug-in Microphones',4,56169,'293:15052:56169',1),
(122662,'Cardstock',3,11788,'14339:11788',1),
(122689,'Glitter',4,160704,'14339:28102:160704',1),
(122691,'Dimensional Adhesives',5,161585,'14339:11788:31253:161585',1),
(122694,'Craft Tape',4,183122,'14339:28102:183122',1),
(122717,'Cutters & Trimmers',5,183173,'14339:28102:183171:183173',1),
(122718,'Craft Tweezers',4,183171,'14339:28102:183171',1),
(122721,'Reborn',3,238,'237:238',1),
(122759,'Other Beds & Mattresses',4,32254,'11700:3197:32254',1),
(122768,'Children\'s Lighting',3,20697,'11700:20697',1),
(122773,'Eye Drops & Wash',3,31414,'26395:31414',1),
(122830,'Sanders',4,3247,'11700:631:3247',1),
(122833,'Circular Saws',5,20783,'11700:631:3247:20783',1),
(122837,'Saw Blades',4,164613,'11700:631:164613',1),
(122839,'Screwdrivers',4,3247,'11700:631:3247',1),
(122891,'Bulbs, Roots & Rhizomes',5,40605,'11700:159912:181003:40605',1),
(122906,'Forks',5,181033,'11700:159912:2032:181033',1),
(122907,'Trowels',5,181033,'11700:159912:2032:181033',1),
(122928,'Donut Makers',3,20667,'20710:20667',1),
(122929,'Countertop Ice Makers',3,20667,'20710:20667',1),
(122930,'Toaster Ovens',3,20667,'20710:20667',1),
(122931,'Pie Makers',3,20667,'20710:20667',1),
(122932,'Rice Cookers',3,20667,'20710:20667',1),
(122933,'Yogurt Makers',3,20667,'20710:20667',1),
(122956,'Lab-Created Emeralds',5,10218,'281:491:181077:10218',1),
(122957,'Lab-Created Rubies',5,10254,'281:491:181077:10254',1),
(122958,'Lab-Created Sapphires',5,10259,'281:491:181077:10259',1),
(122962,'Straps & Charms',3,9394,'15032:9394',1),
(123205,'Movie',4,914,'1:124:914',1),
(123416,'Other Tickets, Travel',2,11730,'11730',1),
(123417,'Chargers & Cradles',3,9394,'15032:9394',1),
(123422,'Cables & Adapters',3,9394,'15032:9394',1),
(123445,'Audio/MIDI-Interfaces',3,180014,'619:180014',1),
(123468,'Skip, Jump Ropes',4,179784,'888:179767:179784',1),
(123473,'High Visibility/Reflective',4,22682,'888:7294:22682',1),
(123474,'Bells & Horns',4,177832,'888:7294:177832',1),
(123475,'Lubrication & Cleaning',4,177844,'888:7294:177844',1),
(123489,'Lights',4,179985,'888:1492:179985',1),
(123490,'Shorts',4,159178,'888:20862:159178',1),
(123687,'NRL, Rugby League',2,888,'888',0),
(123688,'Balls',3,123687,'888:123687',1),
(123689,'Boots',3,123687,'888:123687',1),
(123702,'Other',3,123687,'888:123687',1),
(123703,'Marine Rope',3,26443,'131090:26443',1),
(123707,'Swimwear',3,74050,'888:74050',1),
(123783,'Omnibus Issues',3,181420,'260:181420',1),
(123786,'Bhutan',3,181416,'260:181416',1),
(123787,'Indonesia',3,181416,'260:181416',1),
(123789,'Mongolia',3,181416,'260:181416',1),
(123791,'Bahrain',3,181422,'260:181422',1),
(123794,'Iraq',3,181422,'260:181422',1),
(123795,'Israel',3,181422,'260:181422',1),
(123796,'Jordan',3,181422,'260:181422',1),
(123797,'Kuwait',3,181422,'260:181422',1),
(123798,'Lebanon',3,181422,'260:181422',1),
(123799,'Oman',3,181422,'260:181422',1),
(123800,'Qatar',3,181422,'260:181422',1),
(123801,'Saudi Arabia',3,181422,'260:181422',1),
(123802,'Syria',3,181422,'260:181422',1),
(123803,'United Arab Emirates',3,181422,'260:181422',1),
(123804,'Yemen',3,181422,'260:181422',1),
(123847,'Helicopters',4,182181,'220:2562:182181',1),
(123876,'Caps, Hats',4,159178,'888:20862:159178',1),
(124101,'Robotic Vacuums',3,20614,'20710:20614',1),
(124102,'Maintenance',3,26443,'131090:26443',1),
(124104,'Engine Parts',4,50440,'131090:26443:50440',1),
(124106,'Interior, Cabin & Galley',3,26443,'131090:26443',1),
(124223,'Darbyshire',3,170518,'870:170518',1),
(124225,'Other Unbranded',5,153372,'870:50693:170514:153372',1),
(124226,'Animals',4,64981,'870:24:64981',1),
(124227,'Tableware',4,64981,'870:24:64981',1),
(124228,'Teapots, Tea Sets',4,64981,'870:24:64981',1),
(124229,'Decorative, Ornamental',4,64981,'870:24:64981',1),
(124230,'Figures',4,64981,'870:24:64981',1),
(124270,'Chargers & Cradles',4,56169,'293:15052:56169',1),
(124313,'Tyres & Tubes',4,180035,'131090:14780:180035',1),
(124327,'Pillowcases & Shams',3,20416,'2984:20416',1),
(124603,'Servo Motors',4,181730,'170769:42892:181730',1),
(124820,'Welding Gas Cylinders',4,34095,'170769:182941:34095',1),
(124821,'Solder',5,182949,'170769:182941:182942:182949',1),
(124822,'MIG Welders',5,182897,'170769:182941:34095:182897',1),
(124825,'TIG Welders',5,182897,'170769:182941:34095:182897',1),
(124848,'Flash Lighting',3,30078,'625:30078',0),
(124850,'Flash Heads & Power Supplies',4,124848,'625:30078:124848',1),
(124978,'Weather Stripping',4,180113,'11700:3187:180113',1),
(124980,'Weather Stripping',4,41976,'11700:3187:41976',1),
(125033,'Rivets',4,180974,'11700:3187:180974',1),
(125034,'Nuts',4,180974,'11700:3187:180974',1),
(125072,'Baskets',3,10033,'11700:10033',1),
(125085,'Trunks & Chests',3,3197,'11700:3197',1),
(125226,'Canvas & Canvas Boards',4,28110,'14339:11783:28110',0),
(125227,'Canvas Roll',5,125226,'14339:11783:28110:125226',1),
(125228,'Canvas Stretcher Bars & Frames',5,125226,'14339:11783:28110:125226',1),
(125229,'Stretched Canvas & Board',5,125226,'14339:11783:28110:125226',1),
(125957,'Street Directories',3,171273,'267:171273',1),
(126191,'Paint Primers',4,180979,'11700:3187:180979',1),
(126201,'Wood Veneer Sheets',4,180969,'11700:3187:180969',1),
(126212,'Other Merchandise',4,164767,'888:21563:164767',1),
(126214,'Heated Floor Mats',3,69197,'20710:69197',1),
(126415,'Sauna Parts & Accessories',4,20727,'11700:159912:20727',1),
(126439,'Door Viewers',4,41976,'11700:3187:41976',1),
(126476,'Filter Media & Accessories',3,20754,'1281:20754',1),
(127144,'Africa',3,58520,'11116:58520',1),
(127351,'Guyana',3,181417,'260:181417',1),
(127399,'Slovakia',3,4742,'260:4742',1),
(127400,'Slovenia',3,4742,'260:4742',1),
(127402,'Ukraine',3,4742,'260:4742',1),
(127405,'Belarus',3,4742,'260:4742',1),
(127408,'Japan',3,181416,'260:181416',1),
(127409,'Laos',3,181416,'260:181416',1),
(127410,'Collections, Mixture',3,181416,'260:181416',1),
(127411,'Other Asian',3,181416,'260:181416',1),
(127413,'South Africa',3,181423,'260:181423',1),
(127414,'Algeria',3,181423,'260:181423',1),
(127417,'Congo',3,181423,'260:181423',1),
(127418,'Ivory Coast',3,181423,'260:181423',1),
(127419,'Egypt',3,181422,'260:181422',1),
(127420,'Gabon',3,181423,'260:181423',1),
(127421,'Guinea',3,181423,'260:181423',1),
(127423,'Madagascar',3,181423,'260:181423',1),
(127424,'Morocco',3,181423,'260:181423',1),
(127425,'Mauritania',3,181423,'260:181423',1),
(127426,'Mozambique',3,181423,'260:181423',1),
(127428,'Central African Republic',3,181423,'260:181423',1),
(127431,'Togo',3,181423,'260:181423',1),
(127432,'Tunisia',3,181423,'260:181423',1),
(127433,'Collections, Mixture',3,181423,'260:181423',1),
(127443,'Cameroon',3,181423,'260:181423',1),
(127470,'Eyeglass Cloths & Sprays',3,31414,'26395:31414',1),
(128241,'Other Metalworking Supplies',3,177644,'170769:177644',1),
(128302,'Suriname',3,181417,'260:181417',1),
(128308,'Curacao',3,179377,'260:179377',1),
(128647,'Antique',3,13849,'1:13849',1),
(128775,'Accessories',3,116652,'14339:116652',1),
(129083,'Flat/Ribbon Cable',5,73136,'170769:92074:100016:73136',1),
(129085,'Residual Current Devices (RCD)',5,181815,'170769:92074:181814:181815',1),
(129086,'Cartridge Fuses',5,181823,'170769:92074:181814:181823',1),
(129088,'Centred Tag Fuses',5,181823,'170769:92074:181814:181823',1),
(129111,'Microswitches',5,181845,'170769:92074:100016:181845',1),
(129135,'Ends/Stoppers & Ferrules',6,181812,'170769:92074:100016:73136:181812',1),
(129136,'Cable Channels',6,181812,'170769:92074:100016:73136:181812',1),
(129138,'Heat & Cool Shrink Tubing',6,117489,'170769:92074:100016:73136:117489',1),
(129139,'Coaxial Cable',5,73136,'170769:92074:100016:73136',1),
(129142,'D-Sub Connectors',5,65512,'170769:92074:100016:65512',1),
(129143,'Circular Connectors',5,65512,'170769:92074:100016:65512',1),
(129588,'Shower & Bath Seats',4,182113,'26395:11778:182113',1),
(129589,'Grates, Drains',4,20601,'11700:3187:20601',1),
(129608,'Chemicals',4,20605,'11700:299:20605',1),
(129609,'Sponges, Scourers',4,20605,'11700:299:20605',1),
(129732,'Clocks',4,166227,'888:19292:166227',1),
(129735,'Watches',4,166227,'888:19292:166227',1),
(129736,'Jewellery',4,113795,'99:19266:113795',1),
(129737,'Polished Stones',4,113795,'99:19266:113795',1),
(129782,'Window Sills',4,180113,'11700:3187:180113',1),
(129788,'Trims & Skirting Boards',4,180983,'11700:3187:180983',1),
(130118,'Flooring Underlay',4,180983,'11700:3187:180983',1),
(130122,'Flooring & Tiling Accessories',4,180983,'11700:3187:180983',1),
(130126,'Hooks',4,180974,'11700:3187:180974',1),
(130493,'RF & Coaxial Connectors',5,65512,'170769:92074:100016:65512',1),
(130681,'Australian',5,27371,'131090:6747:50428:27371',1),
(130684,'Keyrings & Novelties',4,34352,'131090:6747:34352',1),
(131081,'Rattles',3,19068,'2984:19068',1),
(131084,'Soft Toys',3,19068,'2984:19068',1),
(131090,'Vehicle Parts & Accessories',1,-1,'',0),
(131093,'Mounts & Holders',4,56169,'293:15052:56169',1),
(131411,'Sunglasses',3,57881,'11450:57881',1),
(131486,'CPU Fans & Heat Sinks',4,42000,'58058:175673:42000',1),
(131487,'Computer Case Fans',4,42000,'58058:175673:42000',1),
(131494,'Hard Drive Cooling',4,42000,'58058:175673:42000',1),
(131495,'Fan Grills & Filters',4,42000,'58058:175673:42000',1),
(131502,'Memory & Chipset Cooling',4,42000,'58058:175673:42000',1),
(131503,'Water Cooling',4,42000,'58058:175673:42000',1),
(131511,'Motherboard & CPU Combos',3,175673,'58058:175673',1),
(131542,'CD, DVD & Blu-ray Drives',3,165,'58058:165',1),
(131553,'External Hard Disk Drives',4,182085,'58058:165:182085',1),
(131579,'Futons, Frames & Covers',3,3197,'11700:3197',1),
(131588,'Mattresses',4,32254,'11700:3197:32254',1),
(131598,'Inflatable Mattresses, Airbeds',4,32254,'11700:3197:32254',1),
(131608,'Complete Sets',4,20637,'11700:20625:20637',1),
(131628,'Palestine',3,181422,'260:181422',1),
(132297,'Audio Docks & Speakers',3,9394,'15032:9394',1),
(132975,'UMDs',2,11232,'11232',1),
(132998,'Atmospheric Effects Fluids',3,12922,'619:12922',1),
(133072,'College Cards',3,212,'888:212',1),
(133693,'Mirrors',3,26677,'11700:26677',1),
(133696,'Bathmats, Rugs & Toilet Covers',3,26677,'11700:26677',1),
(133700,'Mixers (Handheld)',3,20667,'20710:20667',1),
(133701,'Mixers (Countertop)',3,20667,'20710:20667',1),
(133703,'Blenders (Handheld)',3,20667,'20710:20667',1),
(133704,'Blenders (Countertop)',3,20667,'20710:20667',1),
(133705,'Kettles',3,20667,'20710:20667',1),
(133708,'Chillers/ Coolers',4,71259,'14308:179836:71259',1),
(134278,'Duvet Covers & Sets',3,20416,'2984:20416',1),
(134282,'Walkers',3,19068,'2984:19068',1),
(134447,'Clay Rollers & Brayers',4,183308,'14339:183302:183308',1),
(134448,'Books & Magazines',4,183303,'14339:183302:183303',1),
(134558,'Gouache',5,183102,'14339:11783:28110:183102',1),
(134560,'Fabric Paints & Markers',3,183118,'14339:183118',1),
(134569,'Paint Sets',3,116652,'14339:116652',1),
(134570,'Stickers',3,116652,'14339:116652',1),
(134571,'Buckles',4,183127,'14339:28131:183127',1),
(134586,'Embroidery Machine Needles',5,160724,'14339:160706:28141:160724',1),
(134590,'Other Tatting & Lacemaking',4,183231,'14339:160706:183231',1),
(134591,'Lacemaking Bobbins',4,183231,'14339:160706:183231',1),
(134592,'Patterns & Instructional Media',4,183231,'14339:160706:183231',1),
(134594,'Card Making',4,183242,'14339:11788:183242',1),
(134595,'Quilling',4,183242,'14339:11788:183242',1),
(134596,'Origami',4,183242,'14339:11788:183242',1),
(134623,'Pincushions',4,183286,'14339:160737:183286',1),
(134624,'Spinning Wheels',5,183218,'14339:160706:183209:183218',1),
(134628,'Eyelet Setters',4,183171,'14339:28102:183171',1),
(134640,'Tumblers',3,26677,'11700:26677',1),
(134642,'Drawer Slides',4,41971,'11700:3187:41971',1),
(134648,'Sofas & Armchairs',4,66741,'11700:3197:66741',1),
(134650,'Stools',4,66741,'11700:3197:66741',1),
(134671,'Plant Hooks & Hangers',5,179308,'11700:159912:2032:179308',1),
(134674,'Rotisseries',3,20667,'20710:20667',1),
(134727,'Graters',4,20635,'11700:20625:20635',1),
(134728,'Measuring Cups, Jugs & Spoons',4,20635,'11700:20625:20635',1),
(134734,'Ironing Board Covers',3,170737,'20710:170737',1),
(134784,'Lacemaking Shuttles',4,183231,'14339:160706:183231',1),
(135244,'Displays',3,71465,'170638:71465',1),
(135245,'Media',3,11748,'170769:11748',0),
(135246,'Books',4,135245,'170769:11748:135245',1),
(135247,'Videos, DVDs',4,135245,'170769:11748:135245',1),
(135840,'Batteries',4,182278,'131090:84149:182278',1),
(135847,'Bodywork & Frame',3,84149,'131090:84149',0),
(135848,'Other Bodywork & Frame',4,135847,'131090:84149:135847',1),
(135849,'Mirrors',3,84149,'131090:84149',1),
(135859,'Windshields',4,135847,'131090:84149:135847',1),
(136164,'Bagless Vacuums',3,20614,'20710:20614',1),
(136699,'Dummy Mobile Phones',2,15032,'15032',1),
(136820,'Carpet Tiles',3,20571,'11700:20571',1),
(136990,'Replacement Parts',3,15124,'281:15124',1),
(137084,'Sportswear',3,1059,'11450:1059',1),
(137085,'Sportswear',3,15724,'11450:15724',1),
(137835,'Bracelets',3,10290,'281:10290',1),
(137839,'Chains, Necklaces',3,10290,'281:10290',1),
(137843,'Cufflinks',3,10290,'281:10290',1),
(137852,'Pendants',3,10290,'281:10290',1),
(137856,'Rings',3,10290,'281:10290',1),
(137861,'Medicine (Weighted) Balls',4,28064,'888:15273:28064',1),
(137862,'Hand Grippers',4,28064,'888:15273:28064',1),
(137864,'Barbells & Attachments',4,28066,'888:15273:28066',1),
(137865,'Dumbbells',4,28066,'888:15273:28066',1),
(137866,'Wrist & Ankle Weights',4,28066,'888:15273:28066',1),
(137887,'Jumping Castles',3,11743,'220:11743',1),
(137897,'Kites',3,11743,'220:11743',1),
(137902,'Accessories',3,2616,'220:2616',0),
(137904,'Controllers',4,137902,'220:2616:137902',1),
(137906,'Lap Counters',4,137902,'220:2616:137902',1),
(137907,'Motors',4,137902,'220:2616:137902',1),
(139001,'Frost Protection',5,179308,'11700:159912:2032:179308',1),
(139002,'Vegetables',5,19617,'11700:159912:181003:19617',1),
(139004,'Fruits',5,19617,'11700:159912:181003:19617',1),
(139454,'Pants & Shorts',4,179978,'888:1492:179978',1),
(139576,'Horse Feed & Supplements',3,3153,'888:3153',0),
(139577,'Horse Treats',4,139576,'888:3153:139576',1),
(139580,'Horse Care & Grooming',3,3153,'888:3153',0),
(139588,'Electric Fence Chargers',4,85214,'888:3153:85214',1),
(139590,'Other Stable Accessories',4,85214,'888:3153:85214',1),
(139591,'Other Horse Wear',4,57268,'888:3153:57268',1),
(139601,'Halters',4,57268,'888:3153:57268',1),
(139609,'Leads',4,57268,'888:3153:57268',1),
(139792,'Replicas/Repros/Forgeries',3,7898,'260:7898',1),
(139794,'Holidays',3,4752,'260:4752',1),
(139836,'GPS Accessories',2,293,'293',0),
(139844,'Shaver Parts & Accessories',4,180512,'26395:31762:180512',1),
(139849,'Furniture Sets',4,25863,'11700:159912:25863',1),
(139861,'Gardening Boots & Shoes',5,159473,'11700:159912:2032:159473',1),
(139864,'Gardening Gloves',5,159473,'11700:159912:2032:159473',1),
(139868,'Loppers',5,181033,'11700:159912:2032:181033',1),
(139869,'Saws',5,181033,'11700:159912:2032:181033',1),
(139870,'Scythes & Sickles',5,181033,'11700:159912:2032:181033',1),
(139871,'Pruning Shears & Snips',5,181033,'11700:159912:2032:181033',1),
(139872,'Hedge & Grass Shears',5,181033,'11700:159912:2032:181033',1),
(139909,'Drip Irrigation',5,29521,'11700:159912:2032:29521',1),
(139915,'Water Storage & Rain Barrels',5,29521,'11700:159912:2032:29521',1),
(139921,'Pond & Fountain Pumps',4,93632,'11700:159912:93632',1),
(139939,'Greenhouses & Cold Frames',4,177017,'11700:159912:177017',1),
(139946,'Fence Panels',4,177032,'11700:159912:177032',1),
(139948,'Garden Gates',4,177032,'11700:159912:177032',1),
(139949,'Fence Posts',4,177032,'11700:159912:177032',1),
(139950,'Railings',4,177032,'11700:159912:177032',1),
(139956,'Garden & Storage Sheds',4,177017,'11700:159912:177017',1),
(139965,'Nugget',4,45134,'11116:178078:45134',1),
(139968,'Answering Machines',3,164874,'15032:164874',1),
(139971,'Video Game Consoles',2,1249,'1249',1),
(139973,'Video Games',2,1249,'1249',1),
(140010,'Toe Rings',3,10968,'281:10968',1),
(140956,'Charms & Charm Bracelets',3,4196,'281:4196',1),
(141482,'Pool & Spa Thermometers',5,181057,'11700:159912:20727:181057',1),
(141565,'Robert Gordon',3,170518,'870:170518',1),
(141574,'Training Aids',3,21557,'888:21557',1),
(141575,'Training Aids',3,123687,'888:123687',1),
(141577,'Training Aids',3,109938,'888:109938',1),
(141625,'Signed Memorabilia',3,39991,'888:39991',1),
(141755,'Sports Stickers, Sets & Albums',2,888,'888',1),
(145822,'Afghanistan',3,181422,'260:181422',1),
(145824,'Argentina',3,181417,'260:181417',1),
(145825,'Bolivia',3,181417,'260:181417',1),
(145826,'Brazil',3,181417,'260:181417',1),
(145827,'Chile',3,181417,'260:181417',1),
(145828,'Colombia',3,181417,'260:181417',1),
(145829,'Costa Rica',3,181417,'260:181417',1),
(145831,'Ecuador',3,181417,'260:181417',1),
(145832,'El Salvador',3,181417,'260:181417',1),
(145833,'Guatemala',3,181417,'260:181417',1),
(145834,'Haiti',3,179377,'260:179377',1),
(145835,'Honduras',3,181417,'260:181417',1),
(145836,'Nicaragua',3,181417,'260:181417',1),
(145837,'Panama',3,181417,'260:181417',1),
(145838,'Paraguay',3,181417,'260:181417',1),
(145839,'Peru',3,181417,'260:181417',1),
(145840,'Uruguay',3,181417,'260:181417',1),
(145841,'Venezuela',3,181417,'260:181417',1),
(145842,'Collections, Mixture',3,181422,'260:181422',1),
(145937,'DVDs, Baby Educational',2,2984,'2984',1),
(145977,'Bubble Toys',3,11743,'220:11743',1),
(145992,'Water Slides',3,11743,'220:11743',1),
(145995,'Cubby Houses',3,11743,'220:11743',1),
(145997,'Play Tents',3,11743,'220:11743',1),
(145999,'Trampolines',3,11743,'220:11743',1),
(146004,'Card Games-Vintage',4,180350,'220:233:180350',1),
(146289,'Purse Handles, Frames & Feet',4,183274,'14339:160737:183274',1),
(146290,'Beads',3,31723,'14339:31723',1),
(146318,'Appliques',4,183270,'14339:160737:183270',1),
(146324,'Cards',3,71183,'14339:71183',1),
(146334,'Other Leathercraft Supplies',3,28131,'14339:28131',1),
(146356,'Embroidery Machine Patterns',5,160724,'14339:160706:28141:160724',1),
(146370,'Machine Knitting',4,3094,'14339:160706:3094',0),
(146375,'Machine Knitting Patterns',5,146370,'14339:160706:3094:146370',1),
(146376,'Machine Parts & Needles',5,146370,'14339:160706:3094:146370',1),
(146377,'Other Machine Knitting',5,146370,'14339:160706:3094:146370',1),
(146378,'Machine Knitting Yarn',5,146370,'14339:160706:3094:146370',1),
(146396,'Organisation & Storage',3,28102,'14339:28102',0),
(146399,'Photo Organisers',4,146396,'14339:28102:146396',1),
(146400,'Craft Carts',4,146396,'14339:28102:146396',1),
(146401,'Scrapbooking Totes',4,31253,'14339:11788:31253',1),
(146402,'Craft & Paper Racks',4,146396,'14339:28102:146396',1),
(146403,'Pre-Made Pages & Pieces',3,11788,'14339:11788',1),
(146493,'SIM Readers',3,9394,'15032:9394',1),
(146494,'Straps & Charms',4,45066,'15032:45065:45066',1),
(146496,'Screen Protectors',4,45066,'15032:45065:45066',1),
(146504,'FM Transmitters',3,9394,'15032:9394',1),
(146530,'Bags',3,26268,'2984:26268',1),
(146531,'Nappies (Cloth)',3,26268,'2984:26268',1),
(146532,'Other',3,117388,'2984:117388',1),
(146545,'Other Scrapbook Embellishments',5,183591,'14339:11788:31253:183591',1),
(146575,'Vintage Stationary Engines',3,41489,'170769:41489',1),
(146901,'Korea',3,181416,'260:181416',1),
(147147,'Shower Screens',4,20601,'11700:3187:20601',1),
(147192,'Girls',3,3082,'2984:3082',0),
(147202,'Outerwear',4,147192,'2984:3082:147192',1),
(147211,'Outfits, Sets',4,147192,'2984:3082:147192',1),
(147215,'Sleepwear',4,147192,'2984:3082:147192',1),
(147216,'Jumpers',4,147192,'2984:3082:147192',1),
(147218,'Tops, T-Shirts',4,147192,'2984:3082:147192',1),
(147220,'Mixed Items',4,147192,'2984:3082:147192',1),
(147221,'Other',4,147192,'2984:3082:147192',1),
(147285,'Baby Shoes',2,2984,'2984',1),
(147317,'Boys',3,3082,'2984:3082',0),
(147324,'Outerwear',4,147317,'2984:3082:147317',1),
(147333,'Outfits, Sets',4,147317,'2984:3082:147317',1),
(147336,'Sleepwear',4,147317,'2984:3082:147317',1),
(147338,'Jumpers',4,147317,'2984:3082:147317',1),
(147339,'Swimwear',4,147317,'2984:3082:147317',1),
(147340,'Tops, T-Shirts',4,147317,'2984:3082:147317',1),
(147342,'Mixed Items',4,147317,'2984:3082:147317',1),
(147343,'Other',4,147317,'2984:3082:147317',1),
(147699,'Wheels & Rims',4,180035,'131090:14780:180035',1),
(147794,'Tractors',3,177641,'170769:177641',1),
(147806,'Files',3,46576,'170769:46576',1),
(147808,'Calipers',3,46576,'170769:46576',1),
(147812,'Rulers',3,46576,'170769:46576',1),
(147814,'Squares',3,46576,'170769:46576',1),
(147815,'Tape Measures',3,46576,'170769:46576',1),
(147818,'Bolt Cutters',3,46576,'170769:46576',1),
(147832,'Saw Blades',3,170798,'170769:170798',1),
(147834,'Drills',3,64808,'170769:64808',1),
(147835,'Drill Bits',3,170798,'170769:170798',1),
(147836,'Drill Chucks',3,170798,'170769:170798',1),
(148449,'Labels',3,19273,'170638:19273',1),
(148465,'Grinder Discs',3,170798,'170769:170798',1),
(148470,'Sanding Belts',3,170798,'170769:170798',1),
(148495,'Beer',3,179836,'14308:179836',1),
(148620,'Kalimbas',4,181246,'619:180012:181246',1),
(148621,'Mouth Harps',4,181246,'619:180012:181246',1),
(148640,'Footrests',4,180009,'619:3858:180009',1),
(148648,'Tremolos',5,181223,'619:3858:180009:181223',1),
(148725,'Keyboard Covers',4,181224,'619:180010:181224',1),
(148726,'Lamps',4,181224,'619:180010:181224',1),
(148727,'Cases & Bags',4,181224,'619:180010:181224',1),
(148728,'Pedals',4,181224,'619:180010:181224',1),
(148908,'Racquet Covers',3,13340,'888:13340',1),
(148944,'Yoga Straps',4,158927,'888:15273:158927',1),
(148983,'Cleaning & Maintenance',3,20754,'1281:20754',1),
(149201,'Novelties',4,20687,'11700:20625:20687',1),
(149225,'Pieces',4,20637,'11700:20625:20637',1),
(149226,'Novelty Lights',3,20697,'11700:20697',1),
(149229,'Refrigerators, Freezers',2,20710,'20710',0),
(149230,'Bar Fridges',3,149229,'20710:149229',1),
(149242,'Outdoor Cooking & Eating',3,159912,'11700:159912',0),
(149271,'Cords, Wires',4,57215,'11700:3187:57215',1),
(149272,'Sockets',4,57215,'11700:3187:57215',1),
(149273,'Switches',4,57215,'11700:3187:57215',1),
(149275,'Urban Bling',3,10290,'281:10290',1),
(149360,'African',3,3913,'1:3913',1),
(149362,'Asian',3,3913,'1:3913',1),
(149809,'Health, Wellbeing',2,316,'316',1),
(149816,'Household',2,316,'316',1),
(149824,'IT, Communication',2,316,'316',1),
(149832,'Lawn, Yard',2,316,'316',1),
(149841,'Professional, Medical, Dental',2,316,'316',1),
(149854,'Security',2,316,'316',1),
(149860,'Transportation, Shipping',2,316,'316',1),
(149865,'Weddings, Parties',2,316,'316',1),
(149882,'Baby, Maternal',2,316,'316',1),
(149883,'Boating, Marine',2,316,'316',1),
(149884,'Business 2 Business (B2B)',2,316,'316',1),
(149891,'Automotive',2,316,'316',1),
(149928,'Half Dimes',5,253,'11116:58520:45145:253',1),
(149941,'Geocoins',3,159045,'888:159045',1),
(149958,'Audio/Video Transmitters',3,71582,'172176:71582',1),
(149959,'MiniDiscs',4,94893,'293:14961:94893',1),
(149960,'VHS Video Tapes',3,71582,'172176:71582',1),
(149963,'Vinyl Record Cleaning',4,94893,'293:14961:94893',1),
(149971,'Satellite LNB Downconverters',3,71582,'172176:71582',1),
(149972,'Splitters & Combiners',3,71582,'172176:71582',1),
(149973,'Antenna & Dish Mounting Gear',3,71582,'172176:71582',1),
(149975,'Rear-Projection TV Lamps',3,71582,'172176:71582',1),
(149976,'Rear View Monitors/Cams & Kits',4,48604,'131090:3270:48604',1),
(149987,'Marine & Aircraft Radios',3,1500,'293:1500',1),
(150044,'Digital Photo Frames',2,625,'625',1),
(150133,'Ready-Made Moulds',4,183313,'14339:183302:183313',1),
(150135,'Patterns-Vintage',4,3094,'14339:160706:3094',1),
(150138,'Microwave Ovens',2,20710,'20710',1),
(150336,'Surveillance',3,170211,'170638:170211',1),
(150594,'Jolly Jumpers',3,19068,'2984:19068',1),
(150663,'Ballet',4,175639,'11450:112425:175639',1),
(150664,'Jazz, Hip-Hop',4,175639,'11450:112425:175639',1),
(150666,'Skirts',4,175638,'11450:112425:175638',1),
(150750,'Euro',4,45148,'11116:58520:45148',1),
(150752,'Home Brew, Kegs',3,562,'1:562',1),
(150753,'Stickers',3,562,'1:562',1),
(150758,'Slogans',4,109779,'1:32615:109779',1),
(150865,'Books, Instructions',3,31723,'14339:31723',1),
(150871,'Smocks, Shirts',3,116652,'14339:116652',1),
(150897,'Glasses, Cups',4,20687,'11700:20625:20687',1),
(150916,'Russian',4,955,'870:50693:955',1),
(150924,'Other Pacific',3,181424,'260:181424',1),
(150929,'Computers',3,11731,'220:11731',1),
(150930,'Helicopters',4,1189,'220:1188:1189',1),
(150931,'Planes',4,1189,'220:1188:1189',1),
(150954,'Statues',4,102502,'99:19266:102502',1),
(151226,'Shooting Tables & Light Tents',3,30078,'625:30078',1),
(151236,'Telescope Adapters',4,74922,'625:28179:74922',1),
(151543,'Sunglasses',4,179978,'888:1492:179978',1),
(151563,'Clothing',3,22709,'888:22709',0),
(151571,'Sunglasses',4,158913,'888:15273:158913',1),
(151604,'Hoses',5,29521,'11700:159912:2032:29521',1),
(151620,'Axes & Hatchets',5,181033,'11700:159912:2032:181033',1),
(151621,'BBQs',4,149242,'11700:159912:149242',1),
(152342,'Tap',4,175639,'11450:112425:175639',1),
(152345,'Children\'s Dancewear',3,112425,'11450:112425',1),
(152362,'Belly Dancing',4,175638,'11450:112425:175638',1),
(152365,'Leotards & Unitards',4,175638,'11450:112425:175638',1),
(152367,'Tops, Shirts',4,175638,'11450:112425:175638',1),
(152398,'Swimwear',4,147192,'2984:3082:147192',1),
(152553,'Skorts',3,11462,'11450:11462',1),
(152807,'Brooches',3,110633,'281:110633',1),
(152928,'Boats',3,1188,'220:1188',1),
(152934,'Contemporary Manufacture',4,180274,'220:222:180274',1),
(152940,'40K Terrain & Scenery',6,44408,'220:233:16486:31398:44408',1),
(152942,'WFB Terrain & Scenery',6,44409,'220:233:16486:31398:44409',1),
(153004,'Other',4,175639,'11450:112425:175639',1),
(153008,'Shoes',4,36239,'888:7301:36239',1),
(153113,'Art Deco (1925 - 1940)',2,20081,'20081',0),
(153141,'Euro',4,45339,'11116:58507:45339',1),
(153149,'Pacific',3,58520,'11116:58520',0),
(153167,'Soda Syphons',3,3265,'1:3265',1),
(153170,'British Monarchy',4,39630,'1:13877:39630',0),
(153171,'Other British Monarchy',5,153170,'1:13877:39630:153170',1),
(153172,'Danish',4,39630,'1:13877:39630',1),
(153195,'Eggs',3,71183,'14339:71183',1),
(153204,'Vintage Craft Items',2,14339,'14339',1),
(153371,'Branded',4,170514,'870:50693:170514',0),
(153372,'Unbranded',4,170514,'870:50693:170514',0),
(153373,'Dishes, Plates',5,153372,'870:50693:170514:153372',1),
(153374,'Decanters',5,153372,'870:50693:170514:153372',1),
(153375,'Drinkware',5,153372,'870:50693:170514:153372',1),
(153376,'Ornaments',5,153372,'870:50693:170514:153372',1),
(153377,'Vases',5,153372,'870:50693:170514:153372',1),
(153378,'Self Representing Artists',3,170518,'870:170518',1),
(153379,'By State, Territory',3,3468,'260:3468',0),
(153380,'Antarctica',4,153379,'260:3468:153379',1),
(153381,'Christmas Island',4,153379,'260:3468:153379',1),
(153382,'Cocos Island',4,153379,'260:3468:153379',1),
(153383,'By Type',3,3468,'260:3468',0),
(153384,'Topics',4,153383,'260:3468:153383',0),
(153385,'Animation, Cartoons',5,153384,'260:3468:153383:153384',1),
(153386,'Building, Architecture',5,153384,'260:3468:153383:153384',1),
(153387,'Celebrities',5,153384,'260:3468:153383:153384',1),
(153388,'Nature',5,153384,'260:3468:153383:153384',1),
(153389,'Sport',5,153384,'260:3468:153383:153384',1),
(153390,'Transport, Space',5,153384,'260:3468:153383:153384',1),
(153391,'Other Topics',5,153384,'260:3468:153383:153384',1),
(153392,'Pre-Stamped Envelopes',5,111860,'260:3468:153383:111860',1),
(153401,'Shops, Money',3,19169,'220:19169',1),
(153410,'Angels',3,19266,'99:19266',1),
(153411,'Carvings',4,113795,'99:19266:113795',1),
(153545,'Mystery Boxes',2,99,'99',1),
(153564,'Socks',3,11452,'11450:11452',1),
(153797,'Socks & Tights',3,11462,'11450:11462',1),
(153913,'Moulding & Casting Materials',4,183313,'14339:183302:183313',1),
(153915,'Other Needle Felting',5,183211,'14339:160706:183209:183211',1),
(153928,'Bar Stools',3,3197,'11700:3197',1),
(154903,'Belly Belts, Bands',3,172378,'2984:172378',1),
(155056,'Wall Cladding, Plaster',3,3187,'11700:3187',1),
(155057,'Cable Guards',4,57215,'11700:3187:57215',1),
(155058,'Safety Switches',4,57215,'11700:3187:57215',1),
(155059,'External Features, Gables',3,3187,'11700:3187',1),
(155074,'Clothes Airers',4,20620,'11700:299:20620',1),
(155076,'Natural, Organic',4,20605,'11700:299:20605',1),
(155078,'Novelties',3,20625,'11700:20625',1),
(155083,'Leadlights',3,20697,'11700:20697',1),
(155093,'Personalised Gifts',3,16086,'11700:16086',1),
(155094,'Religious',3,16086,'11700:16086',1),
(155101,'Necklaces & Pendants',3,10968,'281:10968',1),
(155114,'Diamonds',3,40131,'281:40131',1),
(155139,'Sets',3,21557,'888:21557',1),
(155141,'Skimboards',4,166201,'888:22709:166201',1),
(155143,'Clothing',4,166096,'888:23806:166096',1),
(155144,'Protective Gear',4,166096,'888:23806:166096',1),
(155149,'Equipment',3,19292,'888:19292',1),
(155151,'Memorabilia',3,31636,'888:31636',1),
(155157,'Equipment',3,170497,'888:170497',1),
(155159,'Creative Services',2,316,'316',1),
(155183,'Tracksuits, Hoodies',3,1059,'11450:1059',1),
(155184,'Adult Unisex',2,11450,'11450',0),
(155185,'Adult Unisex Accessories',3,155184,'11450:155184',0),
(155187,'Belts',4,155185,'11450:155184:155185',1),
(155190,'Umbrellas',4,155185,'11450:155184:155185',1),
(155191,'Other',4,155185,'11450:155184:155185',1),
(155192,'Adult Unisex Clothing',3,155184,'11450:155184',0),
(155193,'T-Shirts',4,155192,'11450:155184:155192',1),
(155194,'Jumpers, Hoodies',4,155192,'11450:155184:155192',1),
(155195,'Jackets, Coats',4,155192,'11450:155184:155192',1),
(155196,'Adult Unisex Shoes',3,155184,'11450:155184',1),
(155197,'Other',4,155192,'11450:155184:155192',1),
(155198,'Children\'s Unisex Clothing',2,11450,'11450',0),
(155199,'Tops, T-Shirts',3,155198,'11450:155198',1),
(155200,'Jumpers, Hoodies',3,155198,'11450:155198',1),
(155201,'Jackets, Coats',3,155198,'11450:155198',1),
(155202,'Children\'s Unisex Shoes',2,11450,'11450',1),
(155203,'Other',3,155198,'11450:155198',1),
(155206,'Tracksuits, Hoodies',3,172378,'2984:172378',1),
(155226,'Tracksuits, Hoodies',3,15724,'11450:15724',1),
(155339,'Electronic Chess',4,40852,'220:233:40852',1),
(155344,'Accessories',3,163147,'11450:163147',0),
(155345,'Capes',4,155344,'11450:163147:155344',1),
(155347,'Footwear',4,155344,'11450:163147:155344',1),
(155348,'Gloves',4,155344,'11450:163147:155344',1),
(155349,'Hats',4,155344,'11450:163147:155344',1),
(155350,'Wigs, Facial Hair',4,155344,'11450:163147:155344',1),
(155351,'Wings',4,155344,'11450:163147:155344',1),
(155353,'Kimonos',3,20082,'20081:20082',1),
(155667,'Inhalers & Nebulisers',3,11778,'26395:11778',1),
(155707,'Cables & Adapters',3,15200,'625:15200',1),
(155817,'Flash Bulbs & Tubes',4,124848,'625:30078:124848',1),
(155823,'Sync Cords',3,64353,'625:64353',1),
(156196,'Fabric Art',2,550,'550',1),
(156320,'Brass',3,181726,'20081:181726',1),
(156322,'Other Antique Instruments',3,181726,'20081:181726',1),
(156346,'Religious',4,914,'1:124:914',1),
(156486,'Calendars (current)',3,45110,'267:45110',1),
(156521,'Vintage Non-Sport Cards',3,182982,'1:182982',1),
(156545,'Empty Ink Cartridges',4,11195,'58058:171961:11195',1),
(156595,'Strategy Guides & Cheats',2,1249,'1249',1),
(156597,'Prepaid Gaming Cards',2,1249,'1249',1),
(156623,'Contemporary Manufacture',4,180275,'220:222:180275',1),
(156693,'Levels',3,13849,'1:13849',1),
(156694,'Asian Ball-Jointed',3,238,'237:238',1),
(156697,'Signs',4,20687,'11700:20625:20687',1),
(156790,'Outfits & Sets',3,11452,'11450:11452',1),
(156801,'Outfits & Sets',3,11462,'11450:11462',1),
(156955,'GPS',2,293,'293',1),
(157009,'TV, Film & Game Replica Blades',3,1401,'1:1401',1),
(157027,'Latch Hooking',4,28147,'14339:160706:28147',0),
(157029,'Primitive Hand Hooking',4,28147,'14339:160706:28147',0),
(157030,'Primitive Hooking Kits',5,157029,'14339:160706:28147:157029',1),
(157031,'Primitive Hooking Patterns',5,157029,'14339:160706:28147:157029',1),
(157032,'Primitive Hooking Tools',5,157029,'14339:160706:28147:157029',1),
(157035,'Other Hand Hooking Supplies',5,157029,'14339:160706:28147:157029',1),
(157158,'DJ & PA Packages',3,48458,'619:48458',1),
(157161,'DJ Turntable Parts & Accs',3,48458,'619:48458',1),
(157777,'Pond Vacuums',4,93632,'11700:159912:93632',1),
(157802,'Pond Water Treatments',4,93632,'11700:159912:93632',1),
(157810,'Pond Water Test Kits',4,93632,'11700:159912:93632',1),
(157813,'Pond De-icers',4,93632,'11700:159912:93632',1),
(157816,'Gabion Baskets & Gabion Stones',4,177032,'11700:159912:177032',1),
(158323,'Charter Boat Hire',3,26429,'9800:26429',1),
(158352,'Brochures',4,135245,'170769:11748:135245',1),
(158354,'Appliances',3,13905,'1:13905',1),
(158356,'Toys',2,1,'1',0),
(158362,'Organic Food',2,14308,'14308',1),
(158363,'Slow Cookers',3,20667,'20710:20667',1),
(158365,'Deep Fryers',3,20667,'20710:20667',1),
(158379,'Websites',3,102480,'99:102480',1),
(158380,'Lampwork',3,50693,'870:50693',1),
(158381,'Environmental Services',2,316,'316',1),
(158384,'Life Jackets, Floatation',4,26450,'131090:26443:26450',1),
(158385,'Beacons, Distress',4,26450,'131090:26443:26450',1),
(158386,'Marine Audio Visual',4,31274,'131090:26443:31274',1),
(158395,'Trailer Parts, Accessories',3,26443,'131090:26443',1),
(158397,'12V Appliances',3,26443,'131090:26443',1),
(158399,'Anchors',4,26446,'131090:26443:26446',1),
(158400,'Cleats',4,26446,'131090:26443:26446',1),
(158401,'Fenders',4,26446,'131090:26443:26446',1),
(158402,'Winches',4,26446,'131090:26443:26446',1),
(158456,'Handle & Lock Sets',4,41976,'11700:3187:41976',1),
(158459,'Hardanger Kits',5,183197,'14339:160706:28141:183197',1),
(158509,'V8',4,33739,'131090:6030:33739',1),
(158511,'Aircraft',3,6747,'131090:6747',1),
(158522,'Novelties',4,50428,'131090:6747:50428',1),
(158656,'Mixed Media',3,60435,'550:60435',1),
(158666,'Anime & Manga',3,246,'220:246',1),
(158671,'Comic Book Heroes',3,246,'220:246',1),
(158672,'Designer & Urban Vinyl',3,246,'220:246',1),
(158679,'Military & Adventure',3,246,'220:246',1),
(158704,'Digital Control Devices',4,180339,'220:180250:180339',1),
(158713,'Dungeons & Dragons',4,16486,'220:233:16486',1),
(158714,'40K Spare Bits & Pieces',6,44408,'220:233:16486:31398:44408',1),
(158718,'Star Wars',4,16486,'220:233:16486',1),
(158742,'GeoTrax',4,2524,'220:19169:2524',1),
(158746,'Kitchen',3,19169,'220:19169',1),
(158747,'Tool Sets',3,19169,'220:19169',1),
(158816,'Drive Bay Caddies',3,165,'58058:165',1),
(158817,'Drive Enclosures & Docks',3,165,'58058:165',1),
(158837,'Keyboard Protectors',3,31530,'58058:31530',1),
(158840,'Monitor/AV Cables & Adapters',3,182094,'58058:182094',1),
(158845,'Monitor Power Supplies',3,162497,'58058:162497',1),
(158846,'Screen Protectors',3,31530,'58058:31530',1),
(158906,'Personal Finance, Tax & Legal',3,18793,'58058:18793',1),
(158911,'Drivers & Utilities',3,18793,'58058:18793',1),
(158913,'Clothing & Accessories',3,15273,'888:15273',0),
(158916,'Shoes',3,15273,'888:15273',0),
(158918,'Hats & Headwear',4,158913,'888:15273:158913',1),
(158919,'Support & Protective Gear',4,158913,'888:15273:158913',1),
(158920,'Other',4,158913,'888:15273:158913',1),
(158922,'Aquatic Fitness Equipment',4,28064,'888:15273:28064',1),
(158923,'Home Gyms',4,28066,'888:15273:28066',1),
(158925,'Push Up Stands',4,28066,'888:15273:28066',1),
(158926,'Weighted Vests',4,28066,'888:15273:28066',1),
(158927,'Yoga & Pilates',3,15273,'888:15273',0),
(158928,'Mats & Non-Slip Towels',4,158927,'888:15273:158927',1),
(158929,'Mat Carriers & Bags',4,158927,'888:15273:158927',1),
(158930,'Other',4,158927,'888:15273:158927',1),
(158937,'Golf Hats & Visors',4,181130,'888:1513:181130',1),
(158938,'Sport Protective Eyewear',4,181130,'888:1513:181130',1),
(158939,'Other Golf Clothing',4,181130,'888:1513:181130',1),
(158940,'Golf Car Cables & Parts',3,170140,'131090:170140',1),
(158941,'Golf Car Chargers',3,170140,'131090:170140',1),
(158942,'Golf Car Enclosures',3,170140,'131090:170140',1),
(158943,'Golf Car Windshields',3,170140,'131090:170140',1),
(158950,'Hydration',4,28064,'888:15273:28064',1),
(158951,'Safety & Reflective Gear',4,158913,'888:15273:158913',1),
(158952,'Men',4,158916,'888:15273:158916',1),
(158953,'Women',4,158916,'888:15273:158916',1),
(158954,'Youth',4,158916,'888:15273:158916',1),
(158960,'Vintage & Collectables',3,20835,'888:20835',1),
(158963,'Clothing, Footwear',3,21194,'888:21194',0),
(158974,'Other',4,158963,'888:21194:158963',1),
(158986,'Men',4,177862,'888:7294:177862',1),
(158987,'Women',4,177862,'888:7294:177862',1),
(158988,'Youth',4,177862,'888:7294:177862',1),
(158994,'Hats, Caps & Headbands',4,22682,'888:7294:22682',1),
(158995,'Other',4,22682,'888:7294:22682',1),
(158997,'Bicycle Stands & Storage',4,177832,'888:7294:177832',1),
(158998,'Other',4,177832,'888:7294:177832',1),
(158999,'Vintage Cycling',3,7294,'888:7294',0),
(159002,'Western Boots',4,27031,'888:3153:27031',1),
(159013,'Hay Nets & Bags',4,85214,'888:3153:85214',1),
(159014,'Tail Bags',4,57268,'888:3153:57268',1),
(159019,'Conchos',4,3161,'888:3153:3161',1),
(159030,'Hammocks',4,181403,'888:16034:181403',1),
(159035,'Hats & Headwear',4,36239,'888:7301:36239',1),
(159045,'Geocaching',2,888,'888',0),
(159046,'Caches',3,159045,'888:159045',1),
(159047,'Other',3,159045,'888:159045',1),
(159050,'Sliding Protection',4,73910,'888:16021:73910',1),
(159051,'Umpire\'s Protection',4,73910,'888:16021:73910',1),
(159052,'Clothing, Shoes & Accessories',3,16021,'888:16021',0),
(159057,'Hats & Headwear',4,159052,'888:16021:159052',1),
(159058,'Shoes & Cleats',4,159052,'888:16021:159052',0),
(159059,'Men\'s',5,159058,'888:16021:159052:159058',1),
(159060,'Women\'s',5,159058,'888:16021:159052:159058',1),
(159061,'Youth',5,159058,'888:16021:159052:159058',1),
(159062,'Other Baseball Clothing & Accs',4,159052,'888:16021:159052',1),
(159073,'Parts',3,16262,'888:16262',0),
(159076,'Other',4,159073,'888:16262:159073',1),
(159091,'Glow Sticks',4,106983,'888:16034:106983',1),
(159092,'Other',4,106983,'888:16034:106983',1),
(159094,'Hats & Headwear',4,72891,'888:16034:72891',1),
(159129,'Volleyball',2,888,'888',1),
(159155,'Other',4,21247,'888:36259:21247',1),
(159163,'Kneeboards',4,166101,'888:23806:166101',1),
(159178,'Clothing, Boots',3,20862,'888:20862',0),
(159179,'Other',4,159178,'888:20862:159178',1),
(159180,'Goals',3,20862,'888:20862',1),
(159181,'Training Aids',3,20862,'888:20862',1),
(159182,'Decals & Stickers',4,119236,'888:36259:119236',1),
(159183,'Hand & Foot Warmers',4,119236,'888:36259:119236',1),
(159184,'Stomp Pads',4,21247,'888:36259:21247',1),
(159189,'Other Toys',3,158356,'1:158356',1),
(159260,'Wholesale, Bulk Lots',2,58058,'58058',0),
(159336,'Empty Boxes',5,180280,'220:180250:19128:180280',1),
(159406,'Soil & Soil Amendments',5,179308,'11700:159912:2032:179308',1),
(159419,'Bark Chips & Mulch',5,179308,'11700:159912:2032:179308',1),
(159427,'Compost Aerators',5,181020,'11700:159912:2032:181020',1),
(159452,'Seed Starting Pots & Trays',5,179308,'11700:159912:2032:179308',1),
(159473,'Garden Clothing & Gear',4,2032,'11700:159912:2032',0),
(159680,'Microcontrollers & Programmers',6,181904,'170769:92074:182412:36330:181904',1),
(159682,'Bale Spears',4,177647,'170769:41489:177647',1),
(159684,'Sprayers',3,11748,'170769:11748',1),
(159695,'Paper Towel Dispensers',3,170639,'170638:170639',1),
(159710,'Other',3,58271,'170638:58271',1),
(159711,'Other',2,170638,'170638',1),
(159719,'Children\'s Fragrances',3,180345,'26395:180345',1),
(159730,'Detox & Cleansers',4,31817,'26395:180959:31817',1),
(159756,'Straight Razors',3,31762,'26395:31762',1),
(159757,'Children\'s Oral Care',3,31769,'26395:31769',1),
(159758,'Dental Floss & Flossers',3,31769,'26395:31769',1),
(159789,'Clipper & Trimmer Parts',3,31762,'26395:31762',1),
(159795,'Laser Hair Removal & IPL',3,31762,'26395:31762',1),
(159797,'Cold Sores',4,75036,'26395:67588:75036',1),
(159799,'Sleep Masks',4,82593,'26395:67588:82593',1),
(159805,'Brush Cleaners',4,36409,'26395:31786:36409',1),
(159806,'Sponges, Applicators & Cotton',4,36409,'26395:31786:36409',1),
(159807,'Other Makeup Tools & Accs.',4,36409,'26395:31786:36409',1),
(159874,'Reacher Grabbers',4,182118,'26395:11778:182118',1),
(159875,'Cholesterol Testing',4,30115,'26395:11778:30115',1),
(159876,'Drug Testing',4,30115,'26395:11778:30115',1),
(159878,'Emergency Alert Systems',4,182118,'26395:11778:182118',1),
(159879,'Ion Foot Baths',3,67659,'26395:67659',1),
(159880,'Self Help Audiovisuals',3,67659,'26395:67659',1),
(159881,'Light Therapy Devices',3,67659,'26395:67659',1),
(159882,'Neti Pots & Cleansers',3,67659,'26395:67659',1),
(159885,'Titanium Therapy Devices',3,67659,'26395:67659',1),
(159886,'Detox Pads',3,67659,'26395:67659',1),
(159889,'Wall Stickers',3,10033,'11700:10033',1),
(159895,'Replacement Parts',3,38219,'11700:38219',1),
(159897,'Storage Boxes',4,43502,'11700:299:43502',1),
(159898,'Storage Bins & Baskets',4,43502,'11700:299:43502',1),
(159903,'Microwave Parts',3,170737,'20710:170737',1),
(159909,'CCTV Systems',3,41968,'11700:41968',1),
(159912,'Yard, Garden & Outdoor Living',2,11700,'11700',0),
(159913,'Other Yard, Garden & Outdoor',3,159912,'11700:159912',1),
(159921,'Pool Fun',4,20727,'11700:159912:20727',0),
(159922,'Other Pool Fun',5,159921,'11700:159912:20727:159921',1),
(159926,'Other Outdoor Cooking & Eating',4,149242,'11700:159912:149242',1),
(159928,'Centerpieces & Table Décor',3,11827,'11700:11827',1),
(159929,'Other Lawnmowers',4,43560,'11700:159912:43560',1),
(159930,'Leaf Blower & Vacuum Parts',4,29518,'11700:159912:29518',1),
(159943,'Euphoniums',3,16212,'619:16212',1),
(159944,'Sousaphones',3,16212,'619:16212',1),
(159945,'Mellophones',3,16212,'619:16212',1),
(159946,'Cornets',4,118974,'619:181162:118974',1),
(159948,'Travel Guitars',3,3858,'619:3858',1),
(159952,'Custom',5,181222,'619:3858:180009:181222',1),
(159954,'Pianola/Player Pianos',5,181196,'619:181162:181193:181196',1),
(159955,'Audio Power Conditioners',3,180014,'619:180014',1),
(159982,'Voice',3,182150,'619:182150',1),
(160041,'English Show Accessories',4,16240,'888:3153:16240',1),
(160042,'Western Show Accessories',4,16240,'888:3153:16240',1),
(160560,'Scenery & Trees',5,81064,'220:180250:30654:81064',1),
(160640,'Instruction Books & Media',3,11783,'14339:11783',1),
(160670,'Other Leathercraft Accessories',4,183127,'14339:28131:183127',1),
(160671,'Other Rug Braiding',5,183226,'14339:160706:28147:183226',1),
(160672,'Other Rug Making Supplies',4,28147,'14339:160706:28147',1),
(160673,'Woodturning Hand Tools',3,3127,'14339:3127',1),
(160677,'Woodcarving Hand Tools',3,3127,'14339:3127',1),
(160704,'Crafting Pieces',3,28102,'14339:28102',0),
(160705,'Other Craft Supplies',4,160704,'14339:28102:160704',1),
(160706,'Needlecrafts & Yarn',2,14339,'14339',0),
(160708,'Fastenings & Tools',4,3094,'14339:160706:3094',1),
(160719,'Punch Needle Kits',5,183197,'14339:160706:28141:183197',1),
(160720,'Hand Embroidery Tools & Accs',4,28141,'14339:160706:28141',0),
(160721,'Hand Embroidery Hoops & Frames',5,160720,'14339:160706:28141:160720',1),
(160722,'Hand Emboridery Needles',5,160720,'14339:160706:28141:160720',1),
(160723,'Other Hand Embroidery Tools',5,160720,'14339:160706:28141:160720',1),
(160724,'Embroidery Machine Supplies',4,28141,'14339:160706:28141',0),
(160725,'Other Machine Embroidery',5,160724,'14339:160706:28141:160724',1),
(160732,'Flattened Bottle Caps',5,183591,'14339:11788:31253:183591',1),
(160733,'Chipboard Accents',5,183591,'14339:11788:31253:183591',1),
(160734,'Flower Embellishments',5,183591,'14339:11788:31253:183591',1),
(160736,'Mixed Lots',5,183591,'14339:11788:31253:183591',1),
(160737,'Sewing',2,14339,'14339',0),
(161001,'Grass Shears',4,29518,'11700:159912:29518',1),
(161008,'Edging & Borders',5,181027,'11700:159912:2032:181027',1),
(161015,'Lawn Rollers',5,181033,'11700:159912:2032:181033',1),
(161152,'Other',5,180314,'220:180250:122601:180314',1),
(161362,'Controllers',4,26189,'170769:11748:26189',1),
(161363,'Pipes',4,26189,'170769:11748:26189',1),
(161364,'Tanks',4,26189,'170769:11748:26189',1),
(161365,'Other Irrigation',4,26189,'170769:11748:26189',1),
(161368,'Hay',4,46526,'170769:11748:46526',1),
(161369,'Shearing',4,46526,'170769:11748:46526',1),
(161397,'Media',3,42935,'170769:42935',1),
(161401,'Mining',2,170769,'170769',0),
(161402,'Equipment',3,161401,'170769:161401',1),
(161403,'Other Mining Items',3,161401,'170769:161401',1),
(161415,'Quads, Trikes, Buggies',3,32073,'9800:32073',0),
(161416,'Buggies',4,161415,'9800:32073:161415',1),
(161417,'Quads',4,161415,'9800:32073:161415',1),
(161418,'Trikes',4,161415,'9800:32073:161415',1),
(161470,'Motor Parts',4,50440,'131090:26443:50440',1),
(161475,'Pirates',3,10860,'1:10860',1),
(161476,'Reapers',3,10860,'1:10860',1),
(161477,'Skeletons',3,10860,'1:10860',1),
(161478,'Witches',3,10860,'1:10860',1),
(161483,'Jars',3,13905,'1:13905',1),
(161492,'Rules',3,13849,'1:13849',1),
(161528,'Bags',3,329,'237:329',1),
(161534,'Media',2,237,'237',0),
(161535,'Books',3,161534,'237:161534',1),
(161536,'Magazines',3,161534,'237:161534',1),
(161580,'Ink',3,3122,'14339:3122',1),
(161581,'Pads',3,3122,'14339:3122',1),
(161585,'Scrapbooking Adhesives',4,31253,'14339:11788:31253',0),
(161586,'Glues & Pastes',4,183122,'14339:28102:183122',1),
(161648,'Dusters',4,20605,'11700:299:20605',1),
(161681,'Intercoms',3,41968,'11700:41968',1),
(161683,'Door Chimes',3,41968,'11700:41968',1),
(161694,'Tumblers',4,106191,'11700:20625:106191',1),
(161695,'Cups',4,106191,'11700:20625:106191',1),
(161696,'Glasses',4,106191,'11700:20625:106191',1),
(161698,'Sandwich Keepers',4,106191,'11700:20625:106191',1),
(161700,'Grinders',4,20635,'11700:20625:20635',1),
(161743,'Bangles',3,110633,'281:110633',1),
(161751,'Archery Sets & Kits',3,20835,'888:20835',1),
(161758,'Bowls',5,153372,'870:50693:170514:153372',1),
(161762,'Travel Wallets',3,93838,'11730:93838',1),
(161805,'Jerseys',3,4388,'888:4388',1),
(161806,'Sticks',3,4388,'888:4388',1),
(161823,'Fillet Tables & Cutting Boards',5,179990,'888:1492:179985:179990',1),
(161826,'Sinkers & Weights',4,179973,'888:1492:179973',1),
(161840,'Yachting Equipment',4,166096,'888:23806:166096',1),
(161848,'Banners',4,166227,'888:19292:166227',1),
(161849,'Flags',4,166227,'888:19292:166227',1),
(161850,'Clothing',3,19292,'888:19292',0),
(161851,'Gloves',4,161850,'888:19292:161850',1),
(161852,'Jackets',4,161850,'888:19292:161850',1),
(161853,'Shirts',4,161850,'888:19292:161850',1),
(161854,'Suits',4,161850,'888:19292:161850',1),
(161891,'Flags',4,159178,'888:20862:159178',1),
(161893,'Scarves',4,159178,'888:20862:159178',1),
(161944,'Cleaning',3,19169,'220:19169',1),
(161945,'Gardening',3,19169,'220:19169',1),
(161950,'Balls',3,11743,'220:11743',1),
(162007,'Incense Accessories',4,113803,'99:19266:113803',1),
(162034,'Food',3,20400,'2984:20400',1),
(162040,'Nursery Bedding Sets',3,20416,'2984:20416',1),
(162041,'Mattress Pads & Covers',3,20416,'2984:20416',1),
(162044,'Other Binoculars & Telescopes',3,28179,'625:28179',1),
(162045,'Batteries',3,15200,'625:15200',1),
(162046,'Chargers & Cradles',3,15200,'625:15200',1),
(162048,'Easels & Negative Carriers',4,182077,'625:69323:182077',1),
(162053,'Cleaning Equipment & Kits',3,15200,'625:15200',1),
(162054,'Cambodia',3,181416,'260:181416',1),
(162057,'Albums',3,181421,'260:181421',1),
(162058,'Magnifiers & Loupes',3,181421,'260:181421',1),
(162059,'Mounts & Hinges',3,181421,'260:181421',1),
(162062,'Scouting',3,4752,'260:4752',1),
(162070,'Other Transportation Stamps',4,181418,'260:4752:181418',1),
(162074,'Somalia',3,181423,'260:181423',1),
(162075,'Vintage Computers & Mainframes',3,11189,'58058:11189',1),
(162078,'Resin Craft Moulds & Supplies',4,160704,'14339:28102:160704',1),
(162081,'Quilt Blocks & Tops',4,180930,'14339:160737:180930',1),
(162091,'Kits',3,31723,'14339:31723',1),
(162133,'Leaf & Flake',4,45134,'11116:178078:45134',1),
(162134,'Scrap & Recovered Gold',4,45134,'11116:178078:45134',1),
(162152,'Malaysia',4,40711,'11116:58520:40711',1),
(162183,'Bed Guards',3,20433,'2984:20433',1),
(162190,'Malaysia',4,8008,'11116:58507:8008',1),
(162193,'Singapore',4,8008,'11116:58507:8008',1),
(162195,'New Zealand',4,45337,'11116:58507:45337',1),
(162480,'Other Camera & Photo Accs',3,15200,'625:15200',1),
(162485,'Binocular Cases & Accessories',3,28179,'625:28179',1),
(162497,'Monitors, Projectors & Accs',2,58058,'58058',0),
(162585,'Boxes',3,20082,'20081:20082',1),
(162588,'Bowls',3,20082,'20081:20082',1),
(162591,'Cups, Mugs',3,20082,'20081:20082',1),
(162594,'Glasses',3,20082,'20081:20082',1),
(162597,'Plates',3,20082,'20081:20082',1),
(162600,'Pots',3,20082,'20081:20082',1),
(162603,'Vases',3,20082,'20081:20082',1),
(162606,'Cabinets',3,20082,'20081:20082',1),
(162609,'Chairs',3,20082,'20081:20082',1),
(162612,'Tables',3,20082,'20081:20082',1),
(162615,'Military',3,20082,'20081:20082',1),
(162618,'Necklaces, Pendants',3,20082,'20081:20082',1),
(162621,'Snuff Bottles',3,20082,'20081:20082',1),
(162626,'Paintings',3,20082,'20081:20082',1),
(162629,'Scrolls',3,20082,'20081:20082',1),
(162653,'Kitchen Tools',3,20086,'20081:20086',1),
(162674,'Plates, Platters',4,63521,'20081:20086:63521',1),
(162725,'Atlases',3,37958,'20081:37958',1),
(162731,'Maps',3,37958,'20081:37958',1),
(162743,'Ship Equipment',3,37965,'20081:37965',1),
(162767,'Fragments',3,181677,'20081:181677',1),
(162782,'Art Nouveau',2,20081,'20081',1),
(162785,'Art',3,153113,'20081:153113',1),
(162788,'Décor',3,153113,'20081:153113',1),
(162791,'Furniture',3,153113,'20081:153113',1),
(162794,'Statues',3,153113,'20081:153113',1),
(162806,'Sculptures',3,113357,'550:113357',1),
(162809,'Paintings',3,113357,'550:113357',1),
(162939,'Amulets',3,20082,'20081:20082',1),
(162941,'Bells',3,20082,'20081:20082',1),
(162942,'Fans',3,20082,'20081:20082',1),
(162943,'Incense Burners',3,20082,'20081:20082',1),
(162945,'Masks',3,20082,'20081:20082',1),
(162946,'Rings',3,20082,'20081:20082',1),
(162947,'Seals',3,20082,'20081:20082',1),
(162963,'Swords (Chinese)',3,20082,'20081:20082',1),
(162964,'Tea Caddies',3,20082,'20081:20082',1),
(162965,'Teapots',3,20082,'20081:20082',1),
(162966,'Bracelets',3,20082,'20081:20082',1),
(162967,'Brush Pots',3,20082,'20081:20082',1),
(162968,'Brush Washers',3,20082,'20081:20082',1),
(162978,'Tsuba',3,20082,'20081:20082',1),
(162993,'Compotes',4,63538,'20081:20086:63538',1),
(162994,'Jugs',4,63538,'20081:20086:63538',1),
(162995,'Dishes',4,63538,'20081:20086:63538',1),
(163004,'Jugs',4,63521,'20081:20086:63521',1),
(163101,'Restoration & Care',2,20081,'20081',1),
(163147,'Costumes',2,11450,'11450',0),
(163149,'Other',3,163147,'11450:163147',1),
(163175,'Bottoms',4,147192,'2984:3082:147192',1),
(163222,'Accessories',3,3082,'2984:3082',0),
(163224,'Hats',4,163222,'2984:3082:163222',1),
(163226,'Other',4,163222,'2984:3082:163222',1),
(163351,'Dresses',4,147192,'2984:3082:147192',1),
(163397,'Unisex',3,3082,'2984:3082',0),
(163399,'Outerwear',4,163397,'2984:3082:163397',1),
(163400,'Sleepwear',4,163397,'2984:3082:163397',1),
(163401,'Tops, T-Shirts',4,163397,'2984:3082:163397',1),
(163402,'Mixed Items',4,163397,'2984:3082:163397',1),
(163424,'Bottoms',4,163397,'2984:3082:163397',1),
(163425,'One-Pieces',4,163397,'2984:3082:163397',1),
(163427,'Outfits, Sets',4,163397,'2984:3082:163397',1),
(163486,'Jackets',4,50935,'170638:11874:50935',1),
(163489,'Coffee Accessories',3,11874,'170638:11874',0),
(163492,'Tampers',4,163489,'170638:11874:163489',1),
(163493,'Displays, Warmers',3,11874,'170638:11874',0),
(163495,'Warmers',4,163493,'170638:11874:163493',1),
(163497,'Cutters',3,26238,'170638:26238',1),
(163498,'Plotters',3,26238,'170638:26238',1),
(163499,'Rolls',3,26238,'170638:26238',1),
(163537,'Backpacks, Bags',4,155185,'11450:155184:155185',1),
(163542,'Belt Buckles',4,155185,'11450:155184:155185',1),
(163543,'Hats',4,155185,'11450:155184:155185',1),
(163560,'Hair Accessories',4,106127,'11450:3259:106127',1),
(163570,'Handbag Accessories',3,4251,'11450:4251',1),
(163573,'Belt Buckles',3,4251,'11450:4251',1),
(163581,'Other Extensions & Wigs',4,182101,'26395:11854:182101',1),
(163586,'Garter Belts',3,11514,'11450:11514',1),
(163587,'Leg Warmers',4,11524,'11450:15724:11524',1),
(163588,'Socks',4,11524,'11450:15724:11524',1),
(163593,'Breast Forms, Enhancers',3,11514,'11450:11514',1),
(163600,'Belt Buckles',4,182059,'11450:175759:182059',1),
(163601,'Belts',4,182059,'11450:175759:182059',1),
(163606,'Clothes Hangers',4,182059,'11450:175759:182059',1),
(163607,'Collars',4,182059,'11450:175759:182059',1),
(163608,'Handkerchiefs',4,182059,'11450:175759:182059',1),
(163619,'Men\'s Hats',4,182059,'11450:175759:182059',1),
(163627,'Shoe Accessories',4,182059,'11450:175759:182059',1),
(163628,'Men\'s Vintage Shoes',3,175759,'11450:175759',1),
(163768,'TV Boards, Parts & Components',3,71582,'172176:71582',1),
(163769,'Replacement Parts & Tools',3,15052,'293:15052',1),
(163824,'Metal Detector Accessories',3,14948,'293:14948',1),
(163826,'Video Glasses',3,14948,'293:14948',1),
(163827,'Pocket Digital Scales',3,14948,'293:14948',1),
(163828,'Other Karaoke Entertainment',4,175696,'293:14969:175696',1),
(163851,'Vintage Blank Media',5,175741,'293:183077:175740:175741',1),
(163853,'Ham Radio Amplifiers',4,4670,'293:1500:4670',1),
(163862,'Other DJ Equipment',3,48458,'619:48458',1),
(163896,'Amplifiers',3,180014,'619:180014',1),
(164114,'Props',3,1424,'11232:1424',1),
(164116,'Wardrobe',3,1424,'11232:1424',1),
(164151,'Trackers',3,41979,'293:41979',1),
(164295,'European',4,92738,'281:10968:92738',1),
(164296,'European',4,92744,'281:10968:92744',1),
(164310,'Wedding Party Jewellery',3,91427,'281:91427',1),
(164311,'Other',3,91427,'281:91427',1),
(164324,'Sets',3,4196,'281:4196',1),
(164329,'Necklaces & Pendants',3,4196,'281:4196',1),
(164352,'Jewellery Design & Repair',2,281,'281',0),
(164353,'Findings',3,164352,'281:164352',0),
(164354,'Crimp & End Beads',4,164353,'281:164352:164353',1),
(164355,'Jump Rings & Split Rings',4,164353,'281:164352:164353',1),
(164356,'Other',4,164353,'281:164352:164353',1),
(164372,'Other',3,10321,'281:10321',1),
(164391,'Ammolite',4,181077,'281:491:181077',1),
(164392,'Diaspore',4,181077,'281:491:181077',1),
(164393,'Labradorite',4,181077,'281:491:181077',1),
(164394,'Sphene/Titanite',4,181077,'281:491:181077',1),
(164395,'Sunstone',4,181077,'281:491:181077',1),
(164398,'Other Emeralds',5,10218,'281:491:181077:10218',1),
(164406,'Other Rubies',5,10254,'281:491:181077:10254',1),
(164408,'Other Sapphires',5,10259,'281:491:181077:10259',1),
(164580,'Media',2,11233,'11233',0),
(164603,'Chisels',4,3244,'11700:631:3244',1),
(164610,'Tile Cutters',4,3244,'11700:631:3244',1),
(164613,'Parts, Accessories',3,631,'11700:631',0),
(164625,'Work Lights',4,3247,'11700:631:3247',1),
(164628,'Drills',4,3247,'11700:631:3247',1),
(164638,'By Biagi',4,92744,'281:10968:92744',1),
(164640,'By Biagi',4,92738,'281:10968:92738',1),
(164641,'By Juicy Couture',4,92738,'281:10968:92738',1),
(164642,'By Pandora',4,92738,'281:10968:92738',1),
(164643,'By Troll',4,92738,'281:10968:92738',1),
(164644,'By Juicy Couture',4,92744,'281:10968:92744',1),
(164645,'By Pandora',4,92744,'281:10968:92744',1),
(164646,'By Troll',4,92744,'281:10968:92744',1),
(164686,'Memorabilia',3,123687,'888:123687',1),
(164741,'Merchandise',3,123687,'888:123687',0),
(164742,'Tazos',4,164741,'888:123687:164741',1),
(164761,'Other Merchandise',4,164741,'888:123687:164741',1),
(164767,'Merchandise',3,21563,'888:21563',0),
(164800,'Luggage Tags',3,93838,'11730:93838',1),
(164856,'Books',3,164580,'11233:164580',1),
(164857,'Magazines',3,164580,'11233:164580',1),
(164874,'Home Telephones & Accessories',2,15032,'15032',0),
(164887,'Team Merchandise',3,21557,'888:21557',1),
(165144,'Watches for Parts',4,173696,'281:14324:173696',1),
(165173,'Magazines',4,135245,'170769:11748:135245',1),
(165179,'Motors',3,11748,'170769:11748',1),
(165266,'Other',3,34,'1:34',1),
(165505,'Banking, Insurance',3,34,'1:34',1),
(165580,'Mixed Lots',4,182981,'1:1401:182981',1),
(165583,'Spears & Spear Heads',3,1401,'1:1401',1),
(165584,'Middle Eastern',4,43336,'1:1401:43336',1),
(165741,'Model Cars & Trucks',4,50428,'131090:6747:50428',1),
(165800,'Souvenirs',2,1,'1',1),
(165930,'Swimbaits',4,179961,'888:1492:179961',1),
(165931,'Tackle Craft',4,179961,'888:1492:179961',1),
(165978,'Decals',5,81055,'220:180250:19119:81055',1),
(165982,'Decals',5,180280,'220:180250:19128:180280',1),
(165985,'Decals',5,180287,'220:180250:19143:180287',1),
(165987,'Decals',5,81043,'220:180250:19145:81043',1),
(165989,'Decals',5,80979,'220:180250:19151:80979',1),
(165995,'Clothes',3,2408,'237:2408',1),
(165996,'Eyes',3,2408,'237:2408',1),
(165997,'Stands',3,2408,'237:2408',1),
(166018,'Craft Books, Magazines',2,14339,'14339',0),
(166019,'Books',3,166018,'14339:166018',1),
(166020,'Magazines',3,166018,'14339:166018',1),
(166030,'Armbands',3,9394,'15032:9394',1),
(166096,'Equipment',3,23806,'888:23806',0),
(166097,'Bindings',4,166096,'888:23806:166096',1),
(166098,'Tow Ropes',4,166096,'888:23806:166096',1),
(166100,'Other Equipment',4,166096,'888:23806:166096',1),
(166101,'Watercraft',3,23806,'888:23806',0),
(166102,'Ski Tubes',4,166101,'888:23806:166101',1),
(166105,'Memorabilia',3,109938,'888:109938',1),
(166106,'Merchandise',3,109938,'888:109938',1),
(166107,'Australian Rules (AFL) Cards',3,212,'888:212',1),
(166126,'Fire Starters',4,181411,'888:16034:181411',1),
(166129,'Pocket Knives',4,75232,'888:16034:75232',1),
(166132,'Table Cloths',4,75184,'888:21567:75184',1),
(166149,'Stopwatches',4,44075,'888:15273:44075',1),
(166159,'Other Reels',4,179950,'888:1492:179950',1),
(166161,'Other Rods',4,179946,'888:1492:179946',1),
(166192,'Beanies',4,23825,'888:16262:23825',1),
(166193,'Hoodies',4,23825,'888:16262:23825',1),
(166195,'Streetboards',3,16262,'888:16262',1),
(166198,'Nets',3,13340,'888:13340',1),
(166201,'Boards',3,22709,'888:22709',0),
(166203,'Other Boards',4,166201,'888:22709:166201',1),
(166205,'Shorts',4,151563,'888:22709:151563',1),
(166206,'Swim Shirts',4,151563,'888:22709:151563',1),
(166210,'Windsurfing Boards',4,166201,'888:22709:166201',1),
(166211,'Windsurfing Sails',4,71164,'888:22709:71164',1),
(166212,'Caps',4,164767,'888:21563:164767',1),
(166213,'Jerseys',4,164767,'888:21563:164767',1),
(166214,'Polo Shirts',4,164767,'888:21563:164767',1),
(166227,'Merchandise',3,19292,'888:19292',0),
(166228,'Other Merchandise',4,166227,'888:19292:166227',1),
(166229,'Other Clothing',4,161850,'888:19292:161850',1),
(166235,'Merchandise',3,20862,'888:20862',1),
(166244,'Overnight Bags',3,16080,'11730:16080',1),
(166325,'Garment Racks',4,43502,'11700:299:43502',1),
(166570,'Poker Chips',4,180350,'220:233:180350',1),
(166571,'Playing Cards',4,180350,'220:233:180350',1),
(166572,'Card Tables & Tabletops',4,180350,'220:233:180350',1),
(166672,'Plasma Cutters',5,182897,'170769:182941:34095:182897',1),
(166673,'Menu Boards',4,57093,'170638:11874:57093',1),
(166674,'Sign Holders',4,57093,'170638:11874:57093',1),
(166675,'Signs',3,11890,'170638:11890',1),
(166682,'Indonesia',4,8008,'11116:58507:8008',1),
(166695,'Socks',4,155185,'11450:155184:155185',1),
(166696,'Jeans, Pants, Shorts',4,155192,'11450:155184:155192',1),
(166704,'Scripts',3,1424,'11232:1424',1),
(166722,'Die Cutting Vinyl',4,183239,'14339:11788:183239',1),
(166729,'Wall Sculptures',3,10033,'11700:10033',1),
(166738,'Perms',3,11854,'26395:11854',1),
(166764,'Maxi Cards',3,7898,'260:7898',1),
(166766,'Angola',3,181423,'260:181423',1),
(166767,'Benin',3,181423,'260:181423',1),
(166768,'Botswana',3,181423,'260:181423',1),
(166769,'Burkina Faso',3,181423,'260:181423',1),
(166770,'Chad',3,181423,'260:181423',1),
(166772,'Ethiopia',3,181423,'260:181423',1),
(166774,'Lesotho',3,181423,'260:181423',1),
(166775,'Liberia',3,181423,'260:181423',1),
(166776,'Libya',3,181423,'260:181423',1),
(166777,'Mali',3,181423,'260:181423',1),
(166779,'Niger',3,181423,'260:181423',1),
(166780,'Senegal',3,181423,'260:181423',1),
(166782,'Tanzania',3,181423,'260:181423',1),
(166800,'Dioramas',4,180278,'220:222:180278',1),
(167125,'Door Closers',4,41976,'11700:3187:41976',1),
(167217,'Driving Bits',4,85178,'888:3153:85178',1),
(167220,'Carts & Carriages',4,85178,'888:3153:85178',1),
(167243,'Saddle Bags',4,3159,'888:3153:3159',1),
(167251,'Fly Masks',4,57268,'888:3153:57268',1),
(167272,'Door Automation',3,170211,'170638:170211',1),
(167309,'Unisex Jewellery',2,281,'281',0),
(167310,'Bracelets',3,167309,'281:167309',1),
(167311,'Chains, Necklaces',3,167309,'281:167309',1),
(167312,'Earrings',3,167309,'281:167309',1),
(167313,'Pendants',3,167309,'281:167309',1),
(167314,'Rings',3,167309,'281:167309',1),
(167315,'Sets',3,167309,'281:167309',1),
(167316,'Other Unisex Jewellery',3,167309,'281:167309',1),
(167324,'Helmets',4,23825,'888:16262:23825',1),
(167805,'Other Anchoring, Mooring',4,26446,'131090:26443:26446',1),
(167842,'Evaporative Coolers',3,20667,'20710:20667',1),
(167846,'Pool Hoses',5,181061,'11700:159912:20727:181061',1),
(167847,'Pool Ladders & Steps',5,181067,'11700:159912:20727:181067',1),
(167851,'Pool Fences',5,181067,'11700:159912:20727:181067',1),
(167862,'Pool & Spa Lights',5,181067,'11700:159912:20727:181067',1),
(167867,'Baskets',5,79692,'11700:159912:149242:79692',1),
(167868,'Cooler Bags',5,79692,'11700:159912:149242:79692',1),
(167869,'Rugs',5,79692,'11700:159912:149242:79692',1),
(167870,'Sets',5,79692,'11700:159912:149242:79692',1),
(167871,'Vacuum Flasks',5,79692,'11700:159912:149242:79692',1),
(167902,'Handkerchiefs',3,4250,'11450:4250',1),
(167903,'Outfits, Sets',3,172378,'2984:172378',1),
(167906,'Handkerchiefs',3,4251,'11450:4251',1),
(167923,'Cables & Adapters',4,45066,'15032:45065:45066',1),
(167924,'Headsets',4,45066,'15032:45065:45066',1),
(167926,'Styluses',4,45066,'15032:45065:45066',1),
(167928,'Screen Protectors',3,15200,'625:15200',1),
(167930,'Viewfinders & Eyecups',3,15200,'625:15200',1),
(167938,'Telescope Mounts',4,74922,'625:28179:74922',1),
(167943,'Vintage Film',3,3326,'625:3326',1),
(168058,'Internet & Media Streamers',2,172176,'172176',1),
(168059,'Power Supply Testers',3,175673,'58058:175673',1),
(168060,'Motherboard Diagnostic Cards',4,182090,'58058:175673:182090',1),
(168061,'Other Laptop Replacement Parts',4,182089,'58058:175673:182089',1),
(168068,'Monitor Replacement Parts',3,162497,'58058:162497',1),
(168074,'Server Fans & Cooling Systems',4,51240,'58058:175698:51240',1),
(168088,'Other Vintage A/V Parts & Accs',5,175741,'293:183077:175740:175741',1),
(168093,'Armbands',4,56169,'293:15052:56169',1),
(168096,'Screen Protectors',4,56169,'293:15052:56169',1),
(168103,'Cases, Skins',3,139836,'293:139836',1),
(168104,'Screen Protectors',3,139836,'293:139836',1),
(168112,'Clocks, Watches',3,196,'11232:196',1),
(168129,'Acoustic Treatments',3,180014,'619:180014',1),
(168134,'Impact Drivers',4,3247,'11700:631:3247',1),
(168135,'Impact Wrenches',4,3247,'11700:631:3247',1),
(168159,'Jewellery Holders & Organisers',3,10321,'281:10321',1),
(168167,'Kornerupine',4,181077,'281:491:181077',1),
(168189,'Card Boxes',3,11827,'11700:11827',1),
(168191,'Shaving Brushes & Mugs',3,31762,'26395:31762',1),
(168192,'Tattoo Removal Machines',3,33914,'26395:33914',1),
(168244,'Viewmasters',3,717,'220:717',1),
(168247,'Tether Cars',3,2562,'220:2562',1),
(168248,'Other RC & Control Line',3,2562,'220:2562',1),
(168693,'Salvage Cars',3,29690,'9800:29690',1),
(168763,'Waffle Makers',3,20667,'20710:20667',1),
(168867,'Lanterns',4,106983,'888:16034:106983',1),
(168875,'Accessories & Cases',4,106983,'888:16034:106983',1),
(168998,'Fascinators',3,4251,'11450:4251',1),
(169164,'Hole Diggers & Augers',4,29518,'11700:159912:29518',1),
(169278,'Gloves, Mittens',4,155185,'11450:155184:155185',1),
(169281,'Scarves, Bandanas',4,155185,'11450:155184:155185',1),
(169283,'Wallets',4,155185,'11450:155184:155185',1),
(169291,'Women\'s Bags',2,11450,'11450',1),
(169362,'GPS/Navigation',3,3270,'131090:3270',1),
(169391,'Power Inverters',4,60207,'131090:3270:60207',1),
(169978,'India',3,181416,'260:181416',1),
(170062,'Tube Testers',5,181998,'170769:92074:181939:181998',1),
(170066,'Digital Camera Backs',3,69323,'625:69323',1),
(170067,'Vintage Manuals & Guides',3,3326,'625:3326',1),
(170078,'Fan, Heat Sink Brackets & Accs',4,42000,'58058:175673:42000',1),
(170080,'Motherboard Backplates',4,182090,'58058:175673:182090',1),
(170082,'Other Motherboard Accessories',4,182090,'58058:175673:182090',1),
(170083,'Memory (RAM)',3,175673,'58058:175673',1),
(170088,'Cables & Interconnects',3,12922,'619:12922',1),
(170089,'Other Stage Lighting & Effects',3,12922,'619:12922',1),
(170098,'Greeting Cards & Invitations',3,16086,'11700:16086',1),
(170115,'Other',3,16086,'11700:16086',1),
(170131,'Bowling Cards',3,212,'888:212',1),
(170134,'Mixed Martial Arts (MMA) Cards',3,212,'888:212',1),
(170135,'Price Guides & Publications',3,212,'888:212',1),
(170137,'Other Stamps',2,260,'260',1),
(170140,'Golf Car Parts & Accessories',2,131090,'131090',0),
(170141,'Wheel Hubs & Bearings',4,33743,'131090:6030:33743',1),
(170171,'Keepsakes',3,117388,'2984:117388',1),
(170178,'Other Silver',3,20096,'20081:20096',1),
(170182,'Statues',3,20082,'20081:20082',1),
(170203,'Pots, Pans, Bowls',4,25367,'170638:11874:25367',1),
(170205,'Carts',3,11759,'170638:11759',1),
(170206,'Market Stalls',3,11759,'170638:11759',1),
(170210,'Memorabilia',3,161401,'170769:161401',1),
(170211,'Security',2,170638,'170638',0),
(170212,'Dividers',3,11828,'170638:11828',1),
(170213,'Storage Cabinets',3,11828,'170638:11828',1),
(170220,'Central America',4,45145,'11116:58520:45145',1),
(170243,'Religious',3,3913,'1:3913',1),
(170248,'Boxes',4,13777,'1:13905:13777',1),
(170249,'Christmas, Holiday',4,13777,'1:13905:13777',1),
(170253,'Biscuit Tins',3,13905,'1:13905',1),
(170273,'Mixed Postcards',4,914,'1:124:914',1),
(170274,'Gramophone',3,29832,'1:29832',1),
(170280,'Pins',3,32615,'1:32615',1),
(170281,'Posters, Photographic',2,1,'1',0),
(170300,'Finished Needlearts',3,71183,'14339:71183',1),
(170301,'Other Mosaic',3,11787,'14339:11787',1),
(170308,'Other Scrapbooking Tools',5,83981,'14339:11788:31253:83981',1),
(170313,'Vintage Fabric',3,13905,'1:13905',1),
(170412,'Other Fasteners',4,180974,'11700:3187:180974',1),
(170416,'Crepe Makers',3,20667,'20710:20667',1),
(170419,'Other Accessories',4,71259,'14308:179836:71259',1),
(170423,'Other Picnicware',5,79692,'11700:159912:149242:79692',1),
(170489,'Clothing',3,123687,'888:123687',1),
(170497,'Horse Racing',2,888,'888',0),
(170514,'Crystal',3,50693,'870:50693',0),
(170515,'Tableware',4,70071,'870:24:70071',1),
(170516,'Other Asian, Oriental',4,91012,'870:24:91012',1),
(170517,'Chinese',4,91012,'870:24:91012',1),
(170518,'Australian Pottery',2,870,'870',0),
(170524,'Mixed',5,3472,'260:3468:153383:3472',1),
(170526,'Mixed',5,3473,'260:3468:153383:3473',1),
(170544,'Other Glow Products',3,111882,'220:111882',1),
(170547,'Other Air Models',4,1189,'220:1188:1189',1),
(170548,'Cars',4,2580,'220:1188:2580',1),
(170575,'Other Branded',5,153371,'870:50693:170514:153371',1),
(170596,'Franchises',3,11759,'170638:11759',1),
(170597,'Privacy Filters',3,31530,'58058:31530',1),
(170599,'Other Printer & Scanner Accs',4,182086,'58058:171961:182086',1),
(170601,'Scanner Parts',4,182086,'58058:171961:182086',1),
(170605,'Capacitors',5,181223,'619:3858:180009:181223',1),
(170608,'Hong Kong SAR',3,181416,'260:181416',1),
(170610,'Dictionaries',3,171273,'267:171273',1),
(170626,'Lint Removers',3,106121,'11450:106121',1),
(170633,'MechWarrior',4,16486,'220:233:16486',1),
(170638,'Business',1,-1,'',0),
(170639,'Bathroom',2,170638,'170638',0),
(170641,'Paper Towels',3,170639,'170638:170639',1),
(170643,'Vending Machine Accessories',2,170638,'170638',0),
(170644,'Locks',3,170643,'170638:170643',1),
(170645,'Parts',3,170643,'170638:170643',1),
(170646,'Other',3,170643,'170638:170643',1),
(170650,'Combos',4,57093,'170638:11874:57093',1),
(170652,'Displays',3,11890,'170638:11890',0),
(170653,'Hangers',4,170652,'170638:11890:170652',1),
(170654,'Holders',4,170652,'170638:11890:170652',1),
(170655,'Racks',4,170652,'170638:11890:170652',1),
(170656,'Stands',4,170652,'170638:11890:170652',1),
(170657,'Paper Cups',4,163489,'170638:11874:163489',1),
(170658,'Drums',3,67076,'170638:67076',1),
(170729,'Pressure Cookers',3,20667,'20710:20667',1),
(170730,'Slushie Makers',3,20667,'20710:20667',1),
(170737,'Accessories, Parts',2,20710,'20710',0),
(170740,'Coffee Machine Parts',3,170737,'20710:170737',1),
(170743,'Water Filter Cartridges',3,170737,'20710:170737',1),
(170744,'Other',3,170737,'20710:170737',1),
(170745,'Files',4,3244,'11700:631:3244',1),
(170746,'Mallets',4,3244,'11700:631:3244',1),
(170750,'Brick Saws',4,46585,'170769:64808:46585',1),
(170751,'Drop Saws',4,46585,'170769:64808:46585',1),
(170753,'Hammers',3,41489,'170769:41489',1),
(170754,'Motors',3,41489,'170769:41489',1),
(170755,'Ramps',3,41489,'170769:41489',1),
(170756,'Tracks',3,41489,'170769:41489',1),
(170763,'Food Dehydrators',3,11748,'170769:11748',1),
(170764,'Hanging Scales',3,11748,'170769:11748',1),
(170765,'Hose Joiners',4,26189,'170769:11748:26189',1),
(170766,'Hose Nozzles',4,26189,'170769:11748:26189',1),
(170767,'Hoses',4,26189,'170769:11748:26189',1),
(170768,'Sprinklers',4,26189,'170769:11748:26189',1),
(170769,'Industrial',1,-1,'',0),
(170778,'Fencing',2,170769,'170769',0),
(170779,'Electric Fence Chargers',3,170778,'170769:170778',1),
(170780,'Fence Posts',3,170778,'170769:170778',1),
(170781,'Gates',3,170778,'170769:170778',1),
(170782,'Insulators',3,170778,'170769:170778',1),
(170783,'Mesh',3,170778,'170769:170778',1),
(170788,'Concrete Cutters',3,64808,'170769:64808',1),
(170789,'Glue Guns',3,64808,'170769:64808',1),
(170794,'Stackers',3,64808,'170769:64808',1),
(170798,'Hardware Parts',2,170769,'170769',0),
(170799,'Batteries',3,170798,'170769:170798',1),
(170800,'Chargers',3,170798,'170769:170798',1),
(170801,'Flap Discs',3,170798,'170769:170798',1),
(170803,'Other',3,170798,'170769:170798',1),
(170805,'Bulldozers',3,177641,'170769:177641',1),
(170816,'Wholesale, Bulk Lots',2,170769,'170769',1),
(170820,'Wakeboard Bindings',4,71164,'888:22709:71164',1),
(170821,'Dry Bags',4,166096,'888:23806:166096',1),
(170822,'Oars',4,166096,'888:23806:166096',1),
(170827,'Pre-Decimal',4,45142,'11116:58520:45142',1),
(171104,'Transmission & Components',4,50440,'131090:26443:50440',1),
(171107,'Engines & Engine Parts',3,14780,'131090:14780',0),
(171108,'Complete Engines',4,171107,'131090:14780:171107',1),
(171111,'Golf Car Wheels & Tyres',3,170140,'131090:170140',1),
(171127,'Cars: Racing',3,222,'220:222',0),
(171134,'Vehicle Parts',4,180278,'220:222:180278',1),
(171135,'Display Cases & Stands',4,180278,'220:222:180278',1),
(171136,'Stickers, Decals & Iron-Ons',4,180278,'220:222:180278',1),
(171137,'Buildings & Set Parts',4,180278,'220:222:180278',1),
(171138,'Tanks & Military Vehicles',3,222,'220:222',1),
(171145,'Simulators',3,2562,'220:2562',1),
(171198,'Price Guides & Publications',3,182982,'1:182982',1),
(171202,'Price Guides & Publications',3,1401,'1:1401',1),
(171210,'Children & YA Non-Fiction',3,182882,'267:182882',1),
(171220,'Children\'s Fiction',3,182882,'267:182882',1),
(171222,'Young Adult Fiction',3,182882,'267:182882',1),
(171228,'Fiction Books',2,267,'267',1),
(171243,'Non-Fiction Books',2,267,'267',1),
(171273,'Dictionaries & Reference',2,267,'267',0),
(171274,'Encyclopedias',3,171273,'267:171273',1),
(171276,'Children\'s Picture Books',3,182882,'267:182882',1),
(171306,'Thesauruses',3,171273,'267:171273',1),
(171308,'Other',3,171273,'267:171273',1),
(171355,'Books On Disc',2,267,'267',1),
(171485,'Tablets & eBook Readers',2,58058,'58058',1),
(171488,'Travel Guides',2,267,'267',1),
(171491,'Graphic Novels',2,267,'267',1),
(171533,'Fusers',3,67076,'170638:67076',1),
(171535,'Toilet Frames & Commodes',4,182113,'26395:11778:182113',1),
(171536,'Crutches',4,28175,'26395:11778:28175',1),
(171537,'Handles & Rails',4,182113,'26395:11778:182113',1),
(171538,'Oximeters',4,30115,'26395:11778:30115',1),
(171540,'Toilet Seats',4,182113,'26395:11778:182113',1),
(171584,'Welding Helmet & Goggle Lenses',5,67044,'170769:182941:34095:67044',1),
(171585,'Plasma Cutter Tips & Nozzles',5,182912,'170769:182941:34095:182912',1),
(171586,'Nozzles, Collets & Lenses',5,182908,'170769:182941:34095:182908',1),
(171593,'Vibration Machines',4,28059,'888:15273:28059',1),
(171668,'Faceplates, Decals & Stickers',3,54968,'1249:54968',1),
(171787,'Other',3,14112,'99:14112',0),
(171788,'Seller Category 1',4,171787,'99:14112:171787',1),
(171789,'Seller Category 2',4,171787,'99:14112:171787',1),
(171790,'Seller Category 3',4,171787,'99:14112:171787',1),
(171791,'Seller Category 4',4,171787,'99:14112:171787',1),
(171792,'Seller Category 5',4,171787,'99:14112:171787',1),
(171813,'Batteries',3,54968,'1249:54968',1),
(171814,'Cables & Adapters',3,54968,'1249:54968',1),
(171820,'Hard Drives',3,54968,'1249:54968',1),
(171821,'Headsets',3,54968,'1249:54968',1),
(171826,'Accessory Bundles',3,54968,'1249:54968',1),
(171831,'Bags, Skins & Travel Cases',3,54968,'1249:54968',1),
(171833,'Replacement Parts & Tools',2,1249,'1249',1),
(171837,'Screen Protectors',3,54968,'1249:54968',1),
(171839,'Styluses',3,54968,'1249:54968',1),
(171858,'Chargers & Charging Docks',3,54968,'1249:54968',1),
(171898,'Cooling Devices',3,54968,'1249:54968',1),
(171922,'Arcade Machines',3,3944,'1249:3944',1),
(171957,'Desktops & All-In-Ones',2,58058,'58058',0),
(171961,'Printers, Scanners & Supplies',2,58058,'58058',0),
(171985,'Magazine Subscriptions',2,267,'267',1),
(172008,'Vouchers, Gift Certificates',2,11730,'11730',1),
(172009,'Gift Cards',1,-1,'',1),
(172011,'Battery Converters',3,48446,'293:48446',1),
(172014,'Sharpeners',4,36409,'26395:31786:36409',1),
(172016,'Body',3,31786,'26395:31786',1),
(172020,'Eyes',3,31786,'26395:31786',0),
(172021,'Eye Shadow Primer',4,172020,'26395:31786:172020',1),
(172022,'Eye Shadow/Liner Combination',4,172020,'26395:31786:172020',1),
(172023,'Lash Growth & Conditioner',4,172020,'26395:31786:172020',1),
(172024,'Other Eye Makeup',4,172020,'26395:31786:172020',1),
(172025,'Face',3,31786,'26395:31786',0),
(172026,'Other Face Makeup',4,172025,'26395:31786:172025',1),
(172027,'Lips',3,31786,'26395:31786',0),
(172028,'Other Lip Makeup',4,172027,'26395:31786:172027',1),
(172029,'Lip Plumper',4,172027,'26395:31786:172027',1),
(172030,'Lip Stain',4,172027,'26395:31786:172027',1),
(172031,'Lip Primer',4,172027,'26395:31786:172027',1),
(172032,'Makeup Remover',3,11863,'26395:11863',1),
(172176,'Home Entertainment',1,-1,'',0),
(172177,'Other',2,172176,'172176',1),
(172378,'Maternity Clothing',2,2984,'2984',0),
(172508,'Health Foods',2,14308,'14308',1),
(172510,'Keyboards & Keypads',3,54968,'1249:54968',1),
(172511,'Stabilizers',3,30090,'625:30090',1),
(172513,'Camcorder Parts',3,182074,'625:182074',1),
(172514,'Camera Tools & Repair Kits',3,182074,'625:182074',1),
(172516,'Light Bulbs & Tubes',4,19590,'625:30078:19590',1),
(172528,'Antipasto, Savoury',2,14308,'14308',1),
(172531,'Wine Fridges',3,149229,'20710:149229',1),
(172538,'Group Buy Listings',2,99,'99',1),
(173511,'Brake Component Packages',4,33559,'131090:6030:33559',1),
(173516,'Bag Tags',4,181128,'888:1513:181128',1),
(173517,'Ball Pick-Ups & Retrievers',4,181128,'888:1513:181128',1),
(173518,'Golf Stickers & Decals',4,181128,'888:1513:181128',1),
(173519,'Stroke Counters',4,181128,'888:1513:181128',1),
(173602,'Korea',4,40711,'11116:58520:40711',1),
(173619,'Germany',4,45148,'11116:58520:45148',1),
(173632,'Headphone Cord Winders',4,56169,'293:15052:56169',1),
(173695,'Boxes, Cases & Watch Winders',3,14324,'281:14324',1),
(173696,'Parts, Tools & Guides',3,14324,'281:14324',0),
(173697,'Nurse Watches',3,14324,'281:14324',1),
(173698,'Ring Watches',3,14324,'281:14324',1),
(173699,'Key Ring Watches',3,14324,'281:14324',1),
(174078,'Handbrake Handles',4,33559,'131090:6030:33559',1),
(174092,'Shock Absorbers/Dampers',4,33579,'131090:6030:33579',1),
(174105,'Gear Boxes & Gear Box Parts',4,33726,'131090:6030:33726',1),
(175517,'Stair Treads',3,20571,'11700:20571',1),
(175521,'Tops, Shirts & T-Shirts',3,11452,'11450:11452',1),
(175529,'Tops, Shirts & T-Shirts',3,11462,'11450:11462',1),
(175633,'Bridesmaids\' & Formal Dresses',3,3259,'11450:3259',1),
(175635,'Wigs & Hairpieces',4,182101,'26395:11854:182101',1),
(175636,'Hair Extensions',4,182101,'26395:11854:182101',1),
(175637,'Wig & Extension Supplies',4,182101,'26395:11854:182101',1),
(175638,'Men\'s & Women\'s Dancewear',3,112425,'11450:112425',0),
(175639,'Dance Shoes',3,112425,'11450:112425',0),
(175653,'Swimwear',3,155198,'11450:155198',1),
(175654,'Pants',3,155198,'11450:155198',1),
(175655,'Shorts',3,155198,'11450:155198',1),
(175656,'Sleepwear',3,155198,'11450:155198',1),
(175658,'Jeans',3,155198,'11450:155198',1),
(175664,'Disc Repair & Disc Cleaning',4,80133,'58058:165:80133',1),
(175665,'Drive Head & Lens Cleaning',4,80133,'58058:165:80133',1),
(175666,'Media Cases, Sleeves & Wallets',4,80133,'58058:165:80133',1),
(175668,'Motherboard Components',4,182090,'58058:175673:182090',1),
(175669,'Solid State Drives',4,182085,'58058:165:182085',1),
(175670,'Other Hard Drives',4,182085,'58058:165:182085',1),
(175671,'Hard Drive Duplicators',3,165,'58058:165',1),
(175672,'Laptops & Netbooks',2,58058,'58058',0),
(175673,'Computer Components & Parts',2,58058,'58058',0),
(175674,'Computer Cases & Accessories',3,175673,'58058:175673',0),
(175676,'Laptop Housings & Touchpads',4,182089,'58058:175673:182089',1),
(175677,'Case Mods, Stickers & Decals',3,31530,'58058:31530',1),
(175678,'Cleaning Equipment & Kits',3,31530,'58058:31530',1),
(175679,'TV Tuner/Video Capture Devices',3,31530,'58058:31530',1),
(175680,'Hard Drive Pouches',3,31530,'58058:31530',1),
(175681,'Coaxial Network Cables',4,20311,'58058:182094:20311',1),
(175682,'Toner Refills & Kits',4,11195,'58058:171961:11195',1),
(175685,'Cleaning & Repair Kits',4,182086,'58058:171961:182086',1),
(175686,'Fusers',4,182086,'58058:171961:182086',1),
(175687,'Power Inverters',3,86722,'58058:86722',1),
(175688,'Other Computer Monitors & Accs',3,162497,'58058:162497',1),
(175689,'Antivirus & Security',3,18793,'58058:18793',1),
(175690,'Vintage Parts & Accessories',3,11189,'58058:11189',1),
(175691,'Music',3,246,'220:246',1),
(175692,'Animals & Dinosaurs',3,246,'220:246',1),
(175693,'Fantasy',3,246,'220:246',1),
(175694,'Historical Figures',3,246,'220:246',1),
(175696,'Karaoke',3,14969,'293:14969',0),
(175698,'Enterprise Networking, Servers',2,58058,'58058',0),
(175699,'Enterprise Routers',3,175698,'58058:175698',1),
(175700,'Servers, Clients & Terminals',3,175698,'58058:175698',0),
(175701,'Terminal Servers',4,175700,'58058:175698:175700',1),
(175702,'Thin Clients',4,175700,'58058:175698:175700',1),
(175703,'Other Ent. Clients & Terminals',4,175700,'58058:175698:175700',1),
(175704,'Other Ent. Router Components',4,182092,'58058:175698:182092',1),
(175705,'Other Ink, Toner & Paper',4,11195,'58058:171961:11195',1),
(175709,'Wireless Access Points',3,11176,'58058:11176',1),
(175710,'Mobile Broadband Devices',3,11176,'58058:11176',1),
(175711,'DVD & Blu-ray Players',2,172176,'172176',1),
(175712,'Car Monitors w/Built-in Player',4,48604,'131090:3270:48604',1),
(175713,'Remote Start Systems',4,60207,'131090:3270:60207',1),
(175714,'Bluetooth, Handsfree Car Kits',4,60207,'131090:3270:60207',1),
(175715,'Other Car Electronics Accs',4,60207,'131090:3270:60207',1),
(175716,'Car Audio',3,3270,'131090:3270',0),
(175717,'Other Car Audio',4,175716,'131090:3270:175716',1),
(175719,'3D TV Glasses & Accessories',2,11232,'11232',1),
(175720,'Antennas & Dishes',3,71582,'172176:71582',1),
(175721,'Audio Cable Plugs & Jacks',3,14961,'293:14961',1),
(175722,'Tools, Crimpers & Strippers',3,71582,'172176:71582',1),
(175723,'Speaker Parts & Components',3,14969,'293:14969',1),
(175726,'Chargers & Batteries',3,139836,'293:139836',1),
(175729,'Heavy-Duty Voltage Converters',3,48446,'293:48446',1),
(175731,'Marine/Air Band Radio Antennas',4,183502,'293:1500:183502',1),
(175732,'Walkie Talkie/Two-Way Antennas',4,183502,'293:1500:183502',1),
(175733,'Other Radio Antennas',4,183502,'293:1500:183502',1),
(175735,'Baluns & Chokes',4,183503,'293:1500:183503',1),
(175736,'Filters',4,183503,'293:1500:183503',1),
(175737,'Oscillators',4,183503,'293:1500:183503',1),
(175738,'Radio & Scanner Crystals',4,183503,'293:1500:183503',1),
(175740,'Vintage Audio & Video',3,183077,'293:183077',0),
(175741,'Vintage Parts & Accessories',4,175740,'293:183077:175740',0),
(175742,'Other Vintage Audio & Video',4,175740,'293:183077:175740',1),
(175744,'PDA Accessories',3,14948,'293:14948',1),
(175745,'Other Gadgets',3,14948,'293:14948',1),
(175749,'Quilts & Bedspreads',3,20444,'11700:20444',1),
(175750,'Blankets',3,20444,'11700:20444',1),
(175752,'Other Home Furniture',3,3197,'11700:3197',1),
(175754,'Slipcovers',3,3197,'11700:3197',1),
(175755,'Fuel & Firewood',3,38219,'11700:38219',1),
(175756,'Fireplaces',3,38219,'11700:38219',1),
(175757,'Window Film',3,63514,'11700:63514',1),
(175758,'Beds & Bed Frames',4,32254,'11700:3197:32254',1),
(175759,'Vintage',2,11450,'11450',0),
(175769,'Wallets & Purses',4,182059,'11450:175759:182059',1),
(175770,'Casual Shirts',4,182044,'11450:175759:182044',1),
(175771,'Outerwear Coats & Jackets',4,182044,'11450:175759:182044',1),
(175772,'Formal Shirts',4,182044,'11450:175759:182044',1),
(175773,'Jeans',4,182044,'11450:175759:182044',1),
(175774,'Jumpers & Cardigans',4,182044,'11450:175759:182044',1),
(175775,'Sleepwear & Robes',4,182044,'11450:175759:182044',1),
(175776,'Shorts',4,182044,'11450:175759:182044',1),
(175777,'Suits',4,182044,'11450:175759:182044',1),
(175778,'Sweats & Tracksuits',4,182044,'11450:175759:182044',1),
(175779,'Swimwear',4,182044,'11450:175759:182044',1),
(175780,'Pants',4,182044,'11450:175759:182044',1),
(175781,'T-Shirts',4,182044,'11450:175759:182044',1),
(175782,'Vests',4,182044,'11450:175759:182044',1),
(175783,'Outerwear Coats & Jackets',4,182047,'11450:175759:182047',1),
(175784,'Dresses',4,182047,'11450:175759:182047',1),
(175785,'Jeans',4,182047,'11450:175759:182047',1),
(175786,'Jumpers & Cardigans',4,182047,'11450:175759:182047',1),
(175787,'Jumpsuits & Playsuits',4,182047,'11450:175759:182047',1),
(175789,'Sleepwear & Robes',4,182047,'11450:175759:182047',1),
(175790,'Shorts',4,182047,'11450:175759:182047',1),
(175791,'Skirts',4,182047,'11450:175759:182047',1),
(175792,'Suits & Coordinated Sets',4,182047,'11450:175759:182047',1),
(175793,'Sweats & Tracksuits',4,182047,'11450:175759:182047',1),
(175794,'Swimwear',4,182047,'11450:175759:182047',1),
(175795,'Tops & Blouses',4,182047,'11450:175759:182047',1),
(175796,'Pants',4,182047,'11450:175759:182047',1),
(175797,'T-Shirts',4,182047,'11450:175759:182047',1),
(175798,'Vests',4,182047,'11450:175759:182047',1),
(175799,'Wedding Dresses & Veils',4,182047,'11450:175759:182047',1),
(175802,'Other',4,36027,'11700:20625:36027',1),
(175803,'Stove & Chimney Pipes',3,38219,'11700:38219',1),
(175805,'Glasses',4,182059,'11450:175759:182059',1),
(175806,'Gloves',4,182059,'11450:175759:182059',1),
(175807,'Scarves & Wraps',4,182059,'11450:175759:182059',1),
(175819,'Hair Accessories',4,182059,'11450:175759:182059',1),
(175820,'Wall-to-Wall Carpeting',3,20571,'11700:20571',1),
(175824,'Fireplace Hearths',3,38219,'11700:38219',1),
(176937,'Ceiling Fans',3,20697,'11700:20697',1),
(176957,'Vests',3,11452,'11450:11452',1),
(176970,'Tablet & eBook Reader Accs',2,58058,'58058',0),
(176971,'Accessory Bundles',3,176970,'58058:176970',1),
(176972,'A/V Cables & Adapters',3,176970,'58058:176970',1),
(176973,'Cases, Covers, Keyboard Folios',3,176970,'58058:176970',1),
(176974,'Chargers & Sync Cables',3,176970,'58058:176970',1),
(176975,'Docking Stations/Keyboards',3,176970,'58058:176970',1),
(176976,'Memory Card & USB Adapters',3,176970,'58058:176970',1),
(176977,'Mounts, Stands & Holders',3,176970,'58058:176970',1),
(176978,'Reading Lights',3,176970,'58058:176970',1),
(176979,'Screen Protectors',3,176970,'58058:176970',1),
(176980,'Stickers & Decals',3,176970,'58058:176970',1),
(176981,'Styluses',3,176970,'58058:176970',1),
(176982,'Other Tablet & eBook Accs',3,176970,'58058:176970',1),
(176983,'Cassettes',2,11233,'11233',1),
(176984,'CDs & DVDs',2,11233,'11233',1),
(176985,'Records',2,11233,'11233',1),
(176990,'Bath Accessory Sets',3,26677,'11700:26677',1),
(176991,'Medicine Cabinets',3,26677,'11700:26677',1),
(176992,'Sexual Wellness',3,67588,'26395:67588',0),
(176993,'Body Enhancing Devices',4,176992,'26395:67588:176992',1),
(176994,'Condoms & Contraceptives',4,176992,'26395:67588:176992',1),
(176995,'Lubricants & Lotions',4,176992,'26395:67588:176992',1),
(176996,'Fantasy, Fetish & Accessories',4,176992,'26395:67588:176992',1),
(176997,'Sex Toys',4,176992,'26395:67588:176992',1),
(176998,'Sexual Remedies & Supplements',4,176992,'26395:67588:176992',1),
(176999,'Other Sexual Wellness',4,176992,'26395:67588:176992',1),
(177004,'Other',4,20637,'11700:20625:20637',1),
(177008,'Salt & Pepper',4,36027,'11700:20625:36027',1),
(177009,'Baking Accs. & Cake Decorating',3,20625,'11700:20625',0),
(177010,'Cake Stands',4,36027,'11700:20625:36027',1),
(177011,'Sugarcraft & Chocolate Moulds',5,183324,'11700:20625:177009:183324',1),
(177012,'Baking Cups & Cases',4,177009,'11700:20625:177009',1),
(177013,'Other Baking Accessories',4,177009,'11700:20625:177009',1),
(177017,'Garden Structures & Shades',3,159912,'11700:159912',0),
(177018,'BBQ Replacement Parts',4,149242,'11700:159912:149242',1),
(177021,'Riding Mowers',4,43560,'11700:159912:43560',1),
(177022,'Stage Lighting Single Units',3,12922,'619:12922',1),
(177023,'DJ Lighting Single Units',3,12922,'619:12922',1),
(177024,'DJ Lighting Systems & Kits',3,12922,'619:12922',1),
(177025,'Folding Screens & Backdrops',3,12922,'619:12922',1),
(177026,'Other Structures & Shade',4,177017,'11700:159912:177017',1),
(177027,'Software, Loops & Samples',3,180014,'619:180014',1),
(177028,'Studio Equipment Packages',3,180014,'619:180014',1),
(177032,'Garden Fencing',3,159912,'11700:159912',0),
(177033,'Other Garden Fencing',4,177032,'11700:159912:177032',1),
(177068,'Icing Bags',5,183324,'11700:20625:177009:183324',1),
(177075,'Helmets & Headwear',3,6747,'131090:6747',0),
(177076,'Helmets',4,177075,'131090:6747:177075',1),
(177077,'Eyewear',4,177075,'131090:6747:177075',1),
(177078,'Visors',4,177075,'131090:6747:177075',1),
(177079,'Visor Inserts',4,177075,'131090:6747:177075',1),
(177080,'Balaclavas, Masks & Tubes',4,177075,'131090:6747:177075',1),
(177081,'Ear Plugs',4,177075,'131090:6747:177075',1),
(177082,'Other Care & Cleaning',5,183514,'131090:6747:177075:183514',1),
(177083,'Helmet & Visor Bags',4,177075,'131090:6747:177075',1),
(177084,'Helmet Parts & Accessories',4,177075,'131090:6747:177075',1),
(177085,'Other Headwear',4,177075,'131090:6747:177075',1),
(177099,'Motorcycle Clothing',3,6747,'131090:6747',0),
(177100,'Base Layers',4,177099,'131090:6747:177099',1),
(177101,'Other Body Armour',4,183504,'131090:6747:183504',1),
(177102,'Boots',4,177099,'131090:6747:177099',1),
(177103,'Gloves',4,177099,'131090:6747:177099',1),
(177104,'Jackets',4,177099,'131090:6747:177099',1),
(177106,'Riding Suits',4,177099,'131090:6747:177099',1),
(177107,'Rain Suits',4,177099,'131090:6747:177099',1),
(177108,'Socks',4,177099,'131090:6747:177099',1),
(177109,'Pants',4,177099,'131090:6747:177099',1),
(177110,'Vests',4,177099,'131090:6747:177099',1),
(177111,'Other Motorcycle Clothing',4,177099,'131090:6747:177099',1),
(177112,'Motocross & Off-Road Gear',3,6747,'131090:6747',0),
(177114,'Boot Parts & Spares',4,177112,'131090:6747:177112',1),
(177115,'Boots',4,177112,'131090:6747:177112',1),
(177116,'Gloves',4,177112,'131090:6747:177112',1),
(177117,'Jackets',4,177112,'131090:6747:177112',1),
(177118,'Jerseys',4,177112,'131090:6747:177112',1),
(177119,'Kits & Sets',4,177112,'131090:6747:177112',1),
(177120,'Pants',4,177112,'131090:6747:177112',1),
(177121,'Socks',4,177112,'131090:6747:177112',1),
(177122,'Other Off-Road Gear',4,177112,'131090:6747:177112',1),
(177124,'Toilet Paper Storage & Covers',3,26677,'11700:26677',1),
(177125,'Sweats & Hoodies',4,34352,'131090:6747:34352',1),
(177412,'Remote Controls',3,14961,'293:14961',1),
(177641,'Heavy Machinery',2,170769,'170769',0),
(177644,'Metalworking',2,170769,'170769',0),
(177647,'Implements & Attachments',3,41489,'170769:41489',0),
(177652,'Coins & Rounds',4,45134,'11116:178078:45134',1),
(177653,'Coins & Rounds',4,39487,'11116:178078:39487',1),
(177655,'Platinum',3,178078,'11116:178078',0),
(177656,'Coins & Rounds',4,177655,'11116:178078:177655',1),
(177657,'Bars',4,177655,'11116:178078:177655',1),
(177658,'Other Hair Care & Styling',3,11854,'26395:11854',1),
(177659,'Straightening & Curling Irons',3,11854,'26395:11854',1),
(177660,'Serum & Oils',3,11854,'26395:11854',1),
(177661,'Shampoos & Conditioners',3,11854,'26395:11854',1),
(177662,'Relaxers & Straightening Prod',3,11854,'26395:11854',1),
(177663,'Hand Sanitisers',3,67588,'26395:67588',1),
(177664,'Eyelash Extensions',4,172020,'26395:31786:172020',1),
(177665,'BB, CC & Alphabet Creams',4,172025,'26395:31786:172025',1),
(177666,'Foundation',4,172025,'26395:31786:172025',1),
(177668,'Decals',3,26443,'131090:26443',1),
(177669,'Complete Outboard Engines',4,178074,'131090:26443:178074',1),
(177670,'Complete Outboard Powerheads',4,178074,'131090:26443:178074',1),
(177671,'Complete Outboard Lower Units',4,178074,'131090:26443:178074',1),
(177672,'Anodes',4,178074,'131090:26443:178074',1),
(177674,'Conversion Kits',4,178074,'131090:26443:178074',1),
(177675,'Cooling Systems',4,178074,'131090:26443:178074',1),
(177676,'Cowlings & Housings',4,178074,'131090:26443:178074',1),
(177677,'Electrical Systems',4,178074,'131090:26443:178074',1),
(177678,'Exhaust Systems',4,178074,'131090:26443:178074',1),
(177679,'Ignition & Starting Systems',4,178074,'131090:26443:178074',1),
(177680,'Intake & Fuel Systems',4,178074,'131090:26443:178074',1),
(177681,'Powerhead Components',4,178074,'131090:26443:178074',1),
(177682,'Oil Systems',4,178074,'131090:26443:178074',1),
(177683,'Mid-Sections',4,178074,'131090:26443:178074',1),
(177684,'Mounting & Brackets',4,178074,'131090:26443:178074',1),
(177685,'Rigging',4,178074,'131090:26443:178074',1),
(177686,'Lower Unit Components',4,178074,'131090:26443:178074',1),
(177687,'Trim & Tilt',4,178074,'131090:26443:178074',1),
(177688,'Other',4,178074,'131090:26443:178074',1),
(177689,'Belts & Pulleys',4,50440,'131090:26443:50440',1),
(177690,'Electrical Systems',4,50440,'131090:26443:50440',1),
(177691,'Oil Systems',4,50440,'131090:26443:50440',1),
(177692,'Jet Drives',3,26443,'131090:26443',1),
(177697,'Alternators & Generators',4,33572,'131090:6030:33572',1),
(177698,'Alternator & Generator Parts',4,33572,'131090:6030:33572',1),
(177699,'Starters',4,33572,'131090:6030:33572',1),
(177700,'Starter Parts',4,33572,'131090:6030:33572',1),
(177701,'Electric Vehicle Parts',3,6030,'131090:6030',0),
(177702,'Accessories',4,177701,'131090:6030:177701',1),
(177703,'Electric Vehicle Batteries',4,177701,'131090:6030:177701',1),
(177704,'Chargers & Service Equipment',4,177701,'131090:6030:177701',1),
(177705,'Controllers',4,177701,'131090:6030:177701',1),
(177706,'Converters & Inverters',4,177701,'131090:6030:177701',1),
(177707,'Conversion Kits',4,177701,'131090:6030:177701',1),
(177708,'Motors',4,177701,'131090:6030:177701',1),
(177709,'Other',4,177701,'131090:6030:177701',1),
(177710,'Air Bags',4,33718,'131090:6030:33718',1),
(177711,'Air Bag Parts',4,33718,'131090:6030:33718',1),
(177712,'Service Tools',3,26443,'131090:26443',1),
(177713,'Sterndrive Motors & Components',3,26443,'131090:26443',0),
(177714,'Complete Sterndrive Engines',4,177713,'131090:26443:177713',1),
(177715,'Complete Sterndrive Outdrives',4,177713,'131090:26443:177713',1),
(177716,'Anodes',4,177713,'131090:26443:177713',1),
(177717,'Belts & Pulleys',4,177713,'131090:26443:177713',1),
(177718,'Conversion Kits',4,177713,'131090:26443:177713',1),
(177719,'Cooling System',4,177713,'131090:26443:177713',1),
(177720,'Cowlings & Housings',4,177713,'131090:26443:177713',1),
(177721,'Electrical System',4,177713,'131090:26443:177713',1),
(177722,'Exhaust System',4,177713,'131090:26443:177713',1),
(177723,'Ignition & Starting System',4,177713,'131090:26443:177713',1),
(177724,'Intake & Fuel System',4,177713,'131090:26443:177713',1),
(177725,'Oil System',4,177713,'131090:26443:177713',1),
(177726,'Mounting & Brackets',4,177713,'131090:26443:177713',1),
(177727,'Internal Engine Parts',4,177713,'131090:26443:177713',1),
(177728,'Transmission & Drive Parts',4,177713,'131090:26443:177713',1),
(177729,'Trim & Tilt',4,177713,'131090:26443:177713',1),
(177730,'Other',4,177713,'131090:26443:177713',1),
(177731,'Salon & Spa Equipment',2,26395,'26395',0),
(177732,'Hair & Makeup Mannequins',3,177731,'26395:177731',1),
(177733,'Magnifying Lamps',3,177731,'26395:177731',1),
(177734,'Professional Facial Machines',3,177731,'26395:177731',1),
(177735,'Professional Styling Tools',3,177731,'26395:177731',1),
(177736,'Professional Waxing Warmers',3,177731,'26395:177731',1),
(177737,'Salon Chairs & Dryers',3,177731,'26395:177731',1),
(177738,'Stylist Stations & Furniture',3,177731,'26395:177731',1),
(177739,'Sterilisers & Towel Warmers',3,177731,'26395:177731',1),
(177740,'Salon & Spa Supplies',3,177731,'26395:177731',1),
(177741,'Other Salon & Spa Equipment',3,177731,'26395:177731',1),
(177748,'Dishwashers',2,20710,'20710',1),
(177752,'Coffee Makers (Specialty)',2,20710,'20710',1),
(177762,'Ring Pillows & Flower Baskets',3,11827,'11700:11827',1),
(177763,'Disposable Cameras',3,11827,'11700:11827',1),
(177764,'Eye Treatments & Masks',3,11863,'26395:11863',1),
(177765,'Cleansers & Toners',3,11863,'26395:11863',1),
(177767,'Home Skin Care Devices',3,11863,'26395:11863',1),
(177769,'Fake & Cheater Body Jewellery',3,15124,'281:15124',1),
(177770,'Other Men\'s Jewellery',3,10290,'281:10290',1),
(177771,'Air Filters',4,180028,'131090:14780:180028',1),
(177772,'Air Pipes & Hoses',4,180028,'131090:14780:180028',1),
(177773,'Carburettors & Parts',4,180028,'131090:14780:180028',1),
(177774,'Intake Covers & Fairings',4,180028,'131090:14780:180028',1),
(177775,'Intake Ducts & Scoops',4,180028,'131090:14780:180028',1),
(177776,'Gaskets & Seals',4,180028,'131090:14780:180028',1),
(177777,'Fuel Caps',4,180028,'131090:14780:180028',1),
(177778,'Fuel Filters',4,180028,'131090:14780:180028',1),
(177779,'Fuel Injectors & Main Jets',4,180028,'131090:14780:180028',1),
(177780,'Fuel Pumps',4,180028,'131090:14780:180028',1),
(177781,'Fuel Petcocks & Taps',4,180028,'131090:14780:180028',1),
(177782,'Fuel Pipes & Hoses',4,180028,'131090:14780:180028',1),
(177783,'Other Intake & Fuel Systems',4,180028,'131090:14780:180028',1),
(177784,'Dishes, Feeders & Fountains',3,20737,'1281:20737',1),
(177785,'Cat Grass & Loose Catnip',3,20737,'1281:20737',1),
(177786,'Grooming',3,20737,'1281:20737',1),
(177789,'Dishes, Feeders & Fountains',3,20742,'1281:20742',1),
(177790,'Tags & Charms',3,20742,'1281:20742',1),
(177791,'Toys',3,20742,'1281:20742',1),
(177796,'Clothing & Shoes',3,20742,'1281:20742',1),
(177798,'Health Care',3,20754,'1281:20754',1),
(177799,'Heaters & Chillers',3,20754,'1281:20754',1),
(177800,'Tubing & Valves',3,20754,'1281:20754',1),
(177801,'Backyard Poultry & Waterfowl',2,1281,'1281',1),
(177802,'Bar Ends & Plugs',4,57262,'888:7294:57262',1),
(177803,'Bearings',4,57262,'888:7294:57262',1),
(177804,'Bolts & Fasteners',4,57262,'888:7294:57262',1),
(177805,'Bottom Brackets',4,57262,'888:7294:57262',1),
(177806,'Brake Pads',4,57262,'888:7294:57262',1),
(177807,'Brake Rotors',4,57262,'888:7294:57262',1),
(177808,'Brakes',4,57262,'888:7294:57262',1),
(177809,'Cassettes, Freewheels & Cogs',4,57262,'888:7294:57262',1),
(177810,'Chain Guards & Bash Guards',4,57262,'888:7294:57262',1),
(177811,'Chainrings & BMX Sprockets',4,57262,'888:7294:57262',1),
(177812,'Derailleurs (Front)',4,57262,'888:7294:57262',1),
(177813,'Derailleurs (Rear)',4,57262,'888:7294:57262',1),
(177814,'Electric Bicycle Components',4,57262,'888:7294:57262',1),
(177815,'Forks',4,57262,'888:7294:57262',1),
(177816,'Handlebar Grips, Tape & Pads',4,57262,'888:7294:57262',1),
(177817,'Handlebars',4,57262,'888:7294:57262',1),
(177818,'Headset Spacers',4,57262,'888:7294:57262',1),
(177819,'Headsets',4,57262,'888:7294:57262',1),
(177820,'Hubs',4,57262,'888:7294:57262',1),
(177821,'Rims',4,57262,'888:7294:57262',1),
(177822,'Saddles, Seats',4,57262,'888:7294:57262',1),
(177823,'Seatpost Clamps',4,57262,'888:7294:57262',1),
(177824,'Shifters',4,57262,'888:7294:57262',1),
(177825,'Skewers',4,57262,'888:7294:57262',1),
(177826,'Spokes',4,57262,'888:7294:57262',1),
(177827,'Stems',4,57262,'888:7294:57262',1),
(177828,'Tyres',4,57262,'888:7294:57262',1),
(177829,'Tubes',4,57262,'888:7294:57262',1),
(177830,'Wheels & Wheelsets',4,57262,'888:7294:57262',1),
(177831,'Bicycles',3,7294,'888:7294',1),
(177832,'Bicycle Accessories',3,7294,'888:7294',0),
(177833,'Bags & Panniers',4,177832,'888:7294:177832',1),
(177834,'Baskets',4,177832,'888:7294:177832',1),
(177835,'Bicycle Transport Cases & Bags',4,177832,'888:7294:177832',1),
(177836,'Carrier & Pannier Racks',4,177832,'888:7294:177832',1),
(177837,'Kickstands',4,177832,'888:7294:177832',1),
(177838,'Saddle Covers, Seat Covers',4,177832,'888:7294:177832',1),
(177839,'Training Wheels',4,177832,'888:7294:177832',1),
(177840,'Bicycle Electronics',3,7294,'888:7294',0),
(177841,'Heart Rate Monitors',4,177840,'888:7294:177840',1),
(177842,'Power Meters',4,177840,'888:7294:177840',1),
(177843,'Other',4,177840,'888:7294:177840',1),
(177844,'Bicycle Maintenance & Tools',3,7294,'888:7294',0),
(177845,'Puncture Repair',4,177844,'888:7294:177844',1),
(177846,'Tools',4,177844,'888:7294:177844',1),
(177847,'Workstands',4,177844,'888:7294:177844',1),
(177848,'Other',4,177844,'888:7294:177844',1),
(177849,'Car & Truck Racks',3,7294,'888:7294',1),
(177850,'Base Layers',4,22682,'888:7294:22682',1),
(177851,'Casual T-Shirts & Tops',4,22682,'888:7294:22682',1),
(177852,'Jersey & Pant/Short Sets',4,22682,'888:7294:22682',1),
(177853,'Shorts',4,22682,'888:7294:22682',1),
(177854,'Tights & Pants',4,22682,'888:7294:22682',1),
(177855,'Underwear & Liners',4,22682,'888:7294:22682',1),
(177856,'Vests',4,22682,'888:7294:22682',1),
(177858,'Vintage Bicycles',4,158999,'888:7294:158999',1),
(177859,'Vintage Frames',4,158999,'888:7294:158999',1),
(177860,'Vintage Bicycle Accessories',4,158999,'888:7294:158999',1),
(177861,'Other',4,158999,'888:7294:158999',1),
(177862,'Cycling Shoes & Shoe Covers',3,7294,'888:7294',0),
(177863,'Shoe Covers',4,177862,'888:7294:177862',1),
(177864,'Helmets & Protective Gear',3,7294,'888:7294',0),
(177865,'Helmet Accessories',4,177864,'888:7294:177864',1),
(177866,'Other',4,177864,'888:7294:177864',1),
(177920,'Brake Cables',4,49790,'131090:14780:49790',1),
(177921,'Brake Cylinders',4,49790,'131090:14780:49790',1),
(177922,'Brake Rotors',4,49790,'131090:14780:49790',1),
(177923,'Brake Drums',4,49790,'131090:14780:49790',1),
(177924,'Brake Lines & Hoses',4,49790,'131090:14780:49790',1),
(177925,'Brake Pads',4,49790,'131090:14780:49790',1),
(177926,'Brake Shoes',4,49790,'131090:14780:49790',1),
(177927,'Calipers & Parts',4,49790,'131090:14780:49790',1),
(177928,'Other Brakes & Suspension',4,49790,'131090:14780:49790',1),
(177929,'Alternators & Parts',4,179853,'131090:14780:179853',1),
(177930,'Condensers',4,179853,'131090:14780:179853',1),
(177931,'Fuses & Fuse Boxes',4,179853,'131090:14780:179853',1),
(177932,'Wires & Electrical Cabling',4,179853,'131090:14780:179853',1),
(177933,'CDIs & ECUs',4,179853,'131090:14780:179853',1),
(177934,'Bearings',4,180029,'131090:14780:180029',1),
(177935,'Chain/Belt Guards & Guides',4,180029,'131090:14780:180029',1),
(177936,'Clutch Cables',4,180029,'131090:14780:180029',1),
(177937,'Clutch Master Cylinders',4,180029,'131090:14780:180029',1),
(177938,'Clutch Slave Cylinders',4,180029,'131090:14780:180029',1),
(177939,'Clutch Plates',4,180029,'131090:14780:180029',1),
(177940,'Complete Clutches & Kits',4,180029,'131090:14780:180029',1),
(177941,'Differentials & Parts',4,180029,'131090:14780:180029',1),
(177942,'Drive Shafts',4,180029,'131090:14780:180029',1),
(177943,'Flywheels & Flywheel Parts',4,180029,'131090:14780:180029',1),
(177944,'Gearboxes & Gearbox Parts',4,180029,'131090:14780:180029',1),
(177945,'Pulleys & Tensioners',4,180029,'131090:14780:180029',1),
(177946,'Gaskets & Seals',4,180029,'131090:14780:180029',1),
(177947,'Other Transmission Parts',4,180029,'131090:14780:180029',1),
(177948,'Clutch Covers',4,180029,'131090:14780:180029',1),
(177949,'Distributors & Parts',4,179853,'131090:14780:179853',1),
(177951,'Horns',4,179853,'131090:14780:179853',1),
(177952,'Ignition Coils',4,179853,'131090:14780:179853',1),
(177953,'Ignition Cables & Wires',4,179853,'131090:14780:179853',1),
(177954,'Stators, Magnetos & Parts',4,179853,'131090:14780:179853',1),
(177955,'Regulators',4,179853,'131090:14780:179853',1),
(177956,'Relays',4,179853,'131090:14780:179853',1),
(177957,'Sensors',4,179853,'131090:14780:179853',1),
(177958,'Spark Plugs',4,179853,'131090:14780:179853',1),
(177959,'Starter Motors & Relays',4,179853,'131090:14780:179853',1),
(177960,'Switches',4,179853,'131090:14780:179853',1),
(177961,'Other Electrical & Ignition',4,179853,'131090:14780:179853',1),
(177962,'Engine Cooling',3,14780,'131090:14780',0),
(177963,'Fans & Fan Parts',4,177962,'131090:14780:177962',1),
(177964,'Bearings',4,171107,'131090:14780:171107',1),
(177965,'Belts & Chains',4,171107,'131090:14780:171107',1),
(177966,'Camshafts',4,171107,'131090:14780:171107',1),
(177967,'Crankshafts & Connecting Rods',4,171107,'131090:14780:171107',1),
(177968,'Cylinder Barrels',4,171107,'131090:14780:171107',1),
(177969,'Cylinder Bolts',4,171107,'131090:14780:171107',1),
(177970,'Cylinder Heads & Valve Covers',4,171107,'131090:14780:171107',1),
(177971,'Gaskets & Seals',4,171107,'131090:14780:171107',1),
(177972,'Kick-Start Levers',4,171107,'131090:14780:171107',1),
(177973,'Oil Filters',4,171107,'131090:14780:171107',1),
(177974,'Oil Pumps',4,171107,'131090:14780:171107',1),
(177975,'Oil Pans',4,171107,'131090:14780:171107',1),
(177976,'Pistons, Rings & Pistons Kits',4,171107,'131090:14780:171107',1),
(177977,'Rocker Arms',4,171107,'131090:14780:171107',1),
(177978,'Throttle & Choke Cables',4,180028,'131090:14780:180028',1),
(177979,'Valves',4,171107,'131090:14780:171107',1),
(177980,'Other Engines & Engine Parts',4,171107,'131090:14780:171107',1),
(177981,'Oil Coolers',4,177962,'131090:14780:177962',1),
(177982,'Pipes & Hoses',4,177962,'131090:14780:177962',1),
(177983,'Radiators',4,177962,'131090:14780:177962',1),
(177984,'Radiator Guards',4,177962,'131090:14780:177962',1),
(177985,'Thermostats & Housings',4,177962,'131090:14780:177962',1),
(177986,'Water Pumps',4,177962,'131090:14780:177962',1),
(177987,'Other Engine Cooling Parts',4,177962,'131090:14780:177962',1),
(177993,'Gaskets & Seals',4,180027,'131090:14780:180027',1),
(177994,'Guards & Heat Shields',4,180027,'131090:14780:180027',1),
(177995,'Clamps, Flanges & Hangers',4,180027,'131090:14780:180027',1),
(177996,'Exhaust Systems',4,180027,'131090:14780:180027',1),
(177997,'Headers, Manifolds & Studs',4,180027,'131090:14780:180027',1),
(177998,'Oxygen Sensors',4,180027,'131090:14780:180027',1),
(177999,'Pipes',4,180027,'131090:14780:180027',1),
(178000,'Silencers, Mufflers & Baffles',4,180027,'131090:14780:180027',1),
(178001,'Other Exhaust Parts',4,180027,'131090:14780:180027',1),
(178010,'Clocks',4,180033,'131090:14780:180033',1),
(178011,'Instrument Cables',4,180033,'131090:14780:180033',1),
(178012,'Instrument Clusters',4,180033,'131090:14780:180033',1),
(178013,'Fuel Gauges',4,180033,'131090:14780:180033',1),
(178014,'Odometers',4,180033,'131090:14780:180033',1),
(178015,'Speedometers',4,180033,'131090:14780:180033',1),
(178016,'Tachometers',4,180033,'131090:14780:180033',1),
(178017,'Temperature Gauges',4,180033,'131090:14780:180033',1),
(178018,'Other Instruments & Gauges',4,180033,'131090:14780:180033',1),
(178019,'Bulbs, LEDs & HIDs',4,180034,'131090:14780:180034',1),
(178020,'Display Lights',4,180034,'131090:14780:180034',1),
(178021,'Fog Light Assemblies',4,180034,'131090:14780:180034',1),
(178022,'Headlight Assemblies',4,180034,'131090:14780:180034',1),
(178023,'Indicator Assemblies',4,180034,'131090:14780:180034',1),
(178024,'Lenses & Projectors',4,180034,'131090:14780:180034',1),
(178025,'Number Plate Lights',4,180034,'131090:14780:180034',1),
(178026,'Rear & Brake Light Assemblies',4,180034,'131090:14780:180034',1),
(178027,'Other Lighting Parts',4,180034,'131090:14780:180034',1),
(178037,'Bearings & Bushings',4,49790,'131090:14780:49790',1),
(178038,'Complete Suspension Units',4,49790,'131090:14780:49790',1),
(178039,'Fork Seals',4,49790,'131090:14780:49790',1),
(178040,'Fork Tubes',4,49790,'131090:14780:49790',1),
(178041,'Triple Trees',4,49790,'131090:14780:49790',1),
(178042,'Shocks',4,49790,'131090:14780:49790',1),
(178059,'Cookie Presses',4,177009,'11700:20625:177009',1),
(178074,'Outboard Engines & Components',3,26443,'131090:26443',0),
(178075,'Bullbars',4,33637,'131090:6030:33637',1),
(178078,'Bullion',2,11116,'11116',0),
(178348,'eBay Test Only',3,14112,'99:14112',0),
(178349,'Group 1',4,178348,'99:14112:178348',0),
(178350,'Category 1',5,178349,'99:14112:178348:178349',1),
(178351,'Category 2',5,178349,'99:14112:178348:178349',1),
(178352,'Category 3',5,178349,'99:14112:178348:178349',1),
(178353,'Category 4',5,178349,'99:14112:178348:178349',1),
(178354,'Category 5',5,178349,'99:14112:178348:178349',1),
(178355,'Category 6',5,178349,'99:14112:178348:178349',1),
(178356,'Category 7',5,178349,'99:14112:178348:178349',1),
(178357,'Category 8',5,178349,'99:14112:178348:178349',1),
(178358,'Category 9',5,178349,'99:14112:178348:178349',1),
(178359,'Category 10',5,178349,'99:14112:178348:178349',1),
(178360,'Category 11',5,178349,'99:14112:178348:178349',1),
(178361,'Category 12',5,178349,'99:14112:178348:178349',1),
(178362,'Category 13',5,178349,'99:14112:178348:178349',1),
(178363,'Category 14',5,178349,'99:14112:178348:178349',1),
(178364,'Category 15',5,178349,'99:14112:178348:178349',1),
(178365,'Category 16',5,178349,'99:14112:178348:178349',1),
(178366,'Category 17',5,178349,'99:14112:178348:178349',1),
(178367,'Category 18',5,178349,'99:14112:178348:178349',1),
(178368,'Category 19',5,178349,'99:14112:178348:178349',1),
(178369,'Category 20',5,178349,'99:14112:178348:178349',1),
(178370,'Category 21',5,178349,'99:14112:178348:178349',1),
(178371,'Category 22',5,178349,'99:14112:178348:178349',1),
(178372,'Category 23',5,178349,'99:14112:178348:178349',1),
(178373,'Category 24',5,178349,'99:14112:178348:178349',1),
(178374,'Category 25',5,178349,'99:14112:178348:178349',1),
(178375,'Group 2',4,178348,'99:14112:178348',0),
(178376,'Category 1',5,178375,'99:14112:178348:178375',1),
(178377,'Category 2',5,178375,'99:14112:178348:178375',1),
(178378,'Category 3',5,178375,'99:14112:178348:178375',1),
(178379,'Category 4',5,178375,'99:14112:178348:178375',1),
(178380,'Category 5',5,178375,'99:14112:178348:178375',1),
(178381,'Category 6',5,178375,'99:14112:178348:178375',1),
(178382,'Category 7',5,178375,'99:14112:178348:178375',1),
(178383,'Category 8',5,178375,'99:14112:178348:178375',1),
(178384,'Category 9',5,178375,'99:14112:178348:178375',1),
(178385,'Category 10',5,178375,'99:14112:178348:178375',1),
(178386,'Category 11',5,178375,'99:14112:178348:178375',1),
(178387,'Category 12',5,178375,'99:14112:178348:178375',1),
(178388,'Category 13',5,178375,'99:14112:178348:178375',1),
(178389,'Category 14',5,178375,'99:14112:178348:178375',1),
(178390,'Category 15',5,178375,'99:14112:178348:178375',1),
(178391,'Category 16',5,178375,'99:14112:178348:178375',1),
(178392,'Category 17',5,178375,'99:14112:178348:178375',1),
(178393,'Category 18',5,178375,'99:14112:178348:178375',1),
(178394,'Category 19',5,178375,'99:14112:178348:178375',1),
(178395,'Category 20',5,178375,'99:14112:178348:178375',1),
(178396,'Category 21',5,178375,'99:14112:178348:178375',1),
(178397,'Category 22',5,178375,'99:14112:178348:178375',1),
(178398,'Category 23',5,178375,'99:14112:178348:178375',1),
(178399,'Category 24',5,178375,'99:14112:178348:178375',1),
(178400,'Category 25',5,178375,'99:14112:178348:178375',1),
(178401,'Group 3',4,178348,'99:14112:178348',0),
(178402,'Category 1',5,178401,'99:14112:178348:178401',1),
(178403,'Category 2',5,178401,'99:14112:178348:178401',1),
(178404,'Category 3',5,178401,'99:14112:178348:178401',1),
(178405,'Category 4',5,178401,'99:14112:178348:178401',1),
(178406,'Category 5',5,178401,'99:14112:178348:178401',1),
(178407,'Category 6',5,178401,'99:14112:178348:178401',1),
(178408,'Category 7',5,178401,'99:14112:178348:178401',1),
(178409,'Category 8',5,178401,'99:14112:178348:178401',1),
(178410,'Category 9',5,178401,'99:14112:178348:178401',1),
(178411,'Category 10',5,178401,'99:14112:178348:178401',1),
(178412,'Category 11',5,178401,'99:14112:178348:178401',1),
(178413,'Category 12',5,178401,'99:14112:178348:178401',1),
(178414,'Category 13',5,178401,'99:14112:178348:178401',1),
(178415,'Category 14',5,178401,'99:14112:178348:178401',1),
(178416,'Category 15',5,178401,'99:14112:178348:178401',1),
(178417,'Category 16',5,178401,'99:14112:178348:178401',1),
(178418,'Category 17',5,178401,'99:14112:178348:178401',1),
(178419,'Category 18',5,178401,'99:14112:178348:178401',1),
(178420,'Category 19',5,178401,'99:14112:178348:178401',1),
(178421,'Category 20',5,178401,'99:14112:178348:178401',1),
(178422,'Category 21',5,178401,'99:14112:178348:178401',1),
(178423,'Category 22',5,178401,'99:14112:178348:178401',1),
(178424,'Category 23',5,178401,'99:14112:178348:178401',1),
(178425,'Category 24',5,178401,'99:14112:178348:178401',1),
(178426,'Category 25',5,178401,'99:14112:178348:178401',1),
(178427,'Group 4',4,178348,'99:14112:178348',0),
(178428,'Category 1',5,178427,'99:14112:178348:178427',1),
(178429,'Category 2',5,178427,'99:14112:178348:178427',1),
(178430,'Category 3',5,178427,'99:14112:178348:178427',1),
(178431,'Category 4',5,178427,'99:14112:178348:178427',1),
(178432,'Category 5',5,178427,'99:14112:178348:178427',1),
(178433,'Category 6',5,178427,'99:14112:178348:178427',1),
(178434,'Category 7',5,178427,'99:14112:178348:178427',1),
(178435,'Category 8',5,178427,'99:14112:178348:178427',1),
(178436,'Category 9',5,178427,'99:14112:178348:178427',1),
(178437,'Category 10',5,178427,'99:14112:178348:178427',1),
(178438,'Category 11',5,178427,'99:14112:178348:178427',1),
(178439,'Category 12',5,178427,'99:14112:178348:178427',1),
(178440,'Category 13',5,178427,'99:14112:178348:178427',1),
(178441,'Category 14',5,178427,'99:14112:178348:178427',1),
(178442,'Category 15',5,178427,'99:14112:178348:178427',1),
(178443,'Category 16',5,178427,'99:14112:178348:178427',1),
(178444,'Category 17',5,178427,'99:14112:178348:178427',1),
(178445,'Category 18',5,178427,'99:14112:178348:178427',1),
(178446,'Category 19',5,178427,'99:14112:178348:178427',1),
(178447,'Category 20',5,178427,'99:14112:178348:178427',1),
(178448,'Category 21',5,178427,'99:14112:178348:178427',1),
(178449,'Category 22',5,178427,'99:14112:178348:178427',1),
(178450,'Category 23',5,178427,'99:14112:178348:178427',1),
(178451,'Category 24',5,178427,'99:14112:178348:178427',1),
(178452,'Category 25',5,178427,'99:14112:178348:178427',1),
(178885,'Reel Parts & Repair',4,179950,'888:1492:179950',1),
(178893,'Smart Watches',2,15032,'15032',1),
(178894,'Smart Glasses',3,14948,'293:14948',1),
(178895,'Pianola/Player Piano Rolls',5,181196,'619:181162:181193:181196',1),
(178896,'MIDI Keyboards & Controllers',3,180014,'619:180014',1),
(178906,'Bars',4,45134,'11116:178078:45134',1),
(178959,'Nail Airbrush Kits & Supplies',3,47945,'26395:47945',1),
(178960,'Electric Files & Tools',3,47945,'26395:47945',1),
(178961,'Gel Nails',3,47945,'26395:47945',1),
(178964,'Women\'s Razors',4,179841,'26395:31762:179841',1),
(178965,'Women\'s Razor Blades',4,179841,'26395:31762:179841',1),
(178976,'Melodicas',4,181268,'619:10181:181268',1),
(178977,'Weeding Tools',6,181047,'11700:159912:2032:181034:181047',1),
(178978,'Parts & Accessories',5,181033,'11700:159912:2032:181033',1),
(178980,'Manual Edgers',5,181033,'11700:159912:2032:181033',1),
(178981,'Post Hole Diggers & Augers',5,181033,'11700:159912:2032:181033',1),
(178982,'Mattocks & Picks',5,181033,'11700:159912:2032:181033',1),
(178983,'Shovels',5,181033,'11700:159912:2032:181033',1),
(178984,'Garden Sprayers',5,179308,'11700:159912:2032:179308',1),
(178985,'Environmental Controls',5,43554,'11700:159912:2032:43554',1),
(178986,'Seed Starting & Cloning',5,43554,'11700:159912:2032:43554',1),
(178987,'Grow Light Parts & Accessories',5,43554,'11700:159912:2032:43554',1),
(178988,'Grow Light Bulbs',5,43554,'11700:159912:2032:43554',1),
(178989,'Grow Light Kits',5,43554,'11700:159912:2032:43554',1),
(178990,'Growing Media',5,43554,'11700:159912:2032:43554',1),
(178991,'Hydroponic Systems',5,43554,'11700:159912:2032:43554',1),
(178992,'Nutrients, pH & Supplements',5,43554,'11700:159912:2032:43554',1),
(178993,'Tents, Tarps & Shelves',5,43554,'11700:159912:2032:43554',1),
(179000,'Saddle Covers',4,3159,'888:3153:3159',1),
(179001,'Equipment Parts & Accessories',4,28064,'888:15273:28064',1),
(179002,'Groove Sharpeners',4,181128,'888:1513:181128',1),
(179003,'Skirts, Skorts & Dresses',5,181142,'888:1513:181130:181142',1),
(179010,'Tents',4,181404,'888:16034:181404',1),
(179011,'Canopies & Shelters',4,181404,'888:16034:181404',1),
(179013,'Other Baby Toys',3,19068,'2984:19068',1),
(179014,'Baritones',3,16212,'619:16212',1),
(179015,'Tubas',3,16212,'619:16212',1),
(179016,'Grow Light Ballasts',5,43554,'11700:159912:2032:43554',1),
(179019,'Other Tents & Canopies',4,181404,'888:16034:181404',1),
(179022,'Hydroponic Parts & Accessories',5,43554,'11700:159912:2032:43554',1),
(179170,'Currency',3,179197,'11116:179197',1),
(179171,'Miners',3,179197,'11116:179197',1),
(179172,'Mining Contracts',3,179197,'11116:179197',1),
(179197,'Virtual Currency',2,11116,'11116',0),
(179276,'Tattoo Needles, Grips & Tips',3,33914,'26395:33914',1),
(179281,'Golf Equip. Tools & Supplies',4,47323,'888:1513:47323',1),
(179308,'Plant Care, Soil & Accessories',4,2032,'11700:159912:2032',0),
(179310,'Erotic Clothing',2,11450,'11450',0),
(179312,'Bondage Clothing',3,179310,'11450:179310',1),
(179313,'Women\'s Underwear',3,179310,'11450:179310',0),
(179314,'Bras & Bra Sets',4,179313,'11450:179310:179313',1),
(179315,'Bodies & Catsuits',4,179313,'11450:179310:179313',1),
(179316,'Corsets',4,179313,'11450:179310:179313',1),
(179317,'Panties',4,179313,'11450:179310:179313',1),
(179318,'Stockings',4,179313,'11450:179310:179313',1),
(179319,'Other Women\'s Underwear',4,179313,'11450:179310:179313',1),
(179320,'Men\'s Underwear',3,179310,'11450:179310',1),
(179321,'Women\'s Costumes',3,179310,'11450:179310',1),
(179322,'Men\'s Costumes',3,179310,'11450:179310',1),
(179323,'Shoes & Boots',3,179310,'11450:179310',1),
(179324,'Other Erotic Clothing',3,179310,'11450:179310',1),
(179327,'Kyrgyzstan',3,181416,'260:181416',1),
(179328,'Armenia',3,181416,'260:181416',1),
(179329,'Azerbaijan',3,181416,'260:181416',1),
(179330,'Bangladesh',3,181416,'260:181416',1),
(179331,'Burma/Myanmar',3,181416,'260:181416',1),
(179332,'Georgia',3,181416,'260:181416',1),
(179333,'Kazakhstan',3,181416,'260:181416',1),
(179334,'Macau',3,181416,'260:181416',1),
(179335,'Malaysia',3,181416,'260:181416',1),
(179336,'Maldives',3,181416,'260:181416',1),
(179337,'Pakistan',3,181416,'260:181416',1),
(179338,'Singapore',3,181416,'260:181416',1),
(179339,'Sri Lanka',3,181416,'260:181416',1),
(179340,'Tajikistan',3,181416,'260:181416',1),
(179341,'Timor',3,181416,'260:181416',1),
(179342,'Turkmenistan',3,181416,'260:181416',1),
(179343,'Uzbekistan',3,181416,'260:181416',1),
(179344,'Cook Islands',3,181424,'260:181424',1),
(179345,'Fiji',3,181424,'260:181424',1),
(179346,'Micronesia',3,181424,'260:181424',1),
(179347,'Niue',3,181424,'260:181424',1),
(179348,'Papua New Guinea',3,181424,'260:181424',1),
(179349,'Samoa',3,181424,'260:181424',1),
(179350,'Solomon Islands',3,181424,'260:181424',1),
(179351,'Tokelau Islands',3,181424,'260:181424',1),
(179352,'Tonga',3,181424,'260:181424',1),
(179353,'Vanuatu',3,181424,'260:181424',1),
(179354,'Collections, Mixture',3,181424,'260:181424',1),
(179355,'Djibouti',3,181423,'260:181423',1),
(179356,'Equatorial Guinea',3,181423,'260:181423',1),
(179357,'Eritrea',3,181423,'260:181423',1),
(179358,'Guinea-Bissau',3,181423,'260:181423',1),
(179359,'Burundi',3,181423,'260:181423',1),
(179360,'Comoros',3,181423,'260:181423',1),
(179361,'Gambia',3,181423,'260:181423',1),
(179362,'Ghana',3,181423,'260:181423',1),
(179363,'Kenya',3,181423,'260:181423',1),
(179364,'Nigeria',3,181423,'260:181423',1),
(179365,'Rwanda',3,181423,'260:181423',1),
(179366,'Sao Tome & Principe',3,181423,'260:181423',1),
(179367,'Seychelles',3,181423,'260:181423',1),
(179368,'Sierra Leone',3,181423,'260:181423',1),
(179369,'Swaziland',3,181423,'260:181423',1),
(179370,'Cape Verde',3,181423,'260:181423',1),
(179371,'Malawi',3,181423,'260:181423',1),
(179372,'Namibia',3,181423,'260:181423',1),
(179373,'Uganda',3,181423,'260:181423',1),
(179374,'Zambia',3,181423,'260:181423',1),
(179375,'Zimbabwe',3,181423,'260:181423',1),
(179376,'Other African',3,181423,'260:181423',1),
(179377,'Caribbean',2,260,'260',0),
(179378,'Antigua & Barbuda',3,179377,'260:179377',1),
(179379,'Bahamas',3,179377,'260:179377',1),
(179380,'Barbados',3,179377,'260:179377',1),
(179381,'Dominica',3,179377,'260:179377',1),
(179382,'Dominican Republic',3,179377,'260:179377',1),
(179383,'Grenada',3,179377,'260:179377',1),
(179384,'Jamaica',3,179377,'260:179377',1),
(179385,'St Kitts & Nevis',3,179377,'260:179377',1),
(179386,'St Lucia',3,179377,'260:179377',1),
(179387,'St Vincent & the Grenadines',3,179377,'260:179377',1),
(179388,'Trinidad & Tobago',3,179377,'260:179377',1),
(179389,'Turks & Caicos Islands',3,179377,'260:179377',1),
(179390,'Collections, Mixture',3,179377,'260:179377',1),
(179391,'Other Caribbean',3,179377,'260:179377',1),
(179392,'Cyprus',3,4742,'260:4742',1),
(179393,'Kosovo',3,4742,'260:4742',1),
(179394,'Macedonia',3,4742,'260:4742',1),
(179395,'Malta',3,4742,'260:4742',1),
(179396,'Moldova',3,4742,'260:4742',1),
(179397,'Montenegro',3,4742,'260:4742',1),
(179398,'Serbia',3,4742,'260:4742',1),
(179399,'Belize',3,181417,'260:181417',1),
(179400,'Other Central & South American',3,181417,'260:181417',1),
(179401,'Science & Technology',3,4752,'260:4752',1),
(179402,'Memorabilia',3,7898,'260:7898',1),
(179405,'Other Middle Eastern',3,181422,'260:181422',1),
(179406,'Port Dust Covers',3,9394,'15032:9394',1),
(179407,'Errors, Freaks, Oddities',4,153383,'260:3468:153383',1),
(179469,'Battery Testers & Chargers',4,34998,'131090:6030:34998',0),
(179470,'Battery Testers',5,179469,'131090:6030:34998:179469',1),
(179471,'Chargers & Jump Starters',5,179469,'131090:6030:34998:179469',1),
(179472,'Booster/Jumper Cables',5,179469,'131090:6030:34998:179469',1),
(179473,'Other Battery Equipment',5,179469,'131090:6030:34998:179469',1),
(179653,'Perforation Gauges',3,181421,'260:181421',1),
(179687,'Garage Door Parts & Accs',4,180972,'11700:3187:180972',1),
(179688,'Opener Parts & Accessories',4,180972,'11700:3187:180972',1),
(179689,'Painting Prep',4,41989,'11700:3187:41989',1),
(179690,'Furniture Parts & Accessories',3,3197,'11700:3197',1),
(179697,'Camera Drones',2,625,'625',1),
(179715,'Luggage',3,25622,'131090:25622',0),
(179718,'Backpacks',4,179715,'131090:25622:179715',1),
(179719,'Top Boxes & Tail Bags',4,179715,'131090:25622:179715',1),
(179721,'Other Luggage',4,179715,'131090:25622:179715',1),
(179722,'Other Ramps & Towing',4,183530,'131090:25622:183530',1),
(179723,'Security',3,25622,'131090:25622',0),
(179724,'Alarms',4,179723,'131090:25622:179723',1),
(179725,'Ground & Wall Anchors',4,179723,'131090:25622:179723',1),
(179726,'Chains, Cables & U-Locks',4,179723,'131090:25622:179723',1),
(179727,'Brake Disc Locks',4,179723,'131090:25622:179723',1),
(179728,'Other Security',4,179723,'131090:25622:179723',1),
(179730,'Leg Covers',4,183536,'131090:25622:183536',1),
(179731,'Lifts & Stands',3,25622,'131090:25622',0),
(179732,'Paddock Stands',4,179731,'131090:25622:179731',1),
(179733,'Lifts & Jacks',4,179731,'131090:25622:179731',1),
(179734,'Other Lifts & Stands',4,179731,'131090:25622:179731',1),
(179735,'Care, Cleaning & Protection',3,25622,'131090:25622',0),
(179736,'Brushes, Cloths & Sponges',4,179735,'131090:25622:179735',1),
(179737,'Care Kits',4,179735,'131090:25622:179735',1),
(179739,'Tank Pads',4,179735,'131090:25622:179735',1),
(179740,'Other Care & Cleaning',4,179735,'131090:25622:179735',1),
(179767,'Boxing, Martial Arts & MMA',2,888,'888',0),
(179768,'Belt Displays',4,73980,'888:179767:73980',1),
(179769,'Headbands & Hats',4,73980,'888:179767:73980',1),
(179770,'Hoodies & Sweatshirts',4,73980,'888:179767:73980',1),
(179771,'Jackets',4,73980,'888:179767:73980',1),
(179772,'Pants',4,73980,'888:179767:73980',1),
(179773,'Robes',4,73980,'888:179767:73980',1),
(179774,'Uniforms & Gis',4,73980,'888:179767:73980',1),
(179775,'Protective Gear',3,179767,'888:179767',0),
(179776,'Chest Guards',4,179775,'888:179767:179775',1),
(179777,'Elbow, Knee & Ankle Guards',4,179775,'888:179767:179775',1),
(179778,'Groin Protectors',4,179775,'888:179767:179775',1),
(179779,'Hand Wraps',4,179775,'888:179767:179775',1),
(179780,'Head Gear',4,179775,'888:179767:179775',1),
(179781,'Mouth Guards',4,179775,'888:179767:179775',1),
(179782,'Shin Guards',4,179775,'888:179767:179775',1),
(179783,'Other',4,179775,'888:179767:179775',1),
(179784,'Training Equipment & Supplies',3,179767,'888:179767',0),
(179785,'Bag Stands, Platforms & Accs',4,179784,'888:179767:179784',1),
(179786,'Dummies',4,179784,'888:179767:179784',1),
(179787,'Elevation Training Masks',4,179784,'888:179767:179784',1),
(179788,'Floor Mats & Pads',4,179784,'888:179767:179784',1),
(179789,'Strike Pads & Mitts',4,179784,'888:179767:179784',1),
(179790,'Corner Supplies',4,179784,'888:179767:179784',1),
(179791,'Other',4,179784,'888:179767:179784',1),
(179792,'Martial Arts Weapons',3,179767,'888:179767',0),
(179793,'Knives',4,179792,'888:179767:179792',1),
(179794,'Sticks',4,179792,'888:179767:179792',1),
(179795,'Swords',4,179792,'888:179767:179792',1),
(179796,'Other',4,179792,'888:179767:179792',1),
(179797,'Machine Parts & Accessories',4,28059,'888:15273:28059',1),
(179798,'Activity Trackers',4,44075,'888:15273:44075',1),
(179799,'Fit Tech Parts & Accessories',4,44075,'888:15273:44075',1),
(179800,'Foam Rollers',4,28064,'888:15273:28064',1),
(179801,'Gym Towels',4,28064,'888:15273:28064',1),
(179802,'Running Belts',4,28064,'888:15273:28064',1),
(179803,'Balance Trainers',4,28064,'888:15273:28064',1),
(179804,'Ballet Barres',4,28064,'888:15273:28064',1),
(179805,'Dance Poles & Accessories',4,28064,'888:15273:28064',1),
(179806,'Equipment Mats & Flooring',4,28064,'888:15273:28064',1),
(179807,'Pilates Tables',4,158927,'888:15273:158927',1),
(179808,'Pilates Rings',4,158927,'888:15273:158927',1),
(179809,'Yoga Props',4,158927,'888:15273:158927',1),
(179810,'Running Gloves',4,158913,'888:15273:158913',1),
(179811,'Sweatbands',4,158913,'888:15273:158913',1),
(179812,'Sauna Suits',4,158913,'888:15273:158913',1),
(179813,'Home Gym Attachments',4,28066,'888:15273:28066',1),
(179814,'Kettlebells',4,28066,'888:15273:28066',1),
(179815,'Power Racks & Smith Machines',4,28066,'888:15273:28066',1),
(179816,'Pull Up Bars',4,28066,'888:15273:28066',1),
(179817,'Weight Plates',4,28066,'888:15273:28066',1),
(179818,'Weight Sets',4,28066,'888:15273:28066',1),
(179819,'Weight Storage',4,28066,'888:15273:28066',1),
(179820,'Gloves, Straps & Hooks',4,28066,'888:15273:28066',1),
(179821,'Wrist & Knee Wraps',4,28066,'888:15273:28066',1),
(179822,'Compression & Base Layers',5,40883,'888:15273:158913:40883',1),
(179824,'Skirts & Skorts',5,40883,'888:15273:158913:40883',1),
(179825,'Compression & Base Layers',5,40884,'888:15273:158913:40884',1),
(179827,'Jackets & Vests',5,180091,'888:15273:158913:180091',1),
(179828,'Compression & Base Layers',5,180091,'888:15273:158913:180091',1),
(179829,'Pants',5,180091,'888:15273:158913:180091',1),
(179830,'Shirts',5,180091,'888:15273:158913:180091',1),
(179831,'Shorts',5,180091,'888:15273:158913:180091',1),
(179832,'Socks',5,180091,'888:15273:158913:180091',1),
(179833,'Other',5,180091,'888:15273:158913:180091',1),
(179835,'Prepared Foods',2,14308,'14308',1),
(179836,'Alcohol & Alcohol Mixes',2,14308,'14308',0),
(179837,'Cocktail Mixes',3,179836,'14308:179836',1),
(179838,'Cocktail Rimming Salts, Sugars',4,71259,'14308:179836:71259',1),
(179840,'Pantyhose & Tights',3,172378,'2984:172378',1),
(179841,'Razors & Razor Blades',3,31762,'26395:31762',0),
(179846,'Batteries',4,33572,'131090:6030:33572',1),
(179847,'Battery Cables & Connectors',4,33572,'131090:6030:33572',1),
(179848,'Interior Door Handles',4,33694,'131090:6030:33694',1),
(179849,'Door Hinge Conversion Kits',4,33637,'131090:6030:33637',1),
(179850,'Exterior Door Panels & Frames',4,33637,'131090:6030:33637',1),
(179851,'Exterior Door Handles',4,33637,'131090:6030:33637',1),
(179853,'Electrical & Ignition',3,14780,'131090:14780',0),
(179946,'Rods',3,1492,'888:1492',0),
(179948,'Saltwater Rods',4,179946,'888:1492:179946',1),
(179949,'Travel Rods',4,179946,'888:1492:179946',1),
(179950,'Reels',3,1492,'888:1492',0),
(179953,'Rod & Reel Combos',3,1492,'888:1492',0),
(179954,'Baitcaster Combos',4,179953,'888:1492:179953',1),
(179955,'Spincaster Combos',4,179953,'888:1492:179953',1),
(179956,'Spinning Combos',4,179953,'888:1492:179953',1),
(179957,'Trolling Combos',4,179953,'888:1492:179953',1),
(179959,'Saltwater Combos',4,179953,'888:1492:179953',1),
(179960,'Other',4,179953,'888:1492:179953',1),
(179961,'Baits, Lures & Flies',3,1492,'888:1492',0),
(179962,'Attractants & Scents',4,179961,'888:1492:179961',1),
(179964,'Mixed Lots',4,179961,'888:1492:179961',1),
(179965,'Line & Leaders',3,1492,'888:1492',0),
(179966,'Braided Line',4,179965,'888:1492:179965',1),
(179967,'Fluorocarbon Line',4,179965,'888:1492:179965',1),
(179968,'Lead Core & Trolling Line',4,179965,'888:1492:179965',1),
(179969,'Monofilament Line',4,179965,'888:1492:179965',1),
(179970,'Leaders & Leader Material',4,179965,'888:1492:179965',1),
(179971,'Line Tools & Accessories',4,179965,'888:1492:179965',1),
(179972,'Other',4,179965,'888:1492:179965',1),
(179973,'Terminal Tackle',3,1492,'888:1492',0),
(179974,'Crimps & Sleeves',4,179973,'888:1492:179973',1),
(179975,'Rigs & Harnesses',4,179973,'888:1492:179973',1),
(179976,'Swivels & Snaps',4,179973,'888:1492:179973',1),
(179977,'Other',4,179973,'888:1492:179973',1),
(179978,'Clothing, Shoes & Accessories',3,1492,'888:1492',0),
(179979,'Base Layers',4,179978,'888:1492:179978',1),
(179980,'Boots & Shoes',4,179978,'888:1492:179978',1),
(179981,'Jacket & Pants Sets',4,179978,'888:1492:179978',1),
(179982,'Shirts & Tops',4,179978,'888:1492:179978',1),
(179983,'Jumpers & Hoodies',4,179978,'888:1492:179978',1),
(179984,'Waders',4,179978,'888:1492:179978',1),
(179985,'Fishing Equipment',3,1492,'888:1492',0),
(179986,'Bait Buckets',4,179985,'888:1492:179985',1),
(179988,'Decals, Stickers & Patches',4,179985,'888:1492:179985',1),
(179989,'Fighting Belts & Harnesses',4,179985,'888:1492:179985',1),
(179990,'Fish Processing & Cooking',4,179985,'888:1492:179985',0),
(179991,'Fish Scalers & Skinners',5,179990,'888:1492:179985:179990',1),
(179992,'Other',5,179990,'888:1492:179985:179990',1),
(179994,'Fishing Spears & Gaffs',4,179985,'888:1492:179985',1),
(179997,'Pliers & Hook Removers',4,179985,'888:1492:179985',1),
(179998,'Reel Cases & Storage',4,179985,'888:1492:179985',1),
(179999,'Stringers & Fish Baskets',4,179985,'888:1492:179985',1),
(180000,'Underwater Cameras',4,179985,'888:1492:179985',1),
(180001,'Vintage',3,1492,'888:1492',0),
(180003,'Cutters, Dispensers & Racks',4,109699,'170638:19273:109699',1),
(180004,'Edge Protectors',4,109699,'170638:19273:109699',1),
(180005,'Moving Blankets & Pads',4,109699,'170638:19273:109699',1),
(180006,'Desiccant, Moisture Absorber',3,19273,'170638:19273',1),
(180008,'Generic Accessories',2,619,'619',0),
(180009,'Parts & Accessories',3,3858,'619:3858',0),
(180010,'Pianos, Keyboards & Organs',2,619,'619',0),
(180012,'Percussion',2,619,'619',0),
(180014,'Pro Audio',2,619,'619',0),
(180015,'Sheet Music & Song Books',2,619,'619',0),
(180016,'String',2,619,'619',0),
(180017,'Ocarinas',4,181268,'619:10181:181268',1),
(180018,'Magnetic Building Sets',3,183446,'220:183446',1),
(180019,'Marble Runs',3,183446,'220:183446',1),
(180020,'Storage, Mats & Play Tables',3,183446,'220:183446',1),
(180023,'Minifigure Parts & Accessories',4,183447,'220:183446:183447',1),
(180024,'Oil Tanks',4,171107,'131090:14780:171107',1),
(180025,'Stator Covers',4,171107,'131090:14780:171107',1),
(180026,'Radiator Caps',4,177962,'131090:14780:177962',1),
(180027,'Exhausts & Exhaust Systems',3,14780,'131090:14780',0),
(180028,'Air Intake & Fuel Delivery',3,14780,'131090:14780',0),
(180029,'Drivetrain & Transmission',3,14780,'131090:14780',0),
(180030,'Other Clutch Parts',4,180029,'131090:14780:180029',1),
(180031,'Drive Belts & Parts',4,180029,'131090:14780:180029',1),
(180032,'Primary Drive Belts',4,180029,'131090:14780:180029',1),
(180033,'Instruments & Gauges',3,14780,'131090:14780',0),
(180034,'Lighting & Indicators',3,14780,'131090:14780',0),
(180035,'Wheels, Tyres & Tubes',3,14780,'131090:14780',0),
(180036,'Axles, Bearings & Seals',4,180035,'131090:14780:180035',1),
(180037,'Wheel Hub Assemblies',4,180035,'131090:14780:180035',1),
(180091,'Youth Clothing',4,158913,'888:15273:158913',0),
(180092,'Saltwater Reels',4,179950,'888:1492:179950',1),
(180093,'Premixed & Flavoured Alcohol',3,179836,'14308:179836',1),
(180094,'Energy & Hydration',4,97033,'888:15273:97033',1),
(180112,'Wallpaper Tools & Accessories',4,180981,'11700:3187:180981',1),
(180113,'Windows & Window Hardware',3,3187,'11700:3187',0),
(180114,'Other Window Accessories',4,180113,'11700:3187:180113',1),
(180135,'Hoodies & Sweatshirts',5,180091,'888:15273:158913:180091',1),
(180159,'Big Bore & Top End Kits',4,171107,'131090:14780:171107',1),
(180160,'Idle & Cruise Cables',4,180028,'131090:14780:180028',1),
(180164,'Paint',4,180979,'11700:3187:180979',1),
(180166,'Other Heating, Cooling & Air',3,69197,'20710:69197',1),
(180208,'Beads & Eyes',5,44912,'888:1492:179961:44912',1),
(180235,'Tablet & eBook Reader Parts',2,58058,'58058',1),
(180246,'Other',4,173696,'281:14324:173696',1),
(180249,'Belts & Sashes',4,106127,'11450:3259:106127',1),
(180250,'Model Trains',2,220,'220',0),
(180251,'Parts & Spares',5,81043,'220:180250:19145:81043',1),
(180252,'Empty Boxes',5,81043,'220:180250:19145:81043',1),
(180253,'Empty Boxes',5,81055,'220:180250:19119:81055',1),
(180254,'Parts & Spares',5,81055,'220:180250:19119:81055',1),
(180255,'Decals',5,81022,'220:180250:13290:81022',1),
(180256,'Parts & Spares',5,81022,'220:180250:13290:81022',1),
(180257,'Empty Boxes',5,81022,'220:180250:13290:81022',1),
(180258,'Decals',5,81064,'220:180250:30654:81064',1),
(180259,'Parts & Spares',5,81064,'220:180250:30654:81064',1),
(180260,'Empty Boxes',5,81064,'220:180250:30654:81064',1),
(180261,'Decals',5,81083,'220:180250:19116:81083',1),
(180262,'Parts & Spares',5,81083,'220:180250:19116:81083',1),
(180263,'Empty Boxes',5,81083,'220:180250:19116:81083',1),
(180264,'Parts & Spares',5,80979,'220:180250:19151:80979',1),
(180265,'Empty Boxes',5,80979,'220:180250:19151:80979',1),
(180266,'Mouthwash',3,31769,'26395:31769',1),
(180267,'Tongue Cleaners',3,31769,'26395:31769',1),
(180268,'Aircraft & Spacecraft',3,222,'220:222',0),
(180269,'Boats & Ships',3,222,'220:222',0),
(180270,'Formula 1 Cars',4,171127,'220:222:171127',1),
(180271,'Rally Cars',4,171127,'220:222:171127',1),
(180272,'Sport & Touring Cars',4,171127,'220:222:171127',1),
(180273,'Cars, Trucks & Vans',3,222,'220:222',0),
(180274,'Construction Equipment',3,222,'220:222',0),
(180275,'Farm Vehicles',3,222,'220:222',0),
(180276,'Motorcycles & ATVs',3,222,'220:222',0),
(180277,'Other Vehicles',3,222,'220:222',0),
(180278,'Accessories, Parts & Display',3,222,'220:222',0),
(180279,'Figures',4,180278,'220:222:180278',1),
(180280,'Parts & Accessories',4,19128,'220:180250:19128',0),
(180281,'Parts & Spares',5,180280,'220:180250:19128:180280',1),
(180282,'Passenger Cars',4,19143,'220:180250:19143',1),
(180283,'Locomotives',4,19143,'220:180250:19143',1),
(180284,'Track',4,19143,'220:180250:19143',1),
(180285,'Starter Sets & Packs',4,19143,'220:180250:19143',1),
(180286,'Carriages',4,19143,'220:180250:19143',1),
(180287,'Parts & Accessories',4,19143,'220:180250:19143',0),
(180288,'Buildings, Tunnels & Bridges',5,180287,'220:180250:19143:180287',1),
(180289,'Catenaries',5,180287,'220:180250:19143:180287',1),
(180290,'Figures & People',5,180287,'220:180250:19143:180287',1),
(180291,'Lamps & Lights',5,180287,'220:180250:19143:180287',1),
(180292,'Scenery & Trees',5,180287,'220:180250:19143:180287',1),
(180293,'Signals',5,180287,'220:180250:19143:180287',1),
(180294,'Parts & Spares',5,180287,'220:180250:19143:180287',1),
(180295,'Empty Boxes',5,180287,'220:180250:19143:180287',1),
(180296,'Rare Scales',3,180250,'220:180250',0),
(180297,'Passenger Cars',4,180296,'220:180250:180296',1),
(180298,'Locomotives',4,180296,'220:180250:180296',1),
(180299,'Track',4,180296,'220:180250:180296',1),
(180300,'Starter Sets & Packs',4,180296,'220:180250:180296',1),
(180301,'Carriages',4,180296,'220:180250:180296',1),
(180302,'Parts & Accessories',4,180296,'220:180250:180296',0),
(180303,'Buildings, Tunnels & Bridges',5,180302,'220:180250:180296:180302',1),
(180304,'Catenaries',5,180302,'220:180250:180296:180302',1),
(180305,'Figures & People',5,180302,'220:180250:180296:180302',1),
(180306,'Lamps & Lights',5,180302,'220:180250:180296:180302',1),
(180307,'Scenery & Trees',5,180302,'220:180250:180296:180302',1),
(180308,'Signals',5,180302,'220:180250:180296:180302',1),
(180309,'Decals',5,180302,'220:180250:180296:180302',1),
(180310,'Parts & Spares',5,180302,'220:180250:180296:180302',1),
(180311,'Empty Boxes',5,180302,'220:180250:180296:180302',1),
(180312,'Other',5,180302,'220:180250:180296:180302',1),
(180313,'Other',4,180296,'220:180250:180296',1),
(180314,'Parts & Accessories',4,122601,'220:180250:122601',0),
(180315,'Catenaries',5,180314,'220:180250:122601:180314',1),
(180316,'Figures & People',5,180314,'220:180250:122601:180314',1),
(180317,'Lamps & Lights',5,180314,'220:180250:122601:180314',1),
(180318,'Scenery & Trees',5,180314,'220:180250:122601:180314',1),
(180319,'Decals',5,180314,'220:180250:122601:180314',1),
(180320,'Parts & Spares',5,180314,'220:180250:122601:180314',1),
(180321,'Empty Boxes',5,180314,'220:180250:122601:180314',1),
(180322,'Passenger Cars',4,180508,'220:180250:180508',1),
(180323,'Locomotives',4,180508,'220:180250:180508',1),
(180324,'Track',4,180508,'220:180250:180508',1),
(180325,'Starter Sets & Packs',4,180508,'220:180250:180508',1),
(180326,'Carriages',4,180508,'220:180250:180508',1),
(180327,'Parts & Accessories',4,180508,'220:180250:180508',0),
(180328,'Buildings, Tunnels & Bridges',5,180327,'220:180250:180508:180327',1),
(180329,'Catenaries',5,180327,'220:180250:180508:180327',1),
(180330,'Figures & People',5,180327,'220:180250:180508:180327',1),
(180331,'Lamps & Lights',5,180327,'220:180250:180508:180327',1),
(180332,'Scenery & Trees',5,180327,'220:180250:180508:180327',1),
(180333,'Signals',5,180327,'220:180250:180508:180327',1),
(180334,'Decals',5,180327,'220:180250:180508:180327',1),
(180335,'Parts & Spares',5,180327,'220:180250:180508:180327',1),
(180336,'Empty Boxes',5,180327,'220:180250:180508:180327',1),
(180337,'Other',5,180327,'220:180250:180508:180327',1),
(180338,'Other',4,180508,'220:180250:180508',1),
(180339,'Power & Control',3,180250,'220:180250',0),
(180340,'Boosters',4,180339,'220:180250:180339',1),
(180341,'Control Accessories',4,180339,'220:180250:180339',1),
(180342,'Decoders',4,180339,'220:180250:180339',1),
(180343,'Speed Controllers',4,180339,'220:180250:180339',1),
(180344,'Transformers',4,180339,'220:180250:180339',1),
(180345,'Fragrances',2,26395,'26395',0),
(180347,'Chess Accessories',4,40852,'220:233:40852',1),
(180348,'Other',4,40852,'220:233:40852',1),
(180349,'Contemporary Manufacture',4,2550,'220:233:2550',1),
(180350,'Card Games & Poker',3,233,'220:233',0),
(180506,'Contemporary Manufacture',4,180273,'220:222:180273',1),
(180507,'Vintage Manufacture',4,180273,'220:222:180273',1),
(180508,'Standard Scale',3,180250,'220:180250',0),
(180509,'Narrow Gauge',3,180250,'220:180250',0),
(180510,'Other',5,180287,'220:180250:19143:180287',1),
(180512,'Electric Shavers',3,31762,'26395:31762',0),
(180513,'Electronics & Navigation',3,14780,'131090:14780',0),
(180514,'Amplifiers',4,180513,'131090:14780:180513',1),
(180515,'Audio Systems',4,180513,'131090:14780:180513',1),
(180516,'GPS/Navigation',4,180513,'131090:14780:180513',1),
(180517,'Headsets',4,180513,'131090:14780:180513',1),
(180518,'Intercoms',4,180513,'131090:14780:180513',1),
(180519,'Speakers',4,180513,'131090:14780:180513',1),
(180520,'Replacement Parts',4,180513,'131090:14780:180513',1),
(180521,'Other Electronics & Navigation',4,180513,'131090:14780:180513',1),
(180533,'Contemporary Manufacture',4,180277,'220:222:180277',1),
(180534,'Vintage Manufacture',4,180277,'220:222:180277',1),
(180905,'Canopies & Netting',3,20416,'2984:20416',1),
(180906,'Decorative Nursery Pillows',3,20416,'2984:20416',1),
(180907,'Cot Pillows',3,20416,'2984:20416',1),
(180908,'Quilts & Coverlets',3,20416,'2984:20416',1),
(180909,'Sheets & Sets',3,20416,'2984:20416',1),
(180911,'Pram & Stroller Accessories',3,66698,'2984:66698',0),
(180912,'Bassinets',4,180911,'2984:66698:180911',1),
(180913,'Cup Holders & Snack Trays',4,180911,'2984:66698:180911',1),
(180914,'Hooks',4,180911,'2984:66698:180911',1),
(180915,'Organisers & Nets',4,180911,'2984:66698:180911',1),
(180916,'Seat Liners',4,180911,'2984:66698:180911',1),
(180917,'Other Stroller Accessories',4,180911,'2984:66698:180911',1),
(180918,'Hand Washes',3,11838,'26395:11838',1),
(180919,'Tanning Body Stickers',3,31772,'26395:31772',1),
(180920,'Tanning Disposables',3,31772,'26395:31772',1),
(180921,'Airbrush Tanning Kits',3,31772,'26395:31772',1),
(180922,'Airbrush Compressors & Guns',3,31772,'26395:31772',1),
(180923,'Airbrush Tents',3,31772,'26395:31772',1),
(180924,'Bar Soaps',3,11838,'26395:11838',1),
(180925,'Travel Bottles & Containers',3,11838,'26395:11838',1),
(180926,'Trims',4,183270,'14339:160737:183270',1),
(180927,'Hook & Loop Tape',4,183253,'14339:160737:183253',1),
(180928,'Hot Fix Applicators',4,183270,'14339:160737:183270',1),
(180929,'Sewing Machine Parts & Accs',3,160737,'14339:160737',0),
(180930,'Quilting',3,160737,'14339:160737',0),
(180931,'First Aid',3,67588,'26395:67588',0),
(180932,'Alcohol Prep Pads',4,180931,'26395:67588:180931',1),
(180933,'Squeezable Stress Relievers',3,67588,'26395:67588',1),
(180934,'Chin Straps',4,82593,'26395:67588:82593',1),
(180935,'Mouthpieces',4,82593,'26395:67588:82593',1),
(180936,'Nasal Strips',4,82593,'26395:67588:82593',1),
(180937,'Sleeping Pills',4,82593,'26395:67588:82593',1),
(180938,'Ear Care',3,67588,'26395:67588',0),
(180939,'Ear Drops',4,180938,'26395:67588:180938',1),
(180940,'Ear Plugs',4,180938,'26395:67588:180938',1),
(180941,'Ear Wax Removers',4,180938,'26395:67588:180938',1),
(180942,'Feminine Hygiene',3,67588,'26395:67588',0),
(180943,'Feminine Hygiene Deodorants',4,180942,'26395:67588:180942',1),
(180944,'Feminine Hygiene Washes',4,180942,'26395:67588:180942',1),
(180945,'Menstrual Cups',4,180942,'26395:67588:180942',1),
(180946,'Pantiliners',4,180942,'26395:67588:180942',1),
(180947,'Sanitary Napkins',4,180942,'26395:67588:180942',1),
(180948,'Tampons',4,180942,'26395:67588:180942',1),
(180949,'Vaginal Moisturisers',4,180942,'26395:67588:180942',1),
(180950,'Other Feminine Hygiene',4,180942,'26395:67588:180942',1),
(180951,'Hot & Cold Therapies',3,67588,'26395:67588',0),
(180952,'Cold & Hot Packs & Wraps',4,180951,'26395:67588:180951',1),
(180953,'Electric Heating Pads',4,180951,'26395:67588:180951',1),
(180954,'Herbal Remedies & Resins',3,67659,'26395:67659',1),
(180955,'Homeopathic Remedies',3,67659,'26395:67659',1),
(180956,'Linens & Covers',3,36447,'26395:36447',1),
(180957,'Eyeglass Frames',3,31414,'26395:31414',1),
(180958,'Eyepatches & Eyeglass Patches',3,31414,'26395:31414',1),
(180959,'Vitamins & Dietary Supplements',2,26395,'26395',0),
(180960,'Dietary Supplements',3,180959,'26395:180959',1),
(180961,'Cabinet & Drawer Locks',4,41971,'11700:3187:41971',1),
(180962,'Cabinet Handles',4,41971,'11700:3187:41971',1),
(180963,'Other Cabinet Hardware',4,41971,'11700:3187:41971',1),
(180964,'Door Knobs & Handles',4,41976,'11700:3187:41976',1),
(180965,'Door Knockers',4,41976,'11700:3187:41976',1),
(180966,'Door Locks & Lock Mechanisms',4,41976,'11700:3187:41976',1),
(180967,'Latches & Bolts',4,41976,'11700:3187:41976',1),
(180968,'Screen Doors',4,41976,'11700:3187:41976',1),
(180969,'Timber & Composites',3,3187,'11700:3187',0),
(180970,'Timber',4,180969,'11700:3187:180969',1),
(180971,'Wood Composite Panels & Sheets',4,180969,'11700:3187:180969',1),
(180972,'Garage Doors & Openers',3,3187,'11700:3187',0),
(180973,'Other Garage Door Equipment',4,180972,'11700:3187:180972',1),
(180974,'Nails, Screws & Fasteners',3,3187,'11700:3187',0),
(180975,'Pins',4,180974,'11700:3187:180974',1),
(180976,'Screws & Bolts',4,180974,'11700:3187:180974',1),
(180977,'Washers',4,180974,'11700:3187:180974',1),
(180978,'Fastener Assortments',4,180974,'11700:3187:180974',1),
(180979,'Paint & Varnish',3,3187,'11700:3187',0),
(180980,'Other Paint & Varnish',4,180979,'11700:3187:180979',1),
(180981,'Wallpaper & Accessories',3,3187,'11700:3187',0),
(180982,'Window Screens',4,180113,'11700:3187:180113',1),
(180983,'Flooring & Tiles',3,3187,'11700:3187',0),
(180984,'Chain Link Fencing',4,177032,'11700:159912:177032',1),
(180985,'Hardware Cloth, Metal Mesh',4,177032,'11700:159912:177032',1),
(180986,'Fence Pickets',4,177032,'11700:159912:177032',1),
(180987,'Fencing Clips & Brackets',4,177032,'11700:159912:177032',1),
(180988,'Post Bases, Supports & Spikes',4,177032,'11700:159912:177032',1),
(180989,'Post Caps',4,177032,'11700:159912:177032',1),
(180990,'Post Drivers',4,177032,'11700:159912:177032',1),
(180991,'Privacy Screens, Windscreens',4,177032,'11700:159912:177032',1),
(180992,'Awnings & Canopies',4,177017,'11700:159912:177017',1),
(180993,'Arbors & Arches',4,177017,'11700:159912:177017',1),
(180994,'Marquees & Tents',4,177017,'11700:159912:177017',1),
(180995,'Gazebos',4,177017,'11700:159912:177017',1),
(180996,'Pergolas',4,177017,'11700:159912:177017',1),
(180997,'Shade Sails',4,177017,'11700:159912:177017',1),
(180998,'Umbrellas',4,177017,'11700:159912:177017',1),
(180999,'Umbrella Stands',4,177017,'11700:159912:177017',1),
(181000,'Plant Labels',5,179308,'11700:159912:2032:179308',1),
(181001,'Plant Ties & Supports',5,179308,'11700:159912:2032:179308',1),
(181002,'Planter Liners',5,179308,'11700:159912:2032:179308',1),
(181003,'Plants, Seeds & Bulbs',3,159912,'11700:159912',0),
(181004,'Cultivated Turf',4,181003,'11700:159912:181003',1),
(181005,'Moss',4,181003,'11700:159912:181003',1),
(181006,'Mushrooms, Spawns & Kits',4,181003,'11700:159912:181003',1),
(181007,'Weight Loss Supplements',4,31817,'26395:180959:31817',1),
(181008,'Appetite Control, Suppressants',4,31817,'26395:180959:31817',1),
(181009,'Fat Burners',4,31817,'26395:180959:31817',1),
(181010,'Fruit Pickers',5,181033,'11700:159912:2032:181033',1),
(181011,'Garden Tool Racks',5,181033,'11700:159912:2032:181033',1),
(181012,'Spigots',5,29521,'11700:159912:2032:29521',1),
(181013,'Connectors, Clamps & Fittings',5,29521,'11700:159912:2032:29521',1),
(181014,'Hose Guides',5,29521,'11700:159912:2032:29521',1),
(181015,'Hose Nozzles & Wands',5,29521,'11700:159912:2032:29521',1),
(181016,'Decking Fixtures & Spacers',6,118858,'11700:159912:2032:181027:118858',1),
(181017,'Patio & Deck Cleaners',6,118858,'11700:159912:2032:181027:118858',1),
(181018,'Paver Moulds',6,118858,'11700:159912:2032:181027:118858',1),
(181019,'Carnivorous Plants',5,19617,'11700:159912:181003:19617',1),
(181020,'Composting & Yard Waste',4,2032,'11700:159912:2032',0),
(181021,'Compost Accelerators',5,181020,'11700:159912:2032:181020',1),
(181023,'Garden Compost Bins',5,181020,'11700:159912:2032:181020',1),
(181024,'Garden Waste Bags',5,181020,'11700:159912:2032:181020',1),
(181025,'Garden Waste Bins',5,181020,'11700:159912:2032:181020',1),
(181026,'Other Composting & Yard Waste',5,181020,'11700:159912:2032:181020',1),
(181027,'Landscaping & Garden Materials',4,2032,'11700:159912:2032',0),
(181028,'Anchor Pins, Pegs & Staples',5,181027,'11700:159912:2032:181027',1),
(181029,'Ground Reinforcement Grids',5,181027,'11700:159912:2032:181027',1),
(181030,'Landscape Fabric',5,181027,'11700:159912:2032:181027',1),
(181031,'Synthetic Grass',5,181027,'11700:159912:2032:181027',1),
(181032,'Other Landscaping Materials',5,181027,'11700:159912:2032:181027',1),
(181033,'Garden Hand Tools & Equipment',4,2032,'11700:159912:2032',0),
(181034,'Weed & Pest Control',4,2032,'11700:159912:2032',0),
(181035,'Ultrasonic Pest Repellers',5,181034,'11700:159912:2032:181034',1),
(181036,'Insect & Grub Control',5,181034,'11700:159912:2032:181034',0),
(181037,'Foggers',6,181036,'11700:159912:2032:181034:181036',1),
(181038,'Insect Repellent Sprays',6,181036,'11700:159912:2032:181034:181036',1),
(181039,'Insect Traps & Baits',6,181036,'11700:159912:2032:181034:181036',1),
(181040,'Insect Zappers',6,181036,'11700:159912:2032:181034:181036',1),
(181041,'Insecticides',6,181036,'11700:159912:2032:181034:181036',1),
(181042,'Swatters',6,181036,'11700:159912:2032:181034:181036',1),
(181044,'Rodenticides & Baits',5,181034,'11700:159912:2032:181034',1),
(181045,'Rodent & Animal Traps',5,181034,'11700:159912:2032:181034',1),
(181046,'Protective Netting/Mesh',5,181034,'11700:159912:2032:181034',1),
(181047,'Weed Control',5,181034,'11700:159912:2032:181034',0),
(181048,'Herbicides & Fungicides',6,181047,'11700:159912:2032:181034:181047',1),
(181049,'Weed Control Fabric',6,181047,'11700:159912:2032:181034:181047',1),
(181050,'Weed Preventers',6,181047,'11700:159912:2032:181034:181047',1),
(181051,'Other Gardening Supplies',4,2032,'11700:159912:2032',1),
(181052,'Other Plants, Seeds & Bulbs',4,181003,'11700:159912:181003',1),
(181053,'Swimming Pools',4,20727,'11700:159912:20727',0),
(181054,'Saunas',4,20727,'11700:159912:20727',1),
(181055,'Floats & Rafts',5,159921,'11700:159912:20727:159921',1),
(181056,'Toys & Games',5,159921,'11700:159912:20727:159921',1),
(181057,'Pool Chemicals & Testing',4,20727,'11700:159912:20727',0),
(181058,'Pool Chemicals & Clarifiers',5,181057,'11700:159912:20727:181057',1),
(181059,'Pool Water Testing & Kits',5,181057,'11700:159912:20727:181057',1),
(181060,'Other Pool Chemicals & Testing',5,181057,'11700:159912:20727:181057',1),
(181061,'Pool Cleaning Tools',4,20727,'11700:159912:20727',0),
(181062,'Handheld Pool Brushes & Nets',5,181061,'11700:159912:20727:181061',1),
(181063,'Pool Cleaners & Vacuums',5,181061,'11700:159912:20727:181061',1),
(181064,'Pool Cleaner & Vacuum Parts',5,181061,'11700:159912:20727:181061',1),
(181065,'Pool Cleaner Attachments',5,181061,'11700:159912:20727:181061',1),
(181066,'Other Pool Cleaning',5,181061,'11700:159912:20727:181061',1),
(181067,'Pool Equipment & Parts',4,20727,'11700:159912:20727',0),
(181068,'Pool Covers & Rollers',5,181067,'11700:159912:20727:181067',1),
(181069,'Pool Skimmer Systems & Baskets',5,181067,'11700:159912:20727:181067',1),
(181070,'Pool Equipment Parts & Accs',5,181067,'11700:159912:20727:181067',1),
(181071,'Other Pool Equipment & Parts',5,181067,'11700:159912:20727:181067',1),
(181072,'Pool Slides & Diving Boards',5,181067,'11700:159912:20727:181067',1),
(181074,'Spa & Hot Tub Covers',4,20727,'11700:159912:20727',1),
(181075,'Spa & Hot Tub Parts',4,20727,'11700:159912:20727',1),
(181076,'Other Home & Garden',2,11700,'11700',1),
(181077,'Loose Gemstones',3,491,'281:491',0),
(181078,'Ammonite',4,181077,'281:491:181077',1),
(181079,'Axinite',4,181077,'281:491:181077',1),
(181080,'Azurite',4,181077,'281:491:181077',1),
(181081,'Bloodstone',4,181077,'281:491:181077',1),
(181082,'Calcite',4,181077,'281:491:181077',1),
(181083,'Charoite',4,181077,'281:491:181077',1),
(181084,'Feldspar',4,181077,'281:491:181077',1),
(181085,'Garnet',4,181077,'281:491:181077',0),
(181086,'Howlite',4,181077,'281:491:181077',1),
(181087,'Jade',4,181077,'281:491:181077',0),
(181088,'Jadeite',5,181087,'281:491:181077:181087',1),
(181089,'Nephrite',5,181087,'281:491:181077:181087',1),
(181090,'Larimar/Pectolite',4,181077,'281:491:181077',1),
(181091,'Lepidolite',4,181077,'281:491:181077',1),
(181092,'Man-Made Glass',4,181077,'281:491:181077',1),
(181093,'Paua Shell',4,181077,'281:491:181077',1),
(181094,'Pietersite',4,181077,'281:491:181077',1),
(181095,'Prehnite',4,181077,'281:491:181077',1),
(181096,'Pyrite',4,181077,'281:491:181077',1),
(181097,'Quartz',4,181077,'281:491:181077',0),
(181098,'Green Amethyst (Prasiolite)',5,181097,'281:491:181077:181097',1),
(181099,'Rutilated Quartz',5,181097,'281:491:181077:181097',1),
(181100,'Rhodochrosite',4,181077,'281:491:181077',1),
(181101,'Rhodonite',4,181077,'281:491:181077',1),
(181102,'Ruby in Fuchsite',4,181077,'281:491:181077',1),
(181103,'Ruby in Zoisite',4,181077,'281:491:181077',1),
(181104,'Scapolite',4,181077,'281:491:181077',1),
(181105,'Serpentine',4,181077,'281:491:181077',1),
(181106,'Sphalerite',4,181077,'281:491:181077',1),
(181107,'Grossular',5,181085,'281:491:181077:181085',1),
(181108,'Almandine',5,181085,'281:491:181077:181085',1),
(181109,'Malaia',5,181085,'281:491:181077:181085',1),
(181110,'Black Opals',5,10239,'281:491:181077:10239',1),
(181111,'Boulder Opals',5,10239,'281:491:181077:10239',1),
(181112,'Orchid Seeds',5,40605,'11700:159912:181003:40605',1),
(181113,'Ornamental Grass Seeds',5,40605,'11700:159912:181003:40605',1),
(181114,'Perennial Seeds',5,40605,'11700:159912:181003:40605',1),
(181115,'Rose Seeds',5,40605,'11700:159912:181003:40605',1),
(181116,'Tree Seeds',5,40605,'11700:159912:181003:40605',1),
(181117,'Fern Spores',5,40605,'11700:159912:181003:40605',1),
(181118,'Water Plant Seeds',5,40605,'11700:159912:181003:40605',1),
(181119,'Bulk Seeds',5,40605,'11700:159912:181003:40605',1),
(181120,'Complete Pond Kits',4,93632,'11700:159912:93632',1),
(181121,'Pond Décor',4,93632,'11700:159912:93632',1),
(181122,'Pond Filtration Equipment',4,93632,'11700:159912:93632',1),
(181123,'Pond Lighting',4,93632,'11700:159912:93632',1),
(181124,'Pond Liners',4,93632,'11700:159912:93632',1),
(181125,'Pond Planting Accessories',4,93632,'11700:159912:93632',1),
(181126,'Waterfall Boxes & Spillways',4,93632,'11700:159912:93632',1),
(181127,'Pond & Fountain Equip. Parts',4,93632,'11700:159912:93632',1),
(181128,'Golf Accessories',3,1513,'888:1513',0),
(181129,'Golf Training Aids',3,1513,'888:1513',0),
(181130,'Golf Clothing, Shoes & Accs',3,1513,'888:1513',0),
(181131,'Men\'s Golf Clothing',4,181130,'888:1513:181130',0),
(181132,'Athletic Vests',5,181131,'888:1513:181130:181131',1),
(181133,'Base Layers',5,181131,'888:1513:181130:181131',1),
(181134,'Coats & Jackets',5,181131,'888:1513:181130:181131',1),
(181135,'Golf Gloves',5,181131,'888:1513:181130:181131',1),
(181136,'Golf Shoes',5,181131,'888:1513:181130:181131',1),
(181137,'Pants',5,181131,'888:1513:181130:181131',1),
(181138,'Shirts, Tops & Sweaters',5,181131,'888:1513:181130:181131',1),
(181139,'Shorts',5,181131,'888:1513:181130:181131',1),
(181140,'Socks',5,181131,'888:1513:181130:181131',1),
(181141,'Other Men\'s Golf Clothing',5,181131,'888:1513:181130:181131',1),
(181142,'Women\'s Golf Clothing',4,181130,'888:1513:181130',0),
(181143,'Athletic Vests',5,181142,'888:1513:181130:181142',1),
(181144,'Base Layers',5,181142,'888:1513:181130:181142',1),
(181145,'Coats & Jackets',5,181142,'888:1513:181130:181142',1),
(181146,'Golf Gloves',5,181142,'888:1513:181130:181142',1),
(181147,'Golf Shoes',5,181142,'888:1513:181130:181142',1),
(181148,'Pants',5,181142,'888:1513:181130:181142',1),
(181149,'Shirts, Tops & Sweaters',5,181142,'888:1513:181130:181142',1),
(181150,'Shorts',5,181142,'888:1513:181130:181142',1),
(181151,'Socks',5,181142,'888:1513:181130:181142',1),
(181152,'Other Women\'s Golf Clothing',5,181142,'888:1513:181130:181142',1),
(181153,'Golf Clubs & Equipment',3,1513,'888:1513',0),
(181154,'Golf Buggy & Trolley Parts',4,181153,'888:1513:181153',1),
(181155,'Other Golf Equipment',4,181153,'888:1513:181153',1),
(181156,'Mellophones',4,118974,'619:181162:118974',1),
(181157,'Sousaphones',4,118974,'619:181162:118974',1),
(181158,'Baritones',4,118974,'619:181162:118974',1),
(181159,'Bugles',4,118974,'619:181162:118974',1),
(181160,'Tubas',4,118974,'619:181162:118974',1),
(181161,'Parts & Accessories',4,118974,'619:181162:118974',1),
(181162,'Vintage Musical Instruments',2,619,'619',0),
(181163,'Vintage Guitar & Bass',3,181162,'619:181162',0),
(181164,'Classical Guitars',4,181163,'619:181162:181163',1),
(181165,'Resonator',4,181163,'619:181162:181163',1),
(181166,'Lap & Steel Guitars',4,181163,'619:181162:181163',1),
(181167,'Cigar Box Guitars',4,181163,'619:181162:181163',1),
(181168,'Parts',4,181163,'619:181162:181163',1),
(181169,'Accessories',4,181163,'619:181162:181163',1),
(181170,'Vintage Percussion',3,181162,'619:181162',0),
(181171,'Cymbals',4,181170,'619:181162:181170',1),
(181172,'Drums',4,181170,'619:181162:181170',0),
(181173,'Bass Drums',5,181172,'619:181162:181170:181172',1),
(181174,'Electronic Drums',5,181172,'619:181162:181170:181172',1),
(181175,'Snare Drums',5,181172,'619:181162:181170:181172',1),
(181176,'Toms',5,181172,'619:181162:181170:181172',1),
(181177,'Sets & Kits',5,181172,'619:181162:181170:181172',1),
(181179,'Folk & World Drums',4,181170,'619:181162:181170',1),
(181180,'Hand Percussion',4,181170,'619:181162:181170',0),
(181181,'Shakers & Small Percussion',5,181180,'619:181162:181170:181180',1),
(181182,'Tambourines',5,181180,'619:181162:181170:181180',1),
(181183,'Kalimbas',5,181180,'619:181162:181170:181180',1),
(181184,'Singing Bowls',5,181180,'619:181162:181170:181180',1),
(181185,'Mouth Harps',5,181180,'619:181162:181170:181180',1),
(181187,'Orchestral Percussion',4,181170,'619:181162:181170',0),
(181188,'Mallet Percussion',5,181187,'619:181162:181170:181187',1),
(181189,'Gongs',5,181187,'619:181162:181170:181187',1),
(181190,'Bells & Chimes',5,181187,'619:181162:181170:181187',1),
(181192,'Other Vintage Percussion',4,181170,'619:181162:181170',1),
(181193,'Vintage Pianos & Keyboards',3,181162,'619:181162',0),
(181194,'Electronic Keyboards',4,181193,'619:181162:181193',1),
(181195,'Organs',4,181193,'619:181162:181193',1),
(181196,'Pianos',4,181193,'619:181162:181193',0),
(181197,'Grand & Baby Grand Pianos',5,181196,'619:181162:181193:181196',1),
(181198,'Upright Pianos',5,181196,'619:181162:181193:181196',1),
(181199,'Digital Pianos',5,181196,'619:181162:181193:181196',1),
(181201,'Other Vintage Pianos',4,181193,'619:181162:181193',1),
(181202,'Vintage Wind & Woodwind',3,181162,'619:181162',0),
(181203,'Band & Orchestral',4,181202,'619:181162:181202',0),
(181204,'Bassoons',5,181203,'619:181162:181202:181203',1),
(181205,'Flutes',5,181203,'619:181162:181202:181203',1),
(181206,'Oboes',5,181203,'619:181162:181202:181203',1),
(181207,'Piccolos',5,181203,'619:181162:181202:181203',1),
(181208,'Recorders',5,181203,'619:181162:181202:181203',1),
(181210,'Folk & World',4,181202,'619:181162:181202',0),
(181211,'Accordions',5,181491,'619:181162:181193:181491',1),
(181212,'Bagpipes',5,181210,'619:181162:181202:181210',1),
(181213,'Concertinas',5,181491,'619:181162:181193:181491',1),
(181214,'Melodicas',5,181210,'619:181162:181202:181210',1),
(181215,'Ocarinas',5,181210,'619:181162:181202:181210',1),
(181216,'Whistles',5,181210,'619:181162:181202:181210',1),
(181218,'Other Vintage Woodwind',4,181202,'619:181162:181202',1),
(181219,'Resonator',3,3858,'619:3858',1),
(181220,'Lap & Pedal Steel Guitars',3,3858,'619:3858',1),
(181221,'Cigar Box Guitars',3,3858,'619:3858',1),
(181222,'Effects Pedals',4,180009,'619:3858:180009',0),
(181223,'Guitar Parts',4,180009,'619:3858:180009',0),
(181224,'Parts & Accessories',3,180010,'619:180010',0),
(181225,'Pianos',3,180010,'619:180010',0),
(181227,'Drums',3,180012,'619:180012',0),
(181228,'Folk & World Drums',3,180012,'619:180012',0),
(181229,'Bongos',4,181228,'619:180012:181228',1),
(181230,'Cajons',4,181228,'619:180012:181228',1),
(181231,'Congas',4,181228,'619:180012:181228',1),
(181232,'Darbukas',4,181228,'619:180012:181228',1),
(181233,'Dhols',4,181228,'619:180012:181228',1),
(181234,'Dholaks',4,181228,'619:180012:181228',1),
(181235,'Djembes',4,181228,'619:180012:181228',1),
(181236,'Handpans',4,181228,'619:180012:181228',1),
(181237,'Udu & Ibo Drums',4,181228,'619:180012:181228',1),
(181238,'Mridangams',4,181228,'619:180012:181228',1),
(181239,'Steel Drums',4,181228,'619:180012:181228',1),
(181240,'Surdos',4,181228,'619:180012:181228',1),
(181241,'Tablas',4,181228,'619:180012:181228',1),
(181242,'Talking Drums',4,181228,'619:180012:181228',1),
(181243,'Tamboras',4,181228,'619:180012:181228',1),
(181245,'Other Folk & World Drums',4,181228,'619:180012:181228',1),
(181246,'Hand Percussion',3,180012,'619:180012',0),
(181248,'Other Hand Percussion',4,181246,'619:180012:181246',1),
(181249,'Orchestral Percussion',3,180012,'619:180012',0),
(181250,'Gongs',4,181249,'619:180012:181249',1),
(181251,'Timpani',4,181249,'619:180012:181249',1),
(181253,'Other Orchestral Percussion',4,181249,'619:180012:181249',1),
(181254,'Parts & Accessories',3,180012,'619:180012',0),
(181255,'Orchestral',4,119023,'619:181162:119023',0),
(181256,'Double Basses',5,181255,'619:181162:119023:181255',1),
(181257,'Cellos',5,181255,'619:181162:119023:181255',1),
(181258,'Violas',5,181255,'619:181162:119023:181255',1),
(181260,'Folk & World',4,119023,'619:181162:119023',0),
(181261,'Autoharps & Zithers',5,181260,'619:181162:119023:181260',1),
(181262,'Balalaikas',5,181260,'619:181162:119023:181260',1),
(181263,'Harps & Dulcimers',5,181260,'619:181162:119023:181260',1),
(181264,'Lutes',5,181260,'619:181162:119023:181260',1),
(181265,'Mandolins',5,181260,'619:181162:119023:181260',1),
(181267,'Band & Orchestral',3,10181,'619:10181',0),
(181268,'Folk & World',3,10181,'619:10181',0),
(181269,'Accordions',4,181489,'619:180010:181489',1),
(181270,'Concertinas',4,181489,'619:180010:181489',1),
(181271,'Dizis',4,181268,'619:10181:181268',1),
(181272,'Duduks',4,181268,'619:10181:181268',1),
(181273,'Guanzis',4,181268,'619:10181:181268',1),
(181274,'Harmoniums',4,181489,'619:180010:181489',1),
(181275,'Hulusis',4,181268,'619:10181:181268',1),
(181276,'Kavals',4,181268,'619:10181:181268',1),
(181277,'Neys',4,181268,'619:10181:181268',1),
(181278,'Panflutes',4,181268,'619:10181:181268',1),
(181279,'Shakuhachis',4,181268,'619:10181:181268',1),
(181281,'Orchestral',3,180016,'619:180016',0),
(181282,'Folk & World',3,180016,'619:180016',0),
(181283,'Balalaikas',4,181282,'619:180016:181282',1),
(181284,'Erhus',4,181282,'619:180016:181282',1),
(181285,'Guzhengs',4,181282,'619:180016:181282',1),
(181286,'Ouds',4,181282,'619:180016:181282',1),
(181287,'Pipas',4,181282,'619:180016:181282',1),
(181288,'Rebabs',4,181282,'619:180016:181282',1),
(181289,'Sarods',4,181282,'619:180016:181282',1),
(181290,'Sazs',4,181282,'619:180016:181282',1),
(181291,'Setars',4,181282,'619:180016:181282',1),
(181293,'Bows',3,20835,'888:20835',0),
(181294,'Longbows',4,181293,'888:20835:181293',1),
(181295,'Other Bows',4,181293,'888:20835:181293',1),
(181296,'Protective Gear',3,20835,'888:20835',0),
(181297,'Archery Gloves',4,181296,'888:20835:181296',1),
(181298,'Arm Guards & Chest Guards',4,181296,'888:20835:181296',1),
(181299,'Fingertabs & Fingerguards',4,181296,'888:20835:181296',1),
(181300,'Bags, Cases & Covers',4,36098,'888:20835:36098',1),
(181301,'Bow Slings',4,36098,'888:20835:36098',1),
(181302,'Archery Tools',4,36098,'888:20835:36098',1),
(181303,'Release Aids',4,36098,'888:20835:36098',1),
(181304,'Stabilizers',4,36098,'888:20835:36098',1),
(181305,'Strings',4,36098,'888:20835:36098',1),
(181306,'Other Archery Accessories',4,36098,'888:20835:36098',1),
(181307,'Arrows & Parts',3,20835,'888:20835',0),
(181308,'Complete Arrows',4,181307,'888:20835:181307',1),
(181310,'Fletches',4,181307,'888:20835:181307',1),
(181311,'Nocks',4,181307,'888:20835:181307',1),
(181312,'Other Arrows & Parts',4,181307,'888:20835:181307',1),
(181313,'Balls',3,16021,'888:16021',0),
(181314,'Bats',3,16021,'888:16021',0),
(181315,'Baseball-Adult',4,181314,'888:16021:181314',1),
(181316,'Other Baseball & Softball Bats',4,181314,'888:16021:181314',1),
(181317,'Other Baseball Protective Gear',4,73910,'888:16021:73910',1),
(181318,'Field Equipment',3,16021,'888:16021',0),
(181319,'Base Sets & Homeplates',4,181318,'888:16021:181318',1),
(181320,'Backstop Netting',4,181318,'888:16021:181318',1),
(181321,'Drag Mats',4,181318,'888:16021:181318',1),
(181322,'Count Indicators & Umpire Sets',4,181318,'888:16021:181318',1),
(181323,'Other Field Equipment',4,181318,'888:16021:181318',1),
(181324,'Equipment Care & Accessories',3,16021,'888:16021',0),
(181325,'Bat Grips',4,181324,'888:16021:181324',1),
(181326,'Bat Care',4,181324,'888:16021:181324',1),
(181327,'Bat Racks',4,181324,'888:16021:181324',1),
(181328,'Glove Care',4,181324,'888:16021:181324',1),
(181329,'Other Accessories',4,181324,'888:16021:181324',1),
(181330,'Training Aids',3,16021,'888:16021',0),
(181331,'Weighted Balls & Bats',4,181330,'888:16021:181330',1),
(181332,'Other Baseball Training Aids',4,181330,'888:16021:181330',1),
(181333,'Men\'s',4,159052,'888:16021:159052',0),
(181334,'Baseball Belts',5,181333,'888:16021:159052:181333',1),
(181335,'Baseball Jackets',5,181333,'888:16021:159052:181333',1),
(181336,'Baseball Shirts & Jerseys',5,181333,'888:16021:159052:181333',1),
(181337,'Baseball Pants',5,181333,'888:16021:159052:181333',1),
(181338,'Baseball Socks',5,181333,'888:16021:159052:181333',1),
(181339,'Women\'s',4,159052,'888:16021:159052',0),
(181340,'Baseball Belts',5,181339,'888:16021:159052:181339',1),
(181341,'Baseball Jackets',5,181339,'888:16021:159052:181339',1),
(181342,'Baseball Shirts & Jerseys',5,181339,'888:16021:159052:181339',1),
(181343,'Baseball Pants',5,181339,'888:16021:159052:181339',1),
(181344,'Baseball Socks',5,181339,'888:16021:159052:181339',1),
(181345,'Youth',4,159052,'888:16021:159052',0),
(181346,'Baseball Belts',5,181345,'888:16021:159052:181345',1),
(181347,'Baseball Jackets',5,181345,'888:16021:159052:181345',1),
(181348,'Baseball Shirts & Jerseys',5,181345,'888:16021:159052:181345',1),
(181349,'Baseball Pants',5,181345,'888:16021:159052:181345',1),
(181350,'Baseball Socks',5,181345,'888:16021:159052:181345',1),
(181351,'Batting Gloves',4,159052,'888:16021:159052',0),
(181352,'Men\'s',5,181351,'888:16021:159052:181351',1),
(181353,'Women\'s',5,181351,'888:16021:159052:181351',1),
(181354,'Youth',5,181351,'888:16021:159052:181351',1),
(181355,'Other',3,16021,'888:16021',1),
(181356,'Men\'s',4,72891,'888:16034:72891',0),
(181357,'Base Layers',5,181356,'888:16034:72891:181356',1),
(181358,'Coats & Jackets',5,181356,'888:16034:72891:181356',1),
(181359,'Gloves',5,181356,'888:16034:72891:181356',1),
(181360,'Pants & Shorts',5,181356,'888:16034:72891:181356',1),
(181361,'T-Shirts, Tops & Jumpers',5,181356,'888:16034:72891:181356',1),
(181362,'Socks',5,181356,'888:16034:72891:181356',1),
(181363,'Women\'s',4,72891,'888:16034:72891',0),
(181364,'Base Layers',5,181363,'888:16034:72891:181363',1),
(181365,'Coats & Jackets',5,181363,'888:16034:72891:181363',1),
(181366,'Gloves',5,181363,'888:16034:72891:181363',1),
(181367,'Trousers & Shorts',5,181363,'888:16034:72891:181363',1),
(181368,'T-Shirts, Tops & Jumpers',5,181363,'888:16034:72891:181363',1),
(181369,'Socks',5,181363,'888:16034:72891:181363',1),
(181370,'Kids\'',4,72891,'888:16034:72891',0),
(181371,'Base Layers',5,181370,'888:16034:72891:181370',1),
(181372,'Coats & Jackets',5,181370,'888:16034:72891:181370',1),
(181373,'Gloves',5,181370,'888:16034:72891:181370',1),
(181374,'Trousers & Shorts',5,181370,'888:16034:72891:181370',1),
(181375,'T-Shirts, Tops & Jumpers',5,181370,'888:16034:72891:181370',1),
(181376,'Socks',5,181370,'888:16034:72891:181370',1),
(181377,'Gaiters',4,72891,'888:16034:72891',1),
(181378,'Hiking Backpacks',3,16034,'888:16034',0),
(181379,'Rucksacks',4,181378,'888:16034:181378',1),
(181380,'Waist Packs & Bags',4,181378,'888:16034:181378',1),
(181381,'Camping Cooking Supplies',3,16034,'888:16034',0),
(181382,'Camping Ice Boxes & Coolers',4,181381,'888:16034:181381',1),
(181383,'Outdoor Tableware',4,181381,'888:16034:181381',1),
(181384,'Camping Kettles',4,181381,'888:16034:181381',1),
(181385,'Camping Stoves, Ovens & BBQs',4,181381,'888:16034:181381',0),
(181386,'Camping Stoves',5,181385,'888:16034:181381:181385',1),
(181387,'Camping Ovens',5,181385,'888:16034:181381:181385',1),
(181388,'Camping BBQs & Grills',5,181385,'888:16034:181381:181385',1),
(181389,'Parts & Accessories',5,181385,'888:16034:181381:181385',1),
(181390,'Camping Storage',3,16034,'888:16034',1),
(181391,'Hiking Shoes & Boots',4,72891,'888:16034:72891',0),
(181392,'Men\'s',5,181391,'888:16034:72891:181391',1),
(181393,'Women\'s',5,181391,'888:16034:72891:181391',1),
(181394,'Kids\'',5,181391,'888:16034:72891:181391',1),
(181395,'Camping Hygiene & Sanitation',3,16034,'888:16034',0),
(181396,'Portable Showers & Accessories',4,181395,'888:16034:181395',1),
(181397,'Portable Toilets & Accessories',4,181395,'888:16034:181395',1),
(181398,'Camping Towels',4,181395,'888:16034:181395',1),
(181399,'Camping Wash Basins',4,181395,'888:16034:181395',1),
(181400,'Other Camping Hygiene',4,181395,'888:16034:181395',1),
(181401,'Hiking Equipment',3,16034,'888:16034',0),
(181402,'Map Covers',4,181401,'888:16034:181401',1),
(181403,'Outdoor Sleeping Gear',3,16034,'888:16034',0),
(181404,'Tents & Canopies',3,16034,'888:16034',0),
(181405,'Water Bottles & Hydration',3,16034,'888:16034',0),
(181406,'Purification Tablets',4,181405,'888:16034:181405',1),
(181407,'Portable Water Filters',4,181405,'888:16034:181405',1),
(181408,'Canteens, Bottles & Flasks',4,181405,'888:16034:181405',1),
(181409,'Water Carriers & Jerrycans',4,181405,'888:16034:181405',1),
(181410,'Other Bottles & Hydration',4,181405,'888:16034:181405',1),
(181411,'Emergency Equipment',3,16034,'888:16034',0),
(181412,'Emergency Blankets',4,181411,'888:16034:181411',1),
(181413,'Paracords',4,181411,'888:16034:181411',1),
(181414,'Safety Whistles',4,181411,'888:16034:181411',1),
(181415,'Other Emergency Equipment',4,181411,'888:16034:181411',1),
(181416,'Asia',2,260,'260',0),
(181417,'Central & South America',2,260,'260',0),
(181418,'Transportation',3,4752,'260:4752',0),
(181419,'Animal Kingdom',3,4752,'260:4752',1),
(181420,'Worldwide',2,260,'260',0),
(181421,'Accessories, Publications',2,260,'260',0),
(181422,'Middle East',2,260,'260',0),
(181423,'Africa',2,260,'260',0),
(181424,'Pacific',2,260,'260',0),
(181444,'North America',2,260,'260',0),
(181461,'Sailing Hardware & Gear',3,26443,'131090:26443',0),
(181462,'Sails',4,181461,'131090:26443:181461',1),
(181463,'Sailing Rigging & Fittings',4,181461,'131090:26443:181461',1),
(181464,'Sailing Tools & Repair',4,181461,'131090:26443:181461',1),
(181476,'Golf Carts',2,9800,'9800',1),
(181485,'Pool Pumps',5,181067,'11700:159912:20727:181067',1),
(181489,'Folk & World',3,180010,'619:180010',0),
(181490,'Other Folk & World',4,181489,'619:180010:181489',1),
(181491,'Folk & World',4,181193,'619:181162:181193',0),
(181677,'Textiles, Linens',2,20081,'20081',0),
(181678,'Contactors, Relays & Starters',3,42892,'170769:42892',0),
(181679,'Contactors',4,181678,'170769:42892:181678',0),
(181680,'IEC & NEMA AC Contactors',5,181679,'170769:42892:181678:181679',1),
(181681,'IEC & NEMA DC Contactors',5,181679,'170769:42892:181678:181679',1),
(181682,'Definite Purpose Contactors',5,181679,'170769:42892:181678:181679',1),
(181683,'Lighting Contactors',5,181679,'170769:42892:181678:181679',1),
(181684,'Auxiliary Contacts & Blocks',5,181679,'170769:42892:181678:181679',1),
(181685,'Other Contactors & Accs',5,181679,'170769:42892:181678:181679',1),
(181686,'Relays',4,181678,'170769:42892:181678',0),
(181687,'Latching Relays',5,181686,'170769:42892:181678:181686',1),
(181688,'Control & Machine Tool Relays',5,181686,'170769:42892:181678:181686',1),
(181689,'Overload Protection Relays',5,181686,'170769:42892:181678:181686',1),
(181690,'Overcurrent Protection Relays',5,181686,'170769:42892:181678:181686',1),
(181691,'Plug-In/Ice Cube Relays',5,181686,'170769:42892:181678:181686',1),
(181692,'Reed Relays',5,181686,'170769:42892:181678:181686',1),
(181693,'Relay Modules & Boards',5,181686,'170769:42892:181678:181686',1),
(181694,'Relay Sockets',5,181686,'170769:42892:181678:181686',1),
(181695,'Solid State Relays',5,181686,'170769:42892:181678:181686',1),
(181696,'Time Delay Relays',5,181686,'170769:42892:181678:181686',1),
(181697,'Relay Parts & Accessories',5,181686,'170769:42892:181678:181686',1),
(181698,'Starters',4,181678,'170769:42892:181678',0),
(181699,'Combination Starters',5,181698,'170769:42892:181678:181698',1),
(181700,'Full Voltage (DOL) Starters',5,181698,'170769:42892:181678:181698',1),
(181701,'Multi-Speed Starters',5,181698,'170769:42892:181678:181698',1),
(181702,'Reduced Voltage/Soft Starters',5,181698,'170769:42892:181678:181698',1),
(181704,'Starter Mounts & Enclosures',5,181698,'170769:42892:181678:181698',1),
(181705,'Starter Parts & Accs',5,181698,'170769:42892:181678:181698',1),
(181706,'Other Starters',5,181698,'170769:42892:181678:181698',1),
(181707,'Manual Starters',5,181698,'170769:42892:181678:181698',1),
(181708,'PLC Processors',4,57516,'170769:42892:57516',1),
(181709,'HMI & Open Interface Panels',4,57516,'170769:42892:57516',1),
(181710,'PLC Cables',4,57516,'170769:42892:57516',1),
(181711,'PLC Chassis',4,57516,'170769:42892:57516',1),
(181712,'PLC Software',4,57516,'170769:42892:57516',1),
(181713,'PLC Peripheral Modules',4,57516,'170769:42892:57516',0),
(181714,'PLC Input & Output Modules',5,181713,'170769:42892:57516:181713',1),
(181715,'Counter Modules',5,181713,'170769:42892:57516:181713',1),
(181716,'PLC Data Acquisition Modules',5,181713,'170769:42892:57516:181713',1),
(181717,'PLC Ethernet & Communication',5,181713,'170769:42892:57516:181713',1),
(181718,'PLC Memory Modules',5,181713,'170769:42892:57516:181713',1),
(181719,'PLC Positioning Modules',5,181713,'170769:42892:57516:181713',1),
(181720,'PLC Power Supplies',5,181713,'170769:42892:57516:181713',1),
(181721,'PLC Redundancy Modules',5,181713,'170769:42892:57516:181713',1),
(181722,'PLC Servo Control Modules',5,181713,'170769:42892:57516:181713',1),
(181723,'PLC Temperature Modules',5,181713,'170769:42892:57516:181713',1),
(181724,'Timer Modules',5,181713,'170769:42892:57516:181713',1),
(181725,'Other PLC Peripheral Modules',5,181713,'170769:42892:57516:181713',1),
(181726,'Musical Instruments',2,20081,'20081',0),
(181727,'String',3,181726,'20081:181726',1),
(181728,'Pneumatic Cylinders',4,78186,'170769:42892:78186',1),
(181729,'Rotary Actuators',4,78186,'170769:42892:78186',1),
(181730,'Electric Motors',3,42892,'170769:42892',0),
(181731,'Definite Purpose Motors',4,181730,'170769:42892:181730',1),
(181732,'General Purpose Motors',4,181730,'170769:42892:181730',1),
(181733,'Vibration Motors',4,181730,'170769:42892:181730',1),
(181734,'Electric Motor Parts & Accs',4,181730,'170769:42892:181730',1),
(181735,'Other Electric Motors',4,181730,'170769:42892:181730',1),
(181736,'Linear Motion',3,42892,'170769:42892',0),
(181737,'Bearing Blocks & Supports',4,181736,'170769:42892:181736',1),
(181739,'Lead, Ball & Roller Screws',4,181736,'170769:42892:181736',1),
(181740,'Linear Actuator Controls',4,181736,'170769:42892:181736',1),
(181741,'Linear Bearings & Bushings',4,181736,'170769:42892:181736',1),
(181742,'Linear Encoders',4,181736,'170769:42892:181736',1),
(181743,'Rail & Shaft Supports',4,181736,'170769:42892:181736',1),
(181746,'XY & Rotary Positioning Stages',4,181736,'170769:42892:181736',1),
(181747,'Other Linear Motion',4,181736,'170769:42892:181736',1),
(181748,'Mechanical Power Transmission',3,42892,'170769:42892',0),
(181749,'Bearings & Bushings',4,181748,'170769:42892:181748',0),
(181750,'Ball & Roller Bearings',5,181749,'170769:42892:181748:181749',1),
(181751,'Bushings & Plain Bearings',5,181749,'170769:42892:181748:181749',1),
(181752,'Cam Followers',5,181749,'170769:42892:181748:181749',1),
(181753,'Mounted Bearings & Housings',5,181749,'170769:42892:181748:181749',1),
(181754,'Thrust Bearings',5,181749,'170769:42892:181748:181749',1),
(181755,'Belts & Pulleys',4,181748,'170769:42892:181748',0),
(181756,'Power Transmission Belts',5,181755,'170769:42892:181748:181755',1),
(181757,'Pulleys & Sheaves',5,181755,'170769:42892:181748:181755',1),
(181758,'Brakes',4,181748,'170769:42892:181748',0),
(181759,'Electric/Magnetic Brakes',5,181758,'170769:42892:181748:181758',1),
(181760,'Hydraulic & Pneumatic Brakes',5,181758,'170769:42892:181748:181758',1),
(181761,'Chains & Sprockets',4,181748,'170769:42892:181748',0),
(181762,'Roller Chains',5,181761,'170769:42892:181748:181761',1),
(181763,'Roller Chain Sprockets',5,181761,'170769:42892:181748:181761',1),
(181764,'Chain Tensioners',5,181761,'170769:42892:181748:181761',1),
(181765,'Clutches',4,181748,'170769:42892:181748',0),
(181766,'Electric/Magnetic Clutches',5,181765,'170769:42892:181748:181765',1),
(181767,'Hydraulic & Pneumatic Clutches',5,181765,'170769:42892:181748:181765',1),
(181768,'Couplings & Joints',4,181748,'170769:42892:181748',0),
(181769,'Rigid Couplings',5,181768,'170769:42892:181748:181768',1),
(181770,'Flexible Couplings',5,181768,'170769:42892:181748:181768',1),
(181771,'Universal Joints',5,181768,'170769:42892:181748:181768',1),
(181772,'Gearboxes & Speed Reducers',4,181748,'170769:42892:181748',1),
(181773,'Gears & Gear Racks',4,181748,'170769:42892:181748',0),
(181774,'Bevel Gears',5,181773,'170769:42892:181748:181773',1),
(181775,'Gear Racks',5,181773,'170769:42892:181748:181773',1),
(181776,'Helical Gears',5,181773,'170769:42892:181748:181773',1),
(181777,'Spur Gears',5,181773,'170769:42892:181748:181773',1),
(181778,'Worms & Worm Gears',5,181773,'170769:42892:181748:181773',1),
(181779,'Power Transmission Shafts',4,181748,'170769:42892:181748',1),
(181780,'Seals, O-Rings & Gaskets',4,181748,'170769:42892:181748',1),
(181781,'Shaft Adapters & Bore Reducers',4,181748,'170769:42892:181748',1),
(181782,'Shaft Collars & Clamps',4,181748,'170769:42892:181748',1),
(181783,'Other Mech. Power Transmission',4,181748,'170769:42892:181748',1),
(181784,'Sensors',3,42892,'170769:42892',0),
(181785,'Acceleration Sensors',4,181784,'170769:42892:181784',1),
(181786,'Fibre Optic Sensors',4,181784,'170769:42892:181784',1),
(181787,'Hall Effect Sensor Diodes',4,181784,'170769:42892:181784',1),
(181788,'PIR Motion Sensors',4,181784,'170769:42892:181784',1),
(181790,'Sensor Mountings',4,181784,'170769:42892:181784',1),
(181791,'Ultrasonic Sensors',4,181784,'170769:42892:181784',1),
(181792,'Vibration Sensors',4,181784,'170769:42892:181784',1),
(181793,'Signals & Indicators',3,42892,'170769:42892',0),
(181794,'Indicators & Components',4,181793,'170769:42892:181793',0),
(181795,'Indicator Cables',5,181794,'170769:42892:181793:181794',1),
(181796,'Indicator Lenses',5,181794,'170769:42892:181793:181794',1),
(181797,'Lens & Lampholder Combinations',5,181794,'170769:42892:181793:181794',1),
(181798,'Indicator Lampholders',5,181794,'170769:42892:181793:181794',1),
(181799,'Signals & Components',4,181793,'170769:42892:181793',0),
(181800,'Signal Lamps',5,181799,'170769:42892:181793:181799',1),
(181801,'Signal Cables',5,181799,'170769:42892:181793:181799',1),
(181802,'Signal Lamp Bulbs',5,181799,'170769:42892:181793:181799',1),
(181803,'Signal Lampholders',5,181799,'170769:42892:181793:181799',1),
(181804,'Signal Lenses',5,181799,'170769:42892:181793:181799',1),
(181805,'Signal Lamp & Siren Combos',5,181799,'170769:42892:181793:181799',1),
(181806,'Signal Towers',5,181799,'170769:42892:181793:181799',1),
(181807,'Sirens',5,181799,'170769:42892:181793:181799',1),
(181808,'Signal Acccessories',5,181799,'170769:42892:181793:181799',1),
(181809,'Other Signals',5,181799,'170769:42892:181793:181799',1),
(181810,'Resistance Wire',5,73136,'170769:92074:100016:73136',1),
(181811,'Jump Wire',5,73136,'170769:92074:100016:73136',1),
(181812,'Cable Organisation',5,73136,'170769:92074:100016:73136',0),
(181813,'Cable Joints & Reliefs',6,181812,'170769:92074:100016:73136:181812',1),
(181814,'Circuit Breakers & Fuses',3,92074,'170769:92074',0),
(181815,'Circuit Breakers',4,181814,'170769:92074:181814',0),
(181816,'Air Circuit Breakers (ACB)',5,181815,'170769:92074:181814:181815',1),
(181817,'Load Break Switches (LBS)',5,181815,'170769:92074:181814:181815',1),
(181818,'Miniature Breakers (MCB)',5,181815,'170769:92074:181814:181815',1),
(181819,'Molded Case Breakers (MCCB)',5,181815,'170769:92074:181814:181815',1),
(181820,'Vacuum Circuit Breakers (VCB)',5,181815,'170769:92074:181814:181815',1),
(181821,'Circuit Breaker Accessories',5,181815,'170769:92074:181814:181815',1),
(181822,'Other Circuit Breakers',5,181815,'170769:92074:181814:181815',1),
(181823,'Fuses',4,181814,'170769:92074:181814',0),
(181824,'D-Type Fuses',5,181823,'170769:92074:181814:181823',1),
(181825,'Flush End Contacts Fuses',5,181823,'170769:92074:181814:181823',1),
(181826,'Neutral Links',5,181823,'170769:92074:181814:181823',1),
(181827,'Offset Tag Fuses',5,181823,'170769:92074:181814:181823',1),
(181828,'Solid Links',5,181823,'170769:92074:181814:181823',1),
(181829,'Thermal Fuses',5,181823,'170769:92074:181814:181823',1),
(181830,'Fuse Kits',5,181823,'170769:92074:181814:181823',1),
(181831,'Other Fuses',5,181823,'170769:92074:181814:181823',1),
(181832,'Fuse Accessories',4,181814,'170769:92074:181814',0),
(181833,'Fuse Blocks & Holders',5,181832,'170769:92074:181814:181832',0),
(181834,'Fuse Blocks',6,181833,'170769:92074:181814:181832:181833',1),
(181835,'Fuse Clips',6,181833,'170769:92074:181814:181832:181833',1),
(181836,'Fuse Holders',6,181833,'170769:92074:181814:181832:181833',1),
(181837,'Fuse Pullers & Testers',5,181832,'170769:92074:181814:181832',0),
(181838,'Fuse Pullers',6,181837,'170769:92074:181814:181832:181837',1),
(181839,'Fuse Testers',6,181837,'170769:92074:181814:181832:181837',1),
(181840,'Fuse Puller & Tester Combos',6,181837,'170769:92074:181814:181832:181837',1),
(181841,'Fuse Covers',5,181832,'170769:92074:181814:181832',1),
(181842,'Fuse Mounting Accessories',5,181832,'170769:92074:181814:181832',1),
(181843,'Drag Chain Cable Carriers',6,117489,'170769:92074:100016:73136:117489',1),
(181844,'Wire Wrap',6,117489,'170769:92074:100016:73136:117489',1),
(181845,'Switches',4,100016,'170769:92074:100016',0),
(181846,'DIP & SIP Switches',5,181845,'170769:92074:100016:181845',1),
(181847,'Joystick/Lever Switches',5,181845,'170769:92074:100016:181845',1),
(181848,'Key Switches',5,181845,'170769:92074:100016:181845',1),
(181849,'Piezo & Touch Switches',5,181845,'170769:92074:100016:181845',1),
(181850,'Selector Switches',5,181845,'170769:92074:100016:181845',1),
(181851,'Slide Switches',5,181845,'170769:92074:100016:181845',1),
(181852,'Tilt Switches',5,181845,'170769:92074:100016:181845',1),
(181853,'Switch Mountings',5,181845,'170769:92074:100016:181845',1),
(181854,'Other Electrical Switches',5,181845,'170769:92074:100016:181845',1),
(181855,'Wire Stripping Machines',6,66984,'170769:92074:100016:73136:66984',1),
(181856,'Fusion Splicers & Cleavers',6,66984,'170769:92074:100016:73136:66984',1),
(181857,'Fibre Optic Connectors',5,65512,'170769:92074:100016:65512',1),
(181858,'Flat Connectors',5,65512,'170769:92074:100016:65512',1),
(181859,'Attenuation Connectors',5,65512,'170769:92074:100016:65512',1),
(181860,'Backplane Connectors',5,65512,'170769:92074:100016:65512',1),
(181861,'Banana Connectors',5,65512,'170769:92074:100016:65512',1),
(181862,'Connector Tools & Accessories',5,65512,'170769:92074:100016:65512',0),
(181863,'Connector Housings & Covers',6,181862,'170769:92074:100016:65512:181862',1),
(181864,'Connector Tool Kits',6,181862,'170769:92074:100016:65512:181862',1),
(181865,'Insertion/Extraction Tools',6,181862,'170769:92074:100016:65512:181862',1),
(181866,'IDC Connectors',5,65512,'170769:92074:100016:65512',1),
(181867,'Modular/Rectangular Connectors',5,65512,'170769:92074:100016:65512',1),
(181868,'RCA Connectors',5,65512,'170769:92074:100016:65512',1),
(181869,'Solenoid Connectors',5,65512,'170769:92074:100016:65512',1),
(181870,'Terminal Block Accessories',5,65512,'170769:92074:100016:65512',0),
(181871,'Barrier Strips',6,181870,'170769:92074:100016:65512:181870',1),
(181872,'Terminal Block Assembly Kits',6,181870,'170769:92074:100016:65512:181870',1),
(181873,'Terminal Block Markers',6,181870,'170769:92074:100016:65512:181870',1),
(181874,'Terminal Jumpers',6,181870,'170769:92074:100016:65512:181870',1),
(181875,'Thermocouple Connectors',5,65512,'170769:92074:100016:65512',1),
(181876,'USB Connectors',5,65512,'170769:92074:100016:65512',1),
(181877,'Other Connectors, Tools & Accs',5,65512,'170769:92074:100016:65512',1),
(181878,'Component Solenoids',4,182412,'170769:92074:182412',1),
(181879,'LEDs, LCDs & Display Modules',4,182412,'170769:92074:182412',0),
(181880,'Individual LEDS',5,181879,'170769:92074:182412:181879',1),
(181881,'LED Arrays',5,181879,'170769:92074:182412:181879',1),
(181882,'LED Display Modules',5,181879,'170769:92074:182412:181879',0),
(181883,'LED Bar Arrays',6,181882,'170769:92074:182412:181879:181882',1),
(181884,'LED Dot Matrix Displays',6,181882,'170769:92074:182412:181879:181882',1),
(181885,'LED Segmented Displays',6,181882,'170769:92074:182412:181879:181882',1),
(181886,'LED Accessories',5,181879,'170769:92074:182412:181879',1),
(181887,'LCD Display Modules',5,181879,'170769:92074:182412:181879',1),
(181888,'LCD Controllers & Drivers',5,181879,'170769:92074:182412:181879',1),
(181889,'Vacuum Fluorescent Displays',5,181879,'170769:92074:182412:181879',1),
(181890,'LCD & VFD Accessories',5,181879,'170769:92074:182412:181879',1),
(181891,'Diodes',5,36330,'170769:92074:182412:36330',0),
(181892,'DIACs',6,181891,'170769:92074:182412:36330:181891',1),
(181893,'Photodiodes',6,181891,'170769:92074:182412:36330:181891',1),
(181894,'PIN Diodes',6,181891,'170769:92074:182412:36330:181891',1),
(181895,'Schottky Diodes',6,181891,'170769:92074:182412:36330:181891',1),
(181896,'SCRs',6,181891,'170769:92074:182412:36330:181891',1),
(181897,'TVS Diodes',6,181891,'170769:92074:182412:36330:181891',1),
(181898,'Varactors',6,181891,'170769:92074:182412:36330:181891',1),
(181899,'Zener Diodes',6,181891,'170769:92074:182412:36330:181891',1),
(181900,'Bridge Rectifier Modules',6,181891,'170769:92074:182412:36330:181891',1),
(181901,'Laser Diode Modules',6,181891,'170769:92074:182412:36330:181891',1),
(181902,'Other Diodes',6,181891,'170769:92074:182412:36330:181891',1),
(181903,'TRIACs',5,36330,'170769:92074:182412:36330',1),
(181904,'Integrated Circuits (ICs)',5,36330,'170769:92074:182412:36330',0),
(181905,'Interface ICs',6,181904,'170769:92074:182412:36330:181904',1),
(181906,'Power Management ICs',6,181904,'170769:92074:182412:36330:181904',1),
(181907,'Sensor ICs',6,181904,'170769:92074:182412:36330:181904',1),
(181908,'Optocouplers',6,181904,'170769:92074:182412:36330:181904',1),
(181909,'Other Integrated Circuits',6,181904,'170769:92074:182412:36330:181904',1),
(181911,'Electronics Tweezers',4,182412,'170769:92074:182412',1),
(181912,'General Purpose Resistors',5,182415,'170769:92074:182412:182415',1),
(181913,'Potentiometers',5,182415,'170769:92074:182412:182415',1),
(181914,'PCB Mount Thermistors',5,182415,'170769:92074:182412:182415',1),
(181915,'Trimmer Resistors',5,182415,'170769:92074:182412:182415',1),
(181916,'Rheostats',5,182415,'170769:92074:182412:182415',1),
(181917,'Enclosures, Panels & Boards',4,100182,'170769:92074:100182',0),
(181918,'Electrical Board Accessories',5,181917,'170769:92074:100182:181917',1),
(181919,'Enclosure Accessories',5,181917,'170769:92074:100182:181917',1),
(181920,'Other Enclosures & Panels',5,181917,'170769:92074:100182:181917',1),
(181921,'Power Supplies',4,100182,'170769:92074:100182',0),
(181922,'Switching Mode Power Supplies',5,181921,'170769:92074:100182:181921',1),
(181923,'UPS Batteries',5,181921,'170769:92074:100182:181921',1),
(181924,'Power Supply Accessories',5,181921,'170769:92074:100182:181921',1),
(181925,'Other Power Supplies',5,181921,'170769:92074:100182:181921',1),
(181926,'Receptacles, Outlets & Plugs',4,100182,'170769:92074:100182',0),
(181927,'Outlet Plates & Covers',5,181926,'170769:92074:100182:181926',1),
(181928,'Outlet Accessories',5,181926,'170769:92074:100182:181926',1),
(181929,'Transformers',4,100182,'170769:92074:100182',0),
(181930,'Autotransformers & Variacs',5,181929,'170769:92074:100182:181929',1),
(181931,'Current Transformers',5,181929,'170769:92074:100182:181929',1),
(181932,'LAN Ethernet Transformers',5,181929,'170769:92074:100182:181929',1),
(181933,'Portable Tool Transformers',5,181929,'170769:92074:100182:181929',1),
(181934,'SMPS Transformers',5,181929,'170769:92074:100182:181929',1),
(181935,'Telecom & Audio Transformers',5,181929,'170769:92074:100182:181929',1),
(181936,'Toroidal Transformers',5,181929,'170769:92074:100182:181929',1),
(181937,'Transformer Parts & Accs',5,181929,'170769:92074:100182:181929',1),
(181938,'Other Transformers',5,181929,'170769:92074:100182:181929',1),
(181939,'Test, Measurement & Inspection',3,92074,'170769:92074',0),
(181940,'Analysers & Data Acquisition',4,181939,'170769:92074:181939',0),
(181941,'Cable & Antenna Analysers',5,181940,'170769:92074:181939:181940',1),
(181942,'Communication Service Monitors',5,181940,'170769:92074:181939:181940',1),
(181943,'Gas & Combustion Analysers',5,181940,'170769:92074:181939:181940',1),
(181944,'Power Quality Analysers',5,181940,'170769:92074:181939:181940',1),
(181945,'Parameter Analysers',5,181940,'170769:92074:181939:181940',1),
(181946,'Analyser Parts & Accessories',5,181940,'170769:92074:181939:181940',1),
(181947,'Other Analysers',5,181940,'170769:92074:181939:181940',1),
(181948,'Cameras & Imaging',4,181939,'170769:92074:181939',0),
(181949,'Borescopes & Fibrescopes',5,181948,'170769:92074:181939:181948',1),
(181950,'Infrared & Thermal Imaging',5,181948,'170769:92074:181939:181948',1),
(181951,'Optical Fibre Inspection',5,181948,'170769:92074:181939:181948',1),
(181952,'Imaging Parts & Accessories',5,181948,'170769:92074:181939:181948',1),
(181953,'Other Cameras & Imaging',5,181948,'170769:92074:181939:181948',1),
(181954,'Leads & Probes',4,181939,'170769:92074:181939',0),
(181955,'Current Probes',5,181954,'170769:92074:181939:181954',1),
(181956,'High Frequency/RF Probes',5,181954,'170769:92074:181939:181954',1),
(181957,'High Voltage Probes',5,181954,'170769:92074:181939:181954',1),
(181958,'Logic Probes',5,181954,'170769:92074:181939:181954',1),
(181959,'Multimeter Test Leads',5,181954,'170769:92074:181939:181954',1),
(181960,'Piercing Probes',5,181954,'170769:92074:181939:181954',1),
(181961,'Transducer Probes',5,181954,'170769:92074:181939:181954',1),
(181962,'Other Leads & Probes',5,181954,'170769:92074:181939:181954',1),
(181963,'PXI & VXI Systems',4,181939,'170769:92074:181939',0),
(181964,'PXI & VXI Boards & Modules',5,181963,'170769:92074:181939:181963',1),
(181965,'PXI & VXI Controllers',5,181963,'170769:92074:181939:181963',1),
(181966,'PXI & VXI Mainframes & Chassis',5,181963,'170769:92074:181939:181963',1),
(181967,'Other PXI & VXI Equipment',5,181963,'170769:92074:181939:181963',1),
(181968,'Test Meters & Detectors',4,181939,'170769:92074:181939',0),
(181969,'Air Flow & Anemometers',5,181968,'170769:92074:181939:181968',1),
(181970,'Digital Tachometers',5,181968,'170769:92074:181939:181968',1),
(181971,'Earth Ground Resistance Meters',5,181968,'170769:92074:181939:181968',1),
(181972,'EMF & Gaussmeters',5,181968,'170769:92074:181939:181968',1),
(181973,'Fibre Optic Power Meters',5,181968,'170769:92074:181939:181968',1),
(181974,'Fault Locators & Reflectometry',5,181968,'170769:92074:181939:181968',0),
(181975,'Cable & Pipe Locators',6,181974,'170769:92074:181939:181968:181974',1),
(181976,'Visual Fault Locators',6,181974,'170769:92074:181939:181968:181974',1),
(181977,'OTDRs',6,181974,'170769:92074:181939:181968:181974',1),
(181978,'Frequency Counters',5,181968,'170769:92074:181939:181968',1),
(181979,'Liquid & Mass Flow Meters',5,181968,'170769:92074:181939:181968',1),
(181980,'RF & Microwave Power Meters',5,181968,'170769:92074:181939:181968',1),
(181981,'Signal Level Meters',5,181968,'170769:92074:181939:181968',1),
(181982,'Thermometers & Hygrometers',5,181968,'170769:92074:181939:181968',0),
(181983,'Hygrometers',6,181982,'170769:92074:181939:181968:181982',1),
(181984,'Infrared & Laser Thermometers',6,181982,'170769:92074:181939:181968:181982',1),
(181985,'Resistance Thermometers',6,181982,'170769:92074:181939:181968:181982',1),
(181986,'Temperature Probes',6,181982,'170769:92074:181939:181968:181982',1),
(181987,'Thermocouple Thermometers',6,181982,'170769:92074:181939:181968:181982',1),
(181988,'Other Thermometers',6,181982,'170769:92074:181939:181968:181982',1),
(181989,'Ultrasonic Flaw Detectors',5,181968,'170769:92074:181939:181968',1),
(181990,'Vibration Meters',5,181968,'170769:92074:181939:181968',1),
(181991,'Test Meter Parts & Accessories',5,181968,'170769:92074:181939:181968',1),
(181992,'Signal Sources & Conditioning',4,181939,'170769:92074:181939',0),
(181993,'Adjustable Power Supplies',5,181992,'170769:92074:181939:181992',1),
(181994,'RF Signal Generators',5,181992,'170769:92074:181939:181992',1),
(181995,'RF & Microwave Amplifiers',5,181992,'170769:92074:181939:181992',1),
(181996,'Variable/Step Attenuators',5,181992,'170769:92074:181939:181992',1),
(181997,'Signal Source Parts & Accs',5,181992,'170769:92074:181939:181992',1),
(181998,'Testers & Calibrators',4,181939,'170769:92074:181939',0),
(181999,'Calibrators',5,181998,'170769:92074:181939:181998',0),
(182000,'Pressure Calibrators',6,181999,'170769:92074:181939:181998:181999',1),
(182001,'Process & Current Calibrators',6,181999,'170769:92074:181939:181998:181999',1),
(182002,'Temperature Calibrators',6,181999,'170769:92074:181939:181998:181999',1),
(182004,'Tester Parts & Accessories',5,181998,'170769:92074:181939:181998',1),
(182005,'Other Testers & Calibrators',5,181998,'170769:92074:181939:181998',1),
(182006,'Data Acquisition Modules',6,36314,'170769:92074:181939:181940:36314',1),
(182007,'Data Acquisition PCI Cards',6,36314,'170769:92074:181939:181940:36314',1),
(182008,'Data Acquisition Units/Systems',6,36314,'170769:92074:181939:181940:36314',1),
(182009,'Data Loggers',6,36314,'170769:92074:181939:181940:36314',1),
(182010,'GPIB Interfaces & Adapters',6,36314,'170769:92074:181939:181940:36314',1),
(182011,'Other Data Acquisition',6,36314,'170769:92074:181939:181940:36314',1),
(182012,'Ohmmeters & Megohmmeters',6,50960,'170769:92074:181939:181968:50960',1),
(182013,'Voltmeters & Voltage Detectors',6,50960,'170769:92074:181939:181968:50960',1),
(182014,'Ammeters',6,50960,'170769:92074:181939:181968:50960',1),
(182015,'Test Equipment Cables',5,36315,'170769:92074:181939:36315',1),
(182016,'Test Equip. Power Amplifiers',5,36315,'170769:92074:181939:36315',1),
(182017,'Thermal Management',3,92074,'170769:92074',0),
(182018,'Component Heaters',4,182017,'170769:92074:182017',1),
(182019,'Component Hygro- & Thermostats',4,182017,'170769:92074:182017',1),
(182020,'Heat Exchangers',4,182017,'170769:92074:182017',1),
(182021,'Heat Sink Fan Assemblies',4,182017,'170769:92074:182017',1),
(182022,'Peltier Coolers',4,182017,'170769:92074:182017',1),
(182023,'Thermal Management Mounting',4,182017,'170769:92074:182017',1),
(182024,'Other Thermal Management',4,182017,'170769:92074:182017',1),
(182025,'Children\'s Vintage Clothing',3,175759,'11450:175759',0),
(182026,'Christening Outfits',4,182025,'11450:175759:182025',1),
(182027,'Dresses',4,182025,'11450:175759:182025',1),
(182028,'Children\'s Hats',4,182059,'11450:175759:182059',1),
(182029,'Jeans',4,182025,'11450:175759:182025',1),
(182030,'Jumpsuits & Rompers',4,182025,'11450:175759:182025',1),
(182031,'Outerwear Coats & Jackets',4,182025,'11450:175759:182025',1),
(182032,'Outfit Sets',4,182025,'11450:175759:182025',1),
(182033,'Pants',4,182025,'11450:175759:182025',1),
(182034,'Children\'s Vintage Shoes',3,175759,'11450:175759',1),
(182035,'Shorts',4,182025,'11450:175759:182025',1),
(182036,'Skirts',4,182025,'11450:175759:182025',1),
(182037,'Sleepwear',4,182025,'11450:175759:182025',1),
(182038,'Socks & Tights',4,182025,'11450:175759:182025',1),
(182039,'Suit Jackets & Blazers',4,182025,'11450:175759:182025',1),
(182040,'Suits',4,182025,'11450:175759:182025',1),
(182041,'Jumpers & Cardigans',4,182025,'11450:175759:182025',1),
(182042,'Sweats & Tracksuits',4,182025,'11450:175759:182025',1),
(182043,'Tops & Shirts',4,182025,'11450:175759:182025',1),
(182044,'Men\'s Vintage Clothing',3,175759,'11450:175759',0),
(182045,'Socks',4,182044,'11450:175759:182044',1),
(182046,'Suit Jackets & Blazers',4,182044,'11450:175759:182044',1),
(182047,'Women\'s Vintage Clothing',3,175759,'11450:175759',0),
(182048,'Lingerie',4,182047,'11450:175759:182047',0),
(182049,'Bras',5,182048,'11450:175759:182047:182048',1),
(182050,'Camisoles',5,182048,'11450:175759:182047:182048',1),
(182051,'Corsets & Girdles',5,182048,'11450:175759:182047:182048',1),
(182052,'Garter Belts',5,182048,'11450:175759:182047:182048',1),
(182053,'Pantyhose, Tights & Stockings',5,182048,'11450:175759:182047:182048',1),
(182054,'Panties',5,182048,'11450:175759:182047:182048',1),
(182055,'Slips & Petticoats',5,182048,'11450:175759:182047:182048',1),
(182056,'Other Vintage Lingerie',5,182048,'11450:175759:182047:182048',1),
(182057,'Socks',4,182047,'11450:175759:182047',1),
(182058,'Suit Jackets & Blazers',4,182047,'11450:175759:182047',1),
(182059,'Vintage Accessories',3,175759,'11450:175759',0),
(182060,'Canes & Walking Sticks',4,182059,'11450:175759:182059',1),
(182061,'Hand Fans',4,182059,'11450:175759:182059',1),
(182062,'Suspenders/Braces',4,182059,'11450:175759:182059',1),
(182063,'Umbrellas & Parasols',4,182059,'11450:175759:182059',1),
(182064,'Smart Watch Accessories',2,15032,'15032',0),
(182065,'Chargers & Docking Stations',3,182064,'15032:182064',1),
(182066,'Screen Protectors',3,182064,'15032:182064',1),
(182067,'Smart Watch Cases',3,182064,'15032:182064',1),
(182068,'Watch Bands',3,182064,'15032:182064',1),
(182069,'Other Smart Watch Accessories',3,182064,'15032:182064',1),
(182070,'Cases, Covers & Skins',4,45066,'15032:45065:45066',1),
(182071,'Other Wholesale Accessories',4,45066,'15032:45065:45066',1),
(182072,'Mobile Phone Parts',3,45065,'15032:45065',1),
(182073,'Vintage Mobile Phones',2,15032,'15032',1),
(182074,'Replacement Parts & Tools',2,625,'625',0),
(182075,'Photo Albums & Storage',3,15200,'625:15200',0),
(182076,'Photo Sheets, Sleeves & Pages',4,182075,'625:15200:182075',1),
(182077,'Darkroom & Developing',3,69323,'625:69323',0),
(182085,'Hard Drives (HDD, SSD & NAS)',3,165,'58058:165',0),
(182086,'Printer & Scanner Parts & Accs',3,171961,'58058:171961',0),
(182087,'Duplexers',4,182086,'58058:171961:182086',1),
(182088,'Interface/Add-On Cards',3,175673,'58058:175673',0),
(182089,'Laptop Replacement Parts',3,175673,'58058:175673',0),
(182090,'Motherboard Components & Accs',3,175673,'58058:175673',0),
(182091,'Switches & Hubs',3,175698,'58058:175698',0),
(182092,'Enterprise Router Components',3,175698,'58058:175698',0),
(182093,'Network Storage Disk Arrays',3,175698,'58058:175698',0),
(182094,'Computer Cables & Connectors',2,58058,'58058',0),
(182095,'KVM Cables',3,182094,'58058:182094',1),
(182096,'KVM Switches',3,182094,'58058:182094',1),
(182097,'Power Cables & Connectors',3,182094,'58058:182094',1),
(182098,'Vintage Home Phones',2,15032,'15032',1),
(182099,'Breathalysers',3,14948,'293:14948',1),
(182100,'Shower Caps',3,11854,'26395:11854',1),
(182101,'Hair Extensions & Wigs',3,11854,'26395:11854',0),
(182102,'Asthma',4,75036,'26395:67588:75036',1),
(182103,'Stage Lighting Dimmers',3,12922,'619:12922',1),
(182104,'Clamps & Mounts',3,12922,'619:12922',1),
(182105,'Acrylic Powders & Liquids',3,47945,'26395:47945',1),
(182107,'Fibreglass & Silk Wraps',3,47945,'26395:47945',1),
(182108,'Press-On Nails',3,47945,'26395:47945',1),
(182109,'Cider',3,179836,'14308:179836',1),
(182110,'Digital Vinyl Systems (DVS)',3,48458,'619:48458',1),
(182111,'DJ Controllers',3,48458,'619:48458',1),
(182112,'Cotton Swabs',3,11863,'26395:11863',1),
(182113,'Mobility Furniture & Fixtures',3,11778,'26395:11778',0),
(182114,'Bed & Chair Tables',4,182113,'26395:11778:182113',1),
(182115,'Steps & Stairs',4,182113,'26395:11778:182113',1),
(182116,'Transfer Boards & Benches',4,182113,'26395:11778:182113',1),
(182117,'Other Accessibility Fixtures',4,182113,'26395:11778:182113',1),
(182118,'Daily Living Aids',3,11778,'26395:11778',0),
(182119,'Assisted Washing Aids',4,182118,'26395:11778:182118',1),
(182120,'Bidet & Toilet Tissue Aids',4,182118,'26395:11778:182118',1),
(182121,'Dressing & Grooming Aids',4,182118,'26395:11778:182118',1),
(182122,'Kitchen & Dining Aids',4,182118,'26395:11778:182118',1),
(182123,'Portable Urinals & Bed Pans',4,182118,'26395:11778:182118',1),
(182124,'Work & Leisure Aids',4,182118,'26395:11778:182118',1),
(182125,'Other Daily Living Aids',4,182118,'26395:11778:182118',1),
(182126,'Parts & Accessories',4,28175,'26395:11778:28175',0),
(182127,'Accessories',5,182126,'26395:11778:28175:182126',1),
(182128,'Mobility Scooter Parts',5,182126,'26395:11778:28175:182126',1),
(182129,'Stairlift & Elevator Parts',5,182126,'26395:11778:28175:182126',1),
(182130,'Wheelchair Parts',5,182126,'26395:11778:28175:182126',1),
(182131,'Other Medical Monitoring',4,30115,'26395:11778:30115',1),
(182132,'Orthopedics & Supports',3,11778,'26395:11778',0),
(182133,'Compression Garments',4,182132,'26395:11778:182132',1),
(182134,'Insoles & Shoe Inserts',4,182132,'26395:11778:182132',1),
(182135,'Seat & Posture Cushions',4,182132,'26395:11778:182132',1),
(182136,'Wedges & Bed Positioners',4,182132,'26395:11778:182132',1),
(182137,'Other Orthopedic Products',4,182132,'26395:11778:182132',1),
(182138,'Parts & Accessories',3,16212,'619:16212',0),
(182139,'Bags & Cases',4,182138,'619:16212:182138',1),
(182140,'Care & Cleaning',4,182138,'619:16212:182138',1),
(182141,'Mouthpieces',4,182138,'619:16212:182138',1),
(182142,'Mutes',4,182138,'619:16212:182138',1),
(182143,'Practice Aids',4,182138,'619:16212:182138',1),
(182144,'Stands',4,182138,'619:16212:182138',1),
(182145,'Straps',4,182138,'619:16212:182138',1),
(182146,'Other Accessories',4,182138,'619:16212:182138',1),
(182147,'Accordion Accessories',4,181224,'619:180010:181224',1),
(182148,'Repair & Maintenance',4,181224,'619:180010:181224',1),
(182149,'Harpsichords',3,180010,'619:180010',1),
(182150,'Instruction Books, CDs & Video',2,619,'619',0),
(182151,'Contemporary',3,180015,'619:180015',1),
(182152,'Vintage & Antique',3,180015,'619:180015',1),
(182153,'Parts & Accessories',3,10181,'619:10181',0),
(182154,'Bags & Cases',4,182153,'619:10181:182153',1),
(182155,'Care & Cleaning',4,182153,'619:10181:182153',1),
(182156,'Ligatures & Caps',4,182153,'619:10181:182153',1),
(182157,'Mouthpieces',4,182153,'619:10181:182153',1),
(182158,'Reeds',4,182153,'619:10181:182153',1),
(182159,'Stands',4,182153,'619:10181:182153',1),
(182160,'Straps',4,182153,'619:10181:182153',1),
(182161,'Other Accessories',4,182153,'619:10181:182153',1),
(182162,'Parts & Accessories',3,180016,'619:180016',0),
(182163,'Bags & Cases',4,182162,'619:180016:182162',1),
(182164,'Bows',4,182162,'619:180016:182162',1),
(182165,'Bridges & Tailpieces',4,182162,'619:180016:182162',1),
(182166,'Care & Cleaning',4,182162,'619:180016:182162',1),
(182167,'Mutes',4,182162,'619:180016:182162',1),
(182168,'Pegs',4,182162,'619:180016:182162',1),
(182169,'Picks',4,182162,'619:180016:182162',1),
(182170,'Rests & Pads',4,182162,'619:180016:182162',1),
(182171,'Stands',4,182162,'619:180016:182162',1),
(182172,'Strings',4,182162,'619:180016:182162',1),
(182173,'Other Accessories',4,182162,'619:180016:182162',1),
(182174,'Manuals, Inserts & Box Art',2,1249,'1249',1),
(182175,'Original Game Cases & Boxes',2,1249,'1249',1),
(182176,'Antennas',5,19839,'220:2562:182187:19839',1),
(182177,'Lighting & Lamps',5,19839,'220:2562:182187:19839',1),
(182178,'Switches, Connectors & Wires',5,19839,'220:2562:182187:19839',1),
(182179,'Mounts & Stands',3,54968,'1249:54968',1),
(182180,'Toys to Life',3,54968,'1249:54968',1),
(182181,'RC Model Vehicles & Kits',3,2562,'220:2562',0),
(182182,'Airplanes',4,182181,'220:2562:182181',1),
(182183,'Cars & Motorcycles',4,182181,'220:2562:182181',1),
(182184,'Industrial Vehicles & Trucks',4,182181,'220:2562:182181',1),
(182185,'Quadcopters & Multicopters',4,182181,'220:2562:182181',1),
(182186,'Other RC Model Vehicles & Kits',4,182181,'220:2562:182181',1),
(182187,'RC Model Vehicle Parts & Accs',3,2562,'220:2562',0),
(182188,'Engine, Exhaust & Fuel Systems',4,182187,'220:2562:182187',0),
(182189,'Gas/Nitro Engines',5,182188,'220:2562:182187:182188',1),
(182190,'Exhaust Systems & Mufflers',5,182188,'220:2562:182187:182188',1),
(182191,'Fuel Delivery & Accessories',5,182188,'220:2562:182187:182188',1),
(182192,'Ignition, Glow & Spark Plugs',5,182188,'220:2562:182187:182188',1),
(182193,'Motor & Engine Parts & Accs',5,182188,'220:2562:182187:182188',1),
(182194,'Oils, Lubricants & Maintenance',5,182188,'220:2562:182187:182188',1),
(182195,'Other Engine/Exhaust/Fuel Sys.',5,182188,'220:2562:182187:182188',1),
(182196,'Chassis, Drivetrain & Wheels',4,182187,'220:2562:182187',0),
(182197,'Braking System Parts',5,182196,'220:2562:182187:182196',1),
(182198,'Chassis Plates, Frames & Kits',5,182196,'220:2562:182187:182196',1),
(182199,'Suspension & Steering Parts',5,182196,'220:2562:182187:182196',1),
(182200,'Transmission, Clutches & Gears',5,182196,'220:2562:182187:182196',1),
(182201,'Wheels, Tires, Rims & Hubs',5,182196,'220:2562:182187:182196',1),
(182202,'Other Chassis & Drivetrain',5,182196,'220:2562:182187:182196',1),
(182203,'Body Parts & Interior',4,182187,'220:2562:182187',0),
(182204,'Airplanes',5,182203,'220:2562:182187:182203',1),
(182205,'Helicopters',5,182203,'220:2562:182187:182203',1),
(182206,'Industrial Vehicles & Trucks',5,182203,'220:2562:182187:182203',1),
(182207,'Quadcopters & Multicopters',5,182203,'220:2562:182187:182203',1),
(182208,'Other Vehicles',5,182203,'220:2562:182187:182203',1),
(182209,'Adhesives, Paints & Finishing',4,182187,'220:2562:182187',1),
(182210,'RC Building Materials',4,182187,'220:2562:182187',1),
(182211,'RC Hardware & Fasteners',4,182187,'220:2562:182187',1),
(182212,'RC Plans, Templates & Manuals',4,182187,'220:2562:182187',1),
(182213,'Other RC Parts & Accs',4,182187,'220:2562:182187',1),
(182214,'Parts & Accessories',4,181170,'619:181162:181170',1),
(182215,'Parts & Accessories',4,181193,'619:181162:181193',1),
(182216,'Parts & Accessories',4,181202,'619:181162:181202',1),
(182217,'Parts & Accessories',4,119023,'619:181162:119023',1),
(182218,'Fenders & Mud Guards',4,135847,'131090:84149:135847',1),
(182219,'Footrests, Clamps & Rearsets',4,135847,'131090:84149:135847',1),
(182220,'Number Plate Holders',4,135847,'131090:84149:135847',1),
(182221,'Side Stands',4,135847,'131090:84149:135847',1),
(182222,'Big Bore & Top End Kits',4,65361,'131090:84149:65361',1),
(182223,'Camshafts',4,65361,'131090:84149:65361',1),
(182224,'Engine Valves',4,65361,'131090:84149:65361',1),
(182225,'Flywheels & Flywheel Parts',4,65361,'131090:84149:65361',1),
(182226,'Kick-Start Levers',4,65361,'131090:84149:65361',1),
(182227,'Oil Filters',4,65361,'131090:84149:65361',1),
(182228,'Oil Sumps',4,65361,'131090:84149:65361',1),
(182229,'Oil Pumps',4,65361,'131090:84149:65361',1),
(182230,'Pistons, Rings & Pistons Kits',4,65361,'131090:84149:65361',1),
(182231,'Drive Belts & Timing Chains',4,65361,'131090:84149:65361',1),
(182232,'Crankshafts & Con Rods',4,65361,'131090:84149:65361',1),
(182233,'Cylinder Barrels',4,65361,'131090:84149:65361',1),
(182234,'Cylinder Bolts',4,65361,'131090:84149:65361',1),
(182235,'Tape & Trim',4,180035,'131090:14780:180035',1),
(182236,'Valve Caps & Stems',4,180035,'131090:14780:180035',1),
(182240,'Air Intake & Fuel Delivery',3,84149,'131090:84149',0),
(182241,'Air Filters',4,182240,'131090:84149:182240',1),
(182242,'Air Pipes & Hoses',4,182240,'131090:84149:182240',1),
(182243,'Fuel Caps',4,182240,'131090:84149:182240',1),
(182244,'Fuel Filters',4,182240,'131090:84149:182240',1),
(182245,'Fuel Injectors & Main Jets',4,182240,'131090:84149:182240',1),
(182246,'Fuel Petcocks & Taps',4,182240,'131090:84149:182240',1),
(182247,'Fuel Pipes & Hoses',4,182240,'131090:84149:182240',1),
(182248,'Fuel Pumps',4,182240,'131090:84149:182240',1),
(182249,'Gaskets',4,182240,'131090:84149:182240',1),
(182250,'Idle & Cruise Cables',4,182240,'131090:84149:182240',1),
(182251,'Intake Covers & Fairings',4,182240,'131090:84149:182240',1),
(182252,'Intake Ducts & Scoops',4,182240,'131090:84149:182240',1),
(182253,'Throttle & Choke Cables',4,182240,'131090:84149:182240',1),
(182254,'Other Intake & Fuel Systems',4,182240,'131090:84149:182240',1),
(182255,'Brakes & Brake Parts',3,84149,'131090:84149',0),
(182256,'ABS Components',4,182255,'131090:84149:182255',1),
(182257,'Brake Cables',4,182255,'131090:84149:182255',1),
(182258,'Brake Calipers & Parts',4,182255,'131090:84149:182255',1),
(182259,'Brake Cylinders',4,182255,'131090:84149:182255',1),
(182260,'Brake Discs',4,182255,'131090:84149:182255',1),
(182261,'Brake Drums',4,182255,'131090:84149:182255',1),
(182262,'Brake Lines & Hoses',4,182255,'131090:84149:182255',1),
(182263,'Brake Pads',4,182255,'131090:84149:182255',1),
(182264,'Brake Shoes',4,182255,'131090:84149:182255',1),
(182265,'Complete Brake Kits',4,182255,'131090:84149:182255',1),
(182266,'Drivetrain & Transmission',3,84149,'131090:84149',0),
(182267,'Bearings',4,182266,'131090:84149:182266',1),
(182268,'Chain/Belt Guards & Guides',4,182266,'131090:84149:182266',1),
(182269,'Chains & Sprockets',4,182266,'131090:84149:182266',1),
(182270,'Clutch Cables',4,182266,'131090:84149:182266',1),
(182271,'Clutch Covers',4,182266,'131090:84149:182266',1),
(182272,'Clutch Master Cylinders',4,182266,'131090:84149:182266',1),
(182273,'Clutch Plates',4,182266,'131090:84149:182266',1),
(182274,'Clutch Slave Cylinders',4,182266,'131090:84149:182266',1),
(182275,'Complete Clutches & Kits',4,182266,'131090:84149:182266',1),
(182276,'Driveshafts',4,182266,'131090:84149:182266',1),
(182277,'Pulleys & Tensioners',4,182266,'131090:84149:182266',1),
(182278,'Electrical & Ignition',3,84149,'131090:84149',0),
(182279,'Alarms',4,182278,'131090:84149:182278',1),
(182280,'Alternators & Parts',4,182278,'131090:84149:182278',1),
(182281,'Audio',4,182278,'131090:84149:182278',1),
(182282,'CDIs & ECUs',4,182278,'131090:84149:182278',1),
(182283,'Distributors & Parts',4,182278,'131090:84149:182278',1),
(182284,'Dynamos & Parts',4,182278,'131090:84149:182278',1),
(182285,'Fuses & Fuse Boxes',4,182278,'131090:84149:182278',1),
(182286,'Horns',4,182278,'131090:84149:182278',1),
(182287,'Ignition Coils',4,182278,'131090:84149:182278',1),
(182288,'Ignition Condensers',4,182278,'131090:84149:182278',1),
(182289,'Ignition Leads & Wires',4,182278,'131090:84149:182278',1),
(182290,'Ignition Sensors',4,182278,'131090:84149:182278',1),
(182291,'Magnetos & Parts',4,182278,'131090:84149:182278',1),
(182292,'Regulators',4,182278,'131090:84149:182278',1),
(182293,'Spark Plugs',4,182278,'131090:84149:182278',1),
(182294,'Starter Motors',4,182278,'131090:84149:182278',1),
(182295,'Switches & Relays',4,182278,'131090:84149:182278',1),
(182296,'Wires & Electrical Cabling',4,182278,'131090:84149:182278',1),
(182297,'Engine Cooling',3,84149,'131090:84149',0),
(182298,'Coolant Pipes & Hoses',4,182297,'131090:84149:182297',1),
(182299,'Fans & Fan Parts',4,182297,'131090:84149:182297',1),
(182300,'Oil Coolers & Covers',4,182297,'131090:84149:182297',1),
(182301,'Radiators',4,182297,'131090:84149:182297',1),
(182302,'Radiator Caps',4,182297,'131090:84149:182297',1),
(182303,'Radiator Guards',4,182297,'131090:84149:182297',1),
(182304,'Thermostats',4,182297,'131090:84149:182297',1),
(182305,'Water Pumps',4,182297,'131090:84149:182297',1),
(182306,'Other Engine Cooling',4,182297,'131090:84149:182297',1),
(182307,'Exhausts & Exhaust Systems',3,84149,'131090:84149',0),
(182308,'Clamps, Flanges & Hangers',4,182307,'131090:84149:182307',1),
(182309,'Complete Exhaust Systems',4,182307,'131090:84149:182307',1),
(182310,'Exhaust Gaskets & Seals',4,182307,'131090:84149:182307',1),
(182311,'Exhaust Heat Shields & Guards',4,182307,'131090:84149:182307',1),
(182312,'Exhaust Pipes',4,182307,'131090:84149:182307',1),
(182313,'Headers, Manifolds & Studs',4,182307,'131090:84149:182307',1),
(182314,'Mufflers',4,182307,'131090:84149:182307',1),
(182315,'Oxygen Sensors',4,182307,'131090:84149:182307',1),
(182316,'Handlebars, Grips & Levers',3,84149,'131090:84149',0),
(182317,'Bar End Weights & Covers',4,182316,'131090:84149:182316',1),
(182318,'Brake Levers',4,182316,'131090:84149:182316',1),
(182319,'Clutch Levers',4,182316,'131090:84149:182316',1),
(182320,'Gear Levers',4,182316,'131090:84149:182316',1),
(182321,'Grips',4,182316,'131090:84149:182316',1),
(182322,'Handlebars',4,182316,'131090:84149:182316',1),
(182323,'Risers',4,182316,'131090:84149:182316',1),
(182324,'Instruments & Gauges',3,84149,'131090:84149',0),
(182325,'Clocks',4,182324,'131090:84149:182324',1),
(182326,'Fuel Gauges',4,182324,'131090:84149:182324',1),
(182327,'Instrument Cables',4,182324,'131090:84149:182324',1),
(182328,'Instrument Clusters',4,182324,'131090:84149:182324',1),
(182329,'Odometers',4,182324,'131090:84149:182324',1),
(182330,'Speedometers',4,182324,'131090:84149:182324',1),
(182331,'Tachometers/Rev Counters',4,182324,'131090:84149:182324',1),
(182332,'Temperature Gauges',4,182324,'131090:84149:182324',1),
(182333,'Lighting & Indicators',3,84149,'131090:84149',0),
(182334,'Bulbs & LEDs',4,182333,'131090:84149:182333',1),
(182335,'Display Lights',4,182333,'131090:84149:182333',1),
(182336,'Fog Light Assemblies',4,182333,'131090:84149:182333',1),
(182337,'Headlight Assemblies',4,182333,'131090:84149:182333',1),
(182338,'Indicator Assemblies',4,182333,'131090:84149:182333',1),
(182339,'Lenses',4,182333,'131090:84149:182333',1),
(182340,'Number Plate Lights',4,182333,'131090:84149:182333',1),
(182341,'Rear & Brake Light Assemblies',4,182333,'131090:84149:182333',1),
(182342,'Luggage & Luggage Racks',3,84149,'131090:84149',0),
(182343,'Luggage Racks',4,182342,'131090:84149:182342',1),
(182344,'Saddlebags',4,182342,'131090:84149:182342',1),
(182345,'Tank Bags',4,182342,'131090:84149:182342',1),
(182346,'Top Boxes',4,182342,'131090:84149:182342',1),
(182347,'Other Scooter Luggage',4,182342,'131090:84149:182342',1),
(182348,'Seating',3,84149,'131090:84149',0),
(182349,'Backrests & Sissy Bars',4,182348,'131090:84149:182348',1),
(182350,'Pillion Seats',4,182348,'131090:84149:182348',1),
(182351,'Seat Covers',4,182348,'131090:84149:182348',1),
(182352,'Seat Fairings',4,182348,'131090:84149:182348',1),
(182353,'Seats',4,182348,'131090:84149:182348',1),
(182354,'Service Kits',3,84149,'131090:84149',1),
(182355,'Suspension & Handling',3,84149,'131090:84149',0),
(182356,'Ball Joints',4,182355,'131090:84149:182355',1),
(182357,'Bearings & Bushings',4,182355,'131090:84149:182355',1),
(182358,'Complete Suspension Units',4,182355,'131090:84149:182355',1),
(182359,'Fork Seals',4,182355,'131090:84149:182355',1),
(182360,'Fork Tubes & Stanchions',4,182355,'131090:84149:182355',1),
(182361,'Fork Yokes',4,182355,'131090:84149:182355',1),
(182362,'Shocks',4,182355,'131090:84149:182355',1),
(182363,'Wheels & Tyres',3,84149,'131090:84149',0),
(182364,'Tyres & Tubes',4,182363,'131090:84149:182363',1),
(182365,'Valve Caps & Stems',4,182363,'131090:84149:182363',1),
(182366,'Wheels',4,182363,'131090:84149:182363',1),
(182367,'Wheel Tape & Trims',4,182363,'131090:84149:182363',1),
(182368,'Wheel & Tyre Packages',4,182363,'131090:84149:182363',1),
(182369,'Other Wheel & Tyre Parts',4,182363,'131090:84149:182363',1),
(182400,'Crank Bearings',4,65361,'131090:84149:65361',1),
(182412,'Electronic Components',3,92074,'170769:92074',0),
(182415,'Passive Components',4,182412,'170769:92074:182412',0),
(182882,'Children & Young Adults Books',2,267,'267',0),
(182893,'Welding Sleeves',5,67044,'170769:182941:34095:67044',1),
(182894,'Welding Screens',5,67044,'170769:182941:34095:67044',1),
(182895,'Welding Blankets',5,67044,'170769:182941:34095:67044',1),
(182896,'Welding Curtains',5,67044,'170769:182941:34095:67044',1),
(182897,'Welders, Cutters & Torches',4,34095,'170769:182941:34095',0),
(182898,'Stick Welders',5,182897,'170769:182941:34095:182897',1),
(182899,'Multiprocess Welders & Cutters',5,182897,'170769:182941:34095:182897',1),
(182900,'Plasma Cutter Torches & Bodies',5,182897,'170769:182941:34095:182897',1),
(182901,'Spot Welders',5,182897,'170769:182941:34095:182897',1),
(182902,'Gas Welding Torches',5,182897,'170769:182941:34095:182897',1),
(182903,'Gas Cutting Torches',5,182897,'170769:182941:34095:182897',1),
(182904,'Gas Welding & Cutting Kits',5,182897,'170769:182941:34095:182897',1),
(182905,'Electrodes, Rods & Wires',4,34095,'170769:182941:34095',0),
(182906,'Plasma Cutter Electrodes',5,182905,'170769:182941:34095:182905',1),
(182907,'Other Weld Materials',5,182905,'170769:182941:34095:182905',1),
(182908,'MIG, TIG & Stick Welding Accs',4,34095,'170769:182941:34095',0),
(182909,'Electrode Holders',5,182908,'170769:182941:34095:182908',1),
(182910,'Electrode Drying Ovens',5,182908,'170769:182941:34095:182908',1),
(182911,'Other MIG, TIG & Stick Accs',5,182908,'170769:182941:34095:182908',1),
(182912,'Plasma Cutting Accessories',4,34095,'170769:182941:34095',0),
(182913,'Plasma Cutter Kits',5,182912,'170769:182941:34095:182912',1),
(182914,'Cutter Guides & Stencils',5,182912,'170769:182941:34095:182912',1),
(182915,'Welding Cables',4,34095,'170769:182941:34095',1),
(182916,'Gas Regulators, Valves & Accs',4,34095,'170769:182941:34095',1),
(182917,'Welding Positioners',4,34095,'170769:182941:34095',1),
(182918,'Welding Books & Manuals',4,34095,'170769:182941:34095',1),
(182919,'Raw Materials',3,177644,'170769:177644',0),
(182920,'Metals & Alloys',4,182919,'170769:177644:182919',0),
(182921,'Metal & Alloy Angles',5,182920,'170769:177644:182919:182920',1),
(182922,'Metal & Alloy Channels',5,182920,'170769:177644:182919:182920',1),
(182923,'Metal & Alloy Discs',5,182920,'170769:177644:182919:182920',1),
(182924,'Metal & Alloy Hex Rods',5,182920,'170769:177644:182919:182920',1),
(182925,'Metal & Alloy Hex Tubes',5,182920,'170769:177644:182919:182920',1),
(182926,'Metal & Alloy Round Rods',5,182920,'170769:177644:182919:182920',1),
(182927,'Metal & Alloy Round Tubes',5,182920,'170769:177644:182919:182920',1),
(182928,'Metal Sheets & Flat Stock',5,182920,'170769:177644:182919:182920',1),
(182929,'Metal & Alloy Spheres',5,182920,'170769:177644:182919:182920',1),
(182930,'Metal & Alloy Square Bars',5,182920,'170769:177644:182919:182920',1),
(182931,'Metal & Alloy Square Tubes',5,182920,'170769:177644:182919:182920',1),
(182932,'Metal Non-Electrical Wire',5,182920,'170769:177644:182919:182920',1),
(182933,'Carbon Fibre Raw Materials',4,182919,'170769:177644:182919',0),
(182934,'Carbon Fibre Round Tubes',5,182933,'170769:177644:182919:182933',1),
(182935,'Carbon Fibre Square Tubes',5,182933,'170769:177644:182919:182933',1),
(182936,'Carbon Fibre Sheets',5,182933,'170769:177644:182919:182933',1),
(182937,'Graphite Raw Materials',4,182919,'170769:177644:182919',0),
(182938,'Graphite Round Rods',5,182937,'170769:177644:182919:182937',1),
(182939,'Graphite Square Bars',5,182937,'170769:177644:182919:182937',1),
(182940,'Graphite Sheets',5,182937,'170769:177644:182919:182937',1),
(182941,'Welding & Soldering',2,170769,'170769',0),
(182942,'Soldering & Desoldering',3,182941,'170769:182941',0),
(182943,'Soldering & Rework Stations',4,182942,'170769:182941:182942',1),
(182944,'Soldering Guns',4,182942,'170769:182941:182942',1),
(182945,'Soldering Iron Holders',4,182942,'170769:182941:182942',1),
(182946,'Wire Tip Cleaners',4,182942,'170769:182941:182942',1),
(182947,'Solder Pots & Desolder Baths',4,182942,'170769:182941:182942',1),
(182948,'Soldering Fume Extractors',4,182942,'170769:182941:182942',1),
(182949,'Solder & Soldering Consumables',4,182942,'170769:182941:182942',0),
(182950,'Desolder Braids/Solder Wicks',5,182949,'170769:182941:182942:182949',1),
(182951,'Tinner & Cleaner Compounds',5,182949,'170769:182941:182942:182949',1),
(182952,'Soldering Flux',5,182949,'170769:182941:182942:182949',1),
(182953,'Other Soldering Consumables',5,182949,'170769:182941:182942:182949',1),
(182954,'BGA Reballing Stations & Kits',4,182942,'170769:182941:182942',1),
(182955,'Plastic & Rubber Discs',5,61792,'170769:177644:182919:61792',1),
(182956,'Plastic & Rubber Hex Rods',5,61792,'170769:177644:182919:61792',1),
(182957,'Plastic & Rubber Hex Tubes',5,61792,'170769:177644:182919:61792',1),
(182958,'Plastic & Rubber Round Rods',5,61792,'170769:177644:182919:61792',1),
(182959,'Plastic & Rubber Round Tubes',5,61792,'170769:177644:182919:61792',1),
(182960,'Plastic & Rubber Sheets',5,61792,'170769:177644:182919:61792',1),
(182961,'Plastic & Rubber Spheres',5,61792,'170769:177644:182919:61792',1),
(182962,'Plastic & Rubber Square Bars',5,61792,'170769:177644:182919:61792',1),
(182963,'Plastic & Rubber Square Tubes',5,61792,'170769:177644:182919:61792',1),
(182964,'Bibs',4,182025,'11450:175759:182025',1),
(182965,'Slips & Petticoats',4,182025,'11450:175759:182025',1),
(182966,'Swimwear',4,182025,'11450:175759:182025',1),
(182967,'Vests',4,182025,'11450:175759:182025',1),
(182969,'Camera Drone Parts & Accs',2,625,'625',1),
(182970,'Blade Parts, Supplies & Accs',3,1401,'1:1401',0),
(182971,'Blade Maintenance & Care',4,182970,'1:1401:182970',1),
(182972,'Blade Parts & Supplies',4,182970,'1:1401:182970',1),
(182973,'Collectable Fixed Blade Knives',3,1401,'1:1401',0),
(182974,'Machetes',3,1401,'1:1401',1),
(182975,'European & Mediterranean',4,43336,'1:1401:43336',0),
(182976,'Ancient History',5,182975,'1:1401:43336:182975',1),
(182977,'Renaissance',5,182975,'1:1401:43336:182975',1),
(182978,'Modern',5,182975,'1:1401:43336:182975',1),
(182979,'Asian',4,43336,'1:1401:43336',0),
(182980,'Other Asian Swords',5,182979,'1:1401:43336:182979',1),
(182981,'Collectable Folding Knives',3,1401,'1:1401',0),
(182982,'Non-Sport Trading Cards',2,1,'1',0),
(182983,'Batman Trading Cards',3,182982,'1:182982',0),
(182984,'Trading Card Lots',4,182983,'1:182982:182983',1),
(182985,'Complete Trading Card Sets',4,182983,'1:182982:182983',1),
(182986,'Sealed Trading Cards',4,182983,'1:182982:182983',1),
(182987,'Benchwarmer',3,182982,'1:182982',0),
(182988,'Trading Card Lots',4,182987,'1:182982:182987',1),
(182989,'Complete Trading Card Sets',4,182987,'1:182982:182987',1),
(182990,'Sealed Trading Cards',4,182987,'1:182982:182987',1),
(182991,'Benchwarmer Merchandise',4,182987,'1:182982:182987',1),
(182992,'Doctor Who Trading Cards',3,182982,'1:182982',0),
(182993,'Trading Card Lots',4,182992,'1:182982:182992',1),
(182994,'Complete Trading Card Sets',4,182992,'1:182982:182992',1),
(182995,'Sealed Trading Cards',4,182992,'1:182982:182992',1),
(182996,'Game of Thrones Trading Cards',3,182982,'1:182982',0),
(182997,'Trading Card Singles',4,182996,'1:182982:182996',1),
(182998,'Trading Card Lots',4,182996,'1:182982:182996',1),
(182999,'Complete Trading Card Sets',4,182996,'1:182982:182996',1),
(183000,'Sealed Trading Cards',4,182996,'1:182982:182996',1),
(183001,'Garbage Pail Kids',3,182982,'1:182982',0),
(183002,'Trading Card Lots',4,183001,'1:182982:183001',1),
(183003,'Complete Trading Card Sets',4,183001,'1:182982:183001',1),
(183004,'Sealed Trading Cards',4,183001,'1:182982:183001',1),
(183005,'Garbage Pail Kids Merchandise',4,183001,'1:182982:183001',1),
(183006,'Harry Potter Movie Cards',3,182982,'1:182982',0),
(183007,'Trading Card Lots',4,183006,'1:182982:183006',1),
(183008,'Complete Trading Card Sets',4,183006,'1:182982:183006',1),
(183009,'Sealed Trading Cards',4,183006,'1:182982:183006',1),
(183010,'James Bond Trading Cards',3,182982,'1:182982',0),
(183011,'Trading Card Lots',4,183010,'1:182982:183010',1),
(183012,'Complete Trading Card Sets',4,183010,'1:182982:183010',1),
(183013,'Sealed Trading Cards',4,183010,'1:182982:183010',1),
(183014,'Mars Attacks!',3,182982,'1:182982',0),
(183015,'Trading Card Lots',4,183014,'1:182982:183014',1),
(183016,'Complete Trading Card Sets',4,183014,'1:182982:183014',1),
(183017,'Sealed Trading Cards',4,183014,'1:182982:183014',1),
(183018,'Mars Attacks! Merchandise',4,183014,'1:182982:183014',1),
(183019,'Marvel Movie Trading Cards',3,182982,'1:182982',0),
(183020,'Trading Card Singles',4,183019,'1:182982:183019',1),
(183021,'Trading Card Lots',4,183019,'1:182982:183019',1),
(183022,'Complete Trading Card Sets',4,183019,'1:182982:183019',1),
(183023,'Sealed Trading Cards',4,183019,'1:182982:183019',1),
(183024,'Spider-Man Trading Cards',3,182982,'1:182982',0),
(183025,'Trading Card Lots',4,183024,'1:182982:183024',1),
(183026,'Complete Trading Card Sets',4,183024,'1:182982:183024',1),
(183027,'Sealed Trading Cards',4,183024,'1:182982:183024',1),
(183028,'Star Trek Trading Cards',3,182982,'1:182982',0),
(183029,'Trading Card Lots',4,183028,'1:182982:183028',1),
(183030,'Complete Trading Card Sets',4,183028,'1:182982:183028',1),
(183031,'Sealed Trading Cards',4,183028,'1:182982:183028',1),
(183032,'Trading Card Lots',4,60225,'1:182982:60225',1),
(183033,'Complete Trading Card Sets',4,60225,'1:182982:60225',1),
(183034,'Sealed Trading Cards',4,60225,'1:182982:60225',1),
(183035,'Trading Card Lots',4,100899,'1:182982:100899',1),
(183036,'Wacky Packages',3,182982,'1:182982',0),
(183037,'Trading Card Lots',4,183036,'1:182982:183036',1),
(183038,'Complete Trading Card Sets',4,183036,'1:182982:183036',1),
(183039,'Sealed Trading Cards',4,183036,'1:182982:183036',1),
(183040,'Wacky Packages Merchandise',4,183036,'1:182982:183036',1),
(183041,'Walking Dead Trading Cards',3,182982,'1:182982',0),
(183042,'Trading Card Singles',4,183041,'1:182982:183041',1),
(183043,'Trading Card Lots',4,183041,'1:182982:183041',1),
(183044,'Complete Trading Card Sets',4,183041,'1:182982:183041',1),
(183045,'Sealed Trading Cards',4,183041,'1:182982:183041',1),
(183046,'X-Men Trading Cards',3,182982,'1:182982',0),
(183047,'Trading Card Lots',4,183046,'1:182982:183046',1),
(183048,'Complete Trading Card Sets',4,183046,'1:182982:183046',1),
(183049,'Sealed Trading Cards',4,183046,'1:182982:183046',1),
(183050,'Trading Card Singles',3,182982,'1:182982',1),
(183051,'Trading Card Lots',3,182982,'1:182982',1),
(183052,'Complete Trading Card Sets',3,182982,'1:182982',1),
(183053,'Sealed Trading Cards',3,182982,'1:182982',1),
(183054,'Wrappers & Empty Card Boxes',3,182982,'1:182982',1),
(183056,'Non-Sport Card Supplies & Accs',3,182982,'1:182982',0),
(183057,'Card Sleeves & Bags',4,183056,'1:182982:183056',1),
(183058,'Card Toploaders & Holders',4,183056,'1:182982:183056',1),
(183059,'Card Albums & Pages',4,183056,'1:182982:183056',1),
(183060,'Card Storage Boxes',4,183056,'1:182982:183056',1),
(183061,'Sealed Trading Cards',4,100899,'1:182982:100899',1),
(183062,'3D Printers & Supplies',2,58058,'58058',0),
(183063,'3D Printers',3,183062,'58058:183062',1),
(183064,'3D Scanners',3,183062,'58058:183062',1),
(183065,'3D Printer Consumables',3,183062,'58058:183062',1),
(183066,'Parts & Accessories',3,183062,'58058:183062',1),
(183067,'Virtual Reality',2,293,'293',0),
(183068,'PC & Console VR Headsets',3,183067,'293:183067',1),
(183069,'Smartphone VR Headsets',3,183067,'293:183067',1),
(183070,'Cases, Covers & Skins',3,183067,'293:183067',1),
(183071,'Controllers & Motion Sensors',3,183067,'293:183067',1),
(183072,'Parts',3,183067,'293:183067',1),
(183073,'Other Virtual Reality Accs',3,183067,'293:183067',1),
(183074,'Vintage Headphones',4,175740,'293:183077:175740',1),
(183077,'Vintage Electronics',2,293,'293',0),
(183078,'8-Track Players',4,175740,'293:183077:175740',1),
(183079,'Other Vintage Electronics',3,183077,'293:183077',1),
(183080,'Collage Supplies',3,11783,'14339:11783',1),
(183081,'Drawing & Lettering Supplies',3,11783,'14339:11783',0),
(183082,'Drawing & Calligraphy Inks',4,183081,'14339:11783:183081',1),
(183083,'Drawing Boards & Tables',4,183081,'14339:11783:183081',1),
(183084,'Drawing Accessories',4,183081,'14339:11783:183081',0),
(183085,'Artists\' Mannequins',5,183084,'14339:11783:183081:183084',1),
(183086,'Art Projectors & Light Boxes',5,183084,'14339:11783:183081:183084',1),
(183087,'Blending Stumps & Tortillons',5,183084,'14339:11783:183081:183084',1),
(183088,'Stationery',5,183084,'14339:11783:183081:183084',1),
(183089,'Other Drawing Accessories',5,183084,'14339:11783:183081:183084',1),
(183090,'Fixatives',4,183081,'14339:11783:183081',1),
(183091,'Airbrushing Supplies',4,28110,'14339:11783:28110',0),
(183092,'Airbrush Paints',5,183091,'14339:11783:28110:183091',1),
(183093,'Airbrush Parts',5,183091,'14339:11783:28110:183091',1),
(183094,'Spray Booths',5,183091,'14339:11783:28110:183091',1),
(183095,'Systems & Sets',5,183091,'14339:11783:28110:183091',1),
(183096,'Paint Mediums & Varnishes',4,28110,'14339:11783:28110',1),
(183097,'Primers & Sealers',4,28110,'14339:11783:28110',1),
(183098,'Painting Tools & Accessories',4,28110,'14339:11783:28110',0),
(183099,'Colour Wheels',5,183098,'14339:11783:28110:183098',1),
(183100,'Painting Stencils',5,183098,'14339:11783:28110:183098',1),
(183101,'Other Painting Accessories',5,183098,'14339:11783:28110:183098',1),
(183102,'Paint',4,28110,'14339:11783:28110',0),
(183103,'Tempera',5,183102,'14339:11783:28110:183102',1),
(183104,'Spray Paint',5,183102,'14339:11783:28110:183102',1),
(183105,'Mixed Media Paint Sets',5,183102,'14339:11783:28110:183102',1),
(183106,'Printmaking',3,11783,'14339:11783',0),
(183107,'Printmaking Inks',4,183106,'14339:11783:183106',1),
(183108,'Block Printing Supplies',4,183106,'14339:11783:183106',0),
(183109,'Linoleum',5,183108,'14339:11783:183106:183108',1),
(183110,'Linoleum Cutters',5,183108,'14339:11783:183106:183108',1),
(183111,'Block Printing Brayers',5,183108,'14339:11783:183106:183108',1),
(183112,'Block Printing Sets & Kits',5,183108,'14339:11783:183106:183108',1),
(183113,'Screen Printing',4,183106,'14339:11783:183106',0),
(183114,'Screen Printing Frames',5,183113,'14339:11783:183106:183113',1),
(183115,'Screen Printing Squeegees',5,183113,'14339:11783:183106:183113',1),
(183116,'Screen Printing Sets & Kits',5,183113,'14339:11783:183106:183113',1),
(183117,'Other Printmaking',4,183106,'14339:11783:183106',1),
(183118,'Fabric Painting & Decorating',2,14339,'14339',0),
(183119,'Fabric Cutting Machines',3,183118,'14339:183118',1),
(183120,'Fabric Dyes',3,183118,'14339:183118',1),
(183121,'Other Fabric Painting',3,183118,'14339:183118',1),
(183122,'Adhesives & Tape',3,28102,'14339:28102',0),
(183123,'Mounting Tape',4,183122,'14339:28102:183122',1),
(183124,'Glue Guns & Sticks',4,183122,'14339:28102:183122',1),
(183125,'Other Adhesives & Tape',4,183122,'14339:28102:183122',1),
(183126,'Decorative & Tole Painting',2,14339,'14339',0),
(183127,'Leathercraft Accessories',3,28131,'14339:28131',0),
(183128,'Leathercraft Tools',3,28131,'14339:28131',0),
(183129,'Bonding Tools & Glue',4,183128,'14339:28131:183128',1),
(183130,'Carving Tools & Stamps',4,183128,'14339:28131:183128',1),
(183131,'Edge Slickers/Groovers',4,183128,'14339:28131:183128',1),
(183132,'Grommet Tools/Setters',4,183128,'14339:28131:183128',1),
(183133,'Hammer & Mallets',4,183128,'14339:28131:183128',1),
(183134,'Hollow Punching Tools',4,183128,'14339:28131:183128',1),
(183135,'Lacing Needles',4,183128,'14339:28131:183128',1),
(183136,'Leather Cutting Tools',4,183128,'14339:28131:183128',1),
(183137,'Leather Measuring Tools',4,183128,'14339:28131:183128',1),
(183138,'Leather Threads',4,183128,'14339:28131:183128',1),
(183139,'Sewing Awls',4,183128,'14339:28131:183128',1),
(183140,'Stitching Horses',4,183128,'14339:28131:183128',1),
(183141,'Leather Treatments & Paints',3,28131,'14339:28131',0),
(183142,'Conditioners & Treatments',4,183141,'14339:28131:183141',1),
(183143,'Daubers/Applicators',4,183141,'14339:28131:183141',1),
(183144,'Leather Paints & Finishes',4,183141,'14339:28131:183141',1),
(183145,'Polishing & Creasing Tools',4,183141,'14339:28131:183141',1),
(183146,'Sets & Kits',4,183141,'14339:28131:183141',1),
(183147,'Other Leather Treatments',4,183141,'14339:28131:183141',1),
(183148,'Patterns & Instructional Media',3,28131,'14339:28131',1),
(183149,'Instruction Books & Media',3,3127,'14339:3127',1),
(183150,'Wood Burning Pens',3,3127,'14339:3127',1),
(183151,'Wood Project Kits',3,3127,'14339:3127',0),
(183152,'Wood Burning Kits',4,183151,'14339:3127:183151',1),
(183153,'Wood Carving Kits',4,183151,'14339:3127:183151',1),
(183154,'Wood Turning Kits',4,183151,'14339:3127:183151',1),
(183155,'Wood & Project Materials',3,3127,'14339:3127',0),
(183156,'Carving Roughouts',4,183155,'14339:3127:183155',1),
(183157,'Carving Wood',4,183155,'14339:3127:183155',1),
(183158,'Dowels',4,183155,'14339:3127:183155',1),
(183159,'Inlay',4,183155,'14339:3127:183155',1),
(183160,'Other Wood & Project Materials',4,183155,'14339:3127:183155',1),
(183161,'Other Woodworking Supplies',3,3127,'14339:3127',1),
(183162,'Bottle Caps',4,160704,'14339:28102:160704',1),
(183163,'Chipboard Sheets',4,160704,'14339:28102:160704',1),
(183164,'Clothes Pegs',4,160704,'14339:28102:160704',1),
(183165,'Flatback Charms & Cabachons',4,160704,'14339:28102:160704',1),
(183166,'Flower Embellishments',4,160704,'14339:28102:160704',1),
(183167,'Pipe Cleaners',4,160704,'14339:28102:160704',1),
(183168,'Pom Poms',4,160704,'14339:28102:160704',1),
(183169,'Sequins',4,160704,'14339:28102:160704',1),
(183170,'Wiggle Eyes',4,160704,'14339:28102:160704',1),
(183171,'Crafting Tools',3,28102,'14339:28102',0),
(183172,'Bone Folders',4,183171,'14339:28102:183171',1),
(183173,'Cutting Tools',4,183171,'14339:28102:183171',0),
(183175,'Cutting Mats',5,183173,'14339:28102:183171:183173',1),
(183176,'Paper Punches',5,183173,'14339:28102:183171:183173',1),
(183177,'Scissors & Paper Edgers',5,183173,'14339:28102:183171:183173',1),
(183178,'Other Cutting Tools',5,183173,'14339:28102:183171:183173',1),
(183179,'Other Crafting Tools',4,183171,'14339:28102:183171',1),
(183180,'Crafting Paper',3,28102,'14339:28102',0),
(183181,'Construction Paper',4,183180,'14339:28102:183180',1),
(183182,'Decoupage Tissue Paper',4,183180,'14339:28102:183180',1),
(183183,'Metallic & Foiled Paper',4,183180,'14339:28102:183180',1),
(183184,'Other Crafting Paper',4,183180,'14339:28102:183180',1),
(183185,'Stencils & Templates',3,28102,'14339:28102',1),
(183186,'Plastic Satchel Organisers',4,146396,'14339:28102:146396',1),
(183187,'Other Craft Storage',4,146396,'14339:28102:146396',1),
(183188,'Craft Totes',4,146396,'14339:28102:146396',1),
(183189,'Smocking Pleaters',5,160720,'14339:160706:28141:160720',1),
(183190,'Stitch Markers',5,160720,'14339:160706:28141:160720',1),
(183191,'Embroidery Scissors',5,160720,'14339:160706:28141:160720',1),
(183192,'Embroidery Thimbles',5,160720,'14339:160706:28141:160720',1),
(183193,'Hand Embroidery Bobbins',5,160720,'14339:160706:28141:160720',1),
(183194,'Embroidery Machine Parts',5,160724,'14339:160706:28141:160724',1),
(183195,'Hand Embroidery Cloth & Canvas',4,28141,'14339:160706:28141',0),
(183196,'Embroidery Cloth/Fabric',5,183195,'14339:160706:28141:183195',1),
(183197,'Hand Embroidery Kits',4,28141,'14339:160706:28141',0),
(183198,'Ribbon Embroidery Kits',5,183197,'14339:160706:28141:183197',1),
(183199,'Hand Embr Patterns & Magazines',4,28141,'14339:160706:28141',0),
(183200,'Crewel Patterns',5,183199,'14339:160706:28141:183199',1),
(183201,'Hardanger Patterns',5,183199,'14339:160706:28141:183199',1),
(183202,'Punch Needle Patterns',5,183199,'14339:160706:28141:183199',1),
(183203,'Ribbon Embroidery Patterns',5,183199,'14339:160706:28141:183199',1),
(183204,'Smocking Patterns',5,183199,'14339:160706:28141:183199',1),
(183205,'Macramé',3,160706,'14339:160706',0),
(183206,'Macramé Tools & Accessories',4,183205,'14339:160706:183205',1),
(183207,'Macramé Kits',4,183205,'14339:160706:183205',1),
(183208,'Patterns & Instructional Media',4,183205,'14339:160706:183205',1),
(183209,'Spinning & Felting',3,160706,'14339:160706',0),
(183210,'Felt Appliques',4,183209,'14339:160706:183209',1),
(183211,'Needle Felting',4,183209,'14339:160706:183209',0),
(183212,'Felting Kits',5,183211,'14339:160706:183209:183211',1),
(183213,'Felting Mats',5,183211,'14339:160706:183209:183211',1),
(183214,'Felting Needles & Pens',5,183211,'14339:160706:183209:183211',1),
(183215,'Felting Patterns & Magazines',5,183211,'14339:160706:183209:183211',1),
(183216,'Needle Felting Machines',5,183211,'14339:160706:183209:183211',1),
(183217,'Needle Felting Molds',5,183211,'14339:160706:183209:183211',1),
(183218,'Spinning',4,183209,'14339:160706:183209',0),
(183219,'Hand & Drum Carders',5,183218,'14339:160706:183209:183218',1),
(183220,'Finished Embroidered Pieces',4,28141,'14339:160706:28141',0),
(183221,'Finished Crewel Pieces',5,183220,'14339:160706:28141:183220',1),
(183222,'Finished Hardanger Pieces',5,183220,'14339:160706:28141:183220',1),
(183223,'Finished Punch Needle Pieces',5,183220,'14339:160706:28141:183220',1),
(183224,'Finished Ribbon Embr Pieces',5,183220,'14339:160706:28141:183220',1),
(183225,'Other Finished Pieces',5,183220,'14339:160706:28141:183220',1),
(183226,'Rug Braiding',4,28147,'14339:160706:28147',0),
(183227,'Rug Braiding Kits',5,183226,'14339:160706:28147:183226',1),
(183228,'Rug Braiding Patterns',5,183226,'14339:160706:28147:183226',1),
(183229,'Rug Braiding Supplies',5,183226,'14339:160706:28147:183226',1),
(183230,'Rug Braiding Tools',5,183226,'14339:160706:28147:183226',1),
(183231,'Tatting & Lacemaking',3,160706,'14339:160706',0),
(183232,'Tatting Lace Appliques',4,183231,'14339:160706:183231',1),
(183233,'Weaving',3,160706,'14339:160706',0),
(183234,'Cutting Templates',5,83981,'14339:11788:31253:83981',1),
(183235,'Paper Trimmers',5,83981,'14339:11788:31253:83981',1),
(183236,'Punch & Score Boards',5,83981,'14339:11788:31253:83981',1),
(183237,'Die Cut Shapes & Punchies',5,183591,'14339:11788:31253:183591',1),
(183238,'Rub-On Transfers',5,183591,'14339:11788:31253:183591',1),
(183239,'Die Cutting & Embossing',3,11788,'14339:11788',0),
(183240,'Machine Parts & Accessories',4,183239,'14339:11788:183239',1),
(183241,'Other Die Cutting & Embossing',4,183239,'14339:11788:183239',1),
(183242,'Paper Crafts',3,11788,'14339:11788',0),
(183243,'Other Paper Crafts',4,183242,'14339:11788:183242',1),
(183245,'Tape Runners & Refills',5,161585,'14339:11788:31253:161585',1),
(183246,'Photo Mounting Corners',5,161585,'14339:11788:31253:161585',1),
(183247,'Washi Tape',5,161585,'14339:11788:31253:161585',1),
(183248,'Scrapbooking Albums & Refills',4,31253,'14339:11788:31253',0),
(183249,'Album Extension Posts',5,183248,'14339:11788:31253:183248',1),
(183250,'Photo Pocket & Page Protectors',5,183248,'14339:11788:31253:183248',1),
(183253,'Closures & Connectors',3,160737,'14339:160737',0),
(183254,'Buckles & Straps',4,183253,'14339:160737:183253',1),
(183255,'Button Covering Machines',4,183253,'14339:160737:183253',1),
(183256,'Eyelets',4,183253,'14339:160737:183253',1),
(183257,'Frogs',4,183253,'14339:160737:183253',1),
(183258,'Grommets',4,183253,'14339:160737:183253',1),
(183259,'Hooks & Eyes',4,183253,'14339:160737:183253',1),
(183260,'Lock Ends/Cord Stoppers',4,183253,'14339:160737:183253',1),
(183261,'Rings',4,183253,'14339:160737:183253',1),
(183262,'Snaps',4,183253,'14339:160737:183253',1),
(183263,'Suspender/Pacifier Clips',4,183253,'14339:160737:183253',1),
(183264,'Toggles',4,183253,'14339:160737:183253',1),
(183265,'Cutting Tools',3,160737,'14339:160737',0),
(183266,'Cutting Mats & Boards',4,183265,'14339:160737:183265',1),
(183267,'Rotary Blades',4,183265,'14339:160737:183265',1),
(183268,'Seam Rippers',4,183265,'14339:160737:183265',1),
(183269,'Thread Snips',4,183265,'14339:160737:183265',1),
(183270,'Embelishments & Finishes',3,160737,'14339:160737',0),
(183271,'Clothing Labels',4,183270,'14339:160737:183270',1),
(183272,'Tassels',4,183270,'14339:160737:183270',1),
(183273,'Webbings',4,183270,'14339:160737:183270',1),
(183274,'Foundations & Undergarments',3,160737,'14339:160737',0),
(183275,'Boning',4,183274,'14339:160737:183274',1),
(183276,'Bra Cup Pads',4,183274,'14339:160737:183274',1),
(183277,'Elastic',4,183274,'14339:160737:183274',1),
(183278,'Hat Bodies',4,183274,'14339:160737:183274',1),
(183279,'Hat Frames',4,183274,'14339:160737:183274',1),
(183280,'Piping & Strings',4,183274,'14339:160737:183274',1),
(183281,'Hand Sewing Needles & Accs',3,160737,'14339:160737',0),
(183282,'Needle Cases & Organisers',4,183281,'14339:160737:183281',1),
(183283,'Needle Threaders',4,183281,'14339:160737:183281',1),
(183284,'Point Turners',4,183281,'14339:160737:183281',1),
(183285,'Thimbles',4,183281,'14339:160737:183281',1),
(183286,'Marking Tools',3,160737,'14339:160737',0),
(183287,'Dressmaker\'s Tracing Paper',4,183286,'14339:160737:183286',1),
(183288,'Marking Pencils & Pens',4,183286,'14339:160737:183286',1),
(183289,'Pins',4,183286,'14339:160737:183286',1),
(183290,'Tailor\'s Chalks & Waxes',4,183286,'14339:160737:183286',1),
(183291,'Tracing Wheels',4,183286,'14339:160737:183286',1),
(183292,'Measuring Tools',3,160737,'14339:160737',0),
(183293,'French & Hip Curves',4,183292,'14339:160737:183292',1),
(183294,'L/Framing Squares',4,183292,'14339:160737:183292',1),
(183295,'Measuring Tapes',4,183292,'14339:160737:183292',1),
(183296,'Measuring Tool Kits',4,183292,'14339:160737:183292',1),
(183297,'Seam/Sewing Gauges',4,183292,'14339:160737:183292',1),
(183298,'Sewing Rulers',4,183292,'14339:160737:183292',1),
(183299,'Pressing Equipment',3,160737,'14339:160737',0),
(183300,'Mini Irons',4,183299,'14339:160737:183299',1),
(183301,'Pressing Paper',4,183299,'14339:160737:183299',1),
(183302,'Sculpting, Moulding & Ceramics',2,14339,'14339',0),
(183303,'Ceramics & Pottery',3,183302,'14339:183302',0),
(183304,'Ceramic & Porcelain Paints',4,183303,'14339:183302:183303',1),
(183305,'Ceramic Clays',4,183303,'14339:183302:183303',1),
(183306,'Ceramic Glazes',4,183303,'14339:183302:183303',1),
(183307,'Other Ceramics & Pottery',4,183303,'14339:183302:183303',1),
(183308,'Modelling',3,183302,'14339:183302',0),
(183309,'Armature Wire and Wire Form',4,183308,'14339:183302:183308',1),
(183310,'Modelling Clays & Materials',4,183308,'14339:183302:183308',1),
(183311,'Modelling Tools & Sets',4,183308,'14339:183302:183308',1),
(183312,'Other Modelling',4,183308,'14339:183302:183308',1),
(183313,'Moulding & Casting',3,183302,'14339:183302',0),
(183314,'Release Agents',4,183313,'14339:183302:183313',1),
(183315,'Other Moulding & Casting',4,183313,'14339:183302:183313',1),
(183316,'Stone Carving',3,183302,'14339:183302',0),
(183317,'Carving Stones',4,183316,'14339:183302:183316',1),
(183318,'Stone Carving Tools & Sets',4,183316,'14339:183302:183316',1),
(183319,'Other Sculpting Supplies',3,183302,'14339:183302',1),
(183320,'Drinks Trolleys & Tea Trolleys',3,3197,'11700:3197',1),
(183321,'Benches',4,66741,'11700:3197:66741',1),
(183322,'Sideboards & Buffets',3,3197,'11700:3197',1),
(183324,'Decorating Tools',4,177009,'11700:20625:177009',0),
(183325,'Cake Boards',5,183324,'11700:20625:177009:183324',1),
(183326,'Cake Dowels & Pillars',5,183324,'11700:20625:177009:183324',1),
(183327,'Cake Dummies',5,183324,'11700:20625:177009:183324',1),
(183328,'Cake Levellers',5,183324,'11700:20625:177009:183324',1),
(183329,'Cake Scrapers',5,183324,'11700:20625:177009:183324',1),
(183330,'Crimpers',5,183324,'11700:20625:177009:183324',1),
(183331,'Flower Nails',5,183324,'11700:20625:177009:183324',1),
(183332,'Icing Bag Holders',5,183324,'11700:20625:177009:183324',1),
(183333,'Icing Edgers & Smoothers',5,183324,'11700:20625:177009:183324',1),
(183334,'Icing Nozzles',5,183324,'11700:20625:177009:183324',1),
(183335,'Icing Turntables',5,183324,'11700:20625:177009:183324',1),
(183336,'Modelling Tools & Cutters',5,183324,'11700:20625:177009:183324',1),
(183337,'Nozzle Organisers',5,183324,'11700:20625:177009:183324',1),
(183338,'Other Decorating Tools',5,183324,'11700:20625:177009:183324',1),
(183339,'Decorations & Cake Toppers',4,177009,'11700:20625:177009',0),
(183340,'Cake Airbrushing',5,183339,'11700:20625:177009:183339',1),
(183341,'Cake Toppers',5,183339,'11700:20625:177009:183339',1),
(183342,'Candles',5,183339,'11700:20625:177009:183339',1),
(183343,'Decorating Pens & Presses',5,183339,'11700:20625:177009:183339',1),
(183344,'Edible Glitter & Sprinkles',5,183339,'11700:20625:177009:183339',1),
(183345,'Food Colouring',5,183339,'11700:20625:177009:183339',1),
(183346,'Icing & Fondant',5,183339,'11700:20625:177009:183339',1),
(183347,'Fondant Markers & Gels',5,183339,'11700:20625:177009:183339',1),
(183348,'Ribbons & Cords',5,183339,'11700:20625:177009:183339',1),
(183349,'Sugar Flowers & Decorations',5,183339,'11700:20625:177009:183339',1),
(183350,'Other Decorations',5,183339,'11700:20625:177009:183339',1),
(183351,'Pastry Cutters',4,177009,'11700:20625:177009',1),
(183352,'Pastry Forms',4,177009,'11700:20625:177009',1),
(183353,'Presentation & Packaging',4,177009,'11700:20625:177009',0),
(183354,'Artificial Flowers',5,183353,'11700:20625:177009:183353',1),
(183355,'Cake Boxes & Bags',5,183353,'11700:20625:177009:183353',1),
(183356,'Cake Stands',5,183353,'11700:20625:177009:183353',1),
(183357,'Other Packaging',5,183353,'11700:20625:177009:183353',1),
(183358,'Western Chaps/Full Chaps',4,16240,'888:3153:16240',1),
(183359,'Men\'s Clothing',4,16240,'888:3153:16240',0),
(183360,'Shirts',5,183359,'888:3153:16240:183359',1),
(183361,'Vests',5,183359,'888:3153:16240:183359',1),
(183362,'English Show Jackets',5,183359,'888:3153:16240:183359',1),
(183363,'English Show Shirts',5,183359,'888:3153:16240:183359',1),
(183364,'Western Show Shirts',5,183359,'888:3153:16240:183359',1),
(183365,'Women\'s Clothing',4,16240,'888:3153:16240',0),
(183366,'Shirts & Tops',5,183365,'888:3153:16240:183365',1),
(183367,'Vests',5,183365,'888:3153:16240:183365',1),
(183368,'English Show Jackets',5,183365,'888:3153:16240:183365',1),
(183369,'English Show Shirts',5,183365,'888:3153:16240:183365',1),
(183370,'Western Show Shirts',5,183365,'888:3153:16240:183365',1),
(183371,'Youth Clothing',4,16240,'888:3153:16240',0),
(183372,'Shirts & Tops',5,183371,'888:3153:16240:183371',1),
(183373,'Vests',5,183371,'888:3153:16240:183371',1),
(183374,'English Show Jackets',5,183371,'888:3153:16240:183371',1),
(183375,'English Show Shirts',5,183371,'888:3153:16240:183371',1),
(183376,'Western Show Shirts',5,183371,'888:3153:16240:183371',1),
(183377,'Saddle Pads',4,3159,'888:3153:3159',1),
(183378,'Seat Savers',4,3159,'888:3153:3159',1),
(183379,'Stirrups',4,3159,'888:3153:3159',1),
(183380,'Stirrup Leathers',4,3159,'888:3153:3159',1),
(183381,'Reins',4,3159,'888:3153:3159',1),
(183382,'Tall Riding Boots',4,27031,'888:3153:27031',1),
(183383,'Gaiters/Half Chaps',4,27031,'888:3153:27031',1),
(183384,'Spur Straps',4,27031,'888:3153:27031',1),
(183385,'Boot Bags',4,27031,'888:3153:27031',1),
(183386,'Reflective Vests',4,87443,'888:3153:87443',1),
(183387,'Riding Helmet Covers',4,87443,'888:3153:87443',1),
(183389,'Amplifier Parts & Accessories',4,180009,'619:3858:180009',1),
(183390,'Bamboo Seeds',5,40605,'11700:159912:181003:40605',1),
(183391,'Garden Solar & Flame Torches',4,42154,'11700:159912:42154',1),
(183392,'Outdoor Décor Candle Lanterns',4,42154,'11700:159912:42154',1),
(183393,'Outdoor Security & Floodlights',4,42154,'11700:159912:42154',1),
(183394,'Outdoor String Lights',4,42154,'11700:159912:42154',1),
(183395,'Horse Feed',4,139576,'888:3153:139576',1),
(183396,'Plaiting & Show Accessories',4,139580,'888:3153:139580',1),
(183397,'Curry Combs',4,139580,'888:3153:139580',1),
(183398,'Fly & Insect Repellents',4,139580,'888:3153:139580',1),
(183399,'Grooming Brushes',4,139580,'888:3153:139580',1),
(183400,'Grooming Kits',4,139580,'888:3153:139580',1),
(183401,'Grooming Boxes & Bags',4,139580,'888:3153:139580',1),
(183402,'Hoof Oil & Moisturiser',4,139580,'888:3153:139580',1),
(183403,'Hoof Picks',4,139580,'888:3153:139580',1),
(183404,'Hoof Rasps & Farrier Tools',4,139580,'888:3153:139580',1),
(183405,'Horse Clippers',4,139580,'888:3153:139580',1),
(183406,'Mane & Tail Combs',4,139580,'888:3153:139580',1),
(183407,'Shampoo & Conditioner',4,139580,'888:3153:139580',1),
(183408,'Sweat Scrapers',4,139580,'888:3153:139580',1),
(183409,'Tail Extensions',4,139580,'888:3153:139580',1),
(183410,'Wormers & Health Supplies',4,139580,'888:3153:139580',1),
(183411,'Seat Savers',4,3161,'888:3153:3161',1),
(183412,'Stirrups',4,3161,'888:3153:3161',1),
(183413,'Stirrup Leathers & Fenders',4,3161,'888:3153:3161',1),
(183414,'Bridle Parts & Accessories',4,3161,'888:3153:3161',1),
(183415,'Reins',4,3161,'888:3153:3161',1),
(183416,'Saddle Covers',4,3161,'888:3153:3161',1),
(183417,'Grazing Muzzles',4,57268,'888:3153:57268',1),
(183418,'Hoods & Neck Covers',4,57268,'888:3153:57268',1),
(183419,'Shoulder Guards & Bibs',4,57268,'888:3153:57268',1),
(183420,'Tail Guards',4,57268,'888:3153:57268',1),
(183421,'Lunging & Training Equipment',3,3153,'888:3153',0),
(183422,'Lunge Cavessons',4,183421,'888:3153:183421',1),
(183423,'Lunge Lines',4,183421,'888:3153:183421',1),
(183424,'Lunging & Vaulting Rollers',4,183421,'888:3153:183421',1),
(183425,'Roller Pads',4,183421,'888:3153:183421',1),
(183426,'Other Training Equipment',4,183421,'888:3153:183421',1),
(183427,'Cart & Carriage Parts & Accs',4,85178,'888:3153:85178',1),
(183428,'Bridle & Halter Bags',4,85214,'888:3153:85214',1),
(183429,'Electric Fence Insulators',4,85214,'888:3153:85214',1),
(183430,'Electric Fence Posts',4,85214,'888:3153:85214',1),
(183431,'Electric Fence Wire & Rope',4,85214,'888:3153:85214',1),
(183432,'Saddle Racks & Stands',4,85214,'888:3153:85214',1),
(183433,'Stall Plaques & Signs',4,85214,'888:3153:85214',1),
(183434,'Tack Hooks & Hook Racks',4,85214,'888:3153:85214',1),
(183435,'Wrestling Cards',3,212,'888:212',1),
(183436,'Storage & Display Supplies',3,212,'888:212',0),
(183437,'Card Sleeves & Bags',4,183436,'888:212:183436',1),
(183438,'Card Toploaders & Holders',4,183436,'888:212:183436',1),
(183439,'Albums, Binders & Pages',4,183436,'888:212:183436',1),
(183440,'Card Storage Boxes',4,183436,'888:212:183436',1),
(183441,'Card Sorting Trays',4,183436,'888:212:183436',1),
(183442,'Card Display Cases & Cabinets',4,183436,'888:212:183436',1),
(183443,'Other Supplies',4,183436,'888:212:183436',1),
(183444,'Soccer Cards',3,212,'888:212',1),
(183445,'MTG Sealed Decks & Kits',4,19107,'220:2536:19107',1),
(183446,'Building Toys',2,220,'220',0),
(183447,'LEGO',3,183446,'220:183446',0),
(183448,'Bricks & Building Pieces',4,183447,'220:183446:183447',1),
(183449,'Instruction Manuals',4,183447,'220:183446:183447',1),
(183450,'LEGO Branded Storage',4,183447,'220:183446:183447',1),
(183451,'Mixed Lots',4,183447,'220:183446:183447',1),
(183452,'Yu-Gi-Oh! Sealed Decks & Kits',4,31393,'220:2536:31393',1),
(183453,'Yu-Gi-Oh! Player-Built Decks',4,31393,'220:2536:31393',1),
(183454,'CCG Individual Cards',3,2536,'220:2536',1),
(183455,'CCG Mixed Card Lots',3,2536,'220:2536',1),
(183456,'CCG Sealed Booster Packs',3,2536,'220:2536',1),
(183457,'CCG Sealed Decks & Kits',3,2536,'220:2536',1),
(183458,'CCG Player-Built Decks',3,2536,'220:2536',1),
(183459,'CCG Complete Sets',3,2536,'220:2536',1),
(183460,'CCG Supplies & Accessories',3,2536,'220:2536',0),
(183461,'CCG Card Sleeves',4,183460,'220:2536:183460',1),
(183462,'CCG Deck Boxes',4,183460,'220:2536:183460',1),
(183463,'CCG Dice & Counters',4,183460,'220:2536:183460',1),
(183464,'CCG Playmats',4,183460,'220:2536:183460',1),
(183465,'CCG Albums & Pages',4,183460,'220:2536:183460',1),
(183466,'Pokémon Trading Card Game',3,2536,'220:2536',0),
(183467,'Pokémon Sealed Decks & Kits',4,183466,'220:2536:183466',1),
(183468,'Pokémon Player-Built Decks',4,183466,'220:2536:183466',1),
(183469,'Battery Holders, Covers & Accs',5,19839,'220:2562:182187:19839',1),
(183470,'Flight Recorders & Telemetry',5,19839,'220:2562:182187:19839',1),
(183471,'PCBs, Switch/Function Modules',5,19839,'220:2562:182187:19839',1),
(183472,'40K Starter Sets',6,44408,'220:233:16486:31398:44408',1),
(183473,'40K Miniatures',6,44408,'220:233:16486:31398:44408',1),
(183474,'WFB Starter Sets',6,44409,'220:233:16486:31398:44409',1),
(183475,'WFB Miniatures',6,44409,'220:233:16486:31398:44409',1),
(183476,'WFB Spare Bits & Pieces',6,44409,'220:233:16486:31398:44409',1),
(183477,'Vintage Luggage & Travel Accs',2,11730,'11730',1),
(183478,'Camera & CCTV Testers',5,181948,'170769:92074:181939:181948',1),
(183479,'NIM & CAMAC Systems',4,181939,'170769:92074:181939',0),
(183480,'NIM & CAMAC Bins/Crates',5,183479,'170769:92074:181939:183479',1),
(183481,'NIM & CAMAC Controllers',5,183479,'170769:92074:181939:183479',1),
(183482,'NIM & CAMAC Modules',5,183479,'170769:92074:181939:183479',1),
(183483,'Other NIM & CAMAC Equipment',5,183479,'170769:92074:181939:183479',1),
(183484,'Manometers/Air Pressure Meters',5,181968,'170769:92074:181939:181968',1),
(183485,'Decade Boxes',5,181998,'170769:92074:181939:181998',1),
(183486,'Tone Probes & Generators',5,181998,'170769:92074:181939:181998',1),
(183490,'Sticker Albums, Packs & Spares',3,182982,'1:182982',1),
(183502,'Antennas',3,1500,'293:1500',0),
(183503,'Parts & Accessories',3,1500,'293:1500',0),
(183504,'Body Armour & Protectors',3,6747,'131090:6747',0),
(183505,'Ankle Braces & Supports',4,183504,'131090:6747:183504',1),
(183506,'Armoured Shorts',4,183504,'131090:6747:183504',1),
(183507,'Back Protectors',4,183504,'131090:6747:183504',1),
(183508,'Chest Protectors',4,183504,'131090:6747:183504',1),
(183509,'Elbow & Shoulder Guards',4,183504,'131090:6747:183504',1),
(183510,'Hip Protectors',4,183504,'131090:6747:183504',1),
(183511,'Kidney Belts',4,183504,'131090:6747:183504',1),
(183512,'Knee Braces & Shin Guards',4,183504,'131090:6747:183504',1),
(183513,'Neck Guards & Supports',4,183504,'131090:6747:183504',1),
(183514,'Helmet Care & Cleaning',4,177075,'131090:6747:177075',0),
(183515,'Cleaning Kits',5,183514,'131090:6747:177075:183514',1),
(183516,'Cleaners',5,183514,'131090:6747:177075:183514',1),
(183517,'Cloths & Wipes',5,183514,'131090:6747:177075:183514',1),
(183518,'Over Boots',4,177099,'131090:6747:177099',1),
(183519,'Motorcycle Chaps',4,177099,'131090:6747:177099',1),
(183520,'Cleaners & Degreasers',4,179735,'131090:25622:179735',1),
(183521,'Polish',4,179735,'131090:25622:179735',1),
(183522,'Protection Sprays',4,179735,'131090:25622:179735',1),
(183523,'Handlebar Accessory Mounts',4,180513,'131090:14780:180513',1),
(183524,'On-Board Sockets & Adaptors',4,180513,'131090:14780:180513',1),
(183525,'Wheel Rollers',4,179731,'131090:25622:179731',1),
(183526,'Elastic Cords & Nets',4,179715,'131090:25622:179715',1),
(183527,'Luggage Racks',4,179715,'131090:25622:179715',1),
(183528,'Saddlebags & Panniers',4,179715,'131090:25622:179715',1),
(183529,'Tank Bags',4,179715,'131090:25622:179715',1),
(183530,'Ramps & Towing',3,25622,'131090:25622',0),
(183531,'Motorcycle Cargo Trailers',4,183530,'131090:25622:183530',1),
(183532,'Ramps & Rails',4,183530,'131090:25622:183530',1),
(183533,'Tie-Down Straps',4,183530,'131090:25622:183530',1),
(183534,'Tow Ropes',4,183530,'131090:25622:183530',1),
(183535,'Wheel Chocks',4,183530,'131090:25622:183530',1),
(183536,'Weather Protection',3,25622,'131090:25622',0),
(183537,'Handlebar Muffs',4,183536,'131090:25622:183536',1),
(183538,'Seat Protectors',4,183536,'131090:25622:183536',1),
(183539,'Other Weather Protection',4,183536,'131090:25622:183536',1),
(183540,'Brake Lever Locks',4,179723,'131090:25622:179723',1),
(183541,'Helmet Locks',4,179723,'131090:25622:179723',1),
(183542,'Padlocks',4,179723,'131090:25622:179723',1),
(183543,'Safety Cables',4,179723,'131090:25622:179723',1),
(183544,'Stickers, Emblems & Flags',3,25622,'131090:25622',0),
(183545,'Decals & Stickers',4,183544,'131090:25622:183544',1),
(183546,'Emblems',4,183544,'131090:25622:183544',1),
(183548,'Slides, Rails & Carriages',4,181736,'170769:42892:181736',1),
(183550,'Category 10',5,183559,'99:14112:178348:183559',1),
(183551,'Category 11',5,183559,'99:14112:178348:183559',1),
(183552,'Category 12',5,183559,'99:14112:178348:183559',1),
(183553,'Category 13',5,183559,'99:14112:178348:183559',1),
(183554,'Category 14',5,183559,'99:14112:178348:183559',1),
(183555,'Category 15',5,183559,'99:14112:178348:183559',1),
(183559,'Group 5',4,178348,'99:14112:178348',0),
(183560,'Category 1',5,183559,'99:14112:178348:183559',1),
(183561,'Category 2',5,183559,'99:14112:178348:183559',1),
(183562,'Category 3',5,183559,'99:14112:178348:183559',1),
(183563,'Category 4',5,183559,'99:14112:178348:183559',1),
(183564,'Category 5',5,183559,'99:14112:178348:183559',1),
(183565,'Category 6',5,183559,'99:14112:178348:183559',1),
(183566,'Category 7',5,183559,'99:14112:178348:183559',1),
(183567,'Category 8',5,183559,'99:14112:178348:183559',1),
(183568,'Category 9',5,183559,'99:14112:178348:183559',1),
(183591,'Scrapbooking Embellishments',4,31253,'14339:11788:31253',0),
(183592,'Test Category Group',4,178348,'99:14112:178348',0),
(183593,'Test Category 1',5,183592,'99:14112:178348:183592',1),
(183594,'Test Category 2',5,183592,'99:14112:178348:183592',1),
(183595,'Test Category 3',5,183592,'99:14112:178348:183592',1),
(183596,'Test Category 4',5,183592,'99:14112:178348:183592',1),
(183597,'Test Category 5',5,183592,'99:14112:178348:183592',0),
(183598,'Category 5.1',6,183597,'99:14112:178348:183592:183597',1),
(183599,'Category 5.2',6,183597,'99:14112:178348:183592:183597',1),
(183600,'Category 5.3',6,183597,'99:14112:178348:183592:183597',1),
(183601,'Category 5.4',6,183597,'99:14112:178348:183592:183597',1),
(183602,'Category 5.5',6,183597,'99:14112:178348:183592:183597',1),
(183603,'Category 5.6',6,183597,'99:14112:178348:183592:183597',1),
(183604,'Category 5.7',6,183597,'99:14112:178348:183592:183597',1),
(183605,'Category 5.8',6,183597,'99:14112:178348:183592:183597',1),
(183606,'Category 5.9',6,183597,'99:14112:178348:183592:183597',1),
(183607,'Category 5.10',6,183597,'99:14112:178348:183592:183597',1),
(183608,'Category 5.11',6,183597,'99:14112:178348:183592:183597',1),
(183609,'Category 5.12',6,183597,'99:14112:178348:183592:183597',1),
(183610,'Category 5.13',6,183597,'99:14112:178348:183592:183597',1),
(183611,'Category 5.14',6,183597,'99:14112:178348:183592:183597',1),
(183612,'Category 5.15',6,183597,'99:14112:178348:183592:183597',1),
(183613,'Category 5.16',6,183597,'99:14112:178348:183592:183597',1),
(183614,'Category 5.17',6,183597,'99:14112:178348:183592:183597',1),
(183615,'Category 5.18',6,183597,'99:14112:178348:183592:183597',1),
(183616,'Category 5.19',6,183597,'99:14112:178348:183592:183597',1),
(183617,'Category 5.20',6,183597,'99:14112:178348:183592:183597',1),
(183618,'Category 16',5,183559,'99:14112:178348:183559',1),
(183619,'Category 17',5,183559,'99:14112:178348:183559',1),
(183620,'Category 18',5,183559,'99:14112:178348:183559',1),
(183621,'Category 19',5,183559,'99:14112:178348:183559',1),
(183622,'Category 20',5,183559,'99:14112:178348:183559',1),
(183623,'Category 21',5,183559,'99:14112:178348:183559',1),
(183624,'Category 22',5,183559,'99:14112:178348:183559',1),
(183625,'Category 23',5,183559,'99:14112:178348:183559',1),
(183626,'Category 24',5,183559,'99:14112:178348:183559',1),
(183627,'Category 25',5,183559,'99:14112:178348:183559',1);");
		
		update_option('ebayaffinity_catver', 11);
    }
}
